package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.ArbreCampSkel;
import com.termcat.business.reports.arees.AreaStatitsData;
import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.layout.FunctionalModule;
import java.sql.*;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import java.util.Collections;
import java.util.Vector;

public class ArbreCamp extends ArbreCampSkel 
{       
        private final static String ROOT_AREA_TEMATICA_ID = "root";
        
	public ArbreCamp(){}
        
        /*
         *       Re-escribim el mtode toString per aqui ens mostri el nom de l'area quan es visualitzen els
         *      elements en l'arbre. "( tree.add([ArbreCamp]) )"
         */
        public String toString()
        {
            return getNomArea();
        }
        
        /*
         *       Mtode que esborra tots aquells elements que tinguin com a ID_PARE el id que se li passa 
         *      per parmetre.
         *      @param id:      Identificador del pare.
         */
        /*public void removeChildrenOfParent(String id) throws RemoveException
        {
              Connection con = null;
              Statement stm = null;
              try {
                String sql="DELETE FROM co_arbre_camp WHERE ID_PARE='"+id+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                if (stm.executeUpdate(sql) != 1)
                  throw new RemoveException("Error deleting row");
              } catch (Exception e) {
                throw new RemoveException(e.toString());
              } finally {
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }*/
              
  public Vector getAreesOfFitxa(String idFitxa) throws FinderException 
  { 
      Connection con = null;
      Statement stm = null;
      ResultSet rs = null;
      Vector v = new Vector();
      try 
      {
          String sql="SELECT * from co_arbre_camp ac, co_arees_fitxes af where ac.ID_AREA=af.ID_AREA and af.ID_FITXA='"+idFitxa+"'";
          con = DBConnect.getConnection();
          stm = con.createStatement();
          rs = stm.executeQuery(sql);
          while (rs.next()) 
          {
              ArbreCamp tmp=new ArbreCamp();
              tmp.setIdArea(rs.getString("ID_AREA"));
              tmp.setIdDiccionari(rs.getString("ID_DICCIONARI"));
              tmp.setIdPare(rs.getString("ID_PARE"));
              tmp.setNomArea(rs.getString("NOM_AREA"));
              v.add(tmp);
          }
          
          return v;
      } 
      catch (Exception e) 
      {
          throw new FinderException(e.toString());
      } 
      finally 
      {
        if (rs != null) try { rs.close(); } catch (Exception ignored) {}
        if (stm != null) try { stm.close(); } catch (Exception ignored) {}
        if (con != null) DBConnect.putConnection(con);
      }
   }

  public Vector <AreaStatitsData> getAllNumFitxesGroupByArea() throws FinderException 
  { 
      Connection con = null;
      Statement stm = null;
      ResultSet rs = null;
      Vector <AreaStatitsData> result = new Vector<AreaStatitsData>();
      try 
      {
          String sql="select  arbre.id_area,arbre.nom_area,count(fitxes.id_fitxa),arbre.id_pare "+
                     " from co_arbre_camp arbre, co_arees_fitxes fitxes  " +
                      " where arbre.id_area = fitxes.id_area (+) "+
                 //    " where arbre.id_area = fitxes.id_area (+) AND "+
                //     " arbre.id_area!= '"+ROOT_AREA_TEMATICA_ID+"' "+
                     " group by (arbre.id_area )" ;
          
          con = DBConnect.getConnection();
          stm = con.createStatement();
          rs = stm.executeQuery(sql);
          while (rs.next()) 
          {
             AreaStatitsData data = new AreaStatitsData();
             data.setIdArea(rs.getString(1));
             data.setNumFitxes(rs.getString(3));
             data.setIdPare(rs.getString(4));
             data.setNomArea(FunctionalModule.getAbsoluteAreaName(data.getIdPare(),rs.getString(2),data.getIdArea())); //calculamos en nombre absoluto del area
             result.add(data);
          }
          Collections.sort(result,new TermcatComparator());
          return result;
      } 
      catch (Exception e) 
      {
          throw new FinderException(e.toString());
      } 
      finally 
      {
        if (rs != null) try { rs.close(); } catch (Exception ignored) {}
        if (stm != null) try { stm.close(); } catch (Exception ignored) {}
        if (con != null) DBConnect.putConnection(con);
      }
   }
  
  public Vector <AreaStatitsData> getNumFitxesGroupByAreaForDiccionary(String idDiccionary) throws FinderException 
  { 
      Connection con = null;
      Statement stm = null;
      ResultSet rs = null;
      Vector <AreaStatitsData> result = new Vector<AreaStatitsData>();
      try 
      {
          String sql="select  arbre.id_area,arbre.nom_area,count(fitxes.id_fitxa) "+
                     " from co_arbre_camp arbre, co_arees_fitxes fitxes " +
                     " where arbre.id_area = fitxes.id_area (+) AND "+
                     " arbre.id_area!= '"+ROOT_AREA_TEMATICA_ID+"' AND "+
                     " arbre.id_diccionari = '"+idDiccionary+"' "  +
                     " group by (arbre.nom_area )" ;
          
          con = DBConnect.getConnection();
          stm = con.createStatement();
          rs = stm.executeQuery(sql);
          while (rs.next()) 
          {
             AreaStatitsData data = new AreaStatitsData();
             data.setIdArea(rs.getString(1));
             data.setNomArea(rs.getString(2));
             data.setNumFitxes(rs.getString(3));
             data.setIdDiccionari(idDiccionary);
             result.add(data);
          }
          
          return result;
      } 
      catch (Exception e) 
      {
          throw new FinderException(e.toString());
      } 
      finally 
      {
        if (rs != null) try { rs.close(); } catch (Exception ignored) {}
        if (stm != null) try { stm.close(); } catch (Exception ignored) {}
        if (con != null) DBConnect.putConnection(con);
      }
   }
  
}
