package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.CategoriesSkel;
import com.termcat.business.reports.ObjectStatistics;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;
import com.termcat.layout.commons.lists.ItemListCustom;
import java.util.*;
import java.text.*;

public class Categories extends CategoriesSkel 
{
	public Categories(){}
        
        /**
         *       Mtode que obt totes les categories de la BD ordenades per prioritat.
         *      @return: Vector[Categories]
         */
        public Vector findAllOrderByPriority() throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT * from co_categories order by PRIORITAT";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  Categories tmp=new Categories();
                  tmp.setIdCategoria(rs.getString("ID_CATEGORIA"));
                  tmp.setCodiCategoria(rs.getString("CODI_CATEGORIA"));
                  tmp.setDescripcio(rs.getString("DESCRIPCIO"));
                  tmp.setPrioritat(rs.getLong("PRIORITAT"));
                  v.add(tmp);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
       }
        
        /**
         *       Mtode que obt totes les categories de la BD ordenades per prioritat. La diferencia entre aquest mtode
         *      i l'anterior, es que el vector que es retorna en aquest cas es un Vector[ItemListCustom] on cada element
         *      del vector (ItemListCustom) es una tupla [id,codi].
         *      Aquest mtode s'utilitza per a que en les combos de categories poder visualitzar el codi i enviar el id 
         *      que es el que permet identificar la categoria.
         *      Els combos de categories s'inicialitzen amb els continguts del vector que retorna aquest mtode.
         */
         public Vector findAllCodeIdCategories() throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT * from co_categories order by PRIORITAT";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  ItemListCustom item=new ItemListCustom();
                  item.setId(rs.getString("ID_CATEGORIA"));
                  item.setValue(rs.getString("CODI_CATEGORIA"));
                  v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
         
          /**
           *Numero total de categories agrupado por idioma
           **/
          public Vector <ObjectStatistics> findAllDictionaryCategoriesGroupByLangs(String dictinaryId) throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <ObjectStatistics> v = new Vector<ObjectStatistics>();
              try {
                String sql= " select  deno.id_categoria, deno.id_llengua, "+
                            " count(deno.id_categoria), categs.codi_categoria " +
                            " from co_denominacions deno,co_categories categs "+
                            " where deno.id_categoria = categs.id_categoria  "+
                            " AND deno.id_diccionari = '"+dictinaryId+"' "+
                            " group by (deno.id_llengua,deno.id_categoria )";
                
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ObjectStatistics itemSta = new ObjectStatistics();
                    itemSta.setIdCategoria (rs.getString(1));
                    itemSta.setIdLlengua(rs.getString(2));
                    itemSta.setNumberCategorias (rs.getString(3));
                    itemSta.setCodiCategoria(rs.getString(4));
                    v.add(itemSta);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
         }

         
         public Element addAllToXml(Element queryResult) { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              int k=0;
              try {
                String sql="SELECT * from co_categories ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                //Element queryResult = new Element("query-result");
                while (rs.next()) {
                  CategoriesSkel tmp=new CategoriesSkel();
                  tmp.setIdCategoria(rs.getString("ID_CATEGORIA"));
                  tmp.setCodiCategoria(rs.getString("CODI_CATEGORIA"));
                  tmp.setDescripcio(rs.getString("DESCRIPCIO"));
                  tmp.setPrioritat(rs.getLong("PRIORITAT"));
                  Element tmpElem = tmp.toXml();
                  //tmpElem.setAttribute("rowid",""+k);
                  queryResult.addChild(tmpElem);
                  k++;
                }
                return queryResult;
              } catch (Exception e) {
                throw new BaseRuntimeException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
 
          public static String findCategoriaForDenominacio(String idDenominacio) throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result = "";
              try {
                String sql="select categ.codi_categoria from co_categories  categ, co_denominacions deno where deno.id_categoria = categ.id_categoria and deno.id_denominacio = '"+idDenominacio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if (rs.next()) {
                    result = rs.getString(1);
                }
                return result;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }

         }
         
}