package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.ContextSkel;
import com.termcat.business.reports.ObjectStatistics;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxa;
import com.termcat.layout.FunctionalModule;
//import com.termcat.layout.commons.rtf.HTML2RTF;
import electric.xml.Element;
import java.sql.*;
import java.util.Hashtable;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;

public class Context extends ContextSkel 
{
	public Context(){}
        public Vector <ObjectStatistics> findAllContextGroupByFontsAndLlengues ()throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  fonts.codi_font, fontsContx.id_font,count (fontsContx.id_context) ,"+
                           " lang.id_llengua,lang.Nom from  co_fonts_contextos  fontsContx , " +
                           " co_fonts fonts  , co_context  contxs, co_Llengues lang " +
                           " where fonts.id_font = fontsContx.id_font AND " +
                           " contxs.id_Context = fontsContx.id_Context  AND " +
                           " contxs.id_Llengua = lang.id_Llengua  " +
                           " group by (fontsContx.id_font, contxs.id_Llengua)";

          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setCodiFont(rs.getString(1));
               definitionSt.setidFont(rs.getString(2));
               definitionSt.setNumberContext(rs.getString(3));
               definitionSt.setIdLlengua(rs.getString(4));
               definitionSt.setNameLlengua(rs.getString(5));
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector<ObjectStatistics> findAllNumContextGroupByLlengues (String dictionariId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  langDic.id_llengua,count(cont.id_llengua), lang.nom "+ 
                           " from co_context cont, co_llengues lang, co_llengues_diccionari langDic " +
                           " where  lang.id_llengua = cont.id_llengua(+) "+
                           " AND langDic.id_diccionari = '"+dictionariId+"' "+
                           " AND lang.id_llengua = langDic.id_llengua "+
                           " group by (langDic.id_llengua) order by(langDic.prioritat) ";

          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics contextStat = new ObjectStatistics();
               contextStat.setIdLlengua(rs.getString(1));
               contextStat.setNumberContext(rs.getString(2));
               contextStat.setNameLlengua(rs.getString(3));
               result.add(contextStat);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector <ObjectStatistics> findAllNumFichasMasUnContext (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Hashtable <String,ObjectStatistics> listLangs = new Hashtable <String,ObjectStatistics>();
            String query = " select  id_llengua,id_fitxa ,count(id_context) from co_context "+
                           " where id_diccionari = '"+dictionaryId+"' "+
                           " group by (id_llengua,id_fitxa)"; 
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               int numDefFitxa = rs.getInt(3);
               if(numDefFitxa>1){ //solo metemos aquellas fichas que tengan mas de una definicion
                  String langId = rs.getString(1);
                  ObjectStatistics ctxSta = listLangs.get(langId);
                  if(ctxSta==null){
                    ctxSta = new ObjectStatistics();
                    ctxSta.setIdLlengua(langId);
                    ctxSta.setNumFitxaMasDeUnCtx(1+"");
                  }else{
                      int numFitxas = Integer.parseInt(ctxSta.getNumFitxasMasDeUnaDef());
                      numFitxas++;
                      ctxSta.setNumFitxaMasDeUnCtx(numFitxas+"");
                  }
                   listLangs.put(langId,ctxSta);
               }
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return Notes.trasformHashToVector(listLangs);
        }

        public Element toXml() 
        {
             // Obtenim l'element en format XML fent la crida a la funcio pare.
             Element result=super.toXml();
             
             // Obtenim el contingut en RTF.
             Element e=result.getElement("contextRtf");
             String rtfText=e.getString();
             
             // Creem el nou camp 'contexte' (que contindr el contingut en RTF)
             Element contextRtf=new Element("context");
             contextRtf.setString(rtfText);

             // Esborrem els elements que no volem
             result.removeElement("contextRtf");
             result.removeElement("contextNormal");
             
             // Afegim l'element amb etiqueta context.
             result.addElement(contextRtf);
             return result;
        }  

    public Vector<BeanVeureFitxa> findContexteInfoAndFonts(String idDiccionari,String id) throws FinderException 
    {
         Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector<BeanVeureFitxa> vContext = new Vector<BeanVeureFitxa>();
              
              try 
              {
                   // Problema que el contexte esta en format RTF.
                String sql="select * from "+
                             " (select ctxtFit.codi_llengua,ctxtFit.context_normal, ctxtFit.id_context from "+
                                     " (SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT) ld"+
                             " inner join "+
                        "              (select ll.codi_llengua, c.context_normal,c.id_context,ll.id_llengua "+
                                        "from co_context c, co_llengues ll where c.id_llengua = ll.id_llengua and c.id_fitxa='"+id+"'" +
                        "                ) ctxtFit "+
                        "     on (ld.id_llengua =ctxtFit.id_llengua) order by ld.prioritat "+
                        "    ) ctxtFitOrdered"+
                        " left join "+
                                    " (select fc.id_context,f.codi_font from co_fonts_contextos fc, co_fonts f where fc.id_font=f.id_font )f_c " +
                        " on (f_c.id_context=ctxtFitOrdered.id_context)";                  
                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while(rs.next())
                    {        
                        BeanVeureFitxa context=new BeanVeureFitxa();
                        context.setId(rs.getString("ID_CONTEXT"));
                        context.setCodiLlengua(rs.getString("CODI_LLENGUA"));
                        context.setText(rs.getString("CONTEXT_NORMAL"));                             
                        context.setFonts(rs.getString("CODI_FONT"));

                        // Afegim l'item al vector
                        vContext.add(context);
                }
                
            return vContext;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }     
    }
}