package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.DefinicionsSkel;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxa;
//import com.termcat.layout.commons.rtf.HTML2RTF;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import com.termcat.business.reports.ObjectStatistics;

public class Definicions extends DefinicionsSkel 
{
	public Definicions(){}
        
        public Vector <ObjectStatistics> findAllDefiniciosGroupByFontsAndLlengues ()throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = "select  fonts.codi_font, fontsDef.id_font,count (fontsDef.id_definicio) ,lang.id_llengua,lang.Nom from  co_fonts_definicions fontsDef , co_fonts fonts  , co_definicions  defs, co_Llengues lang " +
                            " where fonts.id_font = fontsDef.id_font AND " +
                            " defs.id_Definicio = fontsDef.id_Definicio  AND "+
                            " defs.id_Llengua = lang.id_Llengua "+
                            " group by (fontsDef.id_font, defs.id_Llengua)";
            
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setCodiFont(rs.getString(1));
               definitionSt.setidFont(rs.getString(2));
               definitionSt.setNumberDefinitions(rs.getString(3));
               definitionSt.setIdLlengua(rs.getString(4));
               definitionSt.setNameLlengua(rs.getString(5));
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector <ObjectStatistics> findAllNumDefinitionsGroupByLlengues (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  lang.id_llengua,count(def.id_llengua), lang.nom "+ 
                           " from co_definicions def,co_llengues lang, co_llengues_diccionari langDic "+
                           " where  lang.id_llengua =  def.id_llengua (+) " +
                           " AND langDic.id_diccionari = '"+dictionaryId+"' "+
                           " AND lang.id_llengua = langDic.id_llengua "+
                           " group by (lang.id_llengua ) order by(langDic.prioritat)"; 
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setIdLlengua(rs.getString(1));
               definitionSt.setNumberDefinitions(rs.getString(2));
               definitionSt.setNameLlengua(rs.getString(3));
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        
        public Vector <ObjectStatistics> findAllNumFichasMasUnaDef (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Hashtable <String,ObjectStatistics> listLangs = new Hashtable <String,ObjectStatistics>();
            String query = " select  id_llengua,id_fitxa ,count(id_definicio) "+ 
                           " from co_definicions    where " +
                           " id_diccionari = '"+dictionaryId+"' " +
                           " group by (id_llengua,id_fitxa)"; 
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               int numDefFitxa = rs.getInt(3);
               if(numDefFitxa>1){ //solo metemos aquellas fichas que tengan mas de una definicion
                  String langId = rs.getString(1);
                  ObjectStatistics defSta = listLangs.get(langId);
                  if(defSta==null){
                    defSta = new ObjectStatistics();
                    defSta.setIdLlengua(langId);
                    defSta.setNumFitxasMasDeUnaDef(1+"");
                  }else{
                      int numFitxas = Integer.parseInt(defSta.getNumFitxasMasDeUnaDef());
                      numFitxas++;
                      defSta.setNumFitxasMasDeUnaDef(numFitxas+"");
                  }
                   listLangs.put(langId,defSta);
               }
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return Notes.trasformHashToVector(listLangs);
        }

        public Element toXml() 
        {
             // Obtenim l'element en format XML fent la crida a la funcio pare.
             Element result=super.toXml();
             Element e=result.getElement("definicionRtf");
             //HTML2RTF html2rtf=new HTML2RTF();
             //String rtfText=html2rtf.convertHTML2RTF(e.getString());
             String rtfText=e.getString();
             e.setString(rtfText);
             return result;
        }



    public Vector<BeanVeureFitxa> findDefinitionInfoAndFonts(String idDiccionari,String id) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector<BeanVeureFitxa> vDef = new Vector<BeanVeureFitxa>();
              
              try 
              {

                String sql="select * from "+
                             " (select defFit.codi_llengua,defFit.definicion_normal, defFit.id_definicio from "+
                                     " (SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT) ld"+
                             " inner join "+
                        "              (select ll.codi_llengua, d.definicion_normal,d.id_definicio,ll.id_llengua "+
                        "               from co_definicions d, co_llengues ll where d.id_llengua = ll.id_llengua  and d.id_fitxa='"+id+"'"+
                        "                ) defFit "+
                        "     on (ld.id_llengua =defFit.id_llengua) order by ld.prioritat, UCASE(defFit.definicion_normal) "+
                        "    ) defFitOrdered"+
                        " left join "+
                        "     (select fd.id_definicio,f.codi_font from co_fonts_definicions fd, co_fonts f where fd.id_font=f.id_font )f_d "+
                        " on (f_d.id_definicio=defFitOrdered.id_definicio)";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {       
                    BeanVeureFitxa def=new BeanVeureFitxa();
                    
                    def.setId(rs.getString("ID_DEFINICIO"));
                    def.setCodiLlengua(rs.getString("CODI_LLENGUA"));
                    def.setText(rs.getString("DEFINICION_NORMAL"));                             
                    def.setFonts(rs.getString("CODI_FONT"));
                    
                    // Afegim l'item al vector
                    vDef.add(def);
                }
                
            return vDef;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }        
    }
    

}