package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.DenominacionsSkel;
import com.termcat.bd.utils.SqlUtils;
import com.termcat.business.reports.ObjectStatistics;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.reports.llistat.sortable.ComparableTermcat;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxaDenominacio;
import com.termcat.layout.commons.ItemCustom;
import com.termcat.layout.commons.lists.ItemListCustom;
//import com.termcat.layout.commons.rtf.HTML2RTF;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Hashtable;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;

public class Denominacions extends DenominacionsSkel implements ComparableTermcat
{
	public Denominacions(){}
       

       /*
        *        Mtode que obt totes les denominacions principals i arees temtiques de les fitxes
        *       d'un diccionari determinat.
        *       @param idDiccionari:    Identificador del diccionari.
        *       @return Vector:         Vector amb les denominacions principals i les arees temtiques de totes les
        *                               fitxes del diccionari. 
        */
        public Vector findAllPrincipalDenominationsAndTematicAreas(String idDiccionari, int rowIni, int numRows) throws FinderException 
        { 
              long timeIni= System.currentTimeMillis();
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try 
              {
                // Query  
                String sql="select dPrincipal.id_fitxa,dPrincipal.terme_normal,arees.nom_area,arees.id_pare,dPrincipal.terme_rtf from " +
                            "(select deno.id_fitxa, deno.terme_normal,deno.terme_rtf from " +
                                "(select id_fitxa from co_fitxes where id_diccionari ='"+idDiccionari+"' ) all " +
                                "left join " +
                                "(select top 1 d.terme_normal, d.id_fitxa, d.terme_rtf from " +
                                    "(SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT ) ld " +
                                    "inner join " +
                                    "co_denominacions d " +
                                    "on (ld.id_llengua =d.id_llengua) order by ld.prioritat, UCASE(d.terme_normal) " +
                                ") deno " +                       
                                " on (all.id_fitxa=deno.id_fitxa)"+" order by deno.terme_normal "+" LIMIT " +rowIni+","+numRows +
                            ") dPrincipal " +
                            "left join " +
                            "(select ac. nom_area, ac.id_pare, af.id_fitxa from  " +
                                "co_arbre_camp ac " +
                                "inner join " +
                                "co_arees_fitxes af " +
                                "on (ac.id_area =af.id_area )" +
                            ") arees " +
                            "on (dPrincipal.id_fitxa=arees.id_fitxa) order by dPrincipal.terme_normal";
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                
                while(rs.next())
                {   
                    ItemCustom ic=new ItemCustom();
                    ic.setId(rs.getString(1));                                     
                    ic.setDenominacio(rs.getString(2));
                    ic.setAreaTematica(rs.getString(3));
                    ic.setIdPare(rs.getString(4));
                    ic.setDenominacioRtf(rs.getString(5));
                    v.add(ic);
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
            long timeFin= System.currentTimeMillis();
            System.out.println("tiempo total query "+((timeFin-timeIni)/1000));
          }
        }

        
        /**
         *@deprecated
         **/
        public Vector findAllPrincipalDenominationsAndTematicAreasByLang(String idDiccionari,String langId) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try 
              {
                String sql="select dPrincipal.id_fitxa,dPrincipal.terme_normal,arees.nom_area,arees.id_pare,dPrincipal.terme_rtf from " +
                            "(select deno.id_fitxa, deno.terme_normal,deno.terme_rtf from " +
                                "(select id_fitxa from co_fitxes where id_diccionari ='"+idDiccionari+"' ) all " +
                                "left join " +
                                "(select top 1 d.terme_normal, d.id_fitxa,d.terme_rtf from " +
                                    "(SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT ) ld " +
                                    "inner join " +
                                    "co_denominacions d " +
                                    "on (ld.id_llengua =d.id_llengua AND d.id_llengua='"+langId+"') order by ld.prioritat, UCASE(d.terme_normal) " +
                                ") deno " +                       
                                " on (all.id_fitxa=deno.id_fitxa)"+" order by deno.terme_normal) dPrincipal " +
                            "left join " +
                            "(select ac. nom_area, ac.id_pare, af.id_fitxa from  " +
                                "co_arbre_camp ac " +
                                "inner join " +
                                "co_arees_fitxes af " +
                                "on (ac.id_area =af.id_area )" +
                            ") arees " +
                            "on (dPrincipal.id_fitxa=arees.id_fitxa) order by dPrincipal.terme_normal";
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                    String idFitxa = rs.getString(1);
                        if(idFitxa!=null){
                        ItemCustom ic=new ItemCustom();
                        ic.setId(idFitxa);                                     
                        ic.setDenominacio(rs.getString(2));
                        ic.setAreaTematica(rs.getString(3));
                        ic.setIdPare(rs.getString(4));
                        ic.setDenominacioRtf(rs.getString(5));
                        v.add(ic);
                    }
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }
    
        /**
         *@deprecated
         **/
         public Vector findAllPrincipalDenominationsByArea(String idDiccionari,String areaId) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try 
              {
                String sql="select dPrincipal.id_fitxa,dPrincipal.terme_normal,arees.nom_area,arees.id_pare,arees.id_area,dPrincipal.terme_rtf from "+ 
                           " (select deno.id_fitxa, deno.terme_normal,deno.terme_rtf from  "+
                           "     (select id_fitxa from co_fitxes where id_diccionari ='"+idDiccionari+"' ) all  "+
                           "     left join  "+
                           "     (select top 1 d.terme_normal, d.id_fitxa, d.terme_rtf from  "+
                           "         (SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT ) ld  "+
                           "         inner join  "+
                           "         co_denominacions d  "+
                           "         on (ld.id_llengua =d.id_llengua) order by ld.prioritat, UCASE(d.terme_normal)  "+
                           "     ) deno                         "+
                           "      on (all.id_fitxa=deno.id_fitxa) order by deno.terme_normal "+
                           " ) dPrincipal  "+
                           " left join  "+
                           " (select ac. nom_area, ac.id_pare, af.id_fitxa,ac.id_area from   "+
                           "     co_arbre_camp ac  "+
                           "     inner join  "+
                           "     co_arees_fitxes af  "+
                           "     on (ac.id_area =af.id_area "+
                           "           ) "+
                           " ) arees  "+
                           " on (dPrincipal.id_fitxa=arees.id_fitxa AND arees.id_area='"+areaId+"') order by dPrincipal.terme_normal ";      
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                    String idAreaRead = rs.getString(5);
                        if(idAreaRead!=null){
                        ItemCustom ic=new ItemCustom();
                        ic.setId(rs.getString(1));                                     
                        ic.setDenominacio(rs.getString(2));
                        ic.setAreaTematica(rs.getString(3));
                        ic.setIdPare(rs.getString(4));
                        ic.setDenominacioRtf(rs.getString(5));
                        v.add(ic);
                    }
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }
        
        public Vector <ObjectStatistics> findAllDenominationsGroupByFontsAndLlengues ()throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  fonts.codi_font, fontsDeno.id_font,count (fontsDeno.id_denominacio), "+
                           " lang.id_llengua,lang.Nom from  co_fonts_denominacions  fontsDeno , co_fonts fonts ,"+
                           " co_denominacions   denos, co_Llengues lang " +
                           " where fonts.id_font = fontsDeno.id_font " + 
                           " AND  denos.id_Denominacio = fontsDeno.id_Denominacio " +
                           " AND  denos.id_Llengua = lang.id_Llengua " +
                           " group by (fontsDeno.id_font, denos.id_Llengua)";
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setCodiFont(rs.getString(1));
               definitionSt.setidFont(rs.getString(2));
               definitionSt.setNumberNumberDenominations(rs.getString(3));
               definitionSt.setIdLlengua(rs.getString(4));
               definitionSt.setNameLlengua(rs.getString(5));
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector <ObjectStatistics> findAllNumDenominationsGroupByLlengues (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = "select  lang.id_llengua,count(deno.id_llengua), lang.nom from co_denominacions deno,co_llengues lang, co_llengues_diccionari langDic "+
                           " where  lang.id_llengua = deno.id_llengua(+) "+
                           " AND langDic .id_diccionari = '"+dictionaryId+"' "+
                           " AND lang.id_llengua = langDic.id_llengua "+
                           " group by (lang.id_llengua ) order by(langDic.prioritat)";
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setIdLlengua(rs.getString(1));
               definitionSt.setNumberNumberDenominations(rs.getString(2));
               definitionSt.setNameLlengua(rs.getString(3));
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector <ObjectStatistics> findAllNumDenoWithoutMarcaPGroupByLlengues (String dictionaryId)throws FinderException {
            
            return findAllNumDenoWithoutAtributeGroupByLlengues(dictionaryId,"id_marca");
        }
        
        public Vector <ObjectStatistics> findAllNumDenoWithoutCategoriaGroupByLlengues (String dictionaryId)throws FinderException {
            
            return findAllNumDenoWithoutAtributeGroupByLlengues(dictionaryId,"id_categoria");
        }
        
        public Vector <ObjectStatistics> findAllNumDenoWithoutJerarquiaGroupByLlengues (String dictionaryId)throws FinderException {
            
            return findAllNumDenoWithoutAtributeGroupByLlengues(dictionaryId,"id_jerarquia");
        }
        
        
        
        private Vector <ObjectStatistics> findAllNumDenoWithoutAtributeGroupByLlengues (String dictionaryId,String atributeName)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  id_llengua, count(id_denominacio) from co_denominacions " +
                           " where ("+atributeName+" is null OR "+atributeName+" ='') " +
                           " AND id_diccionari = '"+dictionaryId+"' " +
                           " group by (id_llengua ) ";
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics objetSt = new ObjectStatistics();
               objetSt.setIdLlengua(rs.getString(1));
               objetSt.setNumberNoAssignedAttribute(rs.getString(2));
               result.add(objetSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

    public Vector findPrincipalDenominationsAndTematicAreasOfSearch(String query) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try 
              {
                // Query  
                String sql=query;
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                    ItemCustom ic=new ItemCustom();
                    ic.setId(rs.getString(1));                                     
                    ic.setDenominacio(rs.getString(2));
                    ic.setAreaTematica(rs.getString(3));
                    ic.setIdPare(rs.getString(4));
                    v.add(ic);
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }        
    }

        public Vector <Denominacions> findAllDenominationsOrderByTermPral(String idDiccionari) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <Denominacions> v = new Vector<Denominacions>();
              try 
              {
                String sql= " select deno.*  " +
                            " from co_denominacions deno, co_llengues_diccionari langDic " + 
                            " where deno.id_llengua = langDic.id_llengua "+
                            " order by (deno.terme_normal,langDic.prioritat)";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {
                    Denominacions deno = new Denominacions();
                    deno.setIdDenominacio(rs.getString("ID_DENOMINACIO"));
                    deno.setIdDiccionari(rs.getString("ID_DICCIONARI"));
                    deno.setIdLlengua(rs.getString("ID_LLENGUA"));
                    deno.setIdMarca(rs.getString("ID_MARCA"));
                    deno.setIdJerarquia(rs.getString("ID_JERARQUIA"));
                    deno.setIdCategoria(rs.getString("ID_CATEGORIA"));
                    deno.setIdFitxa(rs.getString("ID_FITXA"));
                    deno.setTermeRtf(rs.getString("TERME_RTF"));
                    deno.setTermeNormal(rs.getString("TERME_NORMAL"));
                    v.add(deno);
                }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }

        public Denominacions findDenominationData(String idDeno) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Denominacions deno = new Denominacions();
              try 
              {
                String sql= " select deno.* , jer.codi_jerarquia, cat.codi_categoria,marc.codi_marca_p "+
                            " from co_denominacions deno, co_jerarquies jer, co_categories cat, co_marques_p marc "+
                            " where   deno.id_denominacio = '"+idDeno+"' "+
                            " AND   deno.id_jerarquia = jer.id_jerarquia (+) "+
                            " AND    deno.id_categoria = cat.id_categoria (+) "+
                            " AND    deno.id_marca = marc.id_marca (+) ";
                
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {
                    
                    deno.setIdDenominacio(rs.getString("ID_DENOMINACIO"));
                    deno.setIdDiccionari(rs.getString("ID_DICCIONARI"));
                    deno.setIdLlengua(rs.getString("ID_LLENGUA"));
                    //en lugar de quedarnos con los ides nos quedamos con los codigos
                    String codiMarca = rs.getString("CODI_MARCA_P");
                    if (codiMarca==null) codiMarca="";
                    deno.setIdMarca(codiMarca);
                    String codiJer = rs.getString("CODI_JERARQUIA");
                    if (codiJer==null) codiJer="";
                    deno.setIdJerarquia(codiJer);
                    String codiCateg = rs.getString("CODI_CATEGORIA");
                    if (codiCateg==null) codiCateg="";
                    deno.setIdCategoria(codiCateg);
                    deno.setIdFitxa(rs.getString("ID_FITXA"));
                    deno.setTermeRtf(rs.getString("TERME_RTF"));
                    deno.setTermeNormal(rs.getString("TERME_NORMAL"));
                 
                }
                
            return deno;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }
 
         public Element toXml() 
         {
             // Obtenim l'element en format XML fent la crida a la funcio pare.
             Element result=super.toXml();
             Element e=result.getElement("termeRtf");
             //HTML2RTF html2rtf=new HTML2RTF();
             //String rtfText=html2rtf.convertHTML2RTF(e.getString());
             String rtfText=e.getString();
             e.setString(rtfText);
             return result;
         }

    public Vector<BeanVeureFitxaDenominacio> findDenominationInfoAndFonts(String idDiccionari,String id) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector<BeanVeureFitxaDenominacio> vDeno = new Vector<BeanVeureFitxaDenominacio>();
              
              try 
              {
                 String sql="select * from "+
                                " (select allDeno.id_denominacio,allDeno.codi_llengua,allDeno.terme_normal,allDeno.codi_jerarquia,allDeno.codi_categoria,allDeno.codi_marca_p from "+
                                "    (SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT) ld " +
                                " inner join "+
                                "    (select d.id_llengua,d.id_denominacio,ll.codi_llengua,d.terme_normal,j.codi_jerarquia,c.codi_categoria,m.codi_marca_p  "+
                                "    from co_denominacions d, co_llengues ll, co_jerarquies j, co_categories c, co_marques_p m  "+
                                "    where d.id_categoria =c.id_categoria(+) and d.id_marca = m.id_marca(+) and d.id_jerarquia=j.id_jerarquia(+) and ll.id_llengua=d.id_llengua and d.id_fitxa='"+id+"') allDeno  "+
                                " on (ld.id_llengua =allDeno.id_llengua) order by ld.prioritat, UCASE(allDeno.terme_normal) "+
                                " )allDenoOrdered"+
                                " left join "+
                                "    (select fd.id_denominacio,f.codi_font from co_fonts_denominacions fd, co_fonts f where fd.id_font=f.id_font )f_d  "+
                                " on (f_d.id_denominacio=allDenoOrdered.id_denominacio);"; 
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {       
                    BeanVeureFitxaDenominacio deno=new BeanVeureFitxaDenominacio();
                    deno.setId(rs.getString("ID_DENOMINACIO"));
                    deno.setCodiLlengua(rs.getString("CODI_LLENGUA"));
                    deno.setDenominacio(rs.getString("TERME_NORMAL"));
                    //en lugar de quedarnos con los ides nos quedamos con los codigos
                    String codiMarca = rs.getString("CODI_MARCA_P");
                    if (codiMarca==null) 
                        codiMarca="";
                    deno.setCodiMarcaPonderacio(codiMarca);
                    String codiJer = rs.getString("CODI_JERARQUIA");
                    if (codiJer==null) 
                        codiJer="";
                    deno.setCodiJerarquia(codiJer);
                    String codiCateg = rs.getString("CODI_CATEGORIA");
                    if (codiCateg==null) 
                        codiCateg="";
                    deno.setCodiCategoria(codiCateg);
                        
                    deno.setFonts(rs.getString("CODI_FONT"));
                    // Afegim l'item al vector
                    vDeno.add(deno);
                }
                
            return vDeno;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }        
    }
    
       /* public Vector <ItemCustom> findAllDenominationsAndPriorityLangs(String idDiccionari) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <ItemCustom>v = new Vector<ItemCustom>();
              try 
              {
                String sql="select deno.id_fitxa,deno.terme_normal,deno.terme_rtf,langDic.prioritat from co_denominacions deno, co_llengues_diccionari langDic "+
                            " where langDic.id_llengua = deno.id_llengua "+
                            " AND deno.id_diccionari='"+idDiccionari+"'  ";
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                  ItemCustom ic=new ItemCustom();
                  ic.setId(rs.getString(1));
                  ic.setDenominacio(rs.getString(2));
                  ic.setDenominacioRtf(rs.getString(3));
                  ic.setOrderLang(rs.getInt(4));
                  v.add(ic);
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }*/
        public Vector <BeanFichaData> findAllSortedFitxes(String idDiccionari,boolean composeDenoData) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              TermcatComparator coparator = new TermcatComparator();
              Vector <BeanFichaData> result = new Vector<BeanFichaData>();
              Hashtable <String,BeanFichaData> fitxes = new Hashtable<String,BeanFichaData>();

              try 
              {
                String sql="select deno.id_fitxa,deno.terme_normal,deno.terme_rtf,langDic.prioritat,deno.id_denominacio from co_denominacions deno, co_llengues_diccionari langDic "+
                            " where langDic.id_llengua = deno.id_llengua "+
                            " AND deno.id_diccionari='"+idDiccionari+"'  ";
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                  ItemCustom ic=new ItemCustom();
                  ic.setId(rs.getString(1));
                  ic.setDenominacio(rs.getString(2));
                  ic.setDenominacioRtf(rs.getString(3));
                  ic.setOrderLang(rs.getInt(4));
                  ic.setDenominacioId(rs.getString(5));
                  FitxaSortableList.buildSingleFicha(ic,fitxes,result,composeDenoData);
                  
               }
                
            return  FitxaSortableList.sortFichaList(result);
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }

        public Vector <ItemCustom> findAllDenominationsAndPriorityLangsByLang(String idDiccionari,String langId) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <ItemCustom>v = new Vector<ItemCustom>();
              try 
              {
                String sql="select deno.id_fitxa,deno.terme_normal,deno.terme_rtf,langDic.prioritat,deno.id_denominacio from co_denominacions deno, co_llengues_diccionari langDic "+
                            " where langDic.id_llengua = deno.id_llengua "+
                            " AND deno.id_diccionari='"+idDiccionari+"'  "+
                            " AND deno.id_llengua='"+langId+"'";
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                  ItemCustom ic=new ItemCustom();
                  ic.setId(rs.getString(1));
                  ic.setDenominacio(rs.getString(2));
                  ic.setDenominacioRtf(rs.getString(3));
                  ic.setOrderLang(rs.getInt(4));
                  ic.setDenominacioId(rs.getString(5));
                  v.add(ic);
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }    

        public Vector <ItemCustom> findAllDenominationsAndPriorityLangsByArea(String idDiccionari,String areaId) throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <ItemCustom>v = new Vector<ItemCustom>();
              try 
              {
                String sql="select deno.id_fitxa,deno.terme_normal,deno.terme_rtf,langDic.prioritat,deno.id_denominacio from co_denominacions deno, co_llengues_diccionari langDic, co_arees_fitxes areesFi "+
                            " where langDic.id_llengua = deno.id_llengua "+
                            " AND deno.id_diccionari='"+idDiccionari+"'  "+
                            " AND deno.id_fitxa=areesFi.id_fitxa "+
                            " AND areesFi.id_area = '"+areaId+"' ";
                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                  ItemCustom ic=new ItemCustom();
                  ic.setId(rs.getString(1));
                  ic.setDenominacio(rs.getString(2));
                  ic.setDenominacioRtf(rs.getString(3));
                  ic.setOrderLang(rs.getInt(4));
                  ic.setDenominacioId(rs.getString(5));
                  v.add(ic);
               }
                
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }        
        
        
        public Vector <BeanFichaData> findAllSortedFitxesSearch(String idDiccionari,String idFitxes, boolean composeDenoData) throws FinderException 
        { 
              String idFitxaFiltered="";
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              TermcatComparator coparator = new TermcatComparator();
              Vector <BeanFichaData> result = new Vector<BeanFichaData>();
              Hashtable <String,BeanFichaData> fitxes = new Hashtable<String,BeanFichaData>();

              try 
              {
                  String sql="select deno.id_fitxa,deno.terme_normal,deno.terme_rtf,langDic.prioritat,deno.id_denominacio from co_denominacions deno, co_llengues_diccionari langDic "+
                  " where langDic.id_llengua = deno.id_llengua "+
                  " AND deno.id_diccionari='"+idDiccionari+"' AND deno.id_fitxa "+idFitxes;

                System.out.println("all SQL "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while(rs.next())
                {   
                  ItemCustom ic=new ItemCustom();
                  ic.setId(rs.getString(1));
                  ic.setDenominacio(rs.getString(2));
                  ic.setDenominacioRtf(rs.getString(3));
                  ic.setOrderLang(rs.getInt(4));
                  ic.setDenominacioId(rs.getString(5));
                  FitxaSortableList.buildSingleFicha(ic,fitxes,result,composeDenoData);                  
               }
                
            return new FitxaSortableList().sortFichaList(result);
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }

         public String findAllIdFitxesSearch(String idDiccionari,String denoFiltered, String obsFiltered, String idFitxesDefNotesAT,String fontsFiltered) throws FinderException
         {
              String res=" IN(";
              String idFitxaFiltered="";
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              TermcatComparator coparator = new TermcatComparator();
              Vector <BeanFichaData> result = new Vector<BeanFichaData>();
              Hashtable <String,BeanFichaData> fitxes = new Hashtable<String,BeanFichaData>();

              // El cas de que sigui idFitxesDefNotesAT sigui '' es el cas que no hi ha filtre per a ATs, def i notes.
              //if (!idFitxaFiltered.equals(""))
              if (!idFitxesDefNotesAT.equals(""))
                idFitxaFiltered=" AND deno.id_fitxa IN("+idFitxesDefNotesAT+")";
              
              try 
              {
                String sql="select deno.id_fitxa from co_denominacions deno, co_fitxes fitxes, co_fonts_denominacions denoFont "+
                            " where deno.id_denominacio=denoFont.id_denominacio (+) "+
                            " AND deno.id_fitxa=fitxes.id_fitxa" + 
                            " AND deno.id_diccionari='"+idDiccionari+"'  " + denoFiltered + obsFiltered + idFitxaFiltered +fontsFiltered;
                System.out.println("all SQL Search "+sql);
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                
                while(rs.next())
                {   
                    if(rs.isFirst())
                        res+="'"+rs.getString(1)+"'";
                    else
                        res+=",'"+rs.getString(1)+"'";
               }
                res+=")";
              return res;  
            
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
          
         }

        public static int findDenominationJerarquiaPriority(String denoId) 
        {     
              int priority=100;
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Denominacions deno = new Denominacions();
              try 
              {
                String sql= "select jer.prioritat from co_jerarquies jer, co_denominacions  deno where deno.id_jerarquia = jer.id_jerarquia and deno.id_denominacio ='"+denoId+"' AND jer.id_jerarquia!=''";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if(rs.next()){
                    priority = rs.getInt(1);
                }
          } catch (Exception e) {
              e.printStackTrace();
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
          return priority;
        }
         
}

