package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.FitxesSkel;
import com.termcat.business.reports.ObjectStatistics;
import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.business.terminologic.FitxaElement;
//import com.termcat.layout.commons.rtf.HTML2RTF;
import electric.xml.Element;

import java.sql.*;
import java.io.*;
import java.util.Collections;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;

public class Fitxes extends FitxesSkel 
{       
        public final static int ALL_FITXES_CRITERION = 0;
        public final static int FITXES_WITH_AREA_CRITERION = 1;
        public final static int FITXES_WITH_DEFINITION_CRITERION = 2;
        public final static int FITXES_WITH_NOTES_CRITERION = 3;
        public final static int FITXES_WITH_OBSERVATION_CRITERION = 4;
        public final static int FITXES_WITH_CONTEXT_CRITERION = 5;
        
        
	public Fitxes(){}
        
        public String getAreaTematicaPrincipal(String idFitxa)
        {
            return "AreaTematicaDummy";                      
        }
        
    public Vector getLlenguesDiccionariOfFitxa(String idFitxa) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
               String sql="select ID_LLENGUA from CO_LLENGUES_DICCIONARI where id_diccionari=(select fitxa.id_diccionari from co_fitxes fitxa where fitxa. id_fitxa ='"+idFitxa+"' ) order by prioritat ";
               //String sql="select ID_LLENGUA from CO_LLENGUES_DICCIONARI where id_diccionari='"+idDiccionari+"' order by prioritat ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  v.add(rs.getString("ID_LLENGUA"));
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
    }

    public String getNumOfFixesWithoutArea() throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result= "0";
              String sql="select count (id_fitxa)  from co_fitxes "+
                         " where id_fitxa not in ( "+
                         " select fitxes.id_fitxa from co_fitxes fitxes, co_arees_fitxes arees "+
                         " where fitxes.id_fitxa = arees.id_fitxa) ";
              try {
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if(rs.next()){
                    result = rs.getString(1);
                }
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
              return result;
      }

    
    

    public String getNumFixesDictionaryByCriterion(int criterion, String dicctionaryId) throws FinderException {
              String result= "0";
              String sql= null;
              switch (criterion){
                  case ALL_FITXES_CRITERION: sql = "select count(id_fitxa) from co_fitxes  where id_diccionari = '"+dicctionaryId+"'";  ;break;
                  case FITXES_WITH_AREA_CRITERION: {
                      sql = "select count (distinct (arfit.id_fitxa)) from co_arees_fitxes arfit, co_fitxes fitxes " +
                            " where arfit.id_fitxa = fitxes.id_fitxa AND "+
                            " fitxes.id_diccionari = '"+dicctionaryId+"'";
                      }
                      break;
                  case FITXES_WITH_DEFINITION_CRITERION :sql=" select count (distinct (id_fitxa)) from co_definicions where id_diccionari = '"+dicctionaryId+"'"; break;
                  case FITXES_WITH_NOTES_CRITERION: sql=" select count (distinct (id_fitxa)) from co_notes where id_diccionari = '"+dicctionaryId+"'"; break;
                  case FITXES_WITH_OBSERVATION_CRITERION: {
                      sql=" select count (distinct (id_fitxa)) from co_fitxes " + 
                          " where  observacions  IS NOT NULL AND observacions!=''" +
                          " AND id_diccionari = '"+dicctionaryId+"'"; 
                  }
                  break;
                  case FITXES_WITH_CONTEXT_CRITERION: sql="select count (distinct (id_fitxa)) from co_context where id_diccionari = '"+dicctionaryId+"'"; break;
                  default : break;
              }
              if(sql!=null){
                result = executeQuery(sql);
              }
              return result;
    }    
    

    public String getNumFitxesDictionaryWithlang (String dictionaryId,String langId) throws FinderException {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result= "0";
              String sql ="select count (id_fitxa) from co_fitxes where id_fitxa IN "+
                          " ( " +
                              " select f.id_fitxa from co_fitxes f ,co_denominacions deno " +
                              " where "+
                              " deno.id_llengua = '"+langId+"' AND " +
                              " f.id_fitxa = deno.id_fitxa " +
                              " UNION " +
                              " select f.id_fitxa from co_fitxes f ,co_definicions def " +
                              " where " +
                              " def.id_llengua = '"+langId+"' AND "+   
                              " f.id_fitxa = def.id_fitxa "+
                              " UNION "+
                              " select f.id_fitxa from co_fitxes f ,co_notes notes " +
                              " where   "+
                              " notes.id_llengua = '"+langId+"' AND " +
                              " f.id_fitxa = notes.id_fitxa "+
                              " UNION "+
                              " select f.id_fitxa from co_fitxes f ,co_context cont "+
                              " where " +
                              " cont.id_llengua = '"+langId+"' AND "+
                              " f.id_fitxa = cont.id_fitxa "+
                          " ) " +
                          " AND id_diccionari = '"+dictionaryId+"'";
              try {
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if(rs.next()){
                    result = rs.getString(1);
                }
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
              return result;
      }    
    

        public Vector <ObjectStatistics> findAllNumFitxesWhitoutDefinitionsGroupByLlengues (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            //query que me da en numero de fichas con definiciones agrupados por idioma
            String query = " select langDic.id_llengua,count ( distinct (def.id_fitxa)) "+
                           " from co_definicions def,co_llengues lang ,co_llengues_diccionari langDic "+
                           " where langdic.id_llengua  = def.id_llengua (+) " +
                           " AND lang.id_llengua = langDic.id_llengua "+
                           " AND langDic.id_diccionari = '"+dictionaryId+"'" +
                           " group by (langdic.id_llengua ) order by(langDic.prioritat)" ; 
          try {
            int numTotalFitxes =  Integer.parseInt(getNumFixesDictionaryByCriterion(ALL_FITXES_CRITERION,dictionaryId));
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setIdLlengua(rs.getString(1));
               int numFitxasWhitoutDef = numTotalFitxes-rs.getInt(2);
               definitionSt.setNumFitxasWithoutDef(numFitxasWhitoutDef+"");
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector <ObjectStatistics> findAllNumFitxesWhitoutNotesGroupByLlengues (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            //query que me da en numero de fichas con notas agrupados por idioma
            String query = " select langDic.id_llengua,count ( distinct (notes.id_fitxa)) "+
                           " from co_notes notes,co_llengues lang ,co_llengues_diccionari langDic "+
                           " where langDic.id_llengua  = notes.id_llengua (+) "+
                           " AND lang.id_llengua = langDic.id_llengua "+
                           " AND langDic.id_diccionari = '"+dictionaryId+"' " +
                           " group by (langdic.id_llengua ) order by(langDic.prioritat) " ; 
          try {
            int numTotalFitxes =  Integer.parseInt(getNumFixesDictionaryByCriterion(ALL_FITXES_CRITERION,dictionaryId));
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics notesSt = new ObjectStatistics();
               notesSt.setIdLlengua(rs.getString(1));
               int numFitxasWhitoutNote = numTotalFitxes-rs.getInt(2);
               notesSt.setNumFitxasWithoutNote(numFitxasWhitoutNote+"");
               result.add(notesSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector <ObjectStatistics> findAllNumFitxesWhitoutCtxGroupByLlengues (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            //query que me da en numero de fichas con contexto agrupados por idioma
            String query = "  select langDic.id_llengua,count ( distinct (ctx.id_fitxa)) "+
                           " from co_context ctx,co_llengues lang ,co_llengues_diccionari langDic "+
                           "  where langDic.id_llengua  = ctx.id_llengua (+) "+
                           " AND lang.id_llengua = langDic.id_llengua "+
                           " AND langDic.id_diccionari = '"+dictionaryId+"' "+
                           " group by (langdic.id_llengua ) order by(langDic.prioritat)" ; 
          try {
            int numTotalFitxes =  Integer.parseInt(getNumFixesDictionaryByCriterion(ALL_FITXES_CRITERION,dictionaryId));
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics ctxSta = new ObjectStatistics();
               ctxSta.setIdLlengua(rs.getString(1));
               int numFitxasWhitoutCtx = numTotalFitxes-rs.getInt(2);
               ctxSta.setNumFitxaWithoutCtx(numFitxasWhitoutCtx+"");
               result.add(ctxSta);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }
        
        
    public static String getAllFichaIdsWhitoutNota(String dicId) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String listIds = "";
              try {
               String sql="select  id_fitxa from co_fitxes where id_diccionari='"+dicId+"' AND id_fitxa not in (select id_fitxa from co_notes where id_diccionari='"+dicId+"')";
               
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  listIds+= "'"+rs.getString(1)+"',";
                }
                return listIds.substring(0,(listIds.length()-1));
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
    }

    
    public static String getAllFichaIdsWhitoutDefinition(String dicId) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String listIds = "";
              try {
               String sql="select  id_fitxa from co_fitxes where id_diccionari='"+dicId+"' AND id_fitxa not in (select id_fitxa from co_definicions where id_diccionari='"+dicId+"')";
               
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  listIds+= "'"+rs.getString(1)+"',";
                }
                return listIds.substring(0,(listIds.length()-1));
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
    }
    
        
    private String executeQuery (String sql) throws FinderException {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result= "0";
              try {
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if(rs.next()){
                    result = rs.getString(1);
                }
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
              return result;
      }    
    
        public Element toXml() 
        {
             // Obtenim l'element en format XML fent la crida a la funcio pare.
             Element result=super.toXml();
             //System.out.println("E: "+result.toString());
             Element e=result.getElement("observacions");
             //HTML2RTF html2rtf=new HTML2RTF();
             //String rtfText=html2rtf.convertHTML2RTF(e.getString());
             String rtfText=e.getString();
             e.setString(rtfText);
             
             return result;
        }  
    
    /**
     *Metodo llamado directamente desde el report princpal.jasper para generar el datasorce que contendra 
     *todas las definiciones menos la pricipal
     */
    public static Vector<FitxaElement> getAllDenosFromFitxa(String idFitxa,String denoId) {
 
        String sql="select  deno.id_denominacio,deno.terme_normal,deno.terme_rtf,lang.codi_llengua,langdic.prioritat  from co_denominacions deno, co_llengues lang, co_llengues_diccionari langDic "+
                  " where deno.id_llengua = lang.id_llengua "+
                  " AND lang.id_llengua = langdic.id_llengua " + 
                  " AND id_fitxa = '"+idFitxa+"'"+ 
                  " AND deno.id_denominacio!= '"+denoId+"'"+ 
                  " order by (langdic.prioritat)";        
        return getAllEmentOfTypeFromFitxa(sql);
    }
    
    public static Vector<FitxaElement> getAllDefinicionsFromFitxa(String idFitxa) {
 
        String sql="select  def.id_definicio,def.definicion_normal,def.definicion_rtf,lang.codi_llengua,langdic.prioritat  from co_definicions  def, co_llengues lang, co_llengues_diccionari langDic "+
                   " where def.id_llengua = lang.id_llengua "+
                   " AND lang.id_llengua = langdic.id_llengua "+
                   " AND def.id_fitxa = '"+idFitxa+"' "+
                   " order by (langdic.prioritat)";        
        return getAllEmentOfTypeFromFitxa(sql);
    }
    public static Vector<FitxaElement> getAllNotesFromFitxa(String idFitxa) {
 
        String sql="select  notes.id_nota,notes.nota_normal,notes.nota_rtf,lang.codi_llengua,langdic.prioritat  from co_notes notes, co_llengues lang, co_llengues_diccionari langDic "+
                   " where notes.id_llengua = lang.id_llengua "+
                   " AND lang.id_llengua = langdic.id_llengua "+
                   " AND notes.id_fitxa = '"+idFitxa+"'"+
                   " order by (langdic.prioritat)";        
        return getAllEmentOfTypeFromFitxa(sql);
    }
    
   public static Vector<FitxaElement> getAllContextFromFitxa(String idFitxa) {
 
        String sql="select  ctx.id_context,ctx.context_normal,ctx.context_rtf,lang.codi_llengua,langdic.prioritat  from co_context ctx, co_llengues lang, co_llengues_diccionari langDic "+ 
                   " where ctx.id_llengua = lang.id_llengua " +
                   " AND lang.id_llengua = langdic.id_llengua "+ 
                   " AND ctx.id_fitxa = '"+idFitxa+"'"+ 
                   " order by (langdic.prioritat)";        
        return getAllEmentOfTypeFromFitxa(sql);
    }            
    /*public static Vector<FitxaElement> getAllDenosFromFitxa(String idFitxa,String denoId) {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <FitxaElement>result = new Vector<FitxaElement>();
              try {
               String sql="select  deno.id_denominacio,deno.terme_normal,deno.terme_rtf,lang.codi_llengua,langdic.prioritat  from co_denominacions deno, co_llengues lang, co_llengues_diccionari langDic "+
                          " where deno.id_llengua = lang.id_llengua "+
                          " AND lang.id_llengua = langdic.id_llengua " + 
                          " AND id_fitxa = '"+idFitxa+"'"+ 
                          " AND deno.id_denominacio!= '"+denoId+"'"+ 
                          " order by (langdic.prioritat)";
               
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                String currentLang = "";
                Vector <FitxaElement>denoOfCurrentLang = new Vector<FitxaElement>();
                while (rs.next()) {
                    FitxaElement deno = new FitxaElement();
                    deno.setIdElement(rs.getString(1));
                    String desc=rs.getString(2);
                    if(desc!=null)deno.setDescElement(desc.trim());
                    deno.setDescElementRtf(rs.getString(3));
                    deno.setLangCode(rs.getString(4));
                    deno.setLangPriority(rs.getInt(5));
                    if(currentLang.equals("")){//es la primera --> la aadimos a la primera lista por lenguas
                        currentLang=deno.getLangCode();
                        denoOfCurrentLang.add(deno);
                    }
                    else if(currentLang.equals(deno.getLangCode())){ //no hay cambio de lengua-> aadimos a la lista de la lengua actual
                        denoOfCurrentLang.add(deno);
                    }
                    else{ //hay cambio de lengua--> ordenamos  el vector de lengua actual, aadimos elemetos ordenados a resultado, inicializamos nuevo vector de lenguas
                       Collections.sort(denoOfCurrentLang,new TermcatComparator());
                       result.addAll(denoOfCurrentLang);
                       currentLang=deno.getLangCode();
                       denoOfCurrentLang = new Vector<FitxaElement>();
                       denoOfCurrentLang.add(deno);
                    }
                 }
                //al salir del bucle si hay elementos volcamos el contenido de la ultima lengua al vector de resultado 
                if(denoOfCurrentLang.size()>0){
                   Collections.sort(denoOfCurrentLang,new TermcatComparator());
                   result.addAll(denoOfCurrentLang);
                }
                return result;
              } catch (Exception e) {
                e.printStackTrace();
                return result;
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
    } */    

    
    private static Vector<FitxaElement> getAllEmentOfTypeFromFitxa(String query) {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <FitxaElement>result = new Vector<FitxaElement>();
              try {
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(query);
                String currentLang = "";
                Vector <FitxaElement>denoOfCurrentLang = new Vector<FitxaElement>();
                while (rs.next()) {
                    FitxaElement deno = new FitxaElement();
                    deno.setIdElement(rs.getString(1));
                    deno.setDescElement(rs.getString(2));
                    deno.setDescElementRtf(rs.getString(3));
                    deno.setLangCode(rs.getString(4));
                    deno.setLangPriority(rs.getInt(5));
                    if(currentLang.equals("")){//es la primera --> la aadimos a la primera lista por lenguas
                        currentLang=deno.getLangCode();
                        denoOfCurrentLang.add(deno);
                    }
                    else if(currentLang.equals(deno.getLangCode())){ //no hay cambio de lengua-> aadimos a la lista de la lengua actual
                        denoOfCurrentLang.add(deno);
                    }
                    else{ //hay cambio de lengua--> ordenamos  el vector de lengua actual, aadimos elemetos ordenados a resultado, inicializamos nuevo vector de lenguas
                       Collections.sort(denoOfCurrentLang,new TermcatComparator());
                       result.addAll(denoOfCurrentLang);
                       currentLang=deno.getLangCode();
                       denoOfCurrentLang = new Vector<FitxaElement>();
                       denoOfCurrentLang.add(deno);
                    }
                 }
                //al salir del bucle si hay elementos volcamos el contenido de la ultima lengua al vector de resultado 
                if(denoOfCurrentLang.size()>0){
                   Collections.sort(denoOfCurrentLang,new TermcatComparator());
                   result.addAll(denoOfCurrentLang);
                }
                return result;
              } catch (Exception e) {
                e.printStackTrace();
                return result;
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
    }     
    
  }
