package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.FontsSkel;
import com.termcat.bd.exceptions.*;
import com.termcat.business.reports.llistat.sortable.ComparableTermcat;
import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.layout.FunctionalModule;
//import com.termcat.layout.commons.rtf.HTML2RTF;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Collections;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.commons.lists.ItemListCustom;

public class Fonts extends FontsSkel implements ComparableTermcat
{      
    
        private String fontNoRtf = null;
	public Fonts(){}
        
         /**
          *Campos utilizados para ordena de forma discontinua el los listados
          **/     
         public String getTermeNormal(){
             return getCodiFont();
         }

         public String getTermeRtf() {
            return getCodiFont();
         }
   
                 
        /*
         *  Mtode que retorna un Vector d'itemListCustom, tuples [idFont,codiFont] amb totes les fonts disponibles.
         */
        public Vector findAllCodeIdFonts() throws FinderException 
        { 
          Connection con = null;
          Statement stm = null;
          ResultSet rs = null;
          Vector v = new Vector();
          try {
            String sql="SELECT * from co_fonts ";
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(sql);
            while (rs.next()) {
                  ItemListCustom item=new ItemListCustom();
                  item.setId(rs.getString("ID_FONT"));
                  item.setValue(rs.getString("CODI_FONT"));
                  v.add(item);
            }
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }        
        
        public Vector <String> findAllOrderFontsCode() throws FinderException 
        { 
          Connection con = null;
          Statement stm = null;
          ResultSet rs = null;
          Vector v = new Vector<String>();
          try {
            String sql="SELECT CODI_FONT, ID_LLENGUA from CO_FONTS, CO_LLENGUES  order by (CODI_FONT)";
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(sql);
            while (rs.next()) {
                  String codi = rs.getString("CODI_FONT")+"_"+rs.getString("ID_LLENGUA");
                  v.add(codi);
            }
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }        

  
        public void addAllToXml(Element queryResult)
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;

              try {
                String sql="SELECT * from co_fonts ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  FontsSkel tmp=new Fonts();
                  tmp.setIdFont(rs.getString("ID_FONT"));
                  tmp.setCodiFont(rs.getString("CODI_FONT"));
                  tmp.setDescripcio(rs.getString("DESCRIPCIO"));
                  
                  Element tmpElem = tmp.toXml();
                  queryResult.addChild(tmpElem);
                }

              } catch (Exception e) {
                throw new BaseRuntimeException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        } 
        
        public Element toXml() 
        {
             // Obtenim l'element en format XML fent la crida a la funcio pare.
             Element result=super.toXml();
             Element e=result.getElement("descripcio");
             //HTML2RTF html2rtf=new HTML2RTF();
             //String rtfText=html2rtf.convertHTML2RTF(e.getString());
             String rtfText=e.getString();
             e.setString(rtfText);
             return result;
        }
        public Vector findAllSorted() throws FinderException { 
          Connection con = null;
          Statement stm = null;
          ResultSet rs = null;
          Vector v = new Vector();
          try {
            String sql="SELECT * from co_fonts ";
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(sql);
            while (rs.next()) {
              String desc=null;
              Fonts tmp=new Fonts();
              tmp.setIdFont(rs.getString("ID_FONT"));
              tmp.setCodiFont(rs.getString("CODI_FONT"));
              desc=rs.getString("DESCRIPCIO");
              if(desc!=null)tmp.setDescripcio(desc);
              v.add(tmp);
            }
            Collections.sort(v,new TermcatComparator());
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }        

        
        
}