package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.FontsContextosSkel;
import com.termcat.bd.utils.DBConnect;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import com.termcat.layout.commons.lists.ItemListCustom;
import electric.xml.Element;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.Vector;
import com.termcat.bd.exceptions.*;

public class FontsContextos extends FontsContextosSkel 
{
	public FontsContextos(){}
        
         public Vector findFontsContextes(String id) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT fonts.ID_FONT,fonts.CODI_FONT FROM CO_FONTS_CONTEXTOS fonts_contextos, CO_FONTS fonts where fonts.ID_FONT = fonts_contextos.ID_FONT and fonts_contextos.ID_CONTEXT='"+id+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ItemListCustom item=new ItemListCustom();
                    item.setId(rs.getString("ID_FONT"));
                    item.setValue(rs.getString("CODI_FONT"));
                    v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }

        /*
         *   Mtode que elimina totes les fonts associades a una determinada nota.
         *  @param idNota:   Identificador de la nota.
         */
        public void removeFontsContextes(String id) throws FinderException 
        {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector v = new Vector();
            try 
            {
                String sql="delete from CO_FONTS_CONTEXTOS where ID_CONTEXT='"+id+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                stm.execute(sql);
            }
            catch (Exception e) 
            {
                throw new FinderException(e.toString());
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
            }
        }

    public void addAllOfDictionaryToXml(Element elem, String idDiccionari) 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;

             try 
              {
                   String sql="SELECT fonts_contextos.ID_CONTEXT, fonts_contextos.ID_FONT  " +
                       "FROM CO_FONTS_CONTEXTOS fonts_contextos, CO_CONTEXT context " +
                       "where CONTEXT.ID_CONTEXT = fonts_contextos.ID_CONTEXT and context.ID_DICCIONARI='"+idDiccionari+"'";    

                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while (rs.next()) {
                        FontsContextos item=new FontsContextos();
                        item.setIdFont(rs.getString("ID_FONT"));
                        item.setIdContext(rs.getString("ID_CONTEXT"));
                        elem.addChild(item.toXml());
                    }
             }
             catch(Exception e)
             {
                throw new BaseRuntimeException(e.toString());                 
             }
             finally 
             {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }        
    }
         public static String findFontsContextesAsString(String id) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result="";
              try {
                String sql="SELECT fonts.CODI_FONT FROM CO_FONTS_CONTEXTOS fonts_contextos, CO_FONTS fonts where fonts.ID_FONT = fonts_contextos.ID_FONT and fonts_contextos.ID_CONTEXT='"+id+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                   result+= rs.getString("CODI_FONT")+FitxaSortableList.FONT_SEPARATOR;
                }
                if(!result.equals(""))
                  result = result.substring(0,(result.length()-1));                
                return result;
              } catch (Exception e) {
                e.printStackTrace();
                return result;
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
    
}