package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.FontsDefinicionsSkel;
import com.termcat.bd.exceptions.*;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.commons.lists.ItemListCustom;

public class FontsDefinicions extends FontsDefinicionsSkel 
{
	public FontsDefinicions(){}
        
        /*
         *   Mtode que retorna un Vector d'itemListCustom, tuples [idFont,codiFont] amb totes les fonts associades a
         *  una determinada definici.
         *  @param idDefinicio: Identificador de la definici.
         */
         public Vector findFontsDefinicions(String idDefinicio) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT fonts.ID_FONT,fonts.CODI_FONT FROM CO_FONTS_DEFINICIONS fonts_def, CO_FONTS fonts where fonts.ID_FONT = fonts_def.ID_FONT and fonts_def.ID_DEFINICIO='"+idDefinicio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ItemListCustom item=new ItemListCustom();
                    item.setId(rs.getString("ID_FONT"));
                    item.setValue(rs.getString("CODI_FONT"));
                    v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }

        /*
         *   Mtode que elimina totes les fonts associades a una determinada definici.
         *  @param idDefinicio:   Identificador de la definici.
         */
        public void removeFontsDefinicions(String idDefinicio) throws FinderException 
        {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector v = new Vector();
            try 
            {
                String sql="delete from CO_FONTS_DEFINICIONS where ID_DEFINICIO='"+idDefinicio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                stm.execute(sql);
            }
            catch (Exception e) 
            {
                throw new FinderException(e.toString());
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
            }
        }

    public void addAllOfDictionaryToXml(Element elem, String idDiccionari) 
    {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;

            try 
            {
                   String sql="SELECT fonts_definicions.ID_FONT, fonts_definicions.ID_DEFINICIO  " +
                              "FROM CO_FONTS_DEFINICIONS fonts_definicions, CO_DEFINICIONS definicions " +
                              "where definicions.ID_DEFINICIO = fonts_definicions.ID_DEFINICIO and definicions.ID_DICCIONARI='"+idDiccionari+"'";    

                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while (rs.next()) {
                        FontsDefinicions item=new FontsDefinicions();
                        item.setIdFont(rs.getString("ID_FONT"));
                        item.setIdDefinicio(rs.getString("ID_DEFINICIO"));
                        elem.addChild(item.toXml());
                    }
            }
            catch(Exception e)
            {
               throw new BaseRuntimeException(e.toString());                 
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
             }
    
    }
    
         public static String findFontsDefinicionsAsString(String idDefinicio) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result="";
              try {
                String sql="SELECT fonts.CODI_FONT FROM CO_FONTS_DEFINICIONS fonts_def, CO_FONTS fonts where fonts.ID_FONT = fonts_def.ID_FONT and fonts_def.ID_DEFINICIO='"+idDefinicio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                   result+= rs.getString("CODI_FONT")+FitxaSortableList.FONT_SEPARATOR;
                }
                if(!result.equals(""))
                  result = result.substring(0,(result.length()-1));                
                return result;
              } catch (Exception e) {
                e.printStackTrace();
                return result;
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
    

}