package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.FontsDenominacionsSkel;
import com.termcat.bd.exceptions.*;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.commons.lists.ItemListCustom;

public class FontsDenominacions extends FontsDenominacionsSkel 
{
	public FontsDenominacions(){}
   
        /*
         *   Mtode que retorna un Vector d'itemListCustom, tuples [idFont,codiFont] amb totes les fonts associades a
         *  una determinada denominaci.
         *  @param idDenominacio: Identificador de la denominacio.
         */
        public Vector findFontsDenominacions(String idDenominacio) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT fonts.ID_FONT,fonts.CODI_FONT FROM CO_FONTS_DENOMINACIONS fonts_deno, CO_FONTS fonts where fonts.ID_FONT = fonts_deno.ID_FONT and fonts_deno.ID_DENOMINACIO='"+idDenominacio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ItemListCustom item=new ItemListCustom();
                    item.setId(rs.getString("ID_FONT"));
                    item.setValue(rs.getString("CODI_FONT"));
                    v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
        
        /*
         *   Mtode que elimina totes les fonts associades a una determinada denominaci.
         *  @param idDenominacio:   Identificador de la denominaci.
         */
        public void removeFontsDenominations(String idDenominacio) throws FinderException 
        {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector v = new Vector();
            try 
            {
                String sql="delete from CO_FONTS_DENOMINACIONS where ID_DENOMINACIO='"+idDenominacio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                stm.execute(sql);
            }
            catch (Exception e) 
            {
                throw new FinderException(e.toString());
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
            }
        }
        
        public void addAllOfDictionaryToXml(Element elem, String idDiccionari) 
        {            
           Connection con = null;
            Statement stm = null;
            ResultSet rs = null;

            try 
            {
                   String sql="SELECT fonts_denominacions.ID_FONT, fonts_denominacions.ID_DENOMINACIO  " +
                              "FROM CO_FONTS_DENOMINACIONS fonts_denominacions, CO_DENOMINACIONS denominacions " +
                              "where denominacions.ID_DENOMINACIO = fonts_denominacions.ID_DENOMINACIO and denominacions.ID_DICCIONARI='"+idDiccionari+"'";    

                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while (rs.next()) {
                        FontsDenominacions item=new FontsDenominacions();
                        item.setIdFont(rs.getString("ID_FONT"));
                        item.setIdDenominacio(rs.getString("ID_DENOMINACIO"));
                        elem.addChild(item.toXml());
                    }
            }
            catch(Exception e)
            {
               throw new BaseRuntimeException(e.toString());                 
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
             }
    
        }

        
        public Vector<String> getIdFitxa(String idDiccionari,String idFonts)
        {
            Vector<String> v=new Vector<String>();
            
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;

            try 
            {
                   String sql="SELECT denominacions.id_fitxa " +
                              "FROM CO_FONTS_DENOMINACIONS fonts_denominacions, CO_DENOMINACIONS denominacions " +
                              "where denominacions.ID_DENOMINACIO = fonts_denominacions.ID_DENOMINACIO " +
                              "and denominacions.ID_DICCIONARI='"+idDiccionari+"' AND " + idFonts;    

                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while (rs.next()) {
                        String idFitxa=rs.getString("ID_FITXA");
                        v.add(idFitxa);
                    }
            }
            catch(Exception e)
            {
               throw new BaseRuntimeException(e.toString());                 
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
             }

            
            return v;
        }
        
        public static String findFontsDenominacionsAsString(String idDenominacio)  
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result="";
              try {
                String sql="SELECT fonts.CODI_FONT FROM CO_FONTS_DENOMINACIONS fonts_deno, CO_FONTS fonts where fonts.ID_FONT = fonts_deno.ID_FONT and fonts_deno.ID_DENOMINACIO='"+idDenominacio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    result+= rs.getString("CODI_FONT")+FitxaSortableList.FONT_SEPARATOR;
                }
                if(!result.equals(""))
                  result = result.substring(0,(result.length()-1));
                return result;
              } catch (Exception e) {
                e.printStackTrace();
                 return result;
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
        
}