package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.FontsNotesSkel;
import com.termcat.bd.exceptions.*;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.commons.lists.ItemListCustom;

public class FontsNotes extends FontsNotesSkel 
{
	public FontsNotes(){}
        
        /*
         *   Mtode que retorna un Vector d'itemListCustom, tuples [idFont,codiFont] amb totes les fonts associades a
         *  una determinada nota.
         *  @param idNotes: Identificador de la nota.
         */
        public Vector findFontsNotes(String idNota) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT fonts.ID_FONT,fonts.CODI_FONT FROM CO_FONTS_NOTES fonts_notes, CO_FONTS fonts where fonts.ID_FONT = fonts_notes.ID_FONT and fonts_notes.ID_NOTA='"+idNota+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ItemListCustom item=new ItemListCustom();
                    item.setId(rs.getString("ID_FONT"));
                    item.setValue(rs.getString("CODI_FONT"));
                    v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }

        /*
         *   Mtode que elimina totes les fonts associades a una determinada nota.
         *  @param idNota:   Identificador de la nota.
         */
        public void removeFontsNotes(String idNota) throws FinderException 
        {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector v = new Vector();
            try 
            {
                String sql="delete from CO_FONTS_NOTES where ID_NOTA='"+idNota+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                stm.execute(sql);
            }
            catch (Exception e) 
            {
                throw new FinderException(e.toString());
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
            }
        }

    public void addAllOfDictionaryToXml(Element elem, String idDiccionari)
    {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;

            try 
            {
                   String sql="SELECT fonts_notes.ID_FONT, fonts_notes.ID_NOTA  " +
                       "FROM CO_FONTS_NOTES fonts_notes, CO_NOTES notes " +
                       "where notes.ID_NOTA = fonts_notes.ID_NOTA and notes.ID_DICCIONARI='"+idDiccionari+"'";    

                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while (rs.next()) {
                        FontsNotes item=new FontsNotes();
                        item.setIdFont(rs.getString("ID_FONT"));
                        item.setIdNota(rs.getString("ID_NOTA"));
                        elem.addChild(item.toXml());
                    }
            }
            catch(Exception e)
            {
               throw new BaseRuntimeException(e.toString());                 
            }
            finally 
            {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
             }
    }

        public static String findFontsNotesAsString(String idNota) throws FinderException 
        {    
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result="";
              try {
                String sql="SELECT fonts.CODI_FONT FROM CO_FONTS_NOTES fonts_notes, CO_FONTS fonts where fonts.ID_FONT = fonts_notes.ID_FONT and fonts_notes.ID_NOTA='"+idNota+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                   result+= rs.getString("CODI_FONT")+FitxaSortableList.FONT_SEPARATOR;
                }
                if(!result.equals(""))
                  result = result.substring(0,(result.length()-1));                
                return result;
              } catch (Exception e) {
                e.printStackTrace();
                return result;
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }    
}