package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.JerarquiesSkel;
import com.termcat.business.reports.ObjectStatistics;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;

import java.util.*;
import java.text.*;
import com.termcat.layout.commons.lists.ItemListCustom;

public class Jerarquies extends JerarquiesSkel 
{
	public Jerarquies(){}
        
       /**
         *       Mtode que obt totes les jerarquies de la BD ordenades per prioritat.
         *      @return: Vector[Jerarquies]
         */
        public Vector findAllOrderByPriority() throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT * from co_jerarquies order by PRIORITAT";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  Jerarquies tmp=new Jerarquies();
                  tmp.setIdJerarquia(rs.getString("ID_JERARQUIA"));
                  tmp.setCodiJerarquia(rs.getString("CODI_JERARQUIA"));
                  tmp.setDescripcio(rs.getString("DESCRIPCIO"));
                  tmp.setPrioritat(rs.getLong("PRIORITAT"));
                  v.add(tmp);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
        
        /**
         *       Mtode que obt totes les jerarquies de la BD ordenades per prioritat. La diferencia entre aquest mtode
         *      i l'anterior, es que el vector que es retorna en aquest cas es un Vector[ItemListCustom] on cada element
         *      del vector (ItemListCustom) es una tupla [id,codi].
         *      Aquest mtode s'utilitza per a que en les combos de jerarquies poder visualitzar el codi i enviar el id 
         *      que es el que permet identificar la jerarquia.
         *      Els combos de jerarquies s'inicialitzen amb els continguts del vector que retorna aquest mtode.
         */      
        public Vector findAllCodeIdJerarquies() throws FinderException 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT * from co_jerarquies order by PRIORITAT";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                 ItemListCustom item=new ItemListCustom();
                  item.setId(rs.getString("ID_JERARQUIA"));
                  item.setValue(rs.getString("CODI_JERARQUIA"));
                  v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
        }
        

          /**
           *Numero total de jerarquies agrupado por idioma
           **/
          public Vector <ObjectStatistics> findAllDictionaryJerarquiesGroupByLangs(String dictinaryId) throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <ObjectStatistics> v = new Vector<ObjectStatistics>();
              try {
                String sql= " select  deno.id_jerarquia, deno.id_llengua, "+
                            " count(deno.id_jerarquia), jerar.codi_jerarquia "+
                            " from co_denominacions deno,co_jerarquies jerar "+
                            " where deno.id_jerarquia = jerar.id_jerarquia  "+
                            " AND deno.id_diccionari = '"+dictinaryId+"' "+
                            " group by (deno.id_llengua,deno.id_jerarquia ) ";
                
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ObjectStatistics itemSta = new ObjectStatistics();
                    String idJer = rs.getString(1);
                    if (!idJer.trim().equals("")){
                        itemSta.setIdJerarquia(idJer);
                        itemSta.setIdLlengua(rs.getString(2));
                        itemSta.setNumberJerarquias(rs.getString(3));
                        itemSta.setCodiJerarquia(rs.getString(4));
                        v.add(itemSta);
                    }
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
         }
        
        public Element addAllToXml(Element queryResult)
        { 
          Connection con = null;
          Statement stm = null;
          ResultSet rs = null;
          int k=0;
          try {
            String sql="SELECT * from co_jerarquies ";
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(sql);
            //Element queryResult = new Element("query-result");
            while (rs.next()) {
              JerarquiesSkel tmp=new JerarquiesSkel();
              tmp.setIdJerarquia(rs.getString("ID_JERARQUIA"));
              tmp.setCodiJerarquia(rs.getString("CODI_JERARQUIA"));
              tmp.setDescripcio(rs.getString("DESCRIPCIO"));
              tmp.setPrioritat(rs.getLong("PRIORITAT"));
              if(!rs.getString("ID_JERARQUIA").equals(""))
              {
                Element tmpElem = tmp.toXml();                           
                queryResult.addChild(tmpElem);
              }              
            }
            return queryResult;
          } catch (Exception e) {
            throw new BaseRuntimeException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }
        
          public static String findJerarquiaForDenominacio(String idDenominacio) throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result = "";
              try {
                String sql="select jer.codi_jerarquia from co_jerarquies jer, co_denominacions deno where deno.id_jerarquia = jer.id_jerarquia and deno.id_denominacio = '"+idDenominacio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if (rs.next()) {
                    result = rs.getString(1);
                }
                return result;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }

         }
        
}