package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.LlenguesSkel;
import com.termcat.bd.exceptions.*;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.commons.lists.ItemListCustom;
public class Llengues extends LlenguesSkel 
{
	public Llengues(){}
         
        /**
         *       Mtode que obt totes les llengues de la BD. El vector que es retorna en aquest cas es un Vector[ItemListCustom] 
         *      on cada element del vector (ItemListCustom) es una tupla [id,codi].
         *      Aquest mtode s'utilitza per a que en les combos de llengues poder visualitzar el codi i enviar el id 
         *      que es el que permet identificar la llengua.
         */ 
        public Vector findAllCodeIdLlengues() throws FinderException { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT * from co_llengues ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                  ItemListCustom item=new ItemListCustom();
                  item.setId(rs.getString("ID_LLENGUA"));
                  item.setValue(rs.getString("CODI_LLENGUA"));
                  v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
       }
        
        // sobre-escritura del metode 'findAllXml()''
        public void findAllXml(Element queryResult) 
        { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              int k=0;
              try {
                String sql="SELECT * from co_llengues ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                //Element queryResult = new Element("query-result");
                while (rs.next()) {
                  Llengues tmp=new Llengues();
                  tmp.setIdLlengua(rs.getString("ID_LLENGUA"));
                  tmp.setCodiLlengua(rs.getString("CODI_LLENGUA"));
                  tmp.setNom(rs.getString("NOM"));
                  Element tmpElem = tmp.toXml();
                  //tmpElem.setAttribute("rowid",""+k);
                  queryResult.addChild(tmpElem);
                  k++;
                }
                //return queryResult;
              } catch (Exception e) {
                throw new BaseRuntimeException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
}

       
        
        
}