package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.LlenguesDiccionariSkel;
import com.termcat.bd.exceptions.*;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.commons.lists.ItemListCustom;

public class LlenguesDiccionari extends LlenguesDiccionariSkel 
{
	public LlenguesDiccionari(){}
        
        /**
         *       Mtode que obt totes les llengues associades a un determinat diccionari. El vector que es retorna en 
         *      aquest cas es un Vector[ItemListCustom] on cada element del vector (ItemListCustom) es una tupla [id,codi].
         *      Aquest mtode s'utilitza per a que en les combos de llengues poder visualitzar el codi i enviar el id 
         *      que es el que permet identificar la llengua.
         *      Els combos de llengues s'inicialitzen amb els continguts del vector que retorna aquest mtode.
         *
         *      @param idDiccionari:    Identificador del diccionari del que es volen obtenir les llengues.
         */ 
       public Vector findLlenguesOfDictionary(String idDiccionari) throws FinderException { 
          Connection con = null;
          Statement stm = null;
          ResultSet rs = null;
          Vector v = new Vector();
          try {
            String sql="SELECT llengues_dicc.ID_DICCIONARI, llengues_dicc.ID_LLENGUA,llengues_dicc.PRIORITAT,llengues.CODI_LLENGUA,llengues.NOM FROM co_LLENGUES_DICCIONARI  llengues_dicc, CO_LLENGUES llengues WHERE LLENGUES.ID_LLENGUA = LLENGUES_DICC.ID_LLENGUA AND LLENGUES_DICC.ID_DICCIONARI='"+idDiccionari+"' ORDER BY llengues_dicc.PRIORITAT";
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(sql);
            while (rs.next()) {
                ItemListCustom item=new ItemListCustom();
                item.setId(rs.getString("ID_LLENGUA"));
                item.setValue(rs.getString("CODI_LLENGUA"));
                item.setNom(rs.getString("NOM"));
                v.add(item);
            }
            return v;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
        }

}