package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.MarquesPSkel;
import com.termcat.business.reports.ObjectStatistics;
import java.sql.*;
import java.io.*;
import java.util.Vector;
import java.util.List;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;
import electric.xml.*;
import com.termcat.layout.commons.lists.ItemListCustom;


public class MarquesP extends MarquesPSkel 
{
	public MarquesP(){}
               
         /**
         *       Mtode que obt totes les marques de ponderaci de la BD. El vector que es retorna en aquest cas es un 
         *      Vector[ItemListCustom] on cada element del vector (ItemListCustom) es una tupla [id,codi].
         *      Aquest mtode s'utilitza per a que en les combos de marques poder visualitzar el codi i enviar el id 
         *      que es el que permet identificar la marca de ponderaci.
         *      Els combos de marques s'inicialitzen amb els continguts del vector que retorna aquest mtode.
         */ 
          public Vector findAllMarquesCodes() throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector v = new Vector();
              try {
                String sql="SELECT * from co_marques_p ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ItemListCustom item=new ItemListCustom();
                    item.setId(rs.getString("ID_MARCA"));
                    item.setValue(rs.getString("CODI_MARCA_P"));
                    v.add(item);
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }

         }
          
          /**
           *Numero total de marques de ponderacio agrupado por idioma
           **/
          public Vector <ObjectStatistics> findAllDictionaryMarquesGroupByLangs(String dictinaryId) throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector <ObjectStatistics> v = new Vector<ObjectStatistics>();
              try {
                String sql= " select  deno.id_marca, deno.id_llengua, count(deno.id_marca), marcas.codi_marca_p "+
                            " from co_denominacions deno,co_marques_p marcas " +
                            " where deno.id_marca = marcas.id_marca  "+
                            " AND deno.id_diccionari = '"+dictinaryId+"' " +
                            " group by (deno.id_llengua,deno.id_marca ) order by (marcas.codi_marca_p)";
                
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                while (rs.next()) {
                    ObjectStatistics itemSta = new ObjectStatistics();
                    String idMarca = rs.getString(1);
                    if(!idMarca.trim().equals("")){
                        itemSta.setIdMarcaP(idMarca);
                        itemSta.setIdLlengua(rs.getString(2));
                        itemSta.setNumberMarquesP(rs.getString(3));
                        itemSta.setCodiMarcaP(rs.getString(4));
                        v.add(itemSta);
                    }
                }
                return v;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
         }

          
          public Element addAllToXml(Element queryResult) { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              int k=0;
              try {
                String sql="SELECT * from co_marques_p ";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);

                while (rs.next()) {
                  MarquesPSkel tmp=new MarquesPSkel();
                  tmp.setIdMarca(rs.getString("ID_MARCA"));
                  tmp.setCodiMarca_p(rs.getString("CODI_MARCA_P"));
                  tmp.setDescripcio(rs.getString("DESCRIPCIO"));
                  if (!rs.getString("ID_MARCA").equals(""))
                  {    
                      Element tmpElem = tmp.toXml();
                      queryResult.addChild(tmpElem);
                  }
                }
                return queryResult;
              } catch (Exception e) {
                throw new BaseRuntimeException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }
       }


          public static String findMarcaForDenominacio(String idDenominacio) throws FinderException 
          { 
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              String result = "";
              try {
                String sql="select marca.codi_marca_p from co_marques_p marca, co_denominacions deno where deno.id_marca = marca.id_marca and deno.id_denominacio = '"+idDenominacio+"'";
                con = DBConnect.getConnection();
                stm = con.createStatement();
                rs = stm.executeQuery(sql);
                if (rs.next()) {
                    result = rs.getString(1);
                }
                return result;
              } catch (Exception e) {
                throw new FinderException(e.toString());
              } finally {
                if (rs != null) try { rs.close(); } catch (Exception ignored) {}
                if (stm != null) try { stm.close(); } catch (Exception ignored) {}
                if (con != null) DBConnect.putConnection(con);
              }

         }
          
}