package com.termcat.bd.beans;

import com.termcat.bd.beans.skels.NotesSkel;
import com.termcat.business.reports.ObjectStatistics;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxa;
//import com.termcat.layout.commons.rtf.HTML2RTF;
import electric.xml.Element;
import java.sql.*;
import java.io.*;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;
import com.termcat.bd.exceptions.*;

public class Notes extends NotesSkel 
{
	public Notes(){}
        public Vector<ObjectStatistics> findAllNotesGroupByFontsAndLlengues ()throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  fonts.codi_font, fontsNotes.id_font,count (fontsNotes.id_nota) ," +
                           " lang.id_llengua,lang.Nom from  co_fonts_notes  fontsNotes , co_fonts fonts  ,"+
                           " co_notes   notes, co_Llengues lang "+ 
                           " where fonts.id_font = fontsNotes.id_font AND "+ 
                           " notes.id_nota = fontsNotes.id_Nota AND "+
                           " notes.id_Llengua = lang.id_Llengua "+
                           " group by (fontsNotes.id_font, notes.id_Llengua)";

          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics definitionSt = new ObjectStatistics();
               definitionSt.setCodiFont(rs.getString(1));
               definitionSt.setidFont(rs.getString(2));
               definitionSt.setNumberNotes(rs.getString(3));
               definitionSt.setIdLlengua(rs.getString(4));
               definitionSt.setNameLlengua(rs.getString(5));
               result.add(definitionSt);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }

        public Vector<ObjectStatistics> findAllNumNotesGroupByLlengues (String dictionariId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Vector result = new Vector<ObjectStatistics>();
            String query = " select  langDic.id_llengua,count(nota.id_llengua), lang.nom from co_notes nota, " +
                           " co_llengues lang, co_llengues_diccionari langDic " +
                           " where lang.id_llengua = nota.id_llengua(+) "+
                           " AND langDic.id_diccionari = '"+dictionariId+"' "+
                           " AND lang.id_llengua = langDic.id_llengua " +
                           " group by (langDic.id_llengua ) order by(langDic.prioritat) ";

          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               ObjectStatistics notesStat = new ObjectStatistics();
               notesStat.setIdLlengua(rs.getString(1));
               notesStat.setNumberNotes(rs.getString(2));
               notesStat.setNameLlengua(rs.getString(3));
               result.add(notesStat);
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return result;
        }
        
        public Vector <ObjectStatistics> findAllNumFichasMasUnaNota (String dictionaryId)throws FinderException {
            Connection con = null;
            Statement stm = null;
            ResultSet rs = null;
            Hashtable <String,ObjectStatistics> listLangs = new Hashtable <String,ObjectStatistics>();
            String query = " select  id_llengua,id_fitxa ,count(id_nota) " + 
                           " from co_notes "+
                           " where  id_diccionari = '"+dictionaryId+"'"+
                           " group by (id_llengua,id_fitxa)"; 
          try {
            con = DBConnect.getConnection();
            stm = con.createStatement();
            rs = stm.executeQuery(query);
            while (rs.next()){
               int numNotasFitxa = rs.getInt(3);
               if(numNotasFitxa>1){ //solo metemos aquellas fichas que tengan mas de una nota
                  String langId = rs.getString(1);
                  ObjectStatistics notaSta = listLangs.get(langId);
                  if(notaSta==null){
                    notaSta = new ObjectStatistics();
                    notaSta.setIdLlengua(langId);
                    notaSta.setNumFitxasMasDeUnaNota(1+"");
                  }else{
                      int numFitxas = Integer.parseInt(notaSta.getNumFitxasMasDeUnaNota());
                      numFitxas++;
                      notaSta.setNumFitxasMasDeUnaNota(numFitxas+"");
                  }
                   listLangs.put(langId,notaSta);
               }
            }
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }
           return trasformHashToVector(listLangs);
        }
        
        public static Vector <ObjectStatistics> trasformHashToVector(Hashtable <String,ObjectStatistics> listLangs){
            Vector result = new Vector<ObjectStatistics>();
            Enumeration langList = listLangs.elements();
            while (langList.hasMoreElements()){
                result.add(langList.nextElement());
            }
            return result;
            
        }
        
        public Element toXml() 
        {
             // Obtenim l'element en format XML fent la crida a la funcio pare.
             Element result=super.toXml();
             Element e=result.getElement("notaRtf");
             //HTML2RTF html2rtf=new HTML2RTF();
             //String rtfText=html2rtf.convertHTML2RTF(e.getString());
             String rtfText=e.getString();
             e.setString(rtfText);
             return result;
        }        

    public Vector<BeanVeureFitxa> findNotaInfoAndFonts(String idDiccionari,String id) throws FinderException 
    {
              Connection con = null;
              Statement stm = null;
              ResultSet rs = null;
              Vector<BeanVeureFitxa> vNota = new Vector<BeanVeureFitxa>();
              
              try 
              {
                String sql="select * from "+
                             " (select notaFit.codi_llengua,notaFit.nota_normal, notaFit.id_nota from "+
                                     " (SELECT id_llengua, prioritat from CO_LLENGUES_DICCIONARI where ID_DICCIONARI='"+idDiccionari+"' order by PRIORITAT) ld"+
                             " inner join "+
                        "              (select ll.codi_llengua, n.nota_normal,n.id_nota,ll.id_llengua "+
                        "               from co_notes n, co_llengues ll where n.id_llengua = ll.id_llengua  and n.id_fitxa='"+id+"'"+
                        "                ) notaFit "+
                        "     on (ld.id_llengua =notaFit.id_llengua) order by ld.prioritat, UCASE(notaFit.nota_normal) "+
                        "    ) notaFitOrdered"+
                        " left join "+
                             " (select fn.id_nota,f.codi_font from co_fonts_notes fn, co_fonts f where fn.id_font=f.id_font )f_n " +
                        " on (f_n.id_nota=notaFitOrdered.id_nota)";                  
                    con = DBConnect.getConnection();
                    stm = con.createStatement();
                    rs = stm.executeQuery(sql);
                    while(rs.next())
                    {       
                        BeanVeureFitxa nota=new BeanVeureFitxa();
                        
                        nota.setId(rs.getString("ID_NOTA"));
                        nota.setCodiLlengua(rs.getString("CODI_LLENGUA"));
                        nota.setText(rs.getString("NOTA_NORMAL"));                             
                        nota.setFonts(rs.getString("CODI_FONT"));

                        // Afegim l'item al vector
                        vNota.add(nota);
                }
                
            return vNota;
          } catch (Exception e) {
            throw new FinderException(e.toString());
          } finally {
            if (rs != null) try { rs.close(); } catch (Exception ignored) {}
            if (stm != null) try { stm.close(); } catch (Exception ignored) {}
            if (con != null) DBConnect.putConnection(con);
          }            
    }
}