package com.termcat.bd.utils;

import java.sql.Connection;
import java.sql.DriverManager;

public class DBConnect 
{   
        public static String DB_URL = "jdbc:h2:file:"+System.getProperty("user.home")+"/"+"termcat_obert";
        public static String DB_USER = "termcat";
        public static String DB_PASS = "termcat";
        
        public static boolean isTransactional=false;
        // Cont la connexi transaccional.
        public static Connection connection=null;
        
	public DBConnect(){}
	
        public static Connection getConnectionTransactional()
        {
            Connection con=null;
            if (connection==null)
            {
                try
                {
                    con=getConnection();
                    con.setAutoCommit(false);
                    // Marquem l'atribut de transaccionalitat a 'true' i ens guardem la connexi
                    isTransactional=true;
                    connection=con;
                }
                catch (Exception e)
                {
                    // Fem consistent l'estat de la classe i mostrem per pantalla l'error.
                    isTransactional=false;
                    connection=null;
                    System.err.println("Error al obtener conexion de base de datos "); 
                    e.printStackTrace();
                }
            }
            else
            {
                con=connection;
            }
            return con;
        }
        
	public static Connection getConnection()
        {
            Connection con=null;
            
            // Comprovem que estigui activat el flag de transaccional; en aquest cas,retornem la connexi guardada.
            if (isTransactional && connection!=null)
                con=connection;
            else
            {
                String url = DB_URL+";IFEXISTS=TRUE"; 		
                try { 
                    Class.forName("org.h2.Driver"); 
                    con = DriverManager.getConnection(url,DB_USER,DB_PASS); 
                }
                catch(org.h2.jdbc.JdbcSQLException e){
                    System.err.println("No existe base de datos creada --> se procede a su creacion "); 
                    if (new BdRestore().generateBdFromScript()){
                        try{
                            con = DriverManager.getConnection(url,DB_USER,DB_PASS); 
                        }
                        catch(Exception e2){
                            e2.printStackTrace();
                            System.err.println("Error fatal!! imposible crear base de datos");
                        }
                    }
                    else{
                        System.err.println("Error fatal!! imposible crear base de datos");
                    }
                }
                catch (Exception e) { 
                    System.err.println("Error al obtener conexion de base de datos "); 
                    e.printStackTrace();
                }  
            }
	
            return con;
	}
	
	
    public static void putConnection(Connection con)
    {
       //  Nomes tanquem la connexi en el cas en que no tinguem transaccionalitat. En el cas de transaccionalitat,
       // es tancar al fer el 'commit()' o 'rollback()'.
       if (!isTransactional) 
       {    
           if(con!=null)
           {
                try
                {
                    con.close();
                    con=null;
                }
                catch(Exception e)
                {
                    e.printStackTrace();
                }
           }
       }
    }
    
    public static void putConnectionTransactional()
    {
         if(connection!=null)
         {
              try
              {
                  connection.close();
                  connection=null;
                  isTransactional=false;
              }
              catch(Exception e)
              {
                  e.printStackTrace();
              }
         }
     }
}
