/*
 * FontManager.java
 *
 * Created on 18 de julio de 2007, 18:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.maintenance.font;

import com.termcat.bd.beans.FontsContextos;
import com.termcat.bd.beans.FontsDefinicions;
import com.termcat.bd.beans.FontsDenominacions;
import com.termcat.bd.beans.FontsNotes;
import com.termcat.bd.exceptions.CreateException;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.FontException;

import com.termcat.bd.beans.Fonts;
import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.layout.FunctionalModule;
import com.termcat.util.UIDGenerator;
import electric.uddi.Description;
import electric.xml.Element;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.UnsupportedEncodingException;
import java.util.Collections;
import java.util.Iterator;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import org.h2.jdbc.JdbcSQLException;
/**
 *
 * @author Mena
 */
public class FontManager 
{
    
   private static FontManager manager;
   //public static BufferedWriter logger;
   private final String PATH="c:/tmp/log-";

    private String PK_ERROR="Unique index or primary key violation: PRIMARY_KEY";
    /** Creates a new instance of DictionaryManager */
    private FontManager() 
    {

    }
    
    public static FontManager getManager()
    {
        if(manager==null)
        {
            manager = new FontManager();
        }
        return manager;
    }
    
    public void altaFont(String idFont, String codiFont, String descripcio) throws FontException
    {
        Fonts font=new Fonts();        
        try
        {
           if (descripcio==null)
               descripcio="";

            font.setIdFont(idFont);
            if (codiFont==null)
                codiFont="";
            font.setCodiFont(codiFont);
            System.out.println("[      altaFont    ] CodiFont:"+codiFont);
            // El camp descripci es ja el camp en format enriquit.
            font.setDescripcio(descripcio);                    
            font.create();           
        }
        catch(Exception e)
        {
            String error="[altaFont] codiFont"+font.getCodiFont()+" Message:"+e.getMessage();
            //e.printStackTrace();            
            throw new FontException(e.getMessage());
        }        
    }
    
    /*
     *  Mtode que inserta una nova font a la BD.
     *  
     *  @param codi:         Codi de la font que s'inserta
     *  @param descripcion:  Descripci de la font que s'inserta.
     *
     */
    public void altaFont(String codi,String descripcio) throws FontException
    {       
        try
        {
            Fonts font=new Fonts();
            font.setIdFont(UIDGenerator.generateUniqueId());  
            font.setCodiFont(codi);
            // El camp descripci es ja el camp en format enriquit.
            font.setDescripcio(descripcio);                    
            font.create();           
        }
        catch(Exception e)
        {
            throw new FontException(e.getMessage());
        }
    }
    
    /*
     *  Mtode que actualitza els valors d'una font de la BD.
     * 
     *  @param idFont:          Identificador de la font.
     *  @param codi:            Codi de la font.
     *  @param descripcio:      Descripci de la font. 
     */
    public void updateFont(String idFont,String codi,String descripcio) throws FontException
    {
        try
        {
            Fonts font=new Fonts();
            //Fonts font=null;
            Fonts fontSelected=(Fonts)font.findByPrimaryKey(idFont);
            fontSelected.setCodiFont(codi);
            fontSelected.setDescripcio(descripcio);
            fontSelected.flush();
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());
        }
    }
    
    /*
     *  Mtode que elimina una font de la BD.
     * 
     *  @param idFont:   Identificador de la font.
     */
    public void deleteFont(String idFont) throws FontException
    {
        try
        {
            Fonts font=new Fonts();
            Fonts fontSelected=(Fonts)font.findByPrimaryKey(idFont);
            fontSelected.remove();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            System.out.println("MESSAGE: "+e.getMessage());

            throw new FontException(e.getMessage());
        }
    }
    
    /*
     *  Mtode que obte TOTES les fonts disponibles a la BD.
     * 
     */
    public Vector getAllFonts() throws FontException
    {
        try
        {           
            Fonts font=new Fonts();
            Vector allFonts=font.findAll();

            return allFonts;              
        }
        catch(Exception e)
        {
            throw new FontException(e.getMessage());
        }   
    }  
    /*
     *  Mtode que obte TOTES les llengues disponibles a la BD.
     * 
     */
    public Vector getAllCodeIdFonts() throws FontException
    {
        try
        {           
            Fonts font=new Fonts();
            Vector v=font.findAllCodeIdFonts();
            Collections.sort(v,new TermcatComparator());
            return v;
        }
        catch(Exception e)
        {
            throw new FontException(e.getMessage());
        }   
    } 

    public String getRTFDescription(String idFont) throws FontException 
    {
       String descriptionRTF="";  
       try
        {
            Fonts font=new Fonts();
            Fonts fontSelected=(Fonts)font.findByPrimaryKey(idFont);
            descriptionRTF=fontSelected.getDescripcio();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            System.out.println("MESSAGE: "+e.getMessage());

            throw new FontException(e.getMessage());
        }        
       
       return descriptionRTF;
    }
    
    /*
     *      CO_FONTS_DENOMINACIONS
     */
    
    public void altaFontDenominacio(String idDenominacio, String idFont) throws FontException 
    {
        // Mirar de perque no ho fa be! Ja que mai ha de donar un idFont==null.
        if (idFont!=null)
        {
             FontsDenominacions font=new FontsDenominacions();
             font.setIdDenominacio(idDenominacio);

             font.setIdFont(idFont);
            try 
            {
                font.create();        
            }
            catch (CreateException ex) 
            {
               String error="[ERROR > altaFontDenominacio] IDDeno:"+idDenominacio+" idFont:"+idFont;
               System.out.println(error);                

//                String msgError=ex.getMessage();
//                if (!msgError.contains(PK_ERROR))
                    throw new FontException(ex.getMessage());                       
                
            }        
        }
    }     
    
    public void insertFontDenominacions(String idDenominacio, Vector v)
    {
        ItemListCustom item=new ItemListCustom();
        try
        {
            for(int i=0;i<v.size();++i)
            {
                item=(ItemListCustom)v.get(i);
                FontsDenominacions fontDenominacio=new FontsDenominacions();
                fontDenominacio.setIdDenominacio(idDenominacio);
                fontDenominacio.setIdFont(item.getId());
                fontDenominacio.create();
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    public Vector getFontsDenominacions(String idDenominacio) throws FontException 
    {
        try
        {
            FontsDenominacions fontDenominacio=new FontsDenominacions();
            return fontDenominacio.findFontsDenominacions(idDenominacio);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }
    }

    public void deleteFontDenominacions(String idDenominacio)  throws FontException 
    {
        FontsDenominacions fontDenominacio=new FontsDenominacions();
        try 
        {
            fontDenominacio.removeFontsDenominations(idDenominacio);
        } 
        catch (FinderException e) 
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }       
    }
    
    /*
     *      CO_FONTS_DEFINICIONS
     */
        public void altaFontDefinicions(String idDefinicio, String idFont) throws FontException 
        {
            if (idFont!=null)
            {
                 FontsDefinicions font=new FontsDefinicions();
                 font.setIdDefinicio(idDefinicio);
                 font.setIdFont(idFont);
                try 
                {
                    font.create();        
                }
                catch (CreateException ex) 
                {
//                    String msgError=ex.getMessage();
//                    if (!msgError.contains(PK_ERROR))
                        throw new FontException(ex.getMessage());                       
                }
            }
               
        }    
    
        public void insertFontDefinicions(String idDefinicio, Vector v) 
    {
        ItemListCustom item=new ItemListCustom();
        try
        {
            for(int i=0;i<v.size();++i)
            {
                item=(ItemListCustom)v.get(i);
                FontsDefinicions fontDefinicio=new FontsDefinicions();
                fontDefinicio.setIdDefinicio(idDefinicio);
                fontDefinicio.setIdFont(item.getId());
                fontDefinicio.create();
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public Vector getFontsDefinicions(String idDefinicio) throws FontException 
    {
        try
        {
            FontsDefinicions fontDefinicio=new FontsDefinicions();
            return fontDefinicio.findFontsDefinicions(idDefinicio);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }
    }

    public void deleteFontDefinicions(String idDefinicio) throws FontException 
    {
        FontsDefinicions fontDefinicio=new FontsDefinicions();
        try 
        {
            fontDefinicio.removeFontsDefinicions(idDefinicio);
        } 
        catch (FinderException e) 
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());                        
        }       
    }
    
    
    /*
     *      CO_FONTS_NOTES
     */
        public void altaFontNotes(String idNota, String idFont) throws FontException 
        {
             FontsNotes font=new FontsNotes();
             font.setIdNota(idNota);
             font.setIdFont(idFont);
            try 
            {
                font.create();        
            }
            catch (CreateException ex) 
            {
 //               String msgError=ex.getMessage();
//                if (!msgError.contains(PK_ERROR))
                    throw new FontException(ex.getMessage());                      
            }        
        }
        
     public void insertFontNotes(String idNota, Vector v) 
    {
        ItemListCustom item=new ItemListCustom();
        try
        {
            for(int i=0;i<v.size();++i)
            {
                item=(ItemListCustom)v.get(i);
                FontsNotes fontNota=new FontsNotes();
                fontNota.setIdNota(idNota);
                fontNota.setIdFont(item.getId());
                fontNota.create();
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }

    public Vector getFontsNotes(String idNota) throws FontException 
    {
        try
        {
            FontsNotes fontNota=new FontsNotes();
            return fontNota.findFontsNotes(idNota);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }
    }

    public void deleteFontNotes(String idNota) throws FontException 
    {
        FontsNotes fontNota=new FontsNotes();
        try 
        {
            fontNota.removeFontsNotes(idNota);
        } 
        catch (FinderException e) 
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }       
    }

     /*
     *      CO_FONTS_CONTEXTES
     */
    
        public void altaFontContextes(String idCtxt, String idFont) throws FontException 
        {
             FontsContextos font=new FontsContextos();
             font.setIdContext(idCtxt);
             font.setIdFont(idFont);
            try 
            {
                font.create();        
            }
            catch (CreateException ex) 
            {
//                String msgError=ex.getMessage();
//                if (!msgError.contains(PK_ERROR))
                    throw new FontException(ex.getMessage());                       
            }        
        }
        
        // Mirar d'aprofitar la nova funcio creada altaFontContextes()'
        public void insertFontContextes(String idCtxt, Vector v) 
        {
            ItemListCustom item=new ItemListCustom();
            try
            {
                for(int i=0;i<v.size();++i)
                {
                    item=(ItemListCustom)v.get(i);
                    FontsContextos font=new FontsContextos();
                    font.setIdContext(idCtxt);
                    font.setIdFont(item.getId());
                    font.create();
                }
            }
            catch(Exception e)
            {
                e.printStackTrace();
            }
        }

    public Vector getFontsContextes(String idCtxt) throws FontException 
    {
        try
        {
            FontsContextos font=new FontsContextos();
            return font.findFontsContextes(idCtxt);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }
    }

    public void deleteFontContextes(String id) throws FontException 
    {
        FontsContextos font=new FontsContextos();
        try 
        {
            font.removeFontsContextes(id);
        } 
        catch (FinderException e) 
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());            
        }       
    }
    
    
    //  -------------------------------------------------------------------------------
    //  -------------------------------------------------------------------------------   
    //                      Mtodes per a la funcionalitat d'EXPORT
    //  -------------------------------------------------------------------------------
    //  -------------------------------------------------------------------------------
    public void addAllFontsToXML(Element elem) throws FontException
    {
        try
        {           
            Fonts font=new Fonts();
            font.addAllToXml(elem);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());
        } 
    }


    public void addAllFontsDenominacionsToXML(Element elem, String idDiccionari) throws FontException 
    {
        try
        {           
            FontsDenominacions font=new FontsDenominacions();
            font.addAllOfDictionaryToXml(elem,idDiccionari);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());
        } 
    }

    public void addAllFontsDefinicionsToXML(Element elem, String idDiccionari) throws FontException 
    {
         try
        {           
            FontsDefinicions font=new FontsDefinicions();
            font.addAllOfDictionaryToXml(elem,idDiccionari);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());
        }        
    }

    public void addAllFontsContextesToXML(Element elem, String idDiccionari) throws FontException 
    {
        try
        {           
            FontsContextos font=new FontsContextos();
            font.addAllOfDictionaryToXml(elem,idDiccionari);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());
        }    
    }

    public void addAllFontsNotesToXML(Element elem, String idDiccionari) throws FontException 
    {
         try
        {           
            FontsNotes font=new FontsNotes();
            font.addAllOfDictionaryToXml(elem,idDiccionari);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new FontException(e.getMessage());
        } 
    }

    
    public void deleteAllFonts() throws FontException
    {
        String sql="delete from CO_FONTS";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new FontException(e.getMessage());
        }        
    }     

    public void deleteAllFontsContextos() throws FontException
    {
        String sql="delete from CO_FONTS_CONTEXTOS";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new FontException(e.getMessage());
        }        
    }     

    public void deleteAllFontsDefinicions() throws FontException
    {
        String sql="delete from CO_FONTS_DEFINICIONS";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new FontException(e.getMessage());
        }        
    }     

    public void deleteAllFontsDenominacions() throws FontException
    {
        String sql="delete from CO_FONTS_DENOMINACIONS";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new FontException(e.getMessage());
        }        
    }     
 
    public void deleteAllFontsNotes() throws FontException
    {
        String sql="delete from CO_FONTS_NOTES";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new FontException(e.getMessage());
        }        
    }      
}

