/*
 * FontManager.java
 *
 * Created on 18 de julio de 2007, 18:16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.maintenance.mark;

import com.termcat.business.exceptions.MarkException;
import com.termcat.bd.beans.MarquesP;
import com.termcat.util.UIDGenerator;
import electric.xml.Element;
import java.util.Iterator;
import java.util.Vector;
/**
 *
 * @author Mena
 */
public class MarkManager 
{
    
   private static MarkManager manager;
    
    /** Creates a new instance of DictionaryManager */
    private MarkManager() {}
    
    public static MarkManager getManager()
    {
        if(manager==null)
        {
            manager = new MarkManager();
        }
        return manager;
    }

    public void altaMarca(String idMarca, String codi, String descripcio) throws MarkException 
    {
        try
        {
            if (descripcio==null)
                descripcio="";

           // El cas de idMarca==null ja s'inserta al generar la BD mitjanant l'script.
            if(idMarca!=null && codi!=null)
            {
                MarquesP marca=new MarquesP();
                marca.setIdMarca(idMarca);  
                marca.setCodiMarca_p(codi);
                marca.setDescripcio(descripcio);         
                marca.create();           
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new MarkException(e.getMessage());
        }        
    }

    
    /*
     *  Mtode que inserta una nova marca a la BD.
     *  
     *  @param codi:         Codi de la marca que s'inserta
     *  @param descripcion:  Descripci de la marca que s'inserta.
     *
     */
    public void altaMarca(String codi,String descripcio) throws MarkException
    {       
        try
        {
            MarquesP marca=new MarquesP();
            marca.setIdMarca(UIDGenerator.generateUniqueId());  
            marca.setCodiMarca_p(codi);
            marca.setDescripcio(descripcio);         
            marca.create();           
        }
        catch(Exception e)
        {
            throw new MarkException(e.getMessage());
        }
    }
    
    /*
     *  Mtode que actualitza els valors d'una marca de la BD.
     * 
     *  @param idFont:          Identificador de la marca.
     *  @param codi:            Codi de la marca.
     *  @param descripcio:      Descripci de la marca. 
     */
    public void updateMarca(String idFont,String codi,String descripcio) throws MarkException
    {
        try
        {
            MarquesP marca=new MarquesP();
            MarquesP marcaSelected=(MarquesP)marca.findByPrimaryKey(idFont);
            marcaSelected.setCodiMarca_p(codi);
            marcaSelected.setDescripcio(descripcio);
            marcaSelected.flush();
        }
        catch(Exception e)
        {
            throw new MarkException(e.getMessage());
        }
    }
    
    /*
     *  Mtode que elimina una marca de la BD.
     * 
     *  @param idFont:   Identificador de la marca.
     */
    public void deleteMarca(String idFont) throws MarkException
    {
        try
        {
            MarquesP marca=new MarquesP();
            MarquesP marcaSelected=(MarquesP)marca.findByPrimaryKey(idFont);
            marcaSelected.remove();
        }
        catch (Exception e)
        {
            throw new MarkException(e.getMessage());
        }
    }
        
    /*
     *      Mtode que obte TOTES les marcas disponibles a la BD.
     */
    public Vector getAllMarques() throws MarkException
    {
        try
        {           
            MarquesP marca=new MarquesP();
            Vector allMarquesP=marca.findAll();

            return allMarquesP;              
        }
        catch(Exception e)
        {
            throw new MarkException(e.getMessage());
        }   
    }  
    
    /*
     *      Mtode que obte el codi de la categoria que te per idCategoria=@id
     *     Pot ser null.
     */
    public String getCodiMarca(String id) throws MarkException
    {
        String codiMarca=null;
        try
        {
            MarquesP marca=new MarquesP();
            MarquesP marcaSelected=(MarquesP)marca.findByPrimaryKey(id);
            codiMarca=marcaSelected.getCodiMarca_p();
        }
        catch(Exception e)
        {
            e.printStackTrace();
            //throw new MarkException(e.getMessage());            
        }
        return codiMarca;
    }

    /*
     *      Mtode que obt totes les marques de ponderaci de la BD.
     */
    public Vector getAllCodeIdMarques() throws Exception
    {
        try
        {           
            MarquesP marca=new MarquesP();
            Vector allMarquesP=marca.findAllMarquesCodes();
            return allMarquesP;              
        }
        catch(Exception e)
        {
            throw new MarkException(e.getMessage());
        }   
    }
    
    /*
     *    
     */
    public void addAllMarquesToXML(Element elem) throws MarkException
    {
        try
        {           
            MarquesP marca=new MarquesP();
            marca.addAllToXml(elem);
        }
        catch(Exception e)
        {
            throw new MarkException(e.getMessage());
        }   
    }  

    public void deleteAllMarques() throws MarkException
    {
        String sql="delete from CO_MARQUES_P";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new MarkException(e.getMessage());
        }        
    }     

}