/*
 * FontTableModel.java
 *
 * Created on 3 de septiembre de 2007, 12:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.arees;


import com.termcat.bd.beans.ArbreCamp;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Fonts;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;


/**
 *
 * @author Vazquezl
 */
public class AreaTableModel extends DefaultTableModel{
    
    private final Object[] columnNames = new String[]{"NOM_AREA", "NOMBRE_FITXES"};
    
        
    public AreaTableModel() {
        super();
        Vector <AreaStatitsData> statisticData = findStatisticData();
        if(statisticData.size()>0){
            Object [][] data = statisticDataToArray(statisticData);
            setDataVector(data,columnNames);
        }
    }
    
    private Vector<AreaStatitsData> findStatisticData(){
        Vector <AreaStatitsData> data = new  Vector<AreaStatitsData>();
        try{
            ArbreCamp arbreBean = new ArbreCamp();
            data = arbreBean.getAllNumFitxesGroupByArea(); 
            data = setNumFitxesWithoutArea(data);
            //data = arbreBean.getNumFitxesGroupByAreaForDiccionary("9a84fdda-44d2-11dc-98c8-5994d68b1ac3");
            
        }
        catch (Exception e){
           System.out.println("Error calculando estadisticas para areas tematicas. Fallo al acceder a BD"); 
           e.printStackTrace();
        }
        return data;
    }
    
    private Object[][] statisticDataToArray(Vector <AreaStatitsData> dataList){
        int dataNum = dataList.size();
        Object [][] statisticData = new Object[dataNum][columnNames.length];
        for(int i=0;i<dataNum;i++){
            AreaStatitsData data = dataList.get(i); 
            statisticData [i][0]=data.getnomArea() ;
            statisticData [i][1]=data.getNumFitxes();
        }
        return statisticData;
    }
    
    private Vector<AreaStatitsData> setNumFitxesWithoutArea(Vector<AreaStatitsData> dataList){
        String withoutAreaTittle = Literales.getTextForMessage("Areas_FichasSinArea");
        try{
            Fitxes fitxaBean = new Fitxes();
            String numFitxes = fitxaBean.getNumOfFixesWithoutArea();
            //String numFitxes = fitxaBean.getNumOfDicctionaryFixesWithoutArea("9a84fdda-44d2-11dc-98c8-5994d68b1ac3");
            //se aade uno vacio para separarlo de los otros en el listado
            AreaStatitsData voidItem = new AreaStatitsData();
            voidItem.setNomArea("");
            voidItem.setNumFitxes("");
            dataList.add(voidItem);
            
            AreaStatitsData item = new AreaStatitsData();
            item.setNomArea(withoutAreaTittle);
            item.setNumFitxes(numFitxes);
            dataList.add(item);
        }
        catch(Exception e ){
            System.out.println("Error calculando el numero de fichas sin area tematica asociada. Fallo al acceder a BD"); 
        }
        return dataList;
    }
}
