/*
 * DetailReportData.java
 *
 * Created on 17 de septiembre de 2007, 17:27
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fitxes;

import com.termcat.bd.beans.Categories;
import com.termcat.bd.beans.Context;
import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Jerarquies;
import com.termcat.bd.beans.LlenguesDiccionari;
import com.termcat.bd.beans.MarquesP;
import com.termcat.bd.beans.Notes;
import com.termcat.business.reports.ObjectStatistics;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.util.literales.Literales;
import java.awt.Font;
import java.awt.FontMetrics;
import java.util.Vector;
import javax.swing.JFrame;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableModel;




/**
 *
 * @author Vazquezl
 */
public class DetailReportData {
    
    private final String COLUMN_NAME_LANG_NAMES  = "LANG_NAMES"; 
    private final String COLUMN_NAME_NUM_DENOS  = "NUM_DENOMINACIONS";
    private final String COLUMN_NAME_MARCA_P = "MARQUES_LIST";
    private final String COLUMN_NAME_NUM_FITXES = "NUM_FITXES";
    protected static final String BLANCK_SPACE_FOR_TEXT ="                      ";
    protected static final String BLANCK_SPACE_FOR_NUMBER ="                       ";
    protected static final int ITEM_SIZE =45; 
    protected static final int TITLE_ITEM_SIZE =110; 
    
    private final static int TYPE_NO_ITEM = 0;
    private final static int TYPE_MAS_UNA_DEFINICION = 1;
    private final static int TYPE_MAS_UNA_NOTA = 2;
    private final static int TYPE_MAS_UN_CTX = 3;
    private final static int TYPE_FICHA_NO_DEFINICION = 4;
    private final static int TYPE_TOTAL_DEFINICION = 5;
    private final static int TYPE_TOTAL_DENOMINACION = 6;
    private final static int TYPE_TOTAL_NOTAS = 7;
    private final static int TYPE_TOTAL_CTX = 8;
    private final static int TYPE_FICHA_NO_NOTA = 9;
    private final static int TYPE_FICHA_NO_CTX = 10;
    
    private String dictionaryId = null;
    private Vector langList;

    
    public DetailReportData(String dictionaryId) {
        this.dictionaryId = dictionaryId;
        try{
            LlenguesDiccionari langDict = new LlenguesDiccionari();
            langList = langDict.findLlenguesOfDictionary(dictionaryId);
        }
        catch(Exception e){
            System.out.println("Fatal Error obteniendo datos para detalle de estadisticas: idiomas del diccionario!!");
            e.printStackTrace();
        }
    }
    
    
   
    public TableModel getTableModel (){
         
        DefaultTableModel detailModel = new DefaultTableModel();
        Object []dataMarcas = findMarquesPonderacio();
        detailModel.addColumn(COLUMN_NAME_MARCA_P,dataMarcas);
        return detailModel;
    }
    
    public String findDenoValues(){
        Denominacions denoBean = new Denominacions();
        String denoSt = null;
        String [] result = new String [1];
        try{
            Vector <ObjectStatistics> countDenoList = denoBean.findAllNumDenominationsGroupByLlengues(dictionaryId);
            denoSt = getItemStatistictLikeStrig(TYPE_TOTAL_DENOMINACION,countDenoList);
        }
        catch (Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas de denominaciones para fichas!!");
            e.printStackTrace();
        }
        return denoSt;
    }
    
    public String findNumFitxes (){
        String numFitxes  = "0";
        Fitxes fitxa = new Fitxes();
        try{
            numFitxes = fitxa.getNumFixesDictionaryByCriterion(Fitxes.ALL_FITXES_CRITERION,this.dictionaryId);
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: numero de fichas!!");
            e.printStackTrace();
        }
        return numFitxes;
    }
    
    public String findtLlenguesDiccitionary (){
        String langsSt  = "";
        int size = langList.size();
        for (int i=0;i<size;i++){
            ItemListCustom lang = (ItemListCustom)langList.get(i);
            langsSt = langsSt+padString(lang.getNom(),ITEM_SIZE);
            if(i<size-1) langsSt = langsSt+BLANCK_SPACE_FOR_TEXT;
        }
        return langsSt;
    }
    
   
    public String [] findMarquesPonderacio (){
        String [] result = null;
        MarquesP marquesBean = new MarquesP();
        Denominacions denoBean = new Denominacions();
        try{
            Vector <ObjectStatistics> marquesPlist = marquesBean.findAllDictionaryMarquesGroupByLangs(this.dictionaryId);
            StatisticRowManager rowMgr = new StatisticRowManager(marquesPlist,langList,StatisticRowManager.TYPE_MARCA);
            Vector <ObjectStatistics> denoWithoutMarca = denoBean.findAllNumDenoWithoutMarcaPGroupByLlengues(dictionaryId);
            
            String [] denoWithMarca = rowMgr.getAllItemsLikeStringArray();
            String numDenoNoMarca = buildSingleLine(denoWithoutMarca,TYPE_NO_ITEM);
            numDenoNoMarca =padString(Literales.getTextForMessage("Fichas_FichasSinMarca"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+numDenoNoMarca; 
            result = concatElementToArry(denoWithMarca,numDenoNoMarca);

        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: marcas de ponderacio!!");
            e.printStackTrace();
        }
        
        return result;
    }
    
    
    public String [] findCategories (){
        String [] result = null;
        Categories categoriesBean = new Categories();
        Denominacions denoBean = new Denominacions();
        try{
            Vector <ObjectStatistics> categlist = categoriesBean.findAllDictionaryCategoriesGroupByLangs(this.dictionaryId);
            StatisticRowManager rowMgr = new StatisticRowManager(categlist,langList,StatisticRowManager.TYPE_CATEGORIA);
            String [] denoWhitCateg = rowMgr.getAllItemsLikeStringArray();
            Vector <ObjectStatistics> denoWithoutCategoria = denoBean.findAllNumDenoWithoutMarcaPGroupByLlengues(dictionaryId);
            String numDenoNoCateg = buildSingleLine(denoWithoutCategoria,TYPE_NO_ITEM);
            numDenoNoCateg =padString(Literales.getTextForMessage("Fichas_FichasSinCateg"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+numDenoNoCateg; 
            result = concatElementToArry(denoWhitCateg,numDenoNoCateg);
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: categries!!");
            e.printStackTrace();
        }
        return result;
    }

    public String [] findJerarquies (){
        String [] result = null;
        Jerarquies jerarquiesBean = new Jerarquies();
        Denominacions denoBean = new Denominacions();
        try{
            Vector <ObjectStatistics> jerarquiaList = jerarquiesBean.findAllDictionaryJerarquiesGroupByLangs(this.dictionaryId);
            StatisticRowManager rowMgr = new StatisticRowManager(jerarquiaList,langList,StatisticRowManager.TYPE_JERARQUIA);
            String [] denoWhitJer = rowMgr.getAllItemsLikeStringArray();
            Vector <ObjectStatistics> denoWithoutJerarquia = denoBean.findAllNumDenoWithoutJerarquiaGroupByLlengues(dictionaryId);
            String numDenoNoJer = buildSingleLine(denoWithoutJerarquia,TYPE_NO_ITEM);
            numDenoNoJer =padString(Literales.getTextForMessage("Fichas_FichasSinJer"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+numDenoNoJer; 
            result = concatElementToArry(denoWhitJer,numDenoNoJer);
            
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: jerarquies!!");
            e.printStackTrace();
        }
        return result;
    }
    
    public String  findNumTotalDefinicions (){
        String result = null;
        Definicions defBean = new Definicions();
        try{
            Vector <ObjectStatistics> defList = defBean.findAllNumDefinitionsGroupByLlengues(this.dictionaryId);
            result= getItemStatistictLikeStrig(TYPE_TOTAL_DEFINICION,defList);
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: num total definicions!!");
            e.printStackTrace();
        }
        return result;
    }

    public String  findNumFitxasMasUnaDefinicions (){
        String result = null;
        Definicions defBean = new Definicions();
        try{
            Vector <ObjectStatistics> masUnaDefList = defBean.findAllNumFichasMasUnaDef(this.dictionaryId);
            result = buildSingleLine(masUnaDefList,TYPE_MAS_UNA_DEFINICION);
            result = padString(Literales.getTextForMessage("Fichas_MasDeUnaFicha"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+result; 
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: num fichas mas de una definicions!!");
            e.printStackTrace();
        }
        return result;
    }

    public String  findNumFitxasNoDefinicions (){
        String result = null;
        Fitxes fitxesBean = new Fitxes();
        try{
            Vector <ObjectStatistics> noDefList= fitxesBean.findAllNumFitxesWhitoutDefinitionsGroupByLlengues(this.dictionaryId);
            result = buildSingleLine(noDefList,TYPE_FICHA_NO_DEFINICION);
            result = padString(Literales.getTextForMessage("Fichas_FichasSinDef"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+result; 
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: num fichas mas de una definicions!!");
            e.printStackTrace();
        }
        return result;
    }
    
    public String  findNumTotalNotes (){
        String result = null;
        Notes notesBean = new Notes();
        try{
            Vector <ObjectStatistics> notesList = notesBean.findAllNumNotesGroupByLlengues(this.dictionaryId);
            result= getItemStatistictLikeStrig(TYPE_TOTAL_NOTAS,notesList);
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: notes!!");
            e.printStackTrace();
        }
        return result;
    }

    public String  findNumFichasMasUnaNota (){
        String result = null;
        Notes notesBean = new Notes();
        try{
            Vector <ObjectStatistics> masUnaNotaList = notesBean.findAllNumFichasMasUnaNota(this.dictionaryId);
            result = buildSingleLine(masUnaNotaList,TYPE_MAS_UNA_NOTA);
            result = padString(Literales.getTextForMessage("Fichas_MasDeUnaFicha"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+result; 
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: notes!!");
            e.printStackTrace();
        }
        return result;
    }

    public String  findNumFichasNoNota (){
        String result = null;
        Fitxes fitxesBean = new Fitxes();
        try{
            Vector <ObjectStatistics> noNoteList= fitxesBean.findAllNumFitxesWhitoutNotesGroupByLlengues(this.dictionaryId);
            result = buildSingleLine(noNoteList,TYPE_FICHA_NO_NOTA);
            result = padString(Literales.getTextForMessage("Fichas_FichasSinNota"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+result; 
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: notes!!");
            e.printStackTrace();
        }
        return result;
    }
    
    public String  findNumTotalContexts (){
        String result = null;
        Context contextBean = new Context();
        try{
            Vector <ObjectStatistics> contextList = contextBean.findAllNumContextGroupByLlengues(this.dictionaryId);
            result= getItemStatistictLikeStrig(TYPE_TOTAL_CTX,contextList);
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: Context!!");
            e.printStackTrace();
        }
        return result;
    }

    public String  findNumFichasMasUnCtx (){
        String result = null;
        Context contextBean = new Context();
        try{
            Vector <ObjectStatistics> masUnCtxList = contextBean.findAllNumFichasMasUnContext(this.dictionaryId);
            result = buildSingleLine(masUnCtxList,TYPE_MAS_UN_CTX);
            result = padString(Literales.getTextForMessage("Fichas_MasDeUnaFicha"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+result; 
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: Context!!");
            e.printStackTrace();
        }
        return result;
    }

    public String  findNumFichasNoCtx (){
        String result = null;
        Fitxes fitxesBean = new Fitxes();
        try{
            Vector <ObjectStatistics> noTxtList= fitxesBean.findAllNumFitxesWhitoutCtxGroupByLlengues(this.dictionaryId);
            result = buildSingleLine(noTxtList,TYPE_FICHA_NO_CTX);
            result = padString(Literales.getTextForMessage("Fichas_FichasSinCtx"),TITLE_ITEM_SIZE-1)+BLANCK_SPACE_FOR_NUMBER+result; 
        }
        catch(Exception e){
            System.out.println("Error obteniendo datos para detalle de estadisticas: Context!!");
            e.printStackTrace();
        }
        return result;
    }
    
    
    private String getItemStatistictLikeStrig(int type,Vector <ObjectStatistics> countDenoList){
     String result = "";
     int size = countDenoList.size();
     for (int i = 0;i<size;i++){
        ObjectStatistics stObject =  countDenoList.get(i);
        result = result+padString(getNumberForType(type,stObject) ,ITEM_SIZE);
        if(i<size-1) result = result+BLANCK_SPACE_FOR_NUMBER;
     }
     return result;
    }
    
    private void printobjet(Vector <ObjectStatistics> objList){
        for(int i=0;i<objList.size();i++){
            ObjectStatistics obj = objList.get(i);
            System.out.println(obj.toString());
        }
        
    }
   
    protected static String padString(String cad,int limit){
        int size = determineStringFontSize(cad);
        if(size>=limit) return cad;
        int incrementSize = (limit-size)/3;
        for(int i=0;i<incrementSize;i++){
            cad = cad+" ";
        }
         return cad;
    }

    private static int determineStringFontSize(String text){
	Font font = new Font("SansSerif", Font.PLAIN,10);
	FontMetrics fontMetrics = com.termcat.layout.MainFrame.getFrames()[0].getGraphics().getFontMetrics(font);
	return fontMetrics.stringWidth(text);
    }

    
    /**
     * Construye una linea del informe con las estadisticas que se le pasan y el tipo de estas
     **/
    private String buildSingleLine(Vector <ObjectStatistics> denoWithoutItem, int type){
        String result = "";    
        int size = langList.size();
        for(int i=0;i<langList.size();i++){
            String itemCount="0";
            ItemListCustom lang = (ItemListCustom)langList.get(i);
            String langId = lang.getId();
            ObjectStatistics objStat = getItemForLang(denoWithoutItem,langId);
            if(objStat!=null){
              itemCount =  getNumberForType(type,objStat); 
            }
            result = result+padString(itemCount,ITEM_SIZE);
            if(i<size-1) result = result+BLANCK_SPACE_FOR_NUMBER;

        }
        return result;
    }
    
    private String getNumberForType(int type,ObjectStatistics objetcSt){
        String result="0";
        switch (type){
            case TYPE_NO_ITEM: result = objetcSt.getNumberNoAssignedAttribute();break;
            case TYPE_MAS_UNA_DEFINICION: result = objetcSt.getNumFitxasMasDeUnaDef();break;
            case TYPE_MAS_UNA_NOTA: result = objetcSt.getNumFitxasMasDeUnaNota ();break;
            case TYPE_MAS_UN_CTX: result = objetcSt.getNumFitxaMasDeUnCtx();break; 
            case TYPE_FICHA_NO_DEFINICION: result = objetcSt.getNumFitxasWithoutDef();break;
            case TYPE_TOTAL_DENOMINACION: result = objetcSt.getNumberDenominations();break; 
            case TYPE_TOTAL_DEFINICION: result = objetcSt.getNumberDefinitions();break;        
            case TYPE_TOTAL_NOTAS: result = objetcSt.getNumberNotes();break;
            case TYPE_TOTAL_CTX: result = objetcSt.getNumberContext();break; 
            case TYPE_FICHA_NO_NOTA: result = objetcSt.getNumFitxasWithoutNote ();break;
            case TYPE_FICHA_NO_CTX: result = objetcSt.getNumFitxaWithoutCtx ();break;
        }
        
        return result;
    }
    
    private ObjectStatistics getItemForLang( Vector <ObjectStatistics> itemList, String langId){
        ObjectStatistics result = null;
        for(int i=0;i<itemList.size();i++){
            ObjectStatistics objStat = itemList.get(i);
            if(langId.equals(objStat.getidLlengua())){
                result = objStat;
                break;
            }
        }
        return result;
    }
    
    private String [] concatElementToArry(String [] array, String element){
            int numTotal = array.length+1;
            String [] total = new String[numTotal];
            System.arraycopy(array,0,total,0,numTotal-1);
            total[numTotal-1]=element;
            return total;
    }
    
    public static void main (String [] args){
        DetailReportData detail = new DetailReportData("9a84fdda-44d2-11dc-98c8-5994d68b1ac3");
        System.out.println(detail.determineStringFontSize(" "));
    }
}
