/*
 * FitxaReportManager.java
 *
 * Created on 28 de septiembre de 2007, 12:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fitxes;

import com.termcat.business.reports.ReportLauncher;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import com.termcat.layout.FunctionalModule;
import com.termcat.util.literales.Literales;
import com.termcat.business.reports.llistat.LlistatReportManager;

import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Locale;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.data.JRTableModelDataSource;
import net.sf.jasperreports.view.JasperViewer;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;


import com.termcat.bd.utils.DBConnect;
import java.sql.Connection;


/**
 *
 * @author Vazquezl
 */
public class FitxaReportManager {
    
    private String idDicctionary;
    private String itemId;
    private String lagName;
    private DetailReportData reportData;
    
    
    public FitxaReportManager(String idDicctionary) {
        this.idDicctionary = idDicctionary;
        new ReportLauncher().InitReportSystem();
        reportData = new DetailReportData(idDicctionary);
    }
    
 
    public void  viewFitxaReport() {
	new Thread() {
	    public void run() {
		buildReport();
	    }
	}.start();
    }    
    private void buildReport(){
        JDialog dialog = showInfoMessage();
        String resourceName = "/com/termcat/business/reports/fitxes/fichas.jasper";
        String resourceSubreport = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle.jasper";
        String resourceSubreportMarcas = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle_subreport0.jasper";
        String resourceSubreportCateg = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle_Categorias.jasper";
        String resourceSubreportJer = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle_Jerarquias.jasper";
        String resourceSubreportDef = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle_Definiciones.jasper";
        String resourceSubreportNotas = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle_Notas.jasper";
        String resourceSubreportCtx = "/com/termcat/business/reports/fitxes/fichas_subreportDetalle_Ctx.jasper";
 
        try{
            
            JasperReport report = compileReport(resourceName);
            JasperReport subReport = compileReport(resourceSubreport);
            JasperReport subReportMarcas = compileReport(resourceSubreportMarcas);
            JasperReport subReportCateg = compileReport(resourceSubreportCateg);
            JasperReport subReportJer = compileReport(resourceSubreportJer);
            JasperReport subReportDef = compileReport(resourceSubreportDef);
            JasperReport subReportNotas = compileReport(resourceSubreportNotas);
            JasperReport subReportCtx = compileReport(resourceSubreportCtx);
            
            HashMap params = new HashMap();
            params.put("TITULO_INFORME",Literales.getTextForMessage("Fichas_Titulo"));
            params.put("SUBTITULO_PARAMETRO",Literales.getTextForMessage("Fichas_Parametro"));
            params.put("SUBTITULO_NOMBRE",Literales.getTextForMessage("Fichas_Num"));
            
            params.put("DETALLE_DATASOURCE",new JRBeanCollectionDataSource(getDetaillData()));
            params.put("SUBREPORT_DETALLE",subReport);
            
            params.put("NUM_TOTAL_FICHAS",reportData.findNumFitxes());
            
            params.put("SUBREPORT_MARCAS",subReportMarcas);
            params.put("MARCAS_DATASOURCE",new JRBeanCollectionDataSource(getMarcalData()));
            
            params.put("SUBREPORT_CATEG",subReportCateg);
            params.put("CATEG_DATASOURCE",new JRBeanCollectionDataSource(getCategData()));

            params.put("SUBREPORT_JER",subReportJer);
            params.put("JER_DATASOURCE",new JRBeanCollectionDataSource(getJerarquiaData()));
            
            params.put("LISTA_IDIOMAS",reportData.findtLlenguesDiccitionary());
            params.put("DENOMINACIONS",reportData.findDenoValues());
            
            params.put("SUBREPORT_DEF",subReportDef);
            params.put("TOTAL_DEFINICIONS",reportData.findNumTotalDefinicions());
            params.put("DEF_MAS_UNA_FICHA",reportData.findNumFitxasMasUnaDefinicions());
            params.put("DEF_NO_FICHA",reportData.findNumFitxasNoDefinicions());
            
            params.put("SUBREPORT_NOTAS",subReportNotas);
            params.put("TOTAL_NOTAS",reportData.findNumTotalNotes()); 
            params.put("NOTA_MAS_UNA_FICHA",reportData.findNumFichasMasUnaNota());
            params.put("NOTA_NO_FICHA",reportData.findNumFichasNoNota());

            params.put("SUBREPORT_CTX",subReportCtx);
            params.put("TOTAL_CTX",reportData.findNumTotalContexts()); 
            params.put("CTX_MAS_UNA_FICHA",reportData.findNumFichasMasUnCtx());
            params.put("CTX_NO_FICHA",reportData.findNumFichasNoCtx());
           
            
            JasperPrint printer = JasperFillManager.fillReport(report, params,new JRTableModelDataSource(new FitxaTableModel(idDicctionary)));

           
            JasperViewer.viewReport(printer,false,LlistatReportManager.LOCALE);
            
        }
        catch(JRException e){
            System.out.println("Error al general el listado");
            e.printStackTrace();
        }
        catch(IOException ioe){
            System.out.println("Error al buscar los ficheros de definicion del listado");
            ioe.printStackTrace();
        }
        finally{
            dialog.setVisible(false);
        }
    }
    
    
    private JasperReport compileReport(String resourceReportName) throws JRException, IOException{
            JasperReport report = (JasperReport) net.sf.jasperreports.engine.util.JRLoader.loadObject(getClass().getResourceAsStream(resourceReportName));
            return report;
    } 
    
    private Vector getFichasList(int reportType){
        FitxaSortableList fitxSortable=null;
        fitxSortable= new FitxaSortableList(this.idDicctionary,this.itemId,reportType); 
        return fitxSortable.getFixesList();
    }

     private synchronized JDialog showInfoMessage() {
       JOptionPane pane = new JOptionPane(Literales.getTextForMessage("Listado_CargandoListado"),JOptionPane.INFORMATION_MESSAGE);
       ImageIcon icon = new ImageIcon(this.getClass().getResource("/com/termcat/resources/img/loader.gif"));
       pane.setIcon(icon);
       JDialog dialog = pane.createDialog(null, Literales.getTextForMessage("Listado_Titulo"));
       dialog.setModal(false);
       dialog.setVisible(true);
       return dialog;
    }
    
    
    private Vector getDetaillData(){
        Vector result = new Vector();
        String dummy = "DENOMINACIONS                           1111       111";
        FichaItem fItem = new FichaItem();
        fItem.setInformeItem(dummy);
        
        result.add(fItem);
        return result;
    } 
    
    private Vector getMarcalData(){
        String [] marcasList = reportData.findMarquesPonderacio();
        return converArrayToItemVector(marcasList);
    }
    
    private Vector getCategData(){
        String [] categList = reportData.findCategories();
        return converArrayToItemVector(categList);
    }     
    
    private Vector getJerarquiaData(){
        String [] jerList = reportData.findJerarquies();
        return converArrayToItemVector(jerList);
    }     
    
    private Vector converArrayToItemVector(String [] array){
        Vector result = new Vector();
        for(int i=0;i<array.length;i++){
            FichaItem fItem = new FichaItem();
            fItem.setInformeItem(array[i]);
            result.add(fItem);
        }
        return result;
    }
    
    public static void main (String [] args){
        new FitxaReportManager("9a84fdda-44d2-11dc-98c8-5994d68b1ac3").viewFitxaReport();
    }

    public class FichaItem {
        private String item;
        
        public FichaItem(){
        }

        public void setInformeItem(String item){
            this.item = item;
        }
        
        public String getInformeItem(){
            return item;
        }
    }
    
}


