/*
 * FontTableModel.java
 *
 * Created on 3 de septiembre de 2007, 12:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fitxes;


import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.LlenguesDiccionari;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;


/**
 *
 * @author Vazquezl
 */
public class FitxaTableModel extends DefaultTableModel{
    
    public final static int GENERAL_INFO_OPTION = 0;
    public final static int DETAIL_INFO_OPTION = 1;
    
    private final static int NUM_PARAMETRES = 6;
    
    private final Object[] columnNames = new String[]{"PARAMETRES", "NOMBRE_FITXES_PARAMETRE"};
    private String dictionaryId= null;
    
        
    public FitxaTableModel(String dictionaryId) {
        super();
        this.dictionaryId = dictionaryId;
        Object [][] data = null;
        data = getDataForGeneralReport();
        if(data!=null){
           setDataVector(data,columnNames);
         }  
    }
    
    private Object[][] getDataForGeneralReport(){
        Fitxes fitxa = new Fitxes();
        Object [][] result = null;
        try{
            String numFitxes = fitxa.getNumFixesDictionaryByCriterion(Fitxes.ALL_FITXES_CRITERION,dictionaryId);
            String numFitxesWithArea = fitxa.getNumFixesDictionaryByCriterion(Fitxes.FITXES_WITH_AREA_CRITERION,dictionaryId);
            String numFitxesWithDef = fitxa.getNumFixesDictionaryByCriterion(Fitxes.FITXES_WITH_DEFINITION_CRITERION,dictionaryId);
            String numFitxesWithNote = fitxa.getNumFixesDictionaryByCriterion(Fitxes.FITXES_WITH_NOTES_CRITERION,dictionaryId);
            String numFitxesWithObs = fitxa.getNumFixesDictionaryByCriterion(Fitxes.FITXES_WITH_OBSERVATION_CRITERION,dictionaryId);
            String numFitxesWithContext = fitxa.getNumFixesDictionaryByCriterion(Fitxes.FITXES_WITH_CONTEXT_CRITERION,dictionaryId);
            Vector <ItemListCustom> langsFitxa = getLangsData();
            int numLangs = langsFitxa.size();
            result = new Object[NUM_PARAMETRES+numLangs][columnNames.length];
           
            result [0][0] = Literales.getTextForMessage("Fichas_FichasTotal");
            result [0][1] = numFitxes;
            result [1][0] = Literales.getTextForMessage("Fichas_FichasConArea");
            result [1][1] = numFitxesWithArea;
            result [2][0] = Literales.getTextForMessage("Fichas_FichasDefinicion");
            result [2][1] = numFitxesWithDef;
            result [3][0] = Literales.getTextForMessage("Fichas_FichasNota");
            result [3][1] = numFitxesWithNote;
            result [4][0] = Literales.getTextForMessage("Fichas_FichaObserv");
            result [4][1] = numFitxesWithObs;
            result [5][0] = Literales.getTextForMessage("Fichas_FichaContx");
            result [5][1] = numFitxesWithContext;
            for (int i=0;i<numLangs;i++){
               ItemListCustom lang = langsFitxa.get(i);
               result [i+(NUM_PARAMETRES-1)][0]= Literales.getTextForMessage("Fichas_FichasIdioma")+" "+lang.getNom();
               result [i+(NUM_PARAMETRES-1)][1] = lang.getNumFitxes();
            }
        }
        catch (Exception e){
            System.out.println("Error al obtener las estadisticas de fichas!!");
            e.printStackTrace();        
        }
        return result;
    }
    
    private Vector getLangsData(){
        Vector <ItemListCustom>result = new Vector<ItemListCustom>();
         try{
            LlenguesDiccionari langDictionary = new LlenguesDiccionari();
            Vector llenguesDictionaryList = langDictionary.findLlenguesOfDictionary(dictionaryId);
            for (int i=0;i<llenguesDictionaryList.size();i++){
                ItemListCustom lang = (ItemListCustom)llenguesDictionaryList.get(i);
                Fitxes fitxa = new Fitxes();
                lang.setNumFitxes(fitxa.getNumFitxesDictionaryWithlang(dictionaryId,lang.getId()));
                result.add(lang);
            }
         }
         catch (Exception e){
             System.out.println("Error obteniendo las estadisticas de idiomas para fichas");
             e.printStackTrace();
         }
        return result;
    }
}
