/*
 * StatisticRowManager.java
 *
 * Created on 19 de septiembre de 2007, 15:20
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fitxes;

import com.termcat.business.reports.ObjectStatistics;
import com.termcat.layout.commons.lists.ItemListCustom;
import java.util.Hashtable;
import java.util.Vector;

/**
 *
 * @author Vazquezl
 */


public class StatisticRowManager {

    private Vector langList;
    private Vector <ObjectStatistics> itemStatisticsList;
    private Hashtable <String,AtributeItem>itemsProcessed;
    private Vector <String> itempProcessedIds;
    
    private int statisticType;
    
    public final static int TYPE_MARCA = 0;
    public final static int TYPE_CATEGORIA = 1;
    public final static int TYPE_JERARQUIA = 2;
    
    public StatisticRowManager(Vector <ObjectStatistics> itemStatisticsList,Vector langList, int statisticType) {
        this.langList = langList;
        this.itemStatisticsList = itemStatisticsList;
        this.statisticType = statisticType;
        buildAllItems();
        
    }
    
    
    private void buildAllItems(){
        itemsProcessed = new Hashtable<String,AtributeItem>();
        itempProcessedIds = new Vector<String>();
        for(int i=0;i<itemStatisticsList.size();i++){
            ObjectStatistics objetcSt = itemStatisticsList.get(i);
            String idItem = findId(objetcSt);
            AtributeItem atItem = null;
            if(!itemsProcessed.containsKey(idItem)){
               atItem = new AtributeItem(idItem);
               itempProcessedIds.add(idItem);
            }
            else{
                atItem = itemsProcessed.get(idItem);
            }
            atItem.addLangItemCount(objetcSt.getidLlengua(),findNumElement(objetcSt));
            itemsProcessed.put(idItem,atItem);
        }

    }
    
    public String[] getAllItemsLikeStringArray(){
        int size = itempProcessedIds.size();
        String [] result = new String[size];
        for(int i=0;i<size;i++){
          String itemId =  itempProcessedIds.get(i);
          AtributeItem atItem = itemsProcessed.get(itemId);
          result[i]=atItem.toString();
        }
        return result;
    }
    
    
    private String findId(ObjectStatistics objetcSt){
        String result = null;
        switch (statisticType){
            case TYPE_MARCA: result = objetcSt.getCodiMarcaP();break;
            case TYPE_CATEGORIA: result = objetcSt.getCodiCategoria();break;
            case TYPE_JERARQUIA: result = objetcSt.getCodiJerarquia();break;
        }
       return result; 
    }

    private String findNumElement(ObjectStatistics objetcSt){
        String result = null;
        switch (statisticType){
            case TYPE_MARCA: result = objetcSt.getNumberMarquesP();break;
            case TYPE_CATEGORIA: result = objetcSt.getNumberCategorias() ;break;
            case TYPE_JERARQUIA: result = objetcSt.getNumberJerarquias();break;
        }
       return result; 
    }
    
    private  class AtributeItem {
     
        private String itemId;
        private Hashtable <String,String> langItemCount;
        //private Vector <ObjectStatistics> itemStatisticsList;
        
        
        public AtributeItem(String itemId){
            this.itemId = itemId;
            this.langItemCount = new Hashtable<String,String>();
        }
        
        
        public void addLangItemCount(String langId,String itemCount){
            langItemCount.put(langId,itemCount);
        }
        
        public Hashtable <String,String> getLangItemCount(){
            return this.langItemCount;
        }
        
        public String toString(){
            String result = DetailReportData.padString(itemId,DetailReportData.TITLE_ITEM_SIZE)+DetailReportData.BLANCK_SPACE_FOR_NUMBER;
            int size = langList.size();
            for(int i=0;i<langList.size();i++){
                ItemListCustom lang = (ItemListCustom)langList.get(i);
                String langId = lang.getId();
                String langCount = langItemCount.get(langId);
                if (langCount==null)langCount="0";
                result = result+DetailReportData.padString(langCount,DetailReportData.ITEM_SIZE);
                if(i<size-1) result = result+DetailReportData.BLANCK_SPACE_FOR_NUMBER;
            }
            return result;
        }
        /*public void setLangItemCount(Hashtable <String,String> langItemCount){
             this.langItemCount = langItemCount;
        }*/
        
        
   }
    
 }

