/*
 * FontStatisticData.java
 *
 * Created on 6 de septiembre de 2007, 15:57
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fonts;

 import com.termcat.bd.beans.Definicions;
 import com.termcat.bd.beans.Denominacions;
 import com.termcat.bd.beans.Notes;
 import com.termcat.bd.beans.Context;
 import com.termcat.bd.beans.Fonts;
import com.termcat.business.reports.ObjectStatistics;
 
 import java.util.Vector;
 import java.util.Hashtable;
/**
 *
 * @author Vazquezl
 */
public class FontStatisticData {
    
    private Hashtable <String,ObjectStatistics> allRowData;
    
    public FontStatisticData() {
        allRowData = new Hashtable();
    }
    
    public  Vector<ObjectStatistics> getAllStatisticData(){
        Vector <ObjectStatistics>result = new Vector<ObjectStatistics>();
        try{
            Vector <ObjectStatistics> definitionsData = new Definicions().findAllDefiniciosGroupByFontsAndLlengues();
            Vector <ObjectStatistics> denominationData = new Denominacions().findAllDenominationsGroupByFontsAndLlengues();
            Vector <ObjectStatistics> notesData = new Notes().findAllNotesGroupByFontsAndLlengues();
            Vector <ObjectStatistics> contextData = new Context().findAllContextGroupByFontsAndLlengues();
            setStatisticDataFromVector(definitionsData);
            setStatisticDataFromVector(denominationData);
            setStatisticDataFromVector(notesData);
            setStatisticDataFromVector(contextData);
            Vector <String> orderFontsCodeList = new Fonts().findAllOrderFontsCode();
            for(int i =0;i<orderFontsCodeList.size();i++){
                String fontCodeAndLang = orderFontsCodeList.get(i);
                ObjectStatistics dataStatistic = allRowData.get(fontCodeAndLang);
                if(dataStatistic!=null){
                    result.add(dataStatistic);
                }
                else{
                    //por el momento no tenemos en cuenta las fuentes que tienen todas sus estadisticas para
                    //un determinado idioma a cero
                }
            }
        }
        catch(Exception e){
            System.out.println("Error calculando estadisticas para fuente. Fallo al acceder a BD");
            e.printStackTrace();
        }
        return result;
    }
    
    private  void setStatisticDataFromVector (Vector<ObjectStatistics> data){
       for(int i=0;i<data.size();i++){
           ObjectStatistics simpleStatistic = data.get(i);
           String key = simpleStatistic.getCodiFont()+"_"+simpleStatistic.getidLlengua();
           ObjectStatistics rowData = allRowData.get(key);
           if(rowData==null){
               rowData = simpleStatistic;
           }
           else{
               if(simpleStatistic.getNumberDefinitions()!=null){
                   rowData.setNumberDefinitions(simpleStatistic.getNumberDefinitions());
               }
               else if(simpleStatistic.getNumberDenominations()!=null){
                   rowData.setNumberNumberDenominations(simpleStatistic.getNumberDenominations());
               }
               else if(simpleStatistic.getNumberNotes()!=null){
                   rowData.setNumberNotes(simpleStatistic.getNumberNotes());
               }
               else if(simpleStatistic.getNumberContext()!=null){
                   rowData.setNumberContext(simpleStatistic.getNumberContext());
               }
           }
           allRowData.put(key,rowData);
       }    
    }   
}
