/*
 * FontTableModel.java
 *
 * Created on 3 de septiembre de 2007, 12:44
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fonts;


import com.termcat.bd.beans.Fonts;
import com.termcat.layout.FunctionalModule;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;


/**
 *
 * @author Vazquezl
 */
public class FontTableModel extends DefaultTableModel{
    
    final Object[] columnNames = new String[]{"CODI_FONT", "DESCRIPCIO"};
    private boolean showCode;
    
    public FontTableModel(boolean showCode) {
        super();
        this.showCode = showCode;
        Vector allFonts = findAllFonts();
        if(allFonts.size()>0){
            Object [][] fontsData = fontListToArray(allFonts);
            setDataVector(fontsData,columnNames);
        }
    }
    
    private Vector findAllFonts(){
        Vector fontList = new Vector();
        Fonts fontBean = new Fonts();
        try{
            fontList = fontBean.findAllSorted();
        }
        catch(Exception e){
            System.out.println("Error al obtener listado de fuentes");
            e.printStackTrace();
        }
        return fontList;
    }
    
    private Object[][] fontListToArray(Vector fontList){
        int fontsNum = fontList.size();
        Object [][] fontsData = new Object[fontsNum][columnNames.length];
        for(int i=0;i<fontsNum;i++){
            Fonts font = (Fonts)fontList.get(i); 
            if(showCode)fontsData [i][0]= font.getCodiFont();
            try{
                fontsData [i][1]=  FunctionalModule.convertRTF2Text(font.getDescripcio());
            }catch(Exception e){
                e.printStackTrace();
                fontsData [i][1] = "";
            }    
        }
        return fontsData;
    }
}
