/*
 * FontsReportManager.java
 *
 * Created on 28 de septiembre de 2007, 12:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fonts;

import com.termcat.business.reports.ReportLauncher;
import com.termcat.business.reports.llistat.LlistatReportManager;

import com.termcat.layout.FunctionalModule;
import com.termcat.util.literales.Literales;


import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.Locale;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.engine.data.JRTableModelDataSource;
import net.sf.jasperreports.view.JasperViewer;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;


import com.termcat.bd.utils.DBConnect;
import java.sql.Connection;


/**
 *
 * @author Vazquezl
 */
public class FontsReportManager {
    
    private boolean showCode;

    

    public FontsReportManager() {
        this.showCode = true;
        new ReportLauncher().InitReportSystem();
    }
    
    public FontsReportManager(boolean showCode) {
        this.showCode = showCode;
        new ReportLauncher().InitReportSystem();
    }
    
 
    public void  viewReport() {
	new Thread() {
	    public void run() {
		buildReport();
	    }
	}.start();
    }    
    public void  viewStatistic() {
	new Thread() {
	    public void run() {
		buildStatistic();
	    }
	}.start();
    }    
    
    private void buildReport(){
        JDialog dialog = showInfoMessage();
        String resourceName = "/com/termcat/business/reports/fonts/fontListat.jasper";
        if(!showCode)resourceName = "/com/termcat/business/reports/fonts/fontListatNoCodi.jasper";
        try{
            
            JasperReport report = compileReport(resourceName);
            
            HashMap params = new HashMap();
            params.put("TITULO_INFORME",Literales.getTextForMessage("Fonts_Titulo"));
            JasperPrint printer = JasperFillManager.fillReport(report, params,new JRTableModelDataSource(new FontTableModel(showCode)));
            JasperViewer.viewReport(printer,false,LlistatReportManager.LOCALE);
        }
        catch(JRException e){
            System.out.println("Error al general el informe");
            e.printStackTrace();
        }
        catch(IOException ioe){
            System.out.println("Error al buscar los ficheros de definicion del informe");
            ioe.printStackTrace();
        }
        finally{
            dialog.setVisible(false);
        }
        
    }
    
    private void buildStatistic(){
        JDialog dialog = showInfoMessage();
        String resourceName = "/com/termcat/business/reports/fonts/fontStat.jasper";
        try{
            JasperReport report = compileReport(resourceName);
            HashMap params = new HashMap();
            params.put("TITULO_INFORME",Literales.getTextForMessage("Fonts_Stat"));
            JasperPrint printer = JasperFillManager.fillReport(report, params,new JRTableModelDataSource(new StatisticTableModel()));
            JasperViewer.viewReport(printer,false,LlistatReportManager.LOCALE);
        }
        catch(JRException e){
            System.out.println("Error al general la estadistica");
            e.printStackTrace();
        }
        catch(IOException ioe){
            System.out.println("Error al buscar los ficheros de definicion de la estadistica ");
            ioe.printStackTrace();
        }
        finally{
            dialog.setVisible(false);
        }
    }

    
    private JasperReport compileReport(String resourceReportName) throws JRException, IOException{
            JasperReport report = (JasperReport) net.sf.jasperreports.engine.util.JRLoader.loadObject(getClass().getResourceAsStream(resourceReportName));
            return report;
    } 
    

     private synchronized JDialog showInfoMessage() {
       JOptionPane pane = new JOptionPane(Literales.getTextForMessage("Listado_CargandoListado"),JOptionPane.INFORMATION_MESSAGE);
       ImageIcon icon = new ImageIcon(this.getClass().getResource("/com/termcat/resources/img/loader.gif"));
       pane.setIcon(icon);
       JDialog dialog = pane.createDialog(null, Literales.getTextForMessage("Listado_Titulo"));
       dialog.setModal(false);
       dialog.setVisible(true);
       return dialog;
    }
    
    
    
    public static void main (String [] args){
        new FontsReportManager(true).viewStatistic();
    }

    
}


