/*
 * StatisticTableModel.java
 *
 * Created on 5 de septiembre de 2007, 16:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.fonts;

import com.termcat.business.reports.ObjectStatistics;
import java.util.Vector;
import javax.swing.table.DefaultTableModel;


/**
 *
 * @author Vazquezl
 */
public class StatisticTableModel extends DefaultTableModel{
    
    final Object[] columnNames = new String[]{"CODI_FONT", "N_DEFINICIONS","N_DENOMINACIONS","N_NOTES","N_CONTEXTOS","LLENGUA"};    
    
    public StatisticTableModel(){
        FontStatisticData statisticData = new FontStatisticData();
        Vector <ObjectStatistics> statisticList = statisticData.getAllStatisticData();
        //Object[][] data = new String[][]{{"1", "2","3","4","5","6"},{"1", "2","3","4","5","6"}};
        if(statisticList.size()>0){
            Object[][] data = fontListToArray(statisticList);
            setDataVector(data,columnNames);
        }
    }
    private Object[][] fontListToArray(Vector <ObjectStatistics> statisticList){
        int statisticsNum = statisticList.size();
        Object [][] fontsData = new Object[statisticsNum][columnNames.length];
        for(int i=0;i<statisticsNum;i++){
            ObjectStatistics statitsticItem = statisticList.get(i);
            
            String nDef = statitsticItem.getNumberDefinitions();
            if(nDef==null) nDef="0";
            String nDeno = statitsticItem.getNumberDenominations();
            if(nDeno==null) nDeno="0";
            String nNotes = statitsticItem.getNumberNotes();
            if(nNotes==null) nNotes="0";
            String nContext = statitsticItem.getNumberContext();
            if(nContext==null) nContext="0";
            
            fontsData[i][0]=statitsticItem.getCodiFont();
            fontsData[i][1]=nDef;
            fontsData[i][2]=nDeno;
            fontsData[i][3]=nNotes;
            fontsData[i][4]=nContext;
            fontsData[i][5]=statitsticItem.getNameLlengua();
        }
        return fontsData;
    }    
}
