/*
 * LlistatReportManager.java
 *
 * Created on 28 de septiembre de 2007, 12:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.llistat;

import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.reports.ReportLauncher;
import com.termcat.business.reports.llistat.sortable.FitxaSortableList;
import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.layout.FunctionalModule;
import com.termcat.util.literales.Literales;
import java.io.IOException;
import java.io.InputStream;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.view.JasperViewer;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;
import net.sf.jasperreports.engine.data.JRBeanArrayDataSource;


import com.termcat.bd.utils.DBConnect;
import java.sql.Connection;


/**
 *
 * @author Vazquezl
 */
public class LlistatReportManager {
    
    private String idDicctionary;
    private String itemId;
    private String lagName;
    private String areaParentId;
    private String areaName;
    
    public final static int FULL_REPORT = 0;
    public final static int LANG_REPORT = 1;
    public final static int TEMATIC_AREA_REPORT = 2;
    public final static int LANG_INDEX = 3; 
    
    public final static Locale LOCALE = new Locale("ca","ES");
    
    public LlistatReportManager(String idDicctionary) {
        this.idDicctionary = idDicctionary;
        new ReportLauncher().InitReportSystem();
    }
    

    public void  viewMainReport() {
	new Thread() {
	    public void run() {
		buildReport(FULL_REPORT);
	    }
	}.start();
    }

    public void  viewLangReport(String langId,String langName) {
        this.itemId = langId;
        this.lagName = langName;

	new Thread() {
	    public void run() {
		buildReport(LANG_REPORT);
	    }
	}.start();
    }

    public void  viewTematicAreaReport(String areaId,String areaName,String areaParentId) {
        this.itemId = areaId;
        this.areaParentId = areaParentId;
        this.areaName = areaName;
	new Thread() {
	    public void run() {
		buildReport(TEMATIC_AREA_REPORT);
	    }
	}.start();
    }
 
    public void  viewLangIndex(String langId,String langName) {
        this.itemId = langId;
        this.lagName = langName;

	new Thread() {
	    public void run() {
		buidIndexReport();
	    }
	}.start();
    }    
    private void buildReport(int reportType){
        JDialog dialog=showInfoMessage();
        String resourceName = "/com/termcat/business/reports/llistat/principal.jasper";
        String resourceNameSubDeno = "/com/termcat/business/reports/llistat/principal_subreportDeno.jasper";
        String resourceNameSubDef = "/com/termcat/business/reports/llistat/principal_subreportDefini.jasper";
        String resourceNameSubNotes = "/com/termcat/business/reports/llistat/principal_subreportNotes.jasper";
        String resourceNameSubCtx = "/com/termcat/business/reports/llistat/principal_subreportCtx.jasper";
        try{
            Connection con = DBConnect.getConnection();
            
            JasperReport report = compileReport(resourceName);
            JasperReport subReportDeno = compileReport(resourceNameSubDeno);
            JasperReport subReportDef = compileReport(resourceNameSubDef);
            JasperReport subReportNotes = compileReport(resourceNameSubNotes);
            JasperReport subReportCtx = compileReport(resourceNameSubCtx);
            
            
            
            HashMap params = new HashMap();
            params.put("TITULO_INFORME",getReportTitle(reportType));
            params.put("SUBREPORT_DENO",subReportDeno);
            params.put("SUBREPORT_DEFI",subReportDef);
            params.put("SUBREPORT_NOTES",subReportNotes);
            params.put("SUBREPORT_CTX",subReportCtx);
            params.put("REPORT_CONNECTION",con);
            
            
            
            JasperPrint printer = JasperFillManager.fillReport(report, params,new JRBeanCollectionDataSource(getFichasList(reportType)));
            DBConnect.putConnection(con);
           
            JasperViewer.viewReport(printer,false,LOCALE);
            
            
            
        }
        catch(JRException e){
            System.out.println("Error al general el listado");
            e.printStackTrace();
        }
        catch(IOException ioe){
            System.out.println("Error al buscar los ficheros de definicion del listado");
            ioe.printStackTrace();
        }
        finally{
            dialog.setVisible(false);
        }
        
    }
    
    private void buidIndexReport(){
        JDialog dialog=showInfoMessage();
        String resourceName = "/com/termcat/business/reports/llistat/indice.jasper";

        try{
            JasperReport report = compileReport(resourceName);
            
            HashMap params = new HashMap();
            params.put("TITULO_INFORME",getReportTitle(LANG_INDEX));
            JasperPrint printer = JasperFillManager.fillReport(report, params,new JRBeanArrayDataSource(getDenoList()));
            JasperViewer.viewReport(printer,false,LOCALE);
        }
        catch(JRException e){
            System.out.println("Error al general el indice");
            e.printStackTrace();
        }
        catch(IOException ioe){
            System.out.println("Error al buscar el fichero de definicion del indice");
            ioe.printStackTrace();
        }
        catch (FinderException fe){
            System.out.println("Error al buscar las definiciones en BD");
            fe.printStackTrace();
        }
        finally{
            dialog.setVisible(false);
        }
        
    }
    
    /**
     *inicialmente este metodo compilaba actualemente obtiene los reports  a partir de los fichersos previamente compilados
     **/
    private JasperReport compileReport(String resourceReportName) throws JRException, IOException{
            JasperReport report = (JasperReport) net.sf.jasperreports.engine.util.JRLoader.loadObject(getClass().getResourceAsStream(resourceReportName));
            return report;
    } 
    
    private Vector getFichasList(int reportType){
        FitxaSortableList fitxSortable=null;
        fitxSortable= new FitxaSortableList(this.idDicctionary,this.itemId,reportType); 
        return fitxSortable.getFixesList();
    }
    
    
    private Object [] getDenoList() throws FinderException{
        Denominacions denos = new Denominacions();
        List denoList = denos.findByGenericWhere(" id_llengua='"+this.itemId+"' and id_diccionari = '"+this.idDicctionary+"' order by terme_normal");
        Collections.sort(denoList,new TermcatComparator());
        return denoList.toArray();
    }
    
    
    
     private synchronized JDialog showInfoMessage() {
       JOptionPane pane = new JOptionPane(Literales.getTextForMessage("Listado_CargandoListado"),JOptionPane.INFORMATION_MESSAGE);
       ImageIcon icon = new ImageIcon(this.getClass().getResource("/com/termcat/resources/img/loader.gif"));
       pane.setIcon(icon);
       JDialog dialog = pane.createDialog(null, Literales.getTextForMessage("Listado_Titulo"));
       dialog.setModal(false);
       dialog.setVisible(true);
       return dialog;
    }
    
    private String getReportTitle(int reportType){
        String reportTitle = "";
           switch (reportType){
            case FULL_REPORT: {};break;
            case LANG_REPORT: { 
                    reportTitle = Literales.getTextForMessage("Listado_InformeIdioma")+" "+lagName;break;
                 }
            case TEMATIC_AREA_REPORT:{
                    reportTitle = Literales.getTextForMessage("Listado_InformeAreas")+" "+areaName;break;
             }
            case LANG_INDEX:{
                    reportTitle = Literales.getTextForMessage("Listado_Indice")+" "+lagName;break;
             }
            
            default:break;
           } 
        
        return reportTitle;
    }
    
    public static void main (String [] args){
        //new LlistatReportManager("9a84fdda-44d2-11dc-98c8-5994d68b1ac3").viewLangReport("59889117-5b91-11dc-a696-11170167a68d","castell");
        //new LlistatReportManager("9a84fdda-44d2-11dc-98c8-5994d68b1ac3").viewTematicAreaReport("20c6dafa-5b95-11dc-b409-35ac2210b530","area1","root");
        new LlistatReportManager("9a84fdda-44d2-11dc-98c8-5994d68b1ac3").viewLangIndex("0beae076-5b91-11dc-a696-11170167a68d","castal");
    }
    
}
