/*
 * FitxaSortableList.java
 *
 * Created on 2 de octubre de 2007, 10:02
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.llistat.sortable;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.FontsDenominacions;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.reports.llistat.LlistatReportManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.ItemCustom;
import com.termcat.layout.commons.lists.ItemListCustom;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Vector;

/**
 *
 * @author Vazquezl
 */
public class FitxaSortableList {
    
    private String  dictionaryId;
    private int reportType;
    private String langId;
    private String areaId;
    public static final String FONT_SEPARATOR ="  ";
    

    public FitxaSortableList() {
    
    }
    public FitxaSortableList(String dictionaryId,String itemId,int reportType) {
        this.dictionaryId = dictionaryId;
        this.reportType = reportType;
        if(reportType==LlistatReportManager.TEMATIC_AREA_REPORT){
          this.areaId = itemId;
        }
        else{
          this.langId = itemId;  
        }
    }
    
    
    public Vector <BeanFichaData> getFixesList(){
        Vector <BeanFichaData> result = null;
        Denominacions denoBean = new Denominacions();
        try{
           switch (reportType){
             case LlistatReportManager.FULL_REPORT: {
                 //Vector <ItemCustom> allDeno = denoBean.findAllDenominationsAndPriorityLangs(dictionaryId);
                 //result = buildFichaList(allDeno,true);break;
                 result = denoBean.findAllSortedFitxes(dictionaryId,true);break;
             }
            case LlistatReportManager.LANG_REPORT: { 
                Vector <ItemCustom> denoByLang=denoBean.findAllDenominationsAndPriorityLangsByLang(dictionaryId,langId);
                result = buildFichaList(denoByLang,true);break;
                }
            case LlistatReportManager.TEMATIC_AREA_REPORT:{
                Vector <ItemCustom> denoByArea = denoBean.findAllDenominationsAndPriorityLangsByArea(dictionaryId,areaId);
                result = buildFichaList(denoByArea,true);break;
            }
            default:break;
           } 
            
          }
        catch(Exception e){
            System.out.println("Error buscando la lista de todas las denominaciones!");
            e.printStackTrace();
        }
        
        return result;
    }
    
   
    
    
    public   Vector<BeanFichaData> buildFichaList(Vector <ItemCustom> allDeno, boolean composeDenoData){
        TermcatComparator coparator = new TermcatComparator();
        Vector <BeanFichaData> result = new Vector<BeanFichaData>();
        Hashtable <String,BeanFichaData> fitxes = new Hashtable<String,BeanFichaData>();
        for (int i=0;i<allDeno.size();i++){
            ItemCustom deno = allDeno.get(i);
            buildSingleFicha(deno,fitxes,result,composeDenoData);
        }
        return sortFichaList(result);
    }
    
    
    public static void buildSingleFicha(ItemCustom deno,Hashtable <String,BeanFichaData> fitxes,Vector <BeanFichaData> result, boolean composeDenoData){
        TermcatComparator coparator = new TermcatComparator();
        
            String idFicha = deno.getId();
            BeanFichaData ficha = fitxes.get(idFicha);
            if(ficha==null){ //no existe la ficha --> la creamos y la aadimos a la hash
                ficha = new BeanFichaData();
                ficha.setIdFicha(idFicha);
                ficha.setDenominacio(deno.getDenominacio());
                ficha.setTermeRtf(deno.getDenominacioRtf());
                ficha.setOrderLang(deno.getOrderLang());
                ficha.setDenominacioId(deno.getDenominacioId());
                Fitxes beanFitxa = new Fitxes();
                try{
                    beanFitxa.findByPrimaryKey(idFicha);
                    String observacions = beanFitxa.getObservacions();
                    if(observacions!=null)ficha.setObservacions(FunctionalModule.convertRTF2Text(observacions));
                    ficha = setDenoDataToFicha(ficha,composeDenoData,deno.getDenominacioId());
                    ficha.setAreaTematica(buildAreasForFicha(idFicha));
                }
                catch(Exception e){
                    System.out.println("Error al calcular atributos de las definiciones principales");
                    e.printStackTrace();
                }
                
                fitxes.put(idFicha,ficha);
                result.add(ficha);
            }
            else{  //la ficha existe comprovamos el orden de la denominacion 1miramos el orden de la lengua y en caso de que sea necesario 2 el orden de las definiciones
                if(deno.getOrderLang()<ficha.getOrderLang()){ //la lengua de la denominacion de la lista es mas prioritaria que la de la ficha --> la sustituimos
                    ficha.setDenominacio(deno.getDenominacio());
                    ficha.setTermeRtf(deno.getDenominacioRtf());
                    ficha.setOrderLang(deno.getOrderLang());
                    ficha.setDenominacioId(deno.getDenominacioId());
                    ficha = setDenoDataToFicha(ficha,composeDenoData,deno.getDenominacioId());
                    fitxes.put(idFicha,ficha);
                }else if(deno.getOrderLang()==ficha.getOrderLang()){ //son iguales --> comparamos y nos quemaos con la mas pequea
                    int jerPriorityDeno=Denominacions.findDenominationJerarquiaPriority(deno.getDenominacioId());
                    int jerPriorityFicha = Denominacions.findDenominationJerarquiaPriority(ficha.getDenominacioId());
                    if(jerPriorityDeno!=jerPriorityFicha){ //la jerarquias son diferentes -> la mas prioriaria sera aquella que tenga una jerarquia de prioridad mas baja
                        if(jerPriorityDeno<jerPriorityFicha){
                          ficha.setDenominacio(deno.getDenominacio());
                          ficha.setDenominacioId(deno.getDenominacioId());
                          ficha.setTermeRtf(deno.getDenominacioRtf());
                          ficha = setDenoDataToFicha(ficha,composeDenoData,deno.getDenominacioId());
                          fitxes.put(idFicha,ficha);
                        }  
                    }//mismas jerarquias -> se hace una camparacion alfabetica
                    else if(coparator.compare(deno,ficha)<0){ //la denominacion va por delante de la denominacion de la ficha-->la sustituimos
                          ficha.setDenominacio(deno.getDenominacio());
                          ficha.setDenominacioId(deno.getDenominacioId());
                          ficha.setTermeRtf(deno.getDenominacioRtf());
                          ficha = setDenoDataToFicha(ficha,composeDenoData,deno.getDenominacioId());
                          fitxes.put(idFicha,ficha);                        
                    }
                }

        }
        
    }
    
    private static BeanFichaData setDenoDataToFicha (BeanFichaData ficha, boolean composeDenoData,String idDenominacio){
       if(composeDenoData){
           try{
               Denominacions beanDenominacio = new Denominacions();
               beanDenominacio = beanDenominacio.findDenominationData(idDenominacio);
               ficha.setDenominacioData(composeDenoData(beanDenominacio));
           }
           catch(Exception e){
               System.out.println("Error al calcular atributos de las definiciones principales");
               e.printStackTrace();
          }
        }
        return ficha;
    }
    
    private  static String composeDenoData(Denominacions deno){
        String denoData = "";
        String jerCode = deno.getIdJerarquia();
        String categCode = deno.getIdCategoria();
        String marcCode = deno.getIdMarca();
        denoData = categCode+" "+jerCode+" ";
        //buscamos las fuentes asociadas a la denominacion
        try{
            FontsDenominacions fontsDenoBean = new FontsDenominacions();
            Vector <ItemListCustom> fontList = fontsDenoBean.findFontsDenominacions(deno.getIdDenominacio());
            int listSize = fontList.size();
            for(int i=0;i<listSize;i++){
                if(i<(listSize-1))
                  denoData = denoData+fontList.get(i).toString()+FONT_SEPARATOR;
                else
                  denoData =  denoData +fontList.get(i).toString();  
            }
        }
        catch(Exception e){
            System.out.println("Listados: Error buscando las fuentes para la denominacion:"+deno.getTermeNormal());
            e.printStackTrace();
        }
        return denoData;
    }
    
    /**
     *@todo implementar el algoritmo de ordennacion. El atributo que se ha de utilizar para efectuar las comparaciones
     * es la denominacion
     **/
    public  static Vector <BeanFichaData> sortFichaList(Vector <BeanFichaData> fichaList){
        Collections.sort(fichaList,new TermcatComparator());
        return fichaList;
    }

    private static String  buildAreasForFicha(String idFicha) {
        String areas = "";
        ArbreCamp arbre = new ArbreCamp();
        try {
            Vector areesList = arbre.getAreesOfFitxa(idFicha);
            int numAreas = areesList.size();
            for(int i=0;i<numAreas;i++){
                ArbreCamp area = (ArbreCamp) areesList.get(i);
                if(i==numAreas-1){
                   areas = areas + FunctionalModule.getAbsoluteAreaName(area.getIdPare(),area.getNomArea(),area.getIdArea()); 
                }else{ 
                  areas = areas + FunctionalModule.getAbsoluteAreaName(area.getIdPare(),area.getNomArea(),area.getIdArea())+";";   
                }
            }
        } catch (FinderException ex) {
            System.out.println("Error buscando las area tematicas de la ficha:"+idFicha);
            ex.printStackTrace();
        }
        return areas;
    }
  
    public Vector<BeanFichaData> testBuilMainDenoList(String diccId) throws FinderException{
        com.termcat.bd.beans.Denominacions denoBean = new com.termcat.bd.beans.Denominacions();
       // Vector <ItemCustom> allDeno = denoBean.findAllDenominationsAndPriorityLangs(diccId);
        System.out.println("Ya tengo las denos");
        //Vector<BeanFichaData> fichaList = buildFichaList(allDeno,false);
        System.out.println("Ya tengo las fichas");
        //return fichaList; 
        return null;
     }    
    public static void main (String [] args){
        new FitxaSortableList("9a84fdda-44d2-11dc-98c8-5994d68b1ac3",null,0).getFixesList();
        
    } 
}
