/*
 * SortUtils.java
 *
 * Created on 13 de noviembre de 2007, 18:21
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.llistat.sortable;

import java.util.Vector;

/**
 *
 * @author Vazquezl
 */
public class SortUtils {
    

    private final static String [][] SPECIAL_CHARS_PAIR_FIRST_LEVEL = {{"","c"},{"ll","ll"},{"","n"}};
    
    
    private final static String [][] SPECIAL_CHARS_PAIR_SECOND_LEVEL = {{"","a"},{"","a"},{"","a"},{"","a"},
                                                                        {"","e"},{"","e"},{"","e"},{"","e"},
                                                                        {"","i"},{"","i"},{"","i"},{"","i"},
                                                                        {"","o"},{"","o"},{"","o"},{"","o"},
                                                                        {"","u"},{"","u"},{"","u"},{"","u"}};
    
    public final static int FIRST_LEVEL = 1;
    public final static int SECOND_LEVEL = 2;
    public final static int THIRD_LEVEL = 3;
    public final static int FOURTH_LEVEL = 4;
    
    /**
     *Tipos de palabra en funcion del acento
     **/
    private final static int NO_ACCENT_TYPE = 0;
    private final static int ACCENT_HIGHT_TYPE = 1;
    private final static int ACCENT_LOW_TYPE = 2;
    private final static int ACCENT_CIRCUMFLEX_TYPE = 3;
    private final static int ACCENT_DIERESI_TYPE = 4;
    
    /**
     *Tipos de caracteres en funcion del caracter especial
     **/
    private final static int SPECIAL_NOSPECIAL_TYPE = 0;
    private final static int SPECIAL_GUION_TYPE = 1;
    private final static int SPECIAL_APOSTROFE_TYPE = 2;
    private final static int SPECIAL_BARRA_TYPE = 3;
    private final static int SPECIAL_OTROS_TYPE = 4;
    
    //private final static String [] CHAR_LIST_FOR_SIMPLIFY = {"-","/","'","\\","%","$","&","(",")","?","","!","","*","+","","","@","{","}","<",">"};
    //private final static String [] [] SPECIAL_CHARS_PAIR_REPLACE = {{"","c"},{"","C"},{"ll","ll"},{"LL","LL"},{"","n"},{"","N"}};
    
    /**
     *hace un split del string , el separador es el espcio en blanco , no se queda con los string en blanco
     **/
    public static String [] splitString(String cad){
        String result[] = cad.split(" ");
        int numWords = result.length;
        if(numWords==1) return result;
        
        Vector <String> aux = new Vector<String>();
        for(int i=0;i<numWords;i++){
           if(!result[i].trim().equals("")){
               aux.add(result[i]);
           }
        }
        result = aux.toArray(new String[0]);
        return result;
    }
    
    /**
     *  comapara dos Strings como numeros devuelve :
     *  @return 
     *   0 si son numeros iguales
     *   0 si ninguno de los dos strings es un numero
     *   -1 si cad2 > cad1
     *    1 si cad2 < cad1
     *   
     *   una cadena sera mas pequea que otra por que :
     *   a) el numero que representa es mas pequeo que con la que se compara
     *   b) la cadena representa un numero y el string con el que se compara no 
     **/
    public static int compareLikeNumber(String cad1,String cad2){
        int result = 0;
        String aux1 = cad1.replace('.',';'); //los puntos termcat no los trata como parte del numero los cambiamos para que pete al parsear si existen  
        String aux2 = cad2.replace('.',';');
        
         aux1 = aux1.replace(',','.'); //los decimales termcat los expresa con comas -> hay que transformar para que no pete al parsear
         aux2 = aux2.replace(',','.');
                                            
        Float num1 = stringToFloat(aux1);
        Float num2 = stringToFloat(aux2);
        if(num1==null && num2==null){ //ninguno de los dos es un numero
            return 0;
        }
        if(num1!=null && num2==null){ // cad1 es un numero y cad2 no 
            return -1;
        }
        if(num1==null && num2!=null){ // cad2 es un numero y cad1 no 
            return 1;
        }
        //los dos son nuneros --> los comparamos
        result = num1.compareTo(num2);
        return result;
    }
    
    public static int compareLikeWord(String cad1,String cad2){
        int result =0;
        int cad1Size = cad1.length();
        int cad2Size = cad2.length();
        
        int firstCompare = cad1.compareTo(cad2);
        if(firstCompare!=0){ //si la comparacion "tipica" no encuentra ninguna diferencia finalizamos. Si hay diferencias la comparacion tipica no es suficiente hay que buscar

            String [] []specialCharsCad1 = findSpecialChars(cad1,SPECIAL_CHARS_PAIR_FIRST_LEVEL);
            String [] []specialCharsCad2 = findSpecialChars(cad2,SPECIAL_CHARS_PAIR_FIRST_LEVEL);
            if(specialCharsCad1==null && specialCharsCad2==null){
                result = firstCompare;   //no hay caracteres especiales -> la comparacion inicial nos vale
            }                 //si hay caracteres especiale hay que transformar a palabras a sin caracteres especiales y comparar -->si dan igual es que solo difieren en el caracter especial --> el mas pequeo es el que tiene el caracter especial
                              //                                                                      si no dan iguales aplicar el compare
 
            else {
                String cad1Replaced = replaceSpecialChars(cad1,specialCharsCad1);
                String cad2Replaced = replaceSpecialChars(cad2,specialCharsCad2);
                int secondCompare = cad1Replaced.compareTo(cad2Replaced);
                if(secondCompare==0){ //son iguales solo se diferencian en caracteres especiales situados en la misma posicion p.ej peca y pea
                    if(specialCharsCad1==null){ //la primera cadena no tiene carateres especiales va por delante en la ordenacion
                       result = -1;    
                    }
                    else if(specialCharsCad2==null){ //es la segunda cadea la que tiene caracteres especiales
                        result = 1;
                    }else{ //las dos tiene caracteres especiales -> vale la comparacion 
                        result = secondCompare;
                    }
                }
                else { //no son iguales difieren algo mas que los caracteres especiales -> nos vale la comparacio
                    result = secondCompare;
                }
            }
        }
        return result;
    }
    
    
    /**
     * compara dos cadenas iguales que se diferencian en algun signo diacritico
     *  El orden es 1 palabra sin acento
     *              2 palabra con acento agudo ""
     *              3 palabra con acento grave "^"
     *              4 palabra con acento circumflexo "^"
     *              % palabra con dieresi ""
     **/
    public static int compareLikeAccentuatedWord(String cad1,String cad2){
        int result = 0;
        int cad1Type = findAccentuatedType(cad1);
        int cad2Type = findAccentuatedType(cad2);
        if(cad1Type>cad2Type){  //la primera palabra tiene un acento menos prioritario -> es mas pequea -> va por delante
            result = 1;
        }
        else if (cad1Type<cad2Type){
            result = -1;
        }
        return result;
    }
    
    /**
     * compara cadenas iguales que difieren solo en las mayusculas y/o minusculas
     * las minusculas se ordenan  por delante de las mayusculas
     **/
    public static int compareLikeKeySensitiveWord(String cad1,String cad2){
        int result = 0;
        int postDif = calculatePositionDif(cad1,cad2);
        if(postDif>-1){ //hay diferencias
            char charCad1 = cad1.charAt(postDif);
            char charCad2 = cad2.charAt(postDif);
            if(charCad1>charCad2){  //charCad1 es mayuscula
                result = -1;
            }
            else{
                result = 1;
            }
        }
        return result;
    }
    
    
    /**
     *Compara dos codenas teniedo en cuenta los caracteres especiales 
     *el orden de menor a mayor es :
     * 1 Guion (-)
     * 2 Apostrofe (')
     * 3 Barra (/)
     * 4 Otros
     **/
    public static int compareLikeSpecialWord(String cad1,String cad2){
        int result = 0;
        int postDif = calculatePositionDif(cad1,cad2);
        if(postDif>-1){ //hay diferencias
            char charCad1 = cad1.charAt(postDif);
            char charCad2 = cad2.charAt(postDif);
            int typeChar1 = findSpecialCharType(charCad1);
            int typeChar2 = findSpecialCharType(charCad2);
            if(typeChar1>typeChar2){ //el caracter de la primera palabra es menos prioritario
                result = 1;
            }
            else{
                result = -1;
            }
        }
        return result;
    }
    
    private static int findSpecialCharType (char specialChar){
        int result =SPECIAL_OTROS_TYPE;
        switch (specialChar){
            case('-'): result = SPECIAL_GUION_TYPE;break;
            case('\''):result = SPECIAL_APOSTROFE_TYPE;break;
            case('/'):result = SPECIAL_BARRA_TYPE;break;
            default:{
                String aux = String.valueOf(specialChar); //miramos si es un caracter normal
                if(aux.matches("([a-zA-Z0-9 ])*")){ // es un caracter normal
                   result = SPECIAL_NOSPECIAL_TYPE; 
                }
            }break;
        }
        return result;
    }
    
    private static int findAccentuatedType (String cad1){
        int type = NO_ACCENT_TYPE;
        if(cad1.matches("([a-z])*(||||)+([a-z])*")){  //la cadena tiene algun acento agudo
            type = ACCENT_HIGHT_TYPE;
        } 
        else if(cad1.matches("([a-z])*(||||)+([a-z])*")){  //la cadena tiene algun acento grave
            type = ACCENT_LOW_TYPE;
        }
        else if(cad1.matches("([a-z])*(||||)+([a-z])*")){  //la cadena tiene acento circumflexo
            type = ACCENT_CIRCUMFLEX_TYPE;
        }
        else if(cad1.matches("([a-z])*(||||)+([a-z])*")){  //la cadena tiene dieresi
            type = ACCENT_DIERESI_TYPE;
        }
        return type; 
    }
    
    private static String [][] findSpecialChars(String cad,String [][] charList){
        String [][]result = null;
        Vector <String[]> charSelected = new Vector<String[]>();
        for(int i=0;i<charList.length;i++){
            if(cad.contains(charList[i][0])) charSelected.add(charList[i]);
        }
        if(charSelected.size()>0) result = charSelected.toArray(new String[0][0]);
        return result;
    }
    
    
    private static String replaceSpecialChars(String cad,String [][] specialChars){
        if(specialChars!=null){
            for (int i=0;i<specialChars.length;i++){
                cad = cad.replace(specialChars[i][0],specialChars[i][1]);
            }
        }
        return cad;
    }
    
    
    
    public static Float stringToFloat(String cad){
        Float result = null;
        try{
            result = Float.parseFloat(cad);
        }
        catch(Exception ing){}
        return result;
    }
    
    
     /**
      *Elimina todos los caracteres de una cadena a escepcion de las letras numeros . , y  
      *Cambia los caracteres acentuados por sus respectivos sin acento -> solo para el primer nivel de comparacion
      *las mayusculas no se tienen en cuenta
      **/
    public static String simplifyString (String cad, int level){
        String result = cad;
        if(level == FIRST_LEVEL){
            for (int i=0;i<SPECIAL_CHARS_PAIR_SECOND_LEVEL.length;i++){
                result = result.replaceAll(SPECIAL_CHARS_PAIR_SECOND_LEVEL[i][0],SPECIAL_CHARS_PAIR_SECOND_LEVEL[i][1]);
            }
            result = result.replaceAll("[^a-z0-9 ]","");
        }    
        else if(level == SECOND_LEVEL){
            result = result.replaceAll("[^a-z0-9 ]","");
        }
        else{
            result = result.replaceAll("[^a-zA-Z0-9 ѷ]","");
        }
        return result;
    }
     
     
    private static void printArray (String [][] array){
        if(array==null){
            System.out.println("null");
        }else{
            for(int i=0;i<array.length;i++){
                System.out.println("["+array[i][0]+"],["+array[i][1]+"]");
            }
        }
    }

    
    /**
     * metodo que da la posicion en la que discrepan dos strings
     * @return
     *   la posicion en que se dferencian
     *   -1 no hay diferencias
     **/
     public static int calculatePositionDif(String cad1, String cad2){
        int pos=-1;
        int minSize = Math.min(cad1.length(),cad2.length());
        for(int i=0;i<minSize;i++){
            if(cad1.charAt(i)!=cad2.charAt(i)){
                pos=i;
                break;
            }
        }
        return pos;
    }
    
    
    public static void main (String args[]){
        try{
          java.io.BufferedReader br = new java.io.BufferedReader(new java.io.InputStreamReader(System.in));
          String linea = null;
          while (!" ".equals(linea)){
              linea = br.readLine(); 
             // String [][] special= findSpecialChars(linea,SPECIAL_CHARS_PAIR_FIRST_LEVEL);   
             // printArray(special);
             // System.out.println("Transformacion: "+replaceSpecialChars("pea KAA ILLA illa OO nio",special));
              //System.out.println(simplifyString(linea,SECOND_LEVEL));
              //System.out.println( findAccentuatedType(linea));
              //System.out.println( linea.toLowerCase(com.termcat.business.reports.llistat.LlistatReportManager.LOCALE));
              System.out.println(linea.matches("([a-zA-Z0-9 ѷ])*"));
           }  
        }
        catch(Exception e){
            e.printStackTrace();
        }
    }
}
