/*
 * LlistatReportManager.java
 *
 * Created on 28 de septiembre de 2007, 12:33
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.reports.veurefitxa;

import com.termcat.bd.beans.Fitxes;
import com.termcat.business.areas.AreaManager;
import com.termcat.business.exceptions.AreaException;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.reports.ReportLauncher;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.terminologic.contexts.ContextManager;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.business.terminologic.notes.NoteManager;

import com.termcat.layout.FunctionalModule;
import com.termcat.util.literales.Literales;
import java.io.IOException;
import java.io.InputStream;
import java.util.Collection;
import java.util.HashMap;
import java.util.Locale;
import java.util.Vector;
import javax.swing.JDialog;
import javax.swing.JOptionPane;

import net.sf.jasperreports.engine.JasperCompileManager;
import net.sf.jasperreports.engine.JRException;
import net.sf.jasperreports.engine.JRExporterParameter;
import net.sf.jasperreports.engine.JasperExportManager;
import net.sf.jasperreports.engine.JasperFillManager;
import net.sf.jasperreports.engine.JasperPrint;
import net.sf.jasperreports.engine.JasperReport;
import net.sf.jasperreports.engine.JasperRunManager;
import net.sf.jasperreports.view.JasperViewer;
import net.sf.jasperreports.engine.data.JRBeanCollectionDataSource;

import com.termcat.bd.utils.DBConnect;
import java.sql.Connection;


/**
 *
 * @author Vazquezl
 */
public class VeureFitxaReportManager 
{
    
    private String id;
    private String denoPrincipal;
       
    public final static Locale LOCALE = new Locale("ca","ES");
    
    public void  viewFitxaReport(String id, String denoPrincipal) 
    {
       this.id=id;
       this.denoPrincipal=denoPrincipal;
       
	new Thread() {
	    public void run() {
		buildReport();
	    }
	}.start();
    }

 
    private void buildReport()
    {

        String resourceName = "/com/termcat/business/reports/veurefitxa/veure_fitxa_principal.jasper";
        String resourceNameSubAt = "/com/termcat/business/reports/veurefitxa/veure_fitxa_subreportAT.jasper";
        String resourceNameSubDeno = "/com/termcat/business/reports/veurefitxa/veure_fitxa_subreportDenominacions.jasper";
        String resourceNameSubDef = "/com/termcat/business/reports/veurefitxa/veure_fitxa_subreportDefini.jasper";
        String resourceNameSubNotes = "/com/termcat/business/reports/veurefitxa/veure_fitxa_subreportNotes.jasper";
        String resourceNameSubCtx = "/com/termcat/business/reports/veurefitxa/veure_fitxa_subreportContextes.jasper";
        
        try
        {
            //Connection con = DBConnect.getConnection();
            
            JasperReport report = compileReport(resourceName);
            JasperReport subReportAt = compileReport(resourceNameSubAt);
            JasperReport subReportDeno = compileReport(resourceNameSubDeno);
            JasperReport subReportDef = compileReport(resourceNameSubDef);
            JasperReport subReportNotes = compileReport(resourceNameSubNotes);
            JasperReport subReportCtx = compileReport(resourceNameSubCtx);                                

            //params.put("TITULO_INFORME",getReportTitle(reportType));
            HashMap params = new HashMap();
            
            params.put("SUBREPORT_AREA_TEMATICA",subReportAt);            
            params.put("SUBREPORT_DENO",subReportDeno);
            params.put("SUBREPORT_DEFI",subReportDef);
            params.put("SUBREPORT_NOTES",subReportNotes);
            params.put("SUBREPORT_CTX",subReportCtx);
            
            // Passem els valors del camp de text amb el titol del subreport.
            params.put("TITLE_NOM",Literales.getTextForMessage("VeureFitxa_Titol_Nom"));            
            params.put("TITLE_AT",Literales.getTextForMessage("VeureFitxa_Titol_AT"));
            params.put("TITLE_DENOMINACIO",Literales.getTextForMessage("VeureFitxa_Titol_Deno"));
            params.put("TITLE_DEFINICIO",Literales.getTextForMessage("VeureFitxa_Titol_Def"));
            params.put("TITLE_NOTES",Literales.getTextForMessage("VeureFitxa_Titol_Notes"));
            params.put("TITLE_OBSERVACIONS",Literales.getTextForMessage("VeureFitxa_Titol_Obs"));            
            params.put("TITLE_CONTEXTE",Literales.getTextForMessage("VeureFitxa_Titol_Ctxt"));            
            
            Vector reportAt=AreaManager.getManager().getAreesOfFitxa(id);    
            Vector reportDenominacions=(Vector) DenominationManager.getManager().getAllDenominationsOfFitxaAndFonts(FunctionalModule.getMainFrame().getIdCurrentDictionary(),id);
            Vector reportDefinicions=(Vector) DefinitionManager.getManager().getAllDefinitionsOfFitxaAndFonts(FunctionalModule.getMainFrame().getIdCurrentDictionary(),id);
            Vector reportNotes=(Vector) NoteManager.getManager().getAllNotesOfFitxaAndFonts(FunctionalModule.getMainFrame().getIdCurrentDictionary(),id);
            Vector reportContextes=(Vector) ContextManager.getManager().getAllContextesOfFitxaAndFonts(FunctionalModule.getMainFrame().getIdCurrentDictionary(),id);            

            // Passem els beans que alimentaran cadascun dels subreports.
            params.put("DATASOURCE_AT",new JRBeanCollectionDataSource(reportAt));
            params.put("DATASOURCE_DENOMINACIONS",new JRBeanCollectionDataSource(reportDenominacions));
            params.put("DATASOURCE_DEFINICIONS",new JRBeanCollectionDataSource(reportDefinicions));            
            params.put("DATASOURCE_NOTES",new JRBeanCollectionDataSource(reportNotes));
            params.put("DATASOURCE_CONTEXTES",new JRBeanCollectionDataSource(reportContextes));                       
            
            JasperPrint printer = JasperFillManager.fillReport(report, params,new JRBeanCollectionDataSource(getFitxaInfo(this.id)));                    

           //DBConnect.putConnection(con);    
            
            // Tanquem el popup d'edici (que es modal)perque sino l'informe no es pot 'manipular' i inicialitzem el tab.
            FunctionalModule.getMainFrame().closeEditPanelPopup();
            FunctionalModule.getMainFrame().setLastTab(0);
            
            JasperViewer.viewReport(printer,false,LOCALE);
                  
        }
        catch(JRException e){
            System.out.println("Error al general el listado");
            e.printStackTrace();
        }
        catch(IOException ioe){
            System.out.println("Error al buscar los ficheros de definicion del listado");
            ioe.printStackTrace();
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
    }
    

    /**
     *      Inicialmente este metodo compilaba actualemente obtiene los reports  a partir de lso fichersos previamente compilados
     **/
    private JasperReport compileReport(String resourceReportName) throws JRException, IOException{
            JasperReport report = (JasperReport) net.sf.jasperreports.engine.util.JRLoader.loadObject(getClass().getResourceAsStream(resourceReportName));
            return report;
    } 
    
    private Vector getFitxaInfo(String id) 
    {       
        Vector v=new Vector();
        BeanFichaData bean=new BeanFichaData();
        Fitxes fitxaInfo;
        String obsText="";
        try 
        {
            fitxaInfo = DataManager.getManager().getFitxaInfo(id);
            bean.setIdFicha(id);
            String obs=fitxaInfo.getObservacions();
            if (obs==null || obs.equals(""))
                obsText="";
            else
                obsText=FunctionalModule.convertRTF2Text(obs);
            
            bean.setObservacions(obsText);
            bean.setDenominacio(denoPrincipal);       
            v.add(bean);
        }
        catch (Exception ex) 
        {
            ex.printStackTrace();
        }               
        return v;
    }    
}
