/*
 * DenominationManager.java
 *
 * Created on 7 de agosto de 2007, 17:12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.terminologic.contexts;

import com.termcat.bd.beans.Context;
import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Notes;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.ContextException;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxa;
import com.termcat.business.terminologic.FitxaElement;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.util.UIDGenerator;
import electric.xml.Document;
import electric.xml.Element;
import java.sql.Connection;
import java.util.List;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;

/**
 *
 * @author Mena
 */
public class ContextManager {
    
    private static ContextManager manager;
    
    /** Creates a new instance of DenominationManager */
    public ContextManager() {
    }
     
    public static ContextManager getManager()
    {
        if(manager==null)
        {
            manager = new ContextManager();
        }
     
       return manager;
    }
    
    public void altaContext(String idContexte, String idDiccionari, String idFitxa, String idLlengua, String contextNormal, String contextRtf) throws ContextException 
    {
        try
        {
            String ctxtNormal="", ctxtRtf="";
            
            // Comprovacio dels nulls.
            if (contextNormal!=null)
                ctxtNormal=contextNormal;
            if (contextRtf!=null)
                ctxtRtf=contextRtf;           
            
            Connection con=DBConnect.getConnectionTransactional();
            
            Context contexte=new Context();
            contexte.setIdContext(idContexte);
            contexte.setIdDiccionari(idDiccionari);
            contexte.setIdLlengua(idLlengua);
            contexte.setContextNormal(ctxtNormal);
            contexte.setContextRtf(ctxtRtf);            
            contexte.setIdFitxa(idFitxa);
            contexte.create(con);           
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new ContextException(e.getMessage());
        }      
    }
    
    /*
     *  Mtode que inserta una nova definicio a la BD.
     *  
     *  @param idDiccionari:    Identificador del diccionari al que pertany la fitxa.
     *  @param idFitxa:         Identificador de la fitxa a la que pertany.
     *  @param idLlengua:       Identificador de la llengua.
     *  @param notaNormal:      Contingut de la nota sense format.
     *  @param notaRtf:         Contingut de la nota en format rtf.
     */
    public String altaContexte(String idDiccionari,String idFitxa,String idLlengua, String contextNormal, String contextRtf) throws ContextException
    {
        String idContexte=null;
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            
            Context contexte=new Context();
            idContexte=UIDGenerator.generateUniqueId();
            contexte.setIdContext(idContexte);
            contexte.setIdDiccionari(idDiccionari);
            contexte.setIdLlengua(idLlengua);
            contexte.setContextNormal(contextNormal);
            contexte.setContextRtf(contextRtf);
            contexte.setIdFitxa(idFitxa);
            contexte.create(con);           
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new ContextException(e.getMessage());            
        }
        return idContexte;
    }
   
    /*
     *       Mtode que esborra una nota.
     *      @param idNota:     Identificador de la nota.
     */
    public void deleteContexte(String idContexte) 
    {
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Context contexte=new Context();
            Context contexteSelected=(Context)contexte.findByPrimaryKey(idContexte);
            contexteSelected.remove(con);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
   
    /*
     *  Mtode que actualitza els valors d'una nota de la BD.
     * 
     *  @param idNota:          Identificador de la nota.
     *  @param idLlengua:       Identificador de la llengua.
     *  @param notaNormal:      Contingut de la nota sense format. 
     *  @param notaRtf:         Contingut de la nota en format rtf.
     */
    public void updateContexte(String id,String idLlengua, String contextNormal, String contextRtf)
    {
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Context contexte=new Context();
            Context contexteSelected=(Context)contexte.findByPrimaryKey(id);

            contexteSelected.setIdLlengua(idLlengua);
            contexteSelected.setContextNormal(contextNormal);
            contexteSelected.setContextRtf(contextRtf);
            contexteSelected.flush(con);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }
    
     public Element getAllContextesToXML(String idDiccionari)
    {
         Document doc=new Document();
         Element elem=new Element("DadesContextes");
         String sql=" ID_DICCIONARI='"+idDiccionari+"'";
         
         try
         {
            Context newCtxt=new Context();
            Context context=new Context();

            List list=newCtxt.findByGenericWhere(sql);
            for(int i=0;i<list.size();++i)
            {
                context = (Context)list.get(i);
                elem.addElement(context.toXml());
            }
            
            doc.setRoot(elem);
         }
         catch(Exception e)
         {
             e.printStackTrace();
         }

         return doc.getRoot();
    }

    public List getAllContextesOfFitxa(String idFitxa) 
    {
        Context context=null;
        Vector l=null;
        try
        {
            /*String sql="ID_FITXA='"+idFitxa+"'";
            context=new Context();
            l=context.findByGenericWhere(sql);*/
            Vector<FitxaElement> sortCtx = Fitxes.getAllContextFromFitxa(idFitxa);
            int numCtxs = sortCtx.size();
            l = new Vector(numCtxs);
            for(int i=0;i<numCtxs;i++){
                String contextId = sortCtx.get(i).getIdElement();
                Context ctxBean = new Context();
                ctxBean.findByPrimaryKey(contextId);
                l.add(ctxBean);
            }            
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
        return l;
    }
    
    public Element getAllDenominationsToXML(String idDiccionari)
    {
         Document doc=new Document();
         Element elem=new Element("DadesContextes");
         String sql=" ID_DICCIONARI='"+idDiccionari+"'";
         
         try
         {
            Context newCtxt=new Context();
            Context contexte=new Context();

            List list=newCtxt.findByGenericWhere(sql);
            for(int i=0;i<list.size();++i)
            {
                contexte = (Context)list.get(i);
                elem.addElement(contexte.toXml());
            }
            
            doc.setRoot(elem);

         }
         catch(Exception e)
         {
             
         }

         return doc.getRoot();

    }
    
   public String getRTFContext(String id) throws ContextException 
    {
       String descriptionRTF="";  
       try
        {
            Context ctx=new Context();
            Context ctxSelected=(Context)ctx.findByPrimaryKey(id);
            descriptionRTF=ctxSelected.getContextRtf();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            System.out.println("MESSAGE: "+e.getMessage());

            throw new ContextException(e.getMessage());
        }        
       
       return descriptionRTF;        
    }    

    public void deleteAllContextes() throws ContextException
    {
        String sql="delete from CO_CONTEXT";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new ContextException(e.getMessage());
        }        
    } 

    public Vector getAllContextesOfFitxaAndFonts(String idDiccionari,String id) throws FinderException 
    {
        Vector<BeanVeureFitxa> v = new Vector<BeanVeureFitxa>();  
        
        Context context=new Context();
        Vector<BeanVeureFitxa> contextInfo=context.findContexteInfoAndFonts(idDiccionari,id);
        
        // Construim el format correcte per a les fonts : (font1;font2;...;fontN)
        // Tamb haurem de tractar el cas del contexte que estara en format RTF
        //      -   Haurem de fer un ctxt=FunctionalModule.convertRTF2Text(contextInfo.getText())
        v = FunctionalModule.createListFonts(contextInfo);  
         
        return v;        
    }
}