/*
 * DenominationManager.java
 *
 * Created on 7 de agosto de 2007, 17:12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.terminologic.definitions;

import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.skels.BdUtils;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.DefinitionException;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxa;
import com.termcat.business.terminologic.FitxaElement;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.util.UIDGenerator;
import electric.xml.Document;
import electric.xml.Element;
import java.sql.Connection;
import java.util.List;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;


/**
 *
 * @author Mena
 */
public class DefinitionManager {
    
    private static DefinitionManager manager;
    
    /** Creates a new instance of DenominationManager */
    public DefinitionManager() {
    }
     
    public static DefinitionManager getManager()
    {
        if(manager==null)
        {
            manager = new DefinitionManager();
        }
     
       return manager;
    }
    

    /*
     *       Mtode que obt una llista amb totes les definicions d'una determinada fitxa.
     *      @param idFitxa: Identificador de la fitxa.
     */
    public List getAllDefinitionsOfFitxa(String idFitxa) throws DefinitionException
    {
        Definicions definicio=null;
        Vector l=null;
        try
        {
            /*String sql="ID_FITXA='"+idFitxa+"'";
            definicio=new Definicions();
            l=definicio.findByGenericWhere(sql);*/
            Vector<FitxaElement> sortDefs = Fitxes.getAllDefinicionsFromFitxa(idFitxa);
            int numDefs = sortDefs.size();
            l = new Vector(numDefs);
            for(int i=0;i<numDefs;i++){
                String defId = sortDefs.get(i).getIdElement();
                Definicions defBean = new Definicions();
                defBean.findByPrimaryKey(defId);
                l.add(defBean);
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new DefinitionException(e.getMessage());            
        }
                
        return l;
    }
    
    public void altaDefinicio(String idDefinicio, String idDiccionari, String idFitxa, String idLlengua, String definicioNormal, String definicioRtf) throws DefinitionException 
    {
        try
        {
            String defNormal="",defRtf="";
            if (definicioNormal!=null)
                defNormal=definicioNormal;
            if (definicioRtf!=null)
                defRtf=definicioRtf;
            
            
            Connection con=DBConnect.getConnectionTransactional();
            Definicions definicio=new Definicions();
            definicio.setIdDefinicio(idDefinicio);
            definicio.setIdDiccionari(idDiccionari);
            definicio.setIdLlengua(idLlengua);
            definicio.setDefinicionNormal(defNormal);
            definicio.setDefinicionRtf(defRtf);
            definicio.setIdFitxa(idFitxa);
            definicio.create(con);           
            
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new DefinitionException(e.getMessage());            
            
        }
    }    
    
     /*
     *  Mtode que inserta una nova definicio a la BD.
     *  
     *  @param idDiccionari:    Identificador del diccionari al que pertany la fitxa.
     *  @param idFitxa:         Identificador de la fitxa a la que pertany.
     *  @param idLlengua:       Identificador de la llengua.
     *  @param definicioNormal: Definici sense format.
     *  @param definicioRtf:    Definici en format rtf.
     */
    public String altaDefinicio(String idDiccionari,String idFitxa,String idLlengua, String definicioNormal, String definicioRtf)
    {
        String idDefinicio=null;
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Definicions definicio=new Definicions();
            idDefinicio=UIDGenerator.generateUniqueId();
            definicio.setIdDefinicio(idDefinicio);
            definicio.setIdDiccionari(idDiccionari);
            definicio.setIdLlengua(idLlengua);
            definicio.setDefinicionNormal(definicioNormal);
            definicio.setDefinicionRtf(definicioRtf);
            definicio.setIdFitxa(idFitxa);
            definicio.create(con);           
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        return idDefinicio;
    }
   
    /*
     *       Mtode que esborra una definici.
     *      @param idDefinicio:     Identificador de la definici.
     */
    public void deleteDefinicio(String idDefinicio) 
    {
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Definicions definicio=new Definicions();
            Definicions definicioSelected=(Definicions)definicio.findByPrimaryKey(idDefinicio);
            definicioSelected.remove(con);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    /*
     *  Mtode que actualitza els valors d'una definicion de la BD.
     * 
     *  @param idDefinicio:     Identificador de la definicio.
     *  @param idLlengua:       Identificador de la llengua.
     *  @param defNormal:       Definici sense format. 
     *  @param defRtf:          Definici en format rtf.
     */
    public void updateDefinicio(String idDefinicio,String idLlengua, String defNormal, String defRtf)
    {
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Definicions definicio=new Definicions();
            Definicions definicioSelected=(Definicions)definicio.findByPrimaryKey(idDefinicio);

            definicioSelected.setIdLlengua(idLlengua);
            definicioSelected.setDefinicionNormal(defNormal);
            definicioSelected.setDefinicionRtf(defRtf);
            definicioSelected.flush(con);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }

  public Element getAllDefinitionsToXML(String idDiccionari)
    {
         Document doc=new Document();
         Element elem=new Element("DadesDefinicions");
         String sql=" ID_DICCIONARI='"+idDiccionari+"'";
         
         try
         {
            Definicions newDefinition=new Definicions();
            Definicions definition=new Definicions();

            List listDefinitions=newDefinition.findByGenericWhere(sql);
            for(int i=0;i<listDefinitions.size();++i)
            {
                definition = (Definicions)listDefinitions.get(i);
                elem.addElement(definition.toXml());
            }
            
            doc.setRoot(elem);

         }
         catch(Exception e)
         {
             
         }

         return doc.getRoot();

    }

    public String getRTFDefinition(String id) throws DefinitionException 
    {
       String descriptionRTF="";  
       try
        {
            Definicions def=new Definicions();
            Definicions defSelected=(Definicions)def.findByPrimaryKey(id);
            descriptionRTF=defSelected.getDefinicionRtf();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            System.out.println("MESSAGE: "+e.getMessage());

            throw new DefinitionException(e.getMessage());
        }        
       
       return descriptionRTF;        
    }


    public void deleteAllDefinitions() throws DefinitionException
    {
        String sql="delete from CO_DEFINICIONS";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new DefinitionException(e.getMessage());
        }        
    }

    public static Vector getAllDefinitionsOfFitxaAndFonts(String idDiccionari,String id) throws FinderException 
    {
        Vector<BeanVeureFitxa> v = new Vector<BeanVeureFitxa>();  
        
        Definicions def=new Definicions();
        Vector<BeanVeureFitxa> defInfo=def.findDefinitionInfoAndFonts(idDiccionari,id);
        
        // Construim el format correcte per a les fonts : (font1;font2;...;fontN)
        v = FunctionalModule.createListFonts(defInfo);  

        return v;       
    }
    
    public static void main(String args[])
    {
        String id="58bb1196-7cbd-11dc-af6c-43be3a400a39";
        
        try 
        {            
            getAllDefinitionsOfFitxaAndFonts("",id);
        } 
        catch (FinderException ex) 
        {
            ex.printStackTrace();
        }        
    }
    
 }