/*
 * DenominationManager.java
 *
 * Created on 7 de agosto de 2007, 17:12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.terminologic.notes;

import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Notes;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.NoteException;
import com.termcat.business.reports.veurefitxa.BeanVeureFitxa;
import com.termcat.business.terminologic.FitxaElement;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.util.UIDGenerator;
import electric.xml.Document;
import electric.xml.Element;
import java.sql.Connection;
import java.util.List;
import java.util.Vector;
import com.termcat.bd.utils.DBConnect;

/**
 *
 * @author Mena
 */
public class NoteManager {
    
    private static NoteManager manager;
    
    /** Creates a new instance of DenominationManager */
    public NoteManager() {
    }
     
    public static NoteManager getManager()
    {
        if(manager==null)
        {
            manager = new NoteManager();
        }
     
       return manager;
    }
    
    /*
     *       Mtode que obt una llista amb totes les notes d'una determinada fitxa.
     *      @param idFitxa: Identificador de la fitxa.
     */
    public List getAllNotesOfFitxa(String idFitxa)
    {
        Notes notes=null;
        Vector l=null;
        try
        {
            /*String sql="ID_FITXA='"+idFitxa+"'";
            notes=new Notes();
            l=notes.findByGenericWhere(sql);*/
            Vector<FitxaElement> sortNotas = Fitxes.getAllNotesFromFitxa(idFitxa);
            int numNotas = sortNotas.size();
            l = new Vector(numNotas);
            for(int i=0;i<numNotas;i++){
                String notaId = sortNotas.get(i).getIdElement();
                Notes notasBean = new Notes();
                notasBean.findByPrimaryKey(notaId);
                l.add(notasBean);
            }
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
        return l;
    }
    
    public void altaNota(String idNota, String idDiccionari, String idFitxa, String idLlengua, String notaNormal, String notaRtf) throws NoteException 
    {
       try
        {
            String noteNormal="",noteRtf="";
            
            if (notaNormal!=null)
                noteNormal=notaNormal;
            if (notaRtf!=null)
                noteRtf=notaRtf;
            
            Connection con=DBConnect.getConnectionTransactional();
            Notes nota=new Notes();
            nota.setIdNota(idNota);
            nota.setIdDiccionari(idDiccionari);
            nota.setIdLlengua(idLlengua);
            nota.setNotaNormal(noteNormal);
            nota.setNotaRtf(noteRtf);
            nota.setIdFitxa(idFitxa);
            nota.create(con);           
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new NoteException(e.getMessage());
        }      
    }
    
    
    /*
     *  Mtode que inserta una nova definicio a la BD.
     *  
     *  @param idDiccionari:    Identificador del diccionari al que pertany la fitxa.
     *  @param idFitxa:         Identificador de la fitxa a la que pertany.
     *  @param idLlengua:       Identificador de la llengua.
     *  @param notaNormal:      Contingut de la nota sense format.
     *  @param notaRtf:         Contingut de la nota en format rtf.
     */
    public String altaNota(String idDiccionari,String idFitxa,String idLlengua, String notaNormal, String notaRtf) throws NoteException
    {
        String idNota=null;
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Notes nota=new Notes();
            idNota=UIDGenerator.generateUniqueId();
            nota.setIdNota(idNota);
            nota.setIdDiccionari(idDiccionari);
            nota.setIdLlengua(idLlengua);
            nota.setNotaNormal(notaNormal);
            nota.setNotaRtf(notaRtf);
            nota.setIdFitxa(idFitxa);
            nota.create(con);           
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new NoteException(e.getMessage());            
        }
        return idNota;
    }
   
    /*
     *       Mtode que esborra una nota.
     *      @param idNota:     Identificador de la nota.
     */
    public void deleteNota(String idNota) 
    {
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Notes nota=new Notes();
            Notes notaSelected=(Notes)nota.findByPrimaryKey(idNota);
            notaSelected.remove(con);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }
    
    
    /*
     *  Mtode que actualitza els valors d'una nota de la BD.
     * 
     *  @param idNota:          Identificador de la nota.
     *  @param idLlengua:       Identificador de la llengua.
     *  @param notaNormal:      Contingut de la nota sense format. 
     *  @param notaRtf:         Contingut de la nota en format rtf.
     */
    public void updateNota(String idNota,String idLlengua, String notaNormal, String notaRtf)
    {
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            Notes nota=new Notes();
            Notes notaSelected=(Notes)nota.findByPrimaryKey(idNota);

            notaSelected.setIdLlengua(idLlengua);
            notaSelected.setNotaNormal(notaNormal);
            notaSelected.setNotaRtf(notaRtf);
            notaSelected.flush(con);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }
    
     public Element getAllNotesToXML(String idDiccionari)
    {
         Document doc=new Document();
         Element elem=new Element("DadesNotes");
         String sql=" ID_DICCIONARI='"+idDiccionari+"'";
         
         try
         {
            Notes newNote=new Notes();
            Notes note=new Notes();

            List listNotes=newNote.findByGenericWhere(sql);
            for(int i=0;i<listNotes.size();++i)
            {
                note = (Notes)listNotes.get(i);
                elem.addElement(note.toXml());
            }
            
            doc.setRoot(elem);

         }
         catch(Exception e)
         {
             
         }

         return doc.getRoot();

    }

    public String getRTFNote(String id) throws NoteException 
    {
       String descriptionRTF="";  
       try
        {
            Notes nota=new Notes();
            Notes notaSelected=(Notes)nota.findByPrimaryKey(id);
            descriptionRTF=notaSelected.getNotaRtf();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            System.out.println("MESSAGE: "+e.getMessage());

            throw new NoteException(e.getMessage());
        }        
       
       return descriptionRTF;                    
    }

     public void deleteAllNotes() throws NoteException
    {
        String sql="delete from CO_NOTES";
        try 
        {
            com.termcat.bd.beans.BDUtil.execute(sql);        
        } 
        catch (Exception e) 
        {
            throw new NoteException(e.getMessage());
        }        
    }  

    public Vector getAllNotesOfFitxaAndFonts(String idDiccionari,String id) throws FinderException 
    {
        Vector<BeanVeureFitxa> v = new Vector<BeanVeureFitxa>();  
        
        Notes nota=new Notes();
        Vector<BeanVeureFitxa> notaInfo=nota.findNotaInfoAndFonts(idDiccionari,id);
        
        // Construim el format correcte per a les fonts : (font1;font2;...;fontN)
        v = FunctionalModule.createListFonts(notaInfo);        
         
        return v;
    }

}