/*
 * DenominationManager.java
 *
 * Created on 7 de agosto de 2007, 17:12
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.business.terminologic.search;

import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.FontsDenominacions;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.exceptions.SearchException;
import com.termcat.layout.commons.BoolString;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.search.Search;
import com.termcat.layout.commons.search.Values;
import java.util.ArrayList;
import java.util.Vector;

/**
 *
 * @author Mena
 */
public class SearchManager {
    
    private static SearchManager manager;
    
    /** Creates a new instance of DenominationManager */
    public SearchManager() {
    }
     
    public static SearchManager getManager()
    {
        if(manager==null)
        {
            manager = new SearchManager();
        }
     
       return manager;
    }
     
         
   /*
    *        Mtode que obt totes les denominacions principals i arees temtiques de les fitxes 
    *       en funci d'una cerca.
    *       @param: sql : String amb la query filtrada
    */
    public Vector getDenominacionsPrincipalsAndTematicAreasOfSearch(String sql) throws SearchException
    {

         Vector listDenominacions=null;
         try
         {
            Denominacions denominacions=new Denominacions();                     
            listDenominacions=denominacions.findPrincipalDenominationsAndTematicAreasOfSearch(sql);
         }
         catch(Exception e)
         {
             e.printStackTrace();
             throw new SearchException(e.getMessage());
         }
         
         return listDenominacions;
    }
    
    // Obt la part de la query de les denominacions
    private String getFilteredDenominacions(BoolString deno, BoolString llengua, BoolString jerarquia, BoolString categoria) 
    {
        String sql="";
        
        // Comprovaci de la denominaci
        if (!deno.isNull())
            sql+=" AND "+deno.getValue();           

        // Comprovaci de la llengua
        if (!llengua.isNull())            
        {
            if (llengua.getValue().trim().contains("NOT"))
                sql+=" AND (deno.id_llengua IS NULL OR deno.id_llengua "+llengua.getValue()+") ";
            else
                sql+=" AND deno.id_llengua "+llengua.getValue();
        }
        // Comprovaci de la jerarquia
        if (!jerarquia.isNull())
        {
            if (jerarquia.getValue().trim().contains("NOT"))
                sql+=" AND (deno.id_jerarquia IS NULL OR deno.id_jerarquia "+jerarquia.getValue()+") ";
            else
                sql+="AND deno.id_jerarquia "+jerarquia.getValue();
        }
        // Comprovaci de la categoria
        if (!categoria.isNull())
        {    
            if (categoria.getValue().trim().contains("NOT"))
                sql+=" AND (deno.id_categoria IS NULL OR deno.id_categoria "+categoria.getValue()+") ";
            else
                sql+=" AND deno.id_categoria "+categoria.getValue();
        }
        
        // Printem el resultat
        System.out.println("FILTERED DENMOMINACIONS QUERY: "+sql);
        
        return sql;        
    }   

    // Obt la part de la query de les definicions.
    private String getFilteredDefinicio(String idDiccionari,String definicioFilter, String definicioFitxa) 
    {
        String sql="";
        
        //if (!definicioFilter.equals(" UCASE(definicion_normal) "))
        if (!definicioFilter.equals(" definicion_normal "))
            sql+=" AND "+definicioFilter;
        else if (!definicioFitxa.equals(""))
            sql+=" AND "+definicioFitxa;
        
        System.out.println("FILTERED DEFINICIO QUERY: "+sql);
        return sql;
    }

    // Obt la part de la query de les notes.
    private String getFilteredNota(String idDiccionari, String notaFilter, String notaFitxa) 
    {
        String sql="";
        //if (!notaFilter.equals(" UCASE(nota_normal) "))
        if (!notaFilter.equals(" nota_normal "))            
            sql+=" AND "+notaFilter;
        else if (!notaFitxa.equals(""))
            sql+=" AND "+notaFitxa;
        
        System.out.println("FILTERED NOTA QUERY: "+sql);
        
        return sql;
    }
    
    // Obt la part de la query de les fitxes (filtratge de les observacions).
    private String getFilteredFitxa(String idDiccionari, String observacions) 
    {
       String sql="";

       if (!observacions.equals(""))
            sql+=" AND " +observacions;
       
       System.out.println("FILTERED FITXA QUERY: "+sql);
        
        return sql;
    }
    
    // Funcions de 'parse' de les dades de l'objecte de memoria
    //-----------------------------------------------------------   
    private String getValors(Values values) 
    {
        String query="";
        if (!values.getValue().trim().equals(""))
        {
            // En aquest cas vol dir que tenim un filtratge per denominacio.
            switch(values.getType())
            {
                case 0: // Es igual a
                        query+="='"+values.getValue()+"'";
                        break;
                        
                case 1: // Cont
                        //query+="LIKE UCASE('%"+values.getValue()+"%')";                    
                        query+="LIKE '%"+values.getValue()+"%'";                    
                        break;
                        
                case 2: // Comena per
                        //query+="LIKE UCASE('"+values.getValue()+"%')";                                        
                        query+="LIKE '"+values.getValue()+"%'";                                                            
                        break;
                        
                case 3: // Finalitza amb
                        //query+="LIKE UCASE('%"+values.getValue()+"')";   
                        query+="LIKE '%"+values.getValue()+"'";                                                                
                        break;                        
            }
        }                
        return query;
    }

    /*
     *       Mtode que obt els valors de la llista i els posa en format:
     *            -   ('@id1','@id2', ...,'@idN')
     */
    private String getGroup(Vector vector) 
    {
        String sql="";
        if (vector.size()>0)
        {
            sql+="'"+((ItemListCustom)vector.get(0)).getId()+"'";
            for (int i=1;i<vector.size();++i)
            {
                ItemListCustom ic=(ItemListCustom)vector.get(i);
                sql+=",'"+ic.getId()+"'";
            }
        }
        return sql;
    }

    /*
     *    Mtode que crea una query que obt tots els id de les fitxes que CONTENEN les fonts seleccionades.
     *    Aquest cas s'utilitza per a la cerca quan es vol fer una query indicant les fonts i la opcio 'NO CONTE'.
     *    Es fa d'aquesta manera i no amb el NOT IN 'i el getGroup'  ja que en el cas de les fonts podem tenir varies files de la 
     *   resposta amb la mateixa denominacio i diferents fonts i nomes eliminar de la cerca la fila en la que coindideix la font amb la seleccionada.
     *    Pero la resta (en cas d'haver-hi) les retornar i per tant quan es faci el distinc en el createFilteredSubquery mostrar el id de la fitxa, i no 
     *   l'hauria de mostrar.
     *    En canvi amb aquest mtode fem que guardi tots els id de fitxa que continguin alguna de les fonts indicades. I despres al fer el NOT IN del id_fitxa
     *   amb el resultat d'aquesta query, no les mostrar.
     */
    private String getFontGroup(Vector vector, String idDiccionari) throws FinderException 
    {
        String sql="";
        String idFonts="";
        // Tamb es podria fer un NOT IN
        if (vector.size()>0)
        {
            idFonts+="id_font='"+((ItemListCustom)vector.get(0)).getId()+"'";
            for (int i=1;i<vector.size();++i)
            {
                ItemListCustom ic=(ItemListCustom)vector.get(i);
                idFonts+=" or id_font='"+ic.getId()+"'";
            }
        }
        
        // Obtenim els ids de les fitxes que cumpleixen la negativa!
        FontsDenominacions fontsDeno=new FontsDenominacions();
        Vector<String> list= fontsDeno.getIdFitxa(idDiccionari,idFonts);
        if (list.size()>0)
        {
            sql+="'"+list.get(0)+"'";
            for (int i=1;i<list.size();++i)
            {                
                sql+=",'"+list.get(i)+"'";
            }            
        }
        
        return sql;        
    }
    
     private String createFiletredSubQuery(String idDiccionari,String fitxaQuery, String denominacioQuery, String definicioQuery, String notaQuery, String areesTematiquesQuery) 
    {
        String sql="select distinct id_fitxa from view_cerca WHERE id_diccionari='"+idDiccionari + "' "+ fitxaQuery + " " +denominacioQuery + " " + definicioQuery + " " + notaQuery + " " + areesTematiquesQuery;        
        System.out.println("Filtered Subquery: "+sql);
        return sql;
    }    
         
     
     public String getDefinicionsFiltered(Search cerca)
     {
            String sql="";
            String definicioFilter=" definicion_normal ";       
            String definicioFitxa="";

            switch(cerca.getFitxa().getDefinicions())
            {
                case 1:definicioFitxa+=" (definicion_normal IS NOT NULL or definicion_normal!='') ";
                        break;

                case 2: definicioFitxa+="NO_DEF";
                        break;

                default: break;
            } 


           definicioFilter+=getValors(cerca.getDefinicions());        

            if (!definicioFilter.equals(" definicion_normal "))
                sql+=definicioFilter;
            else if (!definicioFitxa.equals(""))
                sql+=definicioFitxa;

           System.out.println("FILTERED DEFINICIONS QUERY: "+sql);

           return sql;
     }
     
     public String getNotesFiltered(Search cerca)
     {
            String sql="";
            String notaFilter=" nota_normal ";               
            String notaFitxa="";        
            switch(cerca.getFitxa().getNotes())
            {
                case 1: notaFitxa+=" (nota_normal IS NOT NULL OR nota_normal!='') ";
                        break;

                case 2: notaFitxa+="NO_NOTA";
                        break;

                default: break;
            }

            notaFilter+=getValors(cerca.getNotes());          

            if (!notaFilter.equals(" nota_normal "))            
                sql+=notaFilter;
            else if (!notaFitxa.equals(""))
                sql+=notaFitxa;
             return sql;
     }
     
     public String getObservacionsFiltered(Search cerca)
     {
         
           String sql="";
           String observacioFitxa="";        
           switch(cerca.getFitxa().getObservacions())
           {
                case 1: observacioFitxa+="fitxes.observacions IS NOT NULL AND fitxes.observacions!=''";                
                        break;

                case 2: observacioFitxa+="(fitxes.observacions IS NULL OR fitxes.observacions='')";                
                        break;

                default: break;
           }        
           
           if (!observacioFitxa.equals(""))
                sql+=" AND " +observacioFitxa;

           System.out.println("FILTERED FITXA QUERY: "+sql);

           return sql;
     }
     
     public String getAreesTematiquesFiltered(Search cerca)
     {
         String sql="";

         if (cerca.getAreesTematiques().getSelectedList().size()>0)
         {             
            if (cerca.getAreesTematiques().getContains())
                sql=" id_area IN ("+getGroup(cerca.getAreesTematiques().getSelectedList())+")";               
            else    
                sql=" (id_area IS NULL OR id_area NOT IN ("+getGroup(cerca.getAreesTematiques().getSelectedList())+") )";
         }
           System.out.println("FILTERED AT QUERY: "+sql);         
         
         return sql;
     }
     
    public String getFontsFiltered(Search cerca,String idDiccionari) throws FinderException 
    {
        String fontDenominacio="";
        String sql="";
                
        boolean containsFont=cerca.getFonts().getContains();
        if (containsFont)
        {
            fontDenominacio=" IN (";            
            fontDenominacio+=getGroup(cerca.getFonts().getSelectedList());               
        }
        else
        {
            fontDenominacio=" NOT IN (";        
            // Aquesta funcio getFontGroup, s'haur de mirar perque el que fa es buscar a la vista.
            fontDenominacio+=getFontGroup(cerca.getFonts().getSelectedList(),idDiccionari);
        }
        
        fontDenominacio+=") ";
 
        BoolString font=new BoolString();   
        font.setValueOfNull(cerca.getFonts().getSelectedList().size()==0);
        font.setValue(fontDenominacio);        

        // Comprovaci de la font 
        if (!font.isNull())
        {
            if (font.getValue().trim().contains("NOT"))
            {                   
                sql+=" AND (denoFont.id_font IS NULL OR deno.id_fitxa"+font.getValue()+") ";              
            }
            else
                sql+=" AND denoFont.id_font "+font.getValue();
        }

        System.out.println("FILTERED FONTS DENOMINACIONS QUERY: "+sql);                     
        
        return sql;
    }

     public String getDenominacionsFiltered(Search cerca)
     {
         String sql="";
         String llenguesDenominacio="", jerarquiesDenominacio="", categoriesDenominacio="";         
         String denominacioFilter=" deno.terme_normal ";
         denominacioFilter+=getValors(cerca.getDenominacions());
         
        // 1. Llengua
        boolean containsLlengua=cerca.getLlengues().getContains();
        if (containsLlengua)
            llenguesDenominacio=" IN (";            
        else    
            llenguesDenominacio=" NOT IN (";        
        llenguesDenominacio+=getGroup(cerca.getLlengues().getSelectedList());               
        llenguesDenominacio+=") ";
        
        // 2. Jerarqua
        boolean containsJerarquia=cerca.getJerarquies().getContains();
        if (containsJerarquia)
            jerarquiesDenominacio=" IN (";            
        else    
            jerarquiesDenominacio=" NOT IN (";        
        jerarquiesDenominacio+=getGroup(cerca.getJerarquies().getSelectedList());               
        jerarquiesDenominacio+=") ";
                
        // 3. Categoria
        boolean containsCategoria=cerca.getCategories().getContains();
        if (containsCategoria)
            categoriesDenominacio=" IN (";            
        else    
            categoriesDenominacio=" NOT IN (";        
        categoriesDenominacio+=getGroup(cerca.getCategories().getSelectedList());               
        categoriesDenominacio+=") ";        
                
        
        // 4. Creaci de l'objecte BoolString
        BoolString denoObject = new BoolString();
        BoolString llenguesObject = new BoolString();
        BoolString jerarquiesObject=new BoolString();
        BoolString categoriesObject=new BoolString();
             

        denoObject.setValueOfNull(cerca.getDenominacions().getValue().trim().equals(""));
        if (denominacioFilter.equals(" deno.terme_normal "))
            denominacioFilter="";
        denoObject.setValue(denominacioFilter);         
        
        llenguesObject.setValueOfNull(cerca.getLlengues().getSelectedList().size()==0);
        llenguesObject.setValue(llenguesDenominacio);
        
        jerarquiesObject.setValueOfNull(cerca.getJerarquies().getSelectedList().size()==0);
        jerarquiesObject.setValue(jerarquiesDenominacio);        
        
        categoriesObject.setValueOfNull(cerca.getCategories().getSelectedList().size()==0);
        categoriesObject.setValue(categoriesDenominacio);        
               
        sql=getFilteredDenominacions(denoObject,llenguesObject,jerarquiesObject,categoriesObject);
         
         
        return sql;
     }

     
     
}