 /* MainFrame.java
 *
 * Created on 12 de julio de 2007, 11:38
 */

package com.termcat.layout;

 import com.termcat.bd.utils.DBConnect;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.layout.informes.reports.SelectLanguagePanel;
import com.termcat.layout.informes.reports.SelectTematicAreaPanel;
 import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.search.Search;
import com.termcat.layout.diccionari.DiccionariEdit;
import com.termcat.layout.diccionari.DiccionariLlengues;
 import com.termcat.layout.diccionari.DiccionariAlta;
 import com.termcat.layout.diccionari.DiccionariLlengues;
import com.termcat.layout.diccionari.arees.AreesMain;
import com.termcat.layout.eines.ExportarDiccionari;
import com.termcat.layout.eines.ImportarDiccionari;
import com.termcat.layout.informes.reports.FontsReport;
 import com.termcat.layout.manteniments.llengues.LlenguesMain;
 import com.termcat.layout.manteniments.fonts.FontsMain;
 
 import com.termcat.layout.manteniments.categories.CategoriesMain;
 import com.termcat.layout.manteniments.marques.MarquesMain;
 import com.termcat.layout.manteniments.jerarquies.JerarquiesMain;
import com.termcat.layout.terminologic.cerca.CercaMain;

 import com.termcat.layout.terminologic.fitxes.FitxesMain;
 import com.termcat.bd.beans.Llengues;
 import com.termcat.business.exceptions.DictionaryException;
import com.termcat.util.literales.Literales;
 
 import java.awt.BorderLayout;
import java.awt.Image;
import java.awt.Toolkit;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
import java.io.File;
import java.sql.Connection;
 import java.util.Locale;
import java.util.Map;
import javax.swing.ImageIcon;
 import javax.swing.JButton;
 import javax.swing.JComponent;
 import javax.swing.JDialog;
 import javax.swing.JLabel;
 import javax.swing.JOptionPane;
 import javax.swing.JPanel;
import javax.swing.JTree;
 import javax.swing.SwingUtilities;
 import javax.swing.JTable;
 import javax.swing.JFrame;
 import javax.swing.JScrollPane;
 import java.awt.Dimension;
 import java.awt.Color;
 import java.util.Vector;
 import java.util.Iterator;
 import com.termcat.layout.commons.popup.PanelPopup;
import javax.swing.UIManager;

import org.jvnet.substance.SubstanceLookAndFeel;
import org.jvnet.substance.theme.ThemeInfo;
import org.jvnet.substance.utils.SubstanceConstants;
import org.jvnet.substance.watermark.SubstanceImageWatermark;
import org.jvnet.substance.watermark.SubstanceNoneWatermark;
import org.jvnet.substance.watermark.SubstanceStripeWatermark;
import org.jvnet.substance.watermark.WatermarkInfo;
 
import com.termcat.layout.ajuda.AboutDialog;

/**
 *
 * @author  Vazquezl
 */
public class MainFrame extends javax.swing.JFrame {
    
    private FunctionalModule currentModule;
    
    private PanelPopup currentPopupPanel;
    private PanelPopup editPopupPanel;
    private PanelPopup altaPopupPanel;
    
    private String idCurrentDictionary;
    private String nomCurrentDicionary;  
   
    private String idCurrentFitxa;  //han de ser statics??
    private boolean isCurrentFitxaDirty; //han de ser statics??
    
    // boolean que indica si estn els camps necessaris
    private boolean isReady2Add;

    // boolean que indica si hi ha alguna denoPrincipal
    private boolean isDenoDefined;

    public JTree tree; // potser s'haurien de posar al Functional module o Fitxa
    public JTable tableAt;

    private int currentPage;
    private int lastTab;
    
   // Tamany de la finestra principal. 
    private double HEIGHT_MENU_FRAME;
    private double WIDTH_MENU_FRAME;
    
    // Constants
    private final int ROWS_IN_PAGE=28;
    //private final int ROWS_IN_PAGE=15;
    // Booleans de conflicte per a la cerca.
    private boolean definitionConflict;
    private boolean noteConflict;

    // Query de la cerca 'actual'
    //private String querySearch;
    private Search currentCerca;

    private boolean llenguesModified;
    private boolean areesModified;    
    private boolean categoriesModified;            
    private boolean jerarquiesModified;                
    private boolean fontsModified;        

    // Vector que cont totes les fonts actualitzades. Far una espcie de "memria cau", per a agilitzar la crrega
    // de les fonts a les estructures de dades que les utilitzin.
    public Vector allFontsUpdated;
    
    /** Creates new form MainFrame */
    public MainFrame() 
    {
        try
        {
            setLookAndFeel("Steel Blue");
            //setWatermark("Square mosaic");
            initComponents();
            
            initMainFrame();

            // Fem el tamamny del panel fixe.
            Dimension dim=new Dimension(1000,768);
            this.setSize(dim);
            this.setPreferredSize(dim);
            this.setMinimumSize(dim);
            this.setMaximumSize(dim);
            this.setBackground(new Color(238,238,238));
            
            this.setLlenguesModified(false);
            this.setATModified(false);
            this.setCategoriesModified(false);
            this.setJerarquiesModified(false);
            // Inicialitzem el vector de fonts
            try
            {
                this.allFontsUpdated=FontManager.getManager().getAllCodeIdFonts();
            }
            catch(Exception exc)
            {          
                exc.printStackTrace();
            }
        } 
        catch(Exception e)
        {
            // Mirar que fer en el cas de que peti el initMainFrame();
            e.printStackTrace();  
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">                          
    private void initComponents() {
        modulePanel = new javax.swing.JPanel();
        barraMenu = new javax.swing.JMenuBar();
        menuArxiu = new javax.swing.JMenu();
        sortirApp = new javax.swing.JMenuItem();
        menuDiccionari = new javax.swing.JMenu();
        altaDiccionari = new javax.swing.JMenuItem();
        propietatsDiccionari = new javax.swing.JMenuItem();
        llenguesDiccionari = new javax.swing.JMenuItem();
        arbreCampDiccionari = new javax.swing.JMenuItem();
        esborrarDiccionari  = new javax.swing.JMenuItem();
        menuTerminologic = new javax.swing.JMenu();
        fitxes = new javax.swing.JMenuItem();
        cercarTermes = new javax.swing.JMenuItem();
        menuManteniments = new javax.swing.JMenu();
        mantenimentLlengues = new javax.swing.JMenuItem();
        mantenimentFonts = new javax.swing.JMenuItem();
        mantenimentCategories = new javax.swing.JMenuItem();
        mantenimentsJerarquies = new javax.swing.JMenuItem();
        mantenimentsMarques = new javax.swing.JMenuItem();
        menuInformes = new javax.swing.JMenu();
        submenuInformes = new javax.swing.JMenu();
        informeLlistats = new javax.swing.JMenu();
        opcioDicAlfa = new javax.swing.JMenuItem();
        opcioDicLang = new javax.swing.JMenuItem();
        opcioDicTem = new javax.swing.JMenuItem();
        opcioIndex = new javax.swing.JMenuItem();
        informeFonts = new javax.swing.JMenuItem();
        submenuEstadistiques = new javax.swing.JMenu();
        fitxesIdenominacions = new javax.swing.JMenuItem();
        arees = new javax.swing.JMenuItem();
        estaditicaFonts = new javax.swing.JMenuItem();
        menuEines = new javax.swing.JMenu();
        importar = new javax.swing.JMenuItem();
        exportar = new javax.swing.JMenuItem();
        menuAjuda = new javax.swing.JMenu();
        ajuda = new javax.swing.JMenuItem();
        about = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(Literales.getTextForLiteral("Gdt_Codi_Obert"));
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                actionWindowClosing(evt);
            }
            public void windowClosing(java.awt.event.WindowEvent evt) {
                actionWindowClosing(evt);
            }
        });

        modulePanel.setMaximumSize(new java.awt.Dimension(1024, 768));
        modulePanel.setMinimumSize(new java.awt.Dimension(1024, 768));
        org.jdesktop.layout.GroupLayout modulePanelLayout = new org.jdesktop.layout.GroupLayout(modulePanel);
        modulePanel.setLayout(modulePanelLayout);
        modulePanelLayout.setHorizontalGroup(
            modulePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 1024, Short.MAX_VALUE)
        );
        modulePanelLayout.setVerticalGroup(
            modulePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 770, Short.MAX_VALUE)
        );
        getContentPane().add(modulePanel, java.awt.BorderLayout.CENTER);

        menuArxiu.setText(Literales.getTextForLiteral("Arxiu"));
        sortirApp.setText(Literales.getTextForLiteral("Sortir"));
        sortirApp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                sortirAppActionPerformed(evt);
            }
        });

        menuArxiu.add(sortirApp);

        barraMenu.add(menuArxiu);

        menuDiccionari.setText(Literales.getTextForLiteral("Diccionari"));
        altaDiccionari.setText(Literales.getTextForLiteral("Alta_de_diccionari"));
        altaDiccionari.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                altaDiccionariActionPerformed(evt);
            }
        });

        menuDiccionari.add(altaDiccionari);

        propietatsDiccionari.setText(Literales.getTextForLiteral("Propietats_generals"));
        propietatsDiccionari.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                propietatsDiccionariActionPerformed(evt);
            }
        });

        menuDiccionari.add(propietatsDiccionari);

        llenguesDiccionari.setText(Literales.getTextForLiteral("Llengues"));
        llenguesDiccionari.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                llenguesDiccionariActionPerformed(evt);
            }
        });

        menuDiccionari.add(llenguesDiccionari);

        arbreCampDiccionari.setText(Literales.getTextForLiteral("ArbreCampLabel"));
        arbreCampDiccionari.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                arbreCampActionPerformed(evt);
            }
        });

        menuDiccionari.add(arbreCampDiccionari);

        esborrarDiccionari.setText(Literales.getTextForLiteral("Esborrar_diccionari"));
        esborrarDiccionari.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                esborrarDiccionariActionPerformed(evt);
            }
        });

        menuDiccionari.add(esborrarDiccionari);
        
        
        barraMenu.add(menuDiccionari);

        menuTerminologic.setText(Literales.getTextForLiteral("Treball_Terminologic"));
        fitxes.setText(Literales.getTextForLiteral("Fitxes"));
        fitxes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fitxesActionPerformed(evt);
            }
        });

        menuTerminologic.add(fitxes);

        cercarTermes.setText(Literales.getTextForLiteral("Cercar_termes"));
        cercarTermes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cercarTermesActionPerformed(evt);
            }
        });

        menuTerminologic.add(cercarTermes);

        barraMenu.add(menuTerminologic);

        menuManteniments.setText(Literales.getTextForLiteral("Manteniments"));
        menuManteniments.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                menuMantenimentsActionPerformed(evt);
            }
        });

        mantenimentLlengues.setText(Literales.getTextForLiteral("Manteniments_de_llengues"));
        mantenimentLlengues.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mantenimentLlenguesActionPerformed(evt);
            }
        });

        menuManteniments.add(mantenimentLlengues);

        mantenimentFonts.setText(Literales.getTextForLiteral("Manteniment_de_fonts"));
        mantenimentFonts.setActionCommand(Literales.getTextForLiteral("Manteniments_de_fonts"));
        mantenimentFonts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mantenimentFontsActionPerformed(evt);
            }
        });

        menuManteniments.add(mantenimentFonts);

        mantenimentCategories.setText(Literales.getTextForLiteral("Manteniment_de_categories"));
        mantenimentCategories.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mantenimentCategoriesActionPerformed(evt);
            }
        });

        menuManteniments.add(mantenimentCategories);

        mantenimentsJerarquies.setText(Literales.getTextForLiteral("Manteniments_de_jerarquies"));
        mantenimentsJerarquies.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mantenimentsJerarquiesActionPerformed(evt);
            }
        });

        menuManteniments.add(mantenimentsJerarquies);

        mantenimentsMarques.setText(Literales.getTextForLiteral("Manteniments_de_marques_de_ponderaci"));
        mantenimentsMarques.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                mantenimentMarquesActionPerformed(evt);
            }
        });

        menuManteniments.add(mantenimentsMarques);

        barraMenu.add(menuManteniments);

        menuInformes.setText(Literales.getTextForLiteral("Informes_i_estadistiques"));
        submenuInformes.setLabel(Literales.getTextForLiteral("Informes"));
        submenuInformes.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                submenuInformesActionPerformed(evt);
            }
        });

        informeLlistats.setText(Literales.getTextForLiteral("Llistats"));
        informeLlistats.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                informeLlistatsActionPerformed(evt);
            }
        });

        opcioDicAlfa.setText(Literales.getTextForLiteral("Diccionari_alfabetic"));
        opcioDicAlfa.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                opcioDicAlfaActionPerformed(evt);
            }
        });

        informeLlistats.add(opcioDicAlfa);

        opcioDicLang.setText(Literales.getTextForLiteral("Diccionari_alfabetic_per_llengues"));
        opcioDicLang.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                opcioDicLangActionPerformed(evt);
            }
        });

        informeLlistats.add(opcioDicLang);

        opcioDicTem.setText(Literales.getTextForLiteral("Diccinari_tematic"));
        opcioDicTem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                opcioDicTemActionPerformed(evt);
            }
        });

        informeLlistats.add(opcioDicTem);

        opcioIndex.setText(Literales.getTextForLiteral("Index_alfabetic"));
        opcioIndex.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                opcioIndexActionPerformed(evt);
            }
        });

        informeLlistats.add(opcioIndex);

        submenuInformes.add(informeLlistats);

        informeFonts.setText(Literales.getTextForLiteral("Fonts"));
        informeFonts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                informeFontsActionPerformed(evt);
            }
        });

        submenuInformes.add(informeFonts);

        menuInformes.add(submenuInformes);

        submenuEstadistiques.setText(Literales.getTextForLiteral("Estadistiques"));
        fitxesIdenominacions.setText(Literales.getTextForLiteral("Fitxes_i_denominacions"));
        fitxesIdenominacions.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fitxesIdenominacionsActionPerformed(evt);
            }
        });

        submenuEstadistiques.add(fitxesIdenominacions);

        arees.setText(Literales.getTextForLiteral("Arees_Tematiques"));
        arees.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                areesActionPerformed(evt);
            }
        });

        submenuEstadistiques.add(arees);

        estaditicaFonts.setText(Literales.getTextForLiteral("Fonts"));
        estaditicaFonts.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                estaditicaFontsActionPerformed(evt);
            }
        });

        submenuEstadistiques.add(estaditicaFonts);

        menuInformes.add(submenuEstadistiques);

        barraMenu.add(menuInformes);

        menuEines.setText(Literales.getTextForLiteral("Eines"));
        importar.setText(Literales.getTextForLiteral("Importar"));
        importar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importarActionPerformed(evt);
            }
        });

        menuEines.add(importar);

        exportar.setText(Literales.getTextForLiteral("Exportar"));
        exportar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportarActionPerformed(evt);
            }
        });

        menuEines.add(exportar);

        barraMenu.add(menuEines);

        menuAjuda.setText(Literales.getTextForLiteral("Ajuda"));
        ajuda.setText(Literales.getTextForLiteral("Ajuda_del_Gdt"));
        ajuda.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ajudaActionPerformed(evt);
            }
        });

        menuAjuda.add(ajuda);

        about.setText(Literales.getTextForLiteral("Quant_al_Gdt"));
        about.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutActionPerformed(evt);
            }
        });

        menuAjuda.add(about);

        barraMenu.add(menuAjuda);

        setJMenuBar(barraMenu);

        pack();
    }// </editor-fold>                        

    private void aboutActionPerformed(java.awt.event.ActionEvent evt) {                                      
        Image image = new ImageIcon(getClass().getResource("/com/termcat/resources/img/logoMedio.jpg")).getImage();
        AboutDialog aboutDialog =  new AboutDialog(this,Literales.getTextForMessage("Ayuda_about_marco") ,Literales.getTextForMessage("Ayuda_about_titulo"),Literales.getTextForMessage("Ayuda_about_version"),Literales.getTextForMessage("Ayuda_about_copy"),Literales.getTextForMessage("Ayuda_about_info"),image);
        aboutDialog.show();        
    }                                     

    private void opcioIndexActionPerformed(java.awt.event.ActionEvent evt) {                                           
        doSelectLanguagePanel(true);
    }                                          

    private void opcioDicAlfaActionPerformed(java.awt.event.ActionEvent evt) {                                             
      new com.termcat.business.reports.llistat.LlistatReportManager(idCurrentDictionary).viewMainReport();
    }                                            

    private void opcioDicTemActionPerformed(java.awt.event.ActionEvent evt) {                                            
        FunctionalModule module = new SelectTematicAreaPanel(this);
        setFuncionalModule (module);
    }                                           

    private void opcioDicLangActionPerformed(java.awt.event.ActionEvent evt) {                                             
        doSelectLanguagePanel(false);
    }                                            

    private void informeLlistatsActionPerformed(java.awt.event.ActionEvent evt) {                                                
// TODO add your handling code here:
    }                                               

    private void cercarTermesActionPerformed(java.awt.event.ActionEvent evt) {                                             
        FunctionalModule module = CercaMain.getInstance(this);
        setFuncionalModule (module);
    }                                            

    private void exportarActionPerformed(java.awt.event.ActionEvent evt) {                                         
        FunctionalModule module = new ExportarDiccionari(this);
        setFuncionalModule (module);
    }                                        

    private void importarActionPerformed(java.awt.event.ActionEvent evt) {                                         
        FunctionalModule module = new ImportarDiccionari(this);
        setFuncionalModule (module);
    }                                        

    private void fitxesIdenominacionsActionPerformed(java.awt.event.ActionEvent evt) {                                                     
       new com.termcat.business.reports.fitxes.FitxaReportManager(idCurrentDictionary).viewFitxaReport();
               
    }                                                    

    private void areesActionPerformed(java.awt.event.ActionEvent evt) {                                      
        new com.termcat.business.reports.arees.AreaReportManager().viewReport();
    }                                     

    private void informeFontsActionPerformed(java.awt.event.ActionEvent evt) {                                             
       FunctionalModule module = new FontsReport(this);
       setFuncionalModule (module);
    }                                            

    private void estaditicaFontsActionPerformed(java.awt.event.ActionEvent evt) {                                                
       new com.termcat.business.reports.fonts.FontsReportManager().viewStatistic();
    }                                               

    private void submenuInformesActionPerformed(java.awt.event.ActionEvent evt) {                                                
// TODO add your handling code here:
    }                                               

    private void sortirAppActionPerformed(java.awt.event.ActionEvent evt) {                                          
        try 
        {
            dispose();
            System.exit(0);
	}
        catch (Exception e)
        {
            e.printStackTrace();
        }
        
    }                                         

    private void propietatsDiccionariActionPerformed(java.awt.event.ActionEvent evt) {                                                     
        FunctionalModule module = new DiccionariEdit(this, this.idCurrentDictionary);
        setFuncionalModule (module);
    }                                                    

    private void arbreCampActionPerformed(java.awt.event.ActionEvent evt) {                                          
        FunctionalModule module = new AreesMain(this);
        setFuncionalModule (module);
    }                                         

    private void esborrarDiccionariActionPerformed(java.awt.event.ActionEvent evt) {                                          
        
        int response = JOptionPane.showConfirmDialog(this, Literales.getTextForMessage("Confirmar_Esbborrar"), Literales.getTextForMessage("Importacio_Exportacio"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
        if (response == JOptionPane.YES_OPTION){
            try{
                DictionaryManager.getManager().deleteDiccionari();
                altaDiccionari.setEnabled(true);
                setEnableMenuOptions(false);
                setIdCurrentDictionary(null);
                showMessageInfo(Literales.getTextForMessage("DeleteDiccionariOK"));
                this.currentCerca=null;
                // Inicialitzem els boleans a false.
                this.isReady2Add=false;
                // Inicialitzem el numero de pgina inicial
                this.currentPage=0;
                this.lastTab=0;        
                // Esborrem el contingut de les arees temtiques.
                this.tree=null;
                this.tableAt=null;
                setNomCurrentDictionary("");
                FunctionalModule module = new DiccionariAlta(this);
                setFuncionalModule (module);
            }
            catch(Exception e){
                e.printStackTrace();
                showMessageError(Literales.getTextForMessage("DeleteDiccionariKO"));
            }
        }
    }                                         
    
    
    private void actionWindowClosing(java.awt.event.WindowEvent evt) {                                     
        try
        {
            Connection con=DBConnect.getConnectionTransactional();
            con.rollback();
            DBConnect.putConnectionTransactional();            
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
    }                                    

    private void llenguesDiccionariActionPerformed(java.awt.event.ActionEvent evt) {                                                   
       FunctionalModule module = new DiccionariLlengues(this);
       setFuncionalModule (module);
    }                                                  

    private void fitxesActionPerformed(java.awt.event.ActionEvent evt) {                                       
    if (!((FunctionalModule)currentModule instanceof FitxesMain || (FunctionalModule)currentModule instanceof CercaMain))
            setCurrentPage(0);
       
       FunctionalModule module = new FitxesMain(this);
       setFuncionalModule (module);
    }                                      

    private void mantenimentMarquesActionPerformed(java.awt.event.ActionEvent evt) {                                                   
       FunctionalModule module = new MarquesMain(this);
       setFuncionalModule (module);
    }                                                  

    private void mantenimentsJerarquiesActionPerformed(java.awt.event.ActionEvent evt) {                                                       
       FunctionalModule module = new JerarquiesMain(this);
       setFuncionalModule (module);
    }                                                      

    private void mantenimentCategoriesActionPerformed(java.awt.event.ActionEvent evt) {                                                      
       FunctionalModule module = new CategoriesMain(this);
       setFuncionalModule (module);
    }                                                     

    private void mantenimentFontsActionPerformed(java.awt.event.ActionEvent evt) {                                                 
       FunctionalModule module = new FontsMain(this);
       setFuncionalModule (module);
    }                                                

    private void ajudaActionPerformed(java.awt.event.ActionEvent evt) {                                      
       new com.termcat.layout.ajuda.HelpLauncher().showHelp(evt);
    }                                     

    private void mantenimentLlenguesActionPerformed(java.awt.event.ActionEvent evt) {                                                    
       FunctionalModule module = new LlenguesMain(this);
       setFuncionalModule (module);
    }                                                   

    private void menuMantenimentsActionPerformed(java.awt.event.ActionEvent evt) {                                                 
    }                                                

    private void altaDiccionariActionPerformed(java.awt.event.ActionEvent evt) {                                               
       FunctionalModule module = new DiccionariAlta(this);
       setFuncionalModule (module);
    }                                              
    
    
    // Variables declaration - do not modify                     
    private javax.swing.JMenuItem about;
    private javax.swing.JMenuItem ajuda;
    private javax.swing.JMenuItem altaDiccionari;
    private javax.swing.JMenuItem arbreCampDiccionari;
    private javax.swing.JMenuItem esborrarDiccionari;
    private javax.swing.JMenuItem arees;
    private javax.swing.JMenuBar barraMenu;
    private javax.swing.JMenuItem cercarTermes;
    private javax.swing.JMenuItem estaditicaFonts;
    private javax.swing.JMenuItem exportar;
    private javax.swing.JMenuItem fitxes;
    private javax.swing.JMenuItem fitxesIdenominacions;
    private javax.swing.JMenuItem importar;
    private javax.swing.JMenuItem informeFonts;
    private javax.swing.JMenu informeLlistats;
    private javax.swing.JMenuItem llenguesDiccionari;
    private javax.swing.JMenuItem mantenimentCategories;
    private javax.swing.JMenuItem mantenimentFonts;
    private javax.swing.JMenuItem mantenimentLlengues;
    private javax.swing.JMenuItem mantenimentsJerarquies;
    private javax.swing.JMenuItem mantenimentsMarques;
    private javax.swing.JMenu menuAjuda;
    private javax.swing.JMenu menuArxiu;
    private javax.swing.JMenu menuDiccionari;
    private javax.swing.JMenu menuEines;
    private javax.swing.JMenu menuInformes;
    private javax.swing.JMenu menuManteniments;
    private javax.swing.JMenu menuTerminologic;
    private javax.swing.JPanel modulePanel;
    private javax.swing.JMenuItem opcioDicAlfa;
    private javax.swing.JMenuItem opcioDicLang;
    private javax.swing.JMenuItem opcioDicTem;
    private javax.swing.JMenuItem opcioIndex;
    private javax.swing.JMenuItem propietatsDiccionari;
    private javax.swing.JMenuItem sortirApp;
    private javax.swing.JMenu submenuEstadistiques;
    private javax.swing.JMenu submenuInformes;
    // End of variables declaration                   
      
    
    public void setFuncionalModule(FunctionalModule module){
        this.currentModule = module;
	JComponent currentFunctionalPanel = module.getPanel();
        JPanel panel = (JPanel)currentFunctionalPanel;
	SwingUtilities.updateComponentTreeUI(currentFunctionalPanel);

	modulePanel.removeAll();
        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(modulePanel);
        modulePanel.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        
	//modulePanel.add(currentFunctionalPanel);
        pack();
    }
   
    public void showMessageError(String msg){
      JOptionPane.showMessageDialog(this, msg, "Error", JOptionPane.ERROR_MESSAGE);
    }

    
    public void showMessageInfo(String msg){
      JOptionPane.showMessageDialog(this, msg, "Informaci", JOptionPane.INFORMATION_MESSAGE);
    }  
    
    public void setPanelPopup(PanelPopup popup)
    {
        setPanelPopup(popup,false);
    }
    
    public void setPanelPopup(PanelPopup popup,boolean close)
    {
        if(close)
            closePanelPopup();
        this.currentPopupPanel=popup;
    }    

    public PanelPopup getCurrentPanelPopup()
    {
        return this.currentPopupPanel;
    }
   
    /*
     *  Mtode que s'encarrega de tancar el popup 'actual'.  
     */
    public void closePanelPopup()
    {
        // Tanquem el popup 'actual'
        this.currentPopupPanel.closePopupWindow();
    }

/*
 *      PopUp Edit
 */
        public void setEditPanelPopup(PanelPopup popup,boolean close)
    {
        if(close)
        {
            closeEditPanelPopup();
        }
        this.editPopupPanel=popup;
    }    

    public PanelPopup getEditPanelPopup()
    {
        return editPopupPanel;
    }
   
    /*
     *  Mtode que s'encarrega de tancar el popup 'actual'.  
     */
    public void closeEditPanelPopup()
    {
        // Tanquem el popup 'actual'
        editPopupPanel.closePopupWindow();
    }
    
 /*
 *      PopUp alta
 */
        public void setAltaPanelPopup(PanelPopup popup,boolean close)
    {
        if(close)
            closeAltaPanelPopup();
        this.altaPopupPanel=popup;
    }    

    public PanelPopup getAltaPanelPopup()
    {
        return this.altaPopupPanel;
    }
   
    /*
     *  Mtode que s'encarrega de tancar el popup 'actual'.  
     */
    public void closeAltaPanelPopup()
    {
        // Tanquem el popup 'actual'
        this.altaPopupPanel.closePopupWindow();
    }
    
            
    public String getIdFitxa()
    {
        return this.idCurrentFitxa;
    } 
     public void setIdFitxa(String idFitxa)
    {
        this.idCurrentFitxa=idFitxa;
    } 

     
    public boolean isCurrentFitxaDirty()
    {
        return this.isCurrentFitxaDirty;
    } 
    
     public void setCurrentFitxaDirty(boolean dirty)
    {
        this.isCurrentFitxaDirty=dirty;
    } 
     
     public boolean isReady2Add()
    {
        return this.isReady2Add;
    } 
    
     public void setReady2Add(boolean b)
    {
        this.isReady2Add=b;
    } 

    /*
     *  Mtode que obte l'identificador del diccionari que est seleccionat en aquests moments.
     */
    public String getIdCurrentDictionary()
    {
        return this.idCurrentDictionary;
    }

    /*
     *  Funci que assigna el nou diccionari 'actual'.
     */
    public void setIdCurrentDictionary(String idDiccionari)
    {
        this.idCurrentDictionary=idDiccionari;
    }

    /*
     *  Mtode que obte el nom del diccionari que est seleccionat en aquests moments.
     */
    public String getNomCurrentDictionary()
    {
        return this.nomCurrentDicionary;
    }

    /*
     *  Mtode que assigna el nom del diccionari 'actual'.
     *  @param nom:     Nom del diccionari.
     */
    public void setNomCurrentDictionary(String nom)
    {
        this.nomCurrentDicionary=nom;
    }
    
        /*
     *  Mtode que obte el nom del diccionari que est seleccionat en aquests moments.
     */
    public boolean getDenoDefined()
    {
        return this.isDenoDefined;
    }

    /*
     *  Mtode que assigna el nom del diccionari 'actual'.
     *  @param nom:     Nom del diccionari.
     */
    public void setDenoDefined(boolean b)
    {
        this.isDenoDefined=b;
    }
    
    public int getRowsInPage()
    {
        return ROWS_IN_PAGE;
    }

    public int getCurrentPage() 
    {
        return currentPage;
    }

    public void setCurrentPage(int page) 
    {
        currentPage=page;
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }

    public void setLastTab(int selectedTab) 
    {
        this.lastTab=selectedTab;   
    }
    
    public int getLastTab() 
    {
        return this.lastTab;   
    }

   // funcions per a obtenir desde els fills el tamany del frame principal de l'aplicaci.
   public double getHeightFrame()
   {
       return HEIGHT_MENU_FRAME;
   }
   
   public double getWidthFrame()
   {
       return WIDTH_MENU_FRAME;
   }

    public void disableMenuAltaDictionary() 
    {
        altaDiccionari.setEnabled(false);
    }

    public void setDefinitionConflict(boolean b) {
        this.definitionConflict=b;
    }

    public void setNoteConflict(boolean b) {
        this.noteConflict=b;
    }
    
    public boolean getDefinitionConflict()
    {
        return this.definitionConflict;
    }
    
    public boolean getNoteConflict()
    {
        return this.noteConflict;
    }

    public Search getCercaObject() {
        return this.currentCerca;
    }
    
    public void setCercaObject(Search search) 
    {
        this.currentCerca=search;
    }

    private void doSelectLanguagePanel(boolean isIndexReport) {
       FunctionalModule module = new SelectLanguagePanel(this,isIndexReport);
       // Creem el nou mdul d'alta de la llengua.
       PanelPopup popupPanel=new PanelPopup(this,module,Literales.getTextForMessage("Informes_Llistats"),450,300,10,50);       
      
       //Actualitzem el popupPanel 'actual'.
       this.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();   
    }

    public void setEnableMenuOptions(boolean b) 
    {
        propietatsDiccionari.setEnabled(b);
        llenguesDiccionari.setEnabled(b);
        arbreCampDiccionari.setEnabled(b);
        esborrarDiccionari.setEnabled(b);
        fitxes.setEnabled(b);
        cercarTermes.setEnabled(b);
        submenuInformes.setEnabled(b);
        informeLlistats.setEnabled(b);
        informeFonts.setEnabled(b);
        submenuEstadistiques.setEnabled(b);
        fitxesIdenominacions.setEnabled(b);
        arees.setEnabled(b);
        estaditicaFonts.setEnabled(b);
        exportar.setEnabled(b);      
        altaDiccionari.setEnabled(!b);
        
    }

    public void initMainFrame() throws DictionaryException 
    {
            //  Actualitzaci del diccionari current             
            String idDiccionariBD=DictionaryManager.getManager().getDiccionariId();
            if (idDiccionariBD==null || idDiccionariBD.equals(""))
            {               
                // Desabilitem aquelles opcions del menu que depenen de tenir seleccionat un diccionari
                setEnableMenuOptions(false);               
                System.out.println("NO hi ha cap diccionari a la BD.");
            }
            else
            {
                setEnableMenuOptions(true);               
                setIdCurrentDictionary(idDiccionariBD);
                // El setNomCurrentDictionary nomes es far en el cas que hi hagi actiu algun diccionari.
                setNomCurrentDictionary(DictionaryManager.getManager().getNomDiccionari(idDiccionariBD));
            }
            // Inicialitzem la cerca i la query a null ("").
            this.currentCerca=null;
            
            // Inicialitzem els boleans a false.
            this.isReady2Add=false;

            // Inicialitzem el numero de pgina inicial
            this.currentPage=0;
            this.lastTab=0;        
            
            // Esborrem el contingut de les arees temtiques.
            this.tree=null;
            this.tableAt=null;
           
            this.setIconImage(new ImageIcon(MainFrame.class.getResource("/com/termcat/resources/img/GdT.gif")).getImage());
    }

      public static void setLookAndFeel(String pTheme) {
            try {
                  // Set substance laf
                  UIManager.setLookAndFeel("org.jvnet.substance.SubstanceLookAndFeel");
                  // hide some useless elements such locker for not editable labels
                  UIManager.put(SubstanceLookAndFeel.NO_EXTRA_ELEMENTS, Boolean.TRUE);
                  UIManager.put(SubstanceLookAndFeel.WATERMARK_TO_BLEED, Boolean.TRUE);
                  UIManager.put(SubstanceLookAndFeel.ENABLE_INVERTED_THEMES,Boolean.TRUE);
                  UIManager.put(SubstanceLookAndFeel.ENABLE_NEGATED_THEMES,Boolean.TRUE);
                  // Check the theme is known, if not take the default theme
                  Map<String, ThemeInfo> themes = SubstanceLookAndFeel.getAllThemes();
                  if (themes.get(pTheme) == null) {
                        pTheme = "Steel Blue";
                  }
                  // Set substance theme
                  SubstanceLookAndFeel.setCurrentTheme(themes.get(pTheme).getClassName());
            } catch (Exception e) {
                 e.printStackTrace();
            }

      }

      public static void setWatermark(String pWatermark) {

            try {
                  String watermark = pWatermark;
                  // Check the watermark is known, if not take the default one
                  Map<String, WatermarkInfo> watermarks = SubstanceLookAndFeel.getAllWatermarks();
                  if (watermarks.get(watermark) == null) {
                        // the image watermark is not included in the list for unknown
                        // reasons
                        if (!"Image".equals(watermark)) {
       //                      watermark = LNF_DEFAULT_WATERMARK;
                        }
                  }
                  // Set the watermark
                  //String image = ConfigurationManager.getProperty(CONF_OPTIONS_WATERMARK_IMAGE);
                  SubstanceLookAndFeel.setCurrentWatermark(watermarks.get(watermark).getClassName());
            } catch (Exception e) {
                e.printStackTrace();
                  // Set default watermark
                  SubstanceLookAndFeel.setCurrentWatermark(new SubstanceStripeWatermark());
                 // ConfigurationManager.setProperty(CONF_OPTIONS_WATERMARK,LNF_DEFAULT_WATERMARK);
            }

      }

    // Mtodes per a calcular si s'ha de regenerar la pestanya de la cerca.
    public boolean isLlenguesModified() {return this.llenguesModified;}    
    public void setLlenguesModified(boolean b){this.llenguesModified=b;}
    
    public boolean isATModified() {return this.areesModified;}    
    public void setATModified(boolean b){this.areesModified=b;}
    
    public boolean isJerarquiesModified() {return this.jerarquiesModified;}    
    public void setJerarquiesModified(boolean b){this.jerarquiesModified=b;}
    
    public boolean isCategoriesModified() {return this.categoriesModified;}    
    public void setCategoriesModified(boolean b){this.categoriesModified=b;}
  
    public boolean isFontsModified() {return this.fontsModified;}    
    public void setFontsModified(boolean b){this.fontsModified=b;}
}


