/*
 * FitxesManager.java
 *
 * Created on 30 de enero de 2008, 9:32
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.fitxes;

import com.termcat.bd.beans.AreesFitxes;
import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Notes;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.terminologic.search.SearchManager;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.ItemCustom;
import com.termcat.layout.commons.popup.MousePopupListener;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.commons.search.Search;
import com.termcat.layout.terminologic.fitxes.EditorFitxes;
import com.termcat.layout.terminologic.fitxes.FitxesMain;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import com.termcat.layout.MainFrame;


/**
 *
 * @author Mena
 */
public class FitxesManager {
    
    /** Creates a new instance of FitxesManager */
    public FitxesManager() {
    }

    
    // Mtodo principal de resfrescar los contenidos.
    public void refreshContents(MainFrame menuFrame,FitxesMain fitxesMain) 
    {        
        // Definicio de les variables.
        boolean insertInTable=true;
        ItemCustom ic=new ItemCustom();
        String areesTematiques=null;
        int i;
        int numFitxes=-1;
        Vector fitxesOfPage=null;
        // Inicialitzaci de la variable que conte el nombre de files de la taula de fitxesMain.
        fitxesMain.MAX_TABLE_FITXES_ROW=0;
        try
        {
            // Inicializem els components: taula i model --> Es creen cada vegada... Massa objectes!!! Mirar de buidar les que existeixen.
            initCustomComponents(fitxesMain,menuFrame);
            
            // Calculem la pgina a la que ens trobem
            
            fitxesMain.getPageLabel().setText("Pgina "+menuFrame.getCurrentPage());

            if (fitxesMain.getFilterInactiveUrl()!=null)
                fitxesMain.getFilterButton().setIcon(new ImageIcon(fitxesMain.getFilterInactiveUrl()));            

            if (menuFrame.getCercaObject()==null)
            {          
                Vector <BeanFichaData> allFichas =  new Denominacions().findAllSortedFitxes(menuFrame.getIdCurrentDictionary(),false);                
                numFitxes=buildFichaList(allFichas,fitxesMain,menuFrame);
            }
            else
            {
                // Cas en que s'ha de fer una cerca de termes
                try
                {
                    numFitxes=getFilteredFitxes(menuFrame.getCercaObject(),menuFrame.getIdCurrentDictionary(),fitxesMain,menuFrame);
                    if (numFitxes!=-1)
                    {
                        String filtreAplicat=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("filtreAplicat");
                        // Mostrem el missatge i indiquem en el boto l'estat de filtre aplicat.
                        fitxesMain.getFilterName().setText(filtreAplicat);  
                        if (fitxesMain.getFilterActiveUrl()!=null)
                            fitxesMain.getFilterButton().setIcon(new ImageIcon(fitxesMain.getFilterActiveUrl()));            
                    }
                    else
                    {
                        // Aquest es el cas en que s'ha clicat a la opci de fer la cerca, pero el formulari de la 
                        // cerca es buit. En aquest cas, no cal fer la cerca sino farem com si no s'hagues clicat res.
                        try
                        {
                            menuFrame.setCercaObject(null);                            
                            Vector <BeanFichaData> allFichas =  new Denominacions().findAllSortedFitxes(menuFrame.getIdCurrentDictionary(),false);                
                            numFitxes=new FitxesManager().buildFichaList(allFichas,fitxesMain,menuFrame);                    
                        }
                        catch (Exception e)
                        {
                            throw new Exception(e);                            
                        }
                    }               
                }
                catch (Exception e)
                {
                    // Cas en que hi ha un problema en la cerca. Mostrem un error i el llistat sense filtratge.
                    e.printStackTrace();
                    String message=e.getMessage();
                    fitxesMain.tratarError(new DataException(message));                       
                    try
                    {
                         menuFrame.setCercaObject(null);
                         Vector <BeanFichaData> allFichas =  new Denominacions().findAllSortedFitxes(menuFrame.getIdCurrentDictionary(),false);                
                         numFitxes=buildFichaList(allFichas,fitxesMain,menuFrame);                                             
                     }
                     catch (Exception ex)
                     {
                        throw new Exception(ex);
                     }
                }
            }
            fitxesMain.setLastPage((menuFrame.getCurrentPage()*menuFrame.getRowsInPage()) + fitxesMain.MAX_TABLE_FITXES_ROW == numFitxes);
            if (fitxesMain.isLastPage())
                fitxesMain.getFwButton().setEnabled(false);
            else
                fitxesMain.getFwButton().setEnabled(true);
            
            String nombreFitxesTotal=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NombreTotalFitxes");
            fitxesMain.getTotalFitxes().setText("("+nombreFitxesTotal+" "+numFitxes+")");
        }
        catch(Exception e)
        {
            // Error en cas de fer un refresh() sense filtratge.
            e.printStackTrace();
            String message=e.getMessage();
            fitxesMain.tratarError(new DataException(e.getMessage()));                       
        }        
    }    
    
    
    public int getFilteredFitxes(Search cerca, String idDiccionari, FitxesMain fMain, MainFrame menuFrame) throws FinderException 
    {
        String denominacioFilter="",restFilter="", idFitxesSearch="";        
        String idFitxesDef="",idFitxesDefNotes,idFitxesDefNotesAT="";
        Vector<BeanFichaData> filteredFitxes = new Vector<BeanFichaData>();
        int numFitxes=-1; 
        // Obtenim el congut del where del filtre aplicat sobre cadascn dels parmetres de la cerca.
        String definicionsFiltered=SearchManager.getManager().getDefinicionsFiltered(cerca);
        String notesFiltered=SearchManager.getManager().getNotesFiltered(cerca);
        String areesFiltered=SearchManager.getManager().getAreesTematiquesFiltered(cerca);
        String obsFiltered=SearchManager.getManager().getObservacionsFiltered(cerca);        
        String fontsFiltered=SearchManager.getManager().getFontsFiltered(cerca,idDiccionari);
        String denominacionsFiltered=SearchManager.getManager().getDenominacionsFiltered(cerca);

        // Obtenim els IDs de les fitxes que cumpleixen els criteris de la cerca per a les definicions,notes i arees temtiques
        // El cas de 'NO_FILTER', es defineix per als casos en que no es defineix cap filtre per a definicions,notes i arees.
        
        if(definicionsFiltered.trim().equals("")&&notesFiltered.trim().equals("")&&areesFiltered.trim().equals("")&&obsFiltered.trim().equals("")&&fontsFiltered.trim().equals("")&&denominacionsFiltered.trim().equals(""))
        {
             numFitxes=-1;
        }
        else
        {
            idFitxesDef=getDefinitionsFromSearch(definicionsFiltered,idDiccionari);
            if (!idFitxesDef.equals(""))
            {
                idFitxesDefNotes=getNotesFromSearch(notesFiltered,idFitxesDef,idDiccionari);
                if (!idFitxesDefNotes.equals(""))
                {
                    idFitxesDefNotesAT=getAreesTematiquesFromSearch(areesFiltered,idFitxesDefNotes);        
                    if(idFitxesDefNotesAT.equals("NO_FILTER"))
                    {
                        idFitxesSearch =  new Denominacions().findAllIdFitxesSearch(idDiccionari,denominacionsFiltered,obsFiltered,"",fontsFiltered);                                                                
                        filteredFitxes = new Denominacions().findAllSortedFitxesSearch(idDiccionari,idFitxesSearch,false);
                    }
                    else
                    {
                        if (!idFitxesDefNotesAT.equals(""))
                        {
                            idFitxesSearch =  new Denominacions().findAllIdFitxesSearch(idDiccionari,denominacionsFiltered,obsFiltered,idFitxesDefNotesAT,fontsFiltered);
                            filteredFitxes = new Denominacions().findAllSortedFitxesSearch(idDiccionari,idFitxesSearch,false);                        
                        }
                    }
                }
            }
            
            numFitxes=buildFichaList(filteredFitxes,fMain,menuFrame);                
        }    

        return numFitxes;            
    }    
    
    public int buildFichaList(Vector <BeanFichaData> allFichas, FitxesMain fMain,MainFrame menuFrame) throws FinderException
    {
       int numFitxes=allFichas.size();
       if(numFitxes>0){       
           List <BeanFichaData> fitxasCurrenPage = getFitxesForCurrentPage(allFichas,fMain,menuFrame);
           for (int i=0;i<fitxasCurrenPage.size();i++){
                 BeanFichaData fitxa = fitxasCurrenPage.get(i);
                 fMain.getModel().addRow(new Object[] {fitxa.getIdFicha(),fitxa.getDenominacio(),fitxa.getAreaTematica()});
                 fMain.MAX_TABLE_FITXES_ROW++;
           }
       }
       else
       {
            fMain.getModel().addRow(new Object[] {null,null,null});
            fMain.getPopUpMenuTable().disableMenuItems();
       }
       if (menuFrame.getCurrentPage()==0)
           fMain.getReButton().setEnabled(false);
       else
         fMain.getReButton().setEnabled(true);
       
       return numFitxes;
    }
    
    private List <BeanFichaData> getFitxesForCurrentPage(Vector <BeanFichaData> allFichas, FitxesMain fMain, MainFrame menuFrame){
        int beginIndex = menuFrame.getCurrentPage()*menuFrame.getRowsInPage();
        int endIndex = beginIndex+menuFrame.getRowsInPage();
        if(endIndex>=allFichas.size()){ //es la ultima pagina -> nos quedamos con los ultimos elementos del vector e inabilitamos el botn de siguiente
           endIndex=allFichas.size();
           fMain.getFwButton().setEnabled(false);
        }
        else fMain.getFwButton().setEnabled(true);
        List <BeanFichaData> fichasPage = allFichas.subList(beginIndex,endIndex); 
        return fichasPage;
    }            
    
    private String getDefinitionsFromSearch(String definicionsFiltered, String idDiccionari) 
    {        
        String idFitxesDef="";
        if (!definicionsFiltered.equals(""))
        {
            
            if("NO_DEF".equals(definicionsFiltered)){
                try{
                    idFitxesDef =  Fitxes.getAllFichaIdsWhitoutDefinition(idDiccionari);
                }
                catch(FinderException e)
                {
                    e.printStackTrace();
                }
            }
            else{
                Definicions def=new Definicions();
                try
                {
                    ArrayList<Definicions> defList=(ArrayList<Definicions>)def.findByGenericWhere(definicionsFiltered);
                    if (defList.size()>0)
                    {
                        idFitxesDef+="'"+defList.get(0).getIdFitxa()+"'";
                        for (int i=1;i<defList.size();++i)
                        {           
                            idFitxesDef+=",'"+defList.get(i).getIdFitxa()+"'";
                        }
                    }

                }
                catch(FinderException e)
                {
                    e.printStackTrace();
                }
            }
        }
        else
            idFitxesDef="NO_FILTER";
        
        return idFitxesDef;      
    }
    
    private String getNotesFromSearch(String notesFiltered, String idFitxesDef, String idDiccionari) 
    {
       
        String idFitxesDefNotes="",idFitxaQuery="";
        
        if(notesFiltered.equals(""))
            if (!idFitxesDef.equals("NO_FILTER"))
                return idFitxesDef; 
            else
                return "NO_FILTER";
        else
            if (!idFitxesDef.equals("NO_FILTER"))
                idFitxaQuery=" AND id_fitxa IN("+idFitxesDef+")";            

        if("NO_NOTA".equals(notesFiltered)){
            try{
                idFitxesDefNotes =  Fitxes.getAllFichaIdsWhitoutNota(idDiccionari);
            }
            catch(FinderException e)
            {
                e.printStackTrace();
            }
        }
        else{
            String sql=notesFiltered+idFitxaQuery;
            System.out.println("Sql Notas:"+sql);

            Notes nota=new Notes();
            try
            {
                ArrayList<Notes> notesList=(ArrayList<Notes>)nota.findByGenericWhere(sql);
                if (notesList.size()>0)
                {
                    idFitxesDefNotes+="'"+notesList.get(0).getIdFitxa()+"'";
                    for (int i=1;i<notesList.size();++i)
                    {           
                        idFitxesDefNotes+=",'"+notesList.get(i).getIdFitxa()+"'";
                    }
                }
            }
            catch(FinderException e)
            {
                e.printStackTrace();
            }
        }        
        return idFitxesDefNotes;      
    }
    
    private String getAreesTematiquesFromSearch(String areesFiltered, String idFitxesDefNotes) 
    {
        String res="",idFitxaQuery="";
        
        if (areesFiltered.equals(""))
            if (!idFitxesDefNotes.equals("NO_FILTER"))                        
                return idFitxesDefNotes;
            else
                return "NO_FILTER";
        else
            if (!idFitxesDefNotes.equals("NO_FILTER"))            
                idFitxaQuery=" AND id_fitxa IN("+idFitxesDefNotes+")";

        
        String sql=areesFiltered+idFitxaQuery;
        
        AreesFitxes areaFitxa=new AreesFitxes();
        try
        {
            ArrayList<AreesFitxes> areaFitxaList=(ArrayList<AreesFitxes>)areaFitxa.findByGenericWhere(sql);
            if (areaFitxaList.size()>0)
            {
                res+="'"+areaFitxaList.get(0).getIdFitxa()+"'";
                for (int i=1;i<areaFitxaList.size();++i)
                {           
                    res+=",'"+areaFitxaList.get(i).getIdFitxa()+"'";
                }
            }
        }
        catch(FinderException e)
        {
            e.printStackTrace();
        }
                
        return res;
    }
    
    public void initCustomComponents(FitxesMain fitxesMain, MainFrame menuFrame)
    {  
        String denominacioPrincipal=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DenoPrincipal");
        String AreaTematica=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cerca_Area");
        
        final String[] names = {"ID",denominacioPrincipal, AreaTematica};
        final Object[][] data =null;
                
        fitxesMain.setModel(new DefaultTableModel(data,names));
        
        JTable tableAux= new JTable(fitxesMain.getModel())
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
        
        fitxesMain.setTablaFichas(tableAux);
       
        // Amagar la columna de la 'vista'.
        fitxesMain.getTablaFichas().getColumnModel().removeColumn(fitxesMain.getTablaFichas().getColumnModel().getColumn(0));
        PopupMenuTable tablaPopupMenu=new PopupMenuTable(fitxesMain.getTablaFichas(),fitxesMain,new EditorFitxes(menuFrame),fitxesMain.EDIT_FITXA,fitxesMain.DELETE_FITXA);
        fitxesMain.setPopUpMenuTable(tablaPopupMenu);
        
        // Associem el listener de l'event del ratol a la taula creada.
        fitxesMain.getTablaFichas().addMouseListener(new MousePopupListener(tablaPopupMenu));
               
        // insertar la table al frame mitjanant un scroll panel.
        fitxesMain.getScrollPaneTabla().setViewportView(fitxesMain.getTablaFichas());
    }
            
}
