/*
 * AssociateLists.java
 *
 *  @author  mena
 *
 * Created on 31 de julio de 2007, 11:33
 */

package com.termcat.layout.commons.lists;

import com.termcat.util.literales.Literales;
import java.awt.Dimension;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JList;
import javax.swing.JFrame;
import javax.swing.DefaultListModel;


public class AssociateLists extends javax.swing.JPanel 
{
    
    private JList noAssociateList;
    private JList associateList;
    // Variables necessaries per fer 'undo'
    private boolean  modifyPriority;
    private Vector noAssociate;
    private Vector associate;
    
    private DefaultListModel listModelNoAssociate;
    private DefaultListModel listModelAssociate;

    private String noAssociateTitle;
    private String associateTitle;
    private int lastAssociateElement;
                
    /*
     *  Constuctor
     * @noAssociate:    Vector amb els valors dels items no associats.
     * @associate:      Vector amb els valors dels items associats.
     * @modifyPriority: Boole per a mostrar o no els botons de modificaci de la llista dels associats.
     */  
    public AssociateLists(Vector noAssociate, Vector associate, boolean modifyPriority,String noAssociateTitle, String associateTitle)
    {
        init(noAssociate,associate,modifyPriority,noAssociateTitle,associateTitle);
    }
    
     public AssociateLists(Vector noAssociate, Vector associate)
    {
        init(noAssociate, associate, false,"No associate items","Associate items");
    }
     
    public AssociateLists(Vector noAssociate, Vector associate,String noAssociateTitle, String associateTitle)
    {
        init(noAssociate,associate,false,noAssociateTitle,associateTitle);
    }
 
        
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        associateButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaRight.gif")),this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaRightDisable.gif")));
        desassociateButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaLeft.gif")),this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaLeftDisable.gif")));
        jPanel2 = new javax.swing.JPanel();
        subsPriorityButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaDown.gif")),this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaDownDisable.gif")));
        addPriorityButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaUp.gif")),this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaUpDisable.gif")));
        priorityLabel = new javax.swing.JLabel();
        paneAssociate = new javax.swing.JScrollPane();
        jpanel1 = new javax.swing.JPanel();
        panelNoAssociate = new javax.swing.JScrollPane();

        setMinimumSize(new java.awt.Dimension(0, 0));
        setVerifyInputWhenFocusTarget(false);
        associateButton.setText("   ");
        associateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                associateButtonActionPerformed(evt);
            }
        });

        desassociateButton.setText("   ");
        desassociateButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                desassociateButtonActionPerformed(evt);
            }
        });

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder(getAssociateTitle()));
        jPanel2.setMaximumSize(new java.awt.Dimension(225, 225));
        jPanel2.setMinimumSize(new java.awt.Dimension(225, 225));
        subsPriorityButton.setText("  ");
        subsPriorityButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                subsPriorityButtonActionPerformed(evt);
            }
        });

        addPriorityButton.setText("  ");
        addPriorityButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                addPriorityButtonActionPerformed(evt);
            }
        });

        priorityLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("PrioritatLabel"));

        org.jdesktop.layout.GroupLayout jPanel2Layout = new org.jdesktop.layout.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .add(paneAssociate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 144, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(addPriorityButton)
                            .add(subsPriorityButton))
                        .add(33, 33, 33))
                    .add(jPanel2Layout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(priorityLabel)
                        .addContainerGap())))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel2Layout.createSequentialGroup()
                .add(19, 19, 19)
                .add(addPriorityButton)
                .add(42, 42, 42)
                .add(priorityLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 43, Short.MAX_VALUE)
                .add(subsPriorityButton)
                .add(26, 26, 26))
            .add(jPanel2Layout.createSequentialGroup()
                .add(paneAssociate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 187, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jpanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(javax.swing.BorderFactory.createTitledBorder(getNoAssociateTitle())));
        jpanel1.setMaximumSize(new java.awt.Dimension(223, 225));
        jpanel1.setMinimumSize(new java.awt.Dimension(223, 225));

        org.jdesktop.layout.GroupLayout jpanel1Layout = new org.jdesktop.layout.GroupLayout(jpanel1);
        jpanel1.setLayout(jpanel1Layout);
        jpanel1Layout.setHorizontalGroup(
            jpanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jpanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(panelNoAssociate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 144, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(45, Short.MAX_VALUE))
        );
        jpanel1Layout.setVerticalGroup(
            jpanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelNoAssociate, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 201, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(jpanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(associateButton)
                    .add(desassociateButton))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 224, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(140, 140, 140))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(66, 66, 66)
                        .add(associateButton)
                        .add(32, 32, 32)
                        .add(desassociateButton))
                    .add(jPanel2, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 220, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jpanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 220, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void subsPriorityButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_subsPriorityButtonActionPerformed
        switchPosition(associateList, listModelAssociate,"DOWN"); 
    }//GEN-LAST:event_subsPriorityButtonActionPerformed

    private void addPriorityButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_addPriorityButtonActionPerformed
        switchPosition(associateList, listModelAssociate,"UP"); 
    }//GEN-LAST:event_addPriorityButtonActionPerformed

    private void desassociateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_desassociateButtonActionPerformed
        cutItemFromList(associateList, listModelAssociate, noAssociateList, listModelNoAssociate); 
        disableButtonsPriority();
    }//GEN-LAST:event_desassociateButtonActionPerformed

    private void associateButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_associateButtonActionPerformed
        cutItemFromList(noAssociateList, listModelNoAssociate, associateList, listModelAssociate); 
    }//GEN-LAST:event_associateButtonActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton addPriorityButton;
    private javax.swing.JButton associateButton;
    private javax.swing.JButton desassociateButton;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jpanel1;
    private javax.swing.JScrollPane paneAssociate;
    private javax.swing.JScrollPane panelNoAssociate;
    private javax.swing.JLabel priorityLabel;
    private javax.swing.JButton subsPriorityButton;
    // End of variables declaration//GEN-END:variables
    
    
     /******************************************************************************   
                                   MTODES PBLICS
     ******************************************************************************/    
    /*
     * Mtode que retorna un vector amb els elements de la llista d'associats (ItemListCustom).
     *  
     */
    public Vector getSelectedList()
      {
          Vector selectedList=new Vector();
          System.out.println("Selected List Elements");
          System.out.println("----------------------");
          // Obtenim els items de la llista dels ASSOCIATS.
          for(int i=0;i<this.listModelAssociate.getSize();++i)
          {
              ItemListCustom item=(ItemListCustom)this.listModelAssociate.getElementAt(i);             
              selectedList.add(item);
              System.out.println("Element "+i+" : "+"id="+item.getId()+" value="+item.getValue());
          }        
          return selectedList;
      }

    /*
     * Mtode que retorna un vector amb els elements de la llista de NO associats (ItemListCustom).
     *  
     */
    public Vector getUnselectedList()
      {
          Vector unselectedList=new Vector();
          System.out.println("UnSelected List Elements");
          System.out.println("----------------------");
          // Obtenim els items de la llista dels ASSOCIATS.
          for(int i=0;i<this.listModelNoAssociate.getSize();++i)
          {
              ItemListCustom item=(ItemListCustom)this.listModelNoAssociate.getElementAt(i);             
              unselectedList.add(item);
              System.out.println("Element "+i+" : "+"id="+item.getId()+" value="+item.getValue());
          }        
          return unselectedList;
      }    
       

    /******************************************************************************   
                                   MTODES PRIVATS
     ******************************************************************************/          
    /*
     *  Mtode encarregat de la inicialitzaci del component.
     */   
    private void init(Vector noAssociate, Vector associate, boolean modifyPriority, String noAssociateTitle, String associateTitle)
    {
        this.noAssociateTitle=noAssociateTitle;
        this.associateTitle=associateTitle;      

        // Inicialitzaci dels components generats automticament.
        initComponents();        
        disableAllButtons();
 
        // Establim el tamany del panell principal
        Dimension dim=new Dimension(475,250);        
        this.setMaximumSize(dim);
        this.setMinimumSize(dim);
        this.setPreferredSize(dim);
        this.setSize(dim);

        //  En cas que el parmetre modifyPriority sigui 'false', no mostrem els botons que permeten
        // modificar la prioritat de la llista d'ASSOCIATS.      
        if (!modifyPriority)
        {
            addPriorityButton.setVisible(false);
            subsPriorityButton.setVisible(false);
            priorityLabel.setVisible(false);
        }
        
        // Inicialitzaci de la llista d'elements no associats
        listModelNoAssociate=initList(noAssociate);
        noAssociateList = new JList(listModelNoAssociate);
        this.noAssociateList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                noAssociateListOnValueChanged(evt);
            }
        });
                
        // Inicialitzaci de la llista d'elements no associats
        listModelAssociate=initList(associate);
        associateList = new JList(listModelAssociate);        
        
        this.associateList.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                associateListOnValueChanged(evt);
            }
        });
        
        panelNoAssociate.remove(noAssociateList);
        paneAssociate.remove(associateList);

        // Insertem les llistes al panell corresponent.
        panelNoAssociate.setViewportView(noAssociateList);
        paneAssociate.setViewportView(associateList);
    }
    
    /*
     *  Mtode d'inicialitzaci del model de la llista amb els valors del vector.
     *
     * @param v:            Vector amb els continguts que es volen mostrar a la llista.
     * @return listModel:   Model de la llista amb els valors del vector. 
     */
    private DefaultListModel initList(Vector v)
    {
        DefaultListModel listModel=new DefaultListModel();
        if (v!=null)
        {
            if(!v.isEmpty())
            {    
                for(int i=0;i<v.size();++i)
                {
                    ItemListCustom item=(ItemListCustom)v.get(i);    
                    listModel.addElement(item);
                    System.out.println("[AssociateList.java] Model "+listModel.get(i));
                }
            }
        }
        return listModel;
    }
    
    /**
     *  Motde encarregat d'esborrar un conjunt d'items seleccionats desde la llista font a la llista de dest.
     *    -  De moment nomes funciona correctament per a un NIC item. -
     * @listSrc:        Llista de la que es vol eliminar l'item.
     * @listModelSrc:   Model de la llista de la que es vol eliminar l'item.
     * @listDst:        Llista a on es vol copiar l'item.
     * @listModelDst:   Model de la llista a on es es vol copiar l'item.
     * 
     */
    private void cutItemFromList(JList listSrc, DefaultListModel listModelSrc, JList listDst, DefaultListModel listModelDst)
    {
        // Obtenim els items seleccionats de la llista.      
        int selectedIndices[]=listSrc.getSelectedIndices();
        ItemListCustom ilc;
        
        // Els passem de la llista font a la llista dest.
        for(int i=0;i<selectedIndices.length;++i)
        {             
            int ind=selectedIndices[i];
            if(ind>0)
                ind=ind-i;
            ilc=(ItemListCustom)listModelSrc.get(ind);            
            listModelDst.addElement(ilc);        
            listModelSrc.remove(ind);                                                            
        }         
    }
    
    /**
     *  Mtode encarregat de canviar la posici de l'element clicat de la llista.
     *
     *  @list:      Llista en la que es vol intercanviar els items.
     *  @listModel: Model de la llista en la que es vol intercanviar els items.
     *  @type:      Tipus de moviment. Es UP / DOWN en funci de si es vol pujar/baixar en la llista.
     */
    private void switchPosition(JList list, DefaultListModel listModel,String type) {

        int index=0;
        int selectedIndex=list.getSelectedIndex();
        
        // Modifiquem la posici dest en funci de si es fa un UP / DOWN.
        if (type.equals("UP"))
        {
            index=selectedIndex-1;
        }
        else if (type.equals("DOWN"))
        {
            index=selectedIndex+1;
        }
        
        // Obtenim els valors que volem intercanviar.
        ItemListCustom selectedValue=(ItemListCustom)list.getSelectedValue();       
        ItemListCustom selectedValueDown=(ItemListCustom)listModel.getElementAt(index);
        
        // Fem l'intercanvi 
        ItemListCustom tmp=selectedValue;
        selectedValue=selectedValueDown;
        selectedValueDown=tmp;                           

        listModel.setElementAt(selectedValue,selectedIndex);
        listModel.setElementAt(selectedValueDown,index);
        list.setSelectedIndex(index);
    }
    
    
    public void noAssociateListOnValueChanged(javax.swing.event.ListSelectionEvent evt) 
    {
       
        if(this.noAssociateList.getSelectedIndex()>=0)
            this.associateButton.setEnabled(true);
        else
            this.associateButton.setEnabled(false);
        System.out.println("NO Associate LIST CHANGED");
    }
    
    public void associateListOnValueChanged(javax.swing.event.ListSelectionEvent evt) 
    {

        int associateIndex=this.associateList.getSelectedIndex();

        
        if (associateIndex>=0)
        {
            this.desassociateButton.setEnabled(true);
            this.lastAssociateElement=associateList.getLastVisibleIndex();
            System.out.println("Last Index: "+lastAssociateElement);
            if (lastAssociateElement==0)
            {
                disableButtonsPriority();
            }
            else if(associateIndex==0)
            {
                this.addPriorityButton.setEnabled(false);
                this.subsPriorityButton.setEnabled(true);
            }
            else if (associateIndex==lastAssociateElement)
            {
                 this.addPriorityButton.setEnabled(true);
                 this.subsPriorityButton.setEnabled(false);
            }
            else
            {
                this.addPriorityButton.setEnabled(true);
                this.subsPriorityButton.setEnabled(true);
            }
         }
         else
            this.desassociateButton.setEnabled(false);
        
         System.out.println("Associate LIST CHANGED");
    }
    
    
    
    /******************************************************************************   
     ******************************************************************************   
                                Mtode MAIN de prova
     ******************************************************************************
     ******************************************************************************/    
    public static void main(String args[]) throws Exception
    {
        String values="Value_";
        Vector v1= new Vector();
        Vector v2= new Vector();
        JFrame frame = new JFrame("Associate LISTs");
        
        // Afegim a m els items als dos vectors
        for (int i=0;i<10;++i) 
        {   
            values=values.concat(Integer.toString(i));
            ItemListCustom item=new ItemListCustom(Integer.toString(i),values);
            v1.add(item);
            values="Value_";
        }
        
        for (int j=10;j<12;++j) 
        {   
            values=values.concat(Integer.toString(j));
            ItemListCustom item=new ItemListCustom(Integer.toString(j),values);
            v2.add(item);
            values="Value_";
        }
       
        AssociateLists lists = new AssociateLists(v1,null,true,"NOT","YES");
        frame.getContentPane().add(lists);
        frame.setSize(700,400);
        frame.setVisible(true);
    }

    private String getAssociateTitle() 
    {
        return this.associateTitle;
    }
    
    private String getNoAssociateTitle() 
    {
        return this.noAssociateTitle;
    }
    
    private void disableAllButtons() 
    {
        this.associateButton.setEnabled(false);
        this.desassociateButton.setEnabled(false);
        disableButtonsPriority();
    }
    
    private void disableButtonsPriority() 
    {
        this.addPriorityButton.setEnabled(false);
        this.subsPriorityButton.setEnabled(false);        
    }

}
