/*
 * ImportLoaderThread.java
 *
 * Created on 30 de noviembre de 2007, 8:14
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.loader;

import com.termcat.business.exceptions.ToolException;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.tools.ToolManager;
import com.termcat.layout.MainFrame;
import com.termcat.layout.eines.ExportarDiccionari;
import com.termcat.layout.eines.ImportarDiccionari;
import com.termcat.synchronizer.exceptions.ExportException;
import com.termcat.util.literales.Literales;
import java.io.File;
import javax.swing.JDialog;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;

/**
 *
 * @author Mena
 */
public class ExportLoaderThread extends Thread
{    
    private MainFrame menuFrame;
    private File file;
    private JLabel diccionariName;
    private JDialog loader;
    private ExportarDiccionari eDiccionari;
            
    /** Creates a new instance of CustomThread */
    public ExportLoaderThread(MainFrame menuFrame, File file, JLabel diccionariName, JDialog loader, ExportarDiccionari eDiccionari) 
    {
        super();
        this.menuFrame=menuFrame;      
        this.file=file;
        this.diccionariName=diccionariName;    
        this.loader=loader;
        this.eDiccionari=eDiccionari;
    }                          
    
    public void run() 
    {    
        try 
        {  
            //Deshabilitem els botons d'export i examinar.
            eDiccionari.setEnableExportButton(false);
            eDiccionari.setEnableExaminarButton(false);
            // Fem la crida al procs que executa la exportaci.
            ToolManager.getManager(menuFrame).createDictionaryXML(file,menuFrame.getIdCurrentDictionary());                    
            
            // Amaguem el missatge d'espera
            loader.setVisible(false);
            
            // Mostrar el missatge 
            menuFrame.showMessageInfo(Literales.getTextForMessage("ExportOK"));  
            
           // Actualitzem el nom del diccionari a la pantalla
           diccionariName.setText(menuFrame.getNomCurrentDictionary());
           
           // Habilitem els botons d'exportaci i examinar per a seleccionar un fitxer.
           eDiccionari.setEnableExportButton(true);
           eDiccionari.setEnableExaminarButton(true);           
           
           this.interrupt();
        }
        catch (ExportException ex) 
        {
            ex.printStackTrace();            
            this.interrupt();
            loader.setVisible(false);
            this.menuFrame.showMessageError(ex.getMessage());
            eDiccionari.setEnableExportButton(true);
            eDiccionari.setEnableExaminarButton(true);    
        }                                 
    }
}
