/*
 * ImportLoaderThread.java
 *
 * Created on 30 de noviembre de 2007, 8:14
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.loader;

import com.termcat.business.exceptions.ToolException;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.tools.ToolManager;
import com.termcat.layout.MainFrame;
import com.termcat.layout.eines.ImportarDiccionari;
import com.termcat.util.literales.Literales;
import java.io.File;
import javax.swing.JDialog;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;

/**
 *
 * @author Mena
 */
public class ImportLoaderThread extends Thread
{    
    private MainFrame menuFrame;
    private File file;
    private JLabel diccionariName;
    private JDialog loader;
    private ImportarDiccionari iDiccionari;
            
    /** Creates a new instance of CustomThread */
    public ImportLoaderThread(MainFrame menuFrame, File file, JLabel diccionariName, JDialog loader, ImportarDiccionari iDiccionari) 
    {
        super();
        this.menuFrame=menuFrame;      
        this.file=file;
        this.diccionariName=diccionariName;    
        this.loader=loader;
        this.iDiccionari=iDiccionari;
    }                          
    
    public void run() 
    {    
        try 
        {  
            iDiccionari.setEnableImportButton(false);
            iDiccionari.setEnableExaminarButton(false);
            
            ToolManager.getManager(menuFrame).importDadesFromXML(file,diccionariName);  

            // Marquem les taules de manteniments com a modificades i amaguem el missatge d'espera            
            updateManteniments();           
            
            if (menuFrame.tree==null)
                menuFrame.tree=iDiccionari.initJTree();
            
            loader.setVisible(false);
            
            // Mostrar el missatge 
            menuFrame.showMessageInfo(Literales.getTextForMessage("ImportOK"));  
            
           // Actualitzem el nom del diccionari a la pantalla
           diccionariName.setText(menuFrame.getNomCurrentDictionary());
           
           // Habilitem els botons d'importaci i examinar per a seleccionar un fitxer.           
           iDiccionari.setEnableImportButton(true);
           iDiccionari.setEnableExaminarButton(true);           
                      
           this.interrupt();           
        }
        catch (ToolException ex) 
        {
            ex.printStackTrace();            
            this.interrupt();
            loader.setVisible(false);
            this.menuFrame.showMessageError(ex.getMessage());
            iDiccionari.setEnableImportButton(true);
            iDiccionari.setEnableExaminarButton(true);    
        }                                 
    }
    
    private void updateManteniments()
    {
        // Fem un update del vector amb les fonts.                        
        try
        {
            menuFrame.allFontsUpdated=FontManager.getManager().getAllCodeIdFonts();
        }
        catch(Exception exc)
        {          
            exc.printStackTrace();
        }
                                
        // Modificaci dels components de la cerca
        this.menuFrame.setLlenguesModified(true);
        this.menuFrame.setATModified(true);
        this.menuFrame.setCategoriesModified(true);
        this.menuFrame.setJerarquiesModified(true);
        this.menuFrame.setFontsModified(true);
    }    
}
