/*
 * PanelPopup.java
 *
 * @author Mena
 *
 * Created on 18 de julio de 2007, 15:52
 *
 */
package com.termcat.layout.commons.popup;

import com.termcat.layout.FunctionalModule;
import javax.swing.JDialog;
import javax.swing.JFrame;


public class PanelPopup extends JDialog
{
    private final int DEFAULT_WIDTH=680;
    private final int DEFAULT_HEIGHT=420;
    
    private final int DEFAULT_X=10;
    private final int DEFAULT_Y=10;
    
    private boolean isModal;
    private String title;
    private int width;
    private int height;
    
    private int pos_x;
    private int pos_y;
    
    private FunctionalModule module;
    
        
    /** Creates a new instance of panelPopup */
    public PanelPopup(JFrame frame, FunctionalModule module) 
    {
        super(frame);

        this.module=module;
        this.title="";
        this.width=DEFAULT_WIDTH;
        this.height=DEFAULT_HEIGHT;
        
        this.pos_x=DEFAULT_X;
        this.pos_y=DEFAULT_Y;
        
        this.isModal=true;      
    }
    
     public PanelPopup(JFrame frame, FunctionalModule module, boolean isModal) 
    {
        super(frame);
        
        this.module=module;
        this.title="";
        this.width=DEFAULT_WIDTH;
        this.height=DEFAULT_HEIGHT;
        this.pos_x=DEFAULT_X;
        this.pos_y=DEFAULT_Y;
        this.isModal=isModal;
        
    }

    public PanelPopup(JFrame frame, FunctionalModule module,String title) 
    {
        super(frame);
        
        this.module=module;
        this.title=title;
        this.width=DEFAULT_WIDTH;
        this.height=DEFAULT_HEIGHT;
        this.pos_x=DEFAULT_X;
        this.pos_y=DEFAULT_Y;
        this.isModal=true;
        
    }
    
    public PanelPopup(JFrame frame, FunctionalModule module,String title, boolean isModal) 
    {
        super(frame);
        
        this.module=module;
        this.title=title;
        this.width=DEFAULT_WIDTH;
        this.height=DEFAULT_HEIGHT;
        this.pos_x=DEFAULT_X;
        this.pos_y=DEFAULT_Y;
        this.isModal=isModal;
        
    }

    public PanelPopup(JFrame frame, FunctionalModule module, String title, int width, int height,int x, int y) 
    {
        super(frame);
        
        this.module=module;
        this.title=title;
        this.width=width;
        this.height=height;
        this.pos_x=x;
        this.pos_y=y;
        this.isModal=true;
    }
    
    public PanelPopup(JFrame frame, FunctionalModule module, String title, int width, int height,int x, int y, boolean isModal) 
    {
        super(frame);
        
        this.module=module;
        this.title=title;
        this.width=width;
        this.height=height;
        this.pos_x=x;
        this.pos_y=y;
        this.isModal=isModal;
    }
    
    /*
     *  Funci encarregada de mostar una finestra emergent amb el contingut d'un mdul.
     *
     *  @param module: Obligatori. Mdul amb el contingut que es vol mostrar.
     *  @param title: Opcional. Titol del modul que es mostrar en la finestra emergent.
     *  @param modal: Opcional. Boole que indica si la finestra ser modal o no. El valor per
     *               defecte ser TRUE.
     *
     */
    
    public void showPopupWindow()
    {          
        setModal(this.isModal);
        add(this.module);
        setTitle(this.title);
        setLocation(this.pos_x,this.pos_y);
        setSize(this.width,this.height);
        setVisible(true);        
    }
        
    // Mirar de destruir totes les dades que hi ha associades al Altamain.
    public void closePopupWindow()
    {
        setVisible(false);     
    }
    
    public FunctionalModule getModule()
    {
        return this.module;
    }
}
