/*
 * PopupMenuTable.java
 *
 * Created on 17 de julio de 2007, 9:21
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.popup;

import com.termcat.layout.commons.*;
import com.termcat.layout.commons.interfaces.IEditor;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import com.termcat.layout.FunctionalModule;

/**
 *
 * @author Mena
 */
public class PopupMenuTable extends JPopupMenu 
{      
     JTable table;
     IEditor editor;
     FunctionalModule module;
     JMenuItem itemEdit;
     JMenuItem itemDelete;
     String edit;
     String delete;

    /** 
     *  Contructor.
     *
     *  @param table:       Taula en la qual es produeixen els events.
     *  @param module:      Module en el que s'ha creat la instncia del PopupMenuTable.
     *                      Necessitem el module perque sino en el editar (del menuListenerActionPerformed) no tenim manera d'executar la funci 'refresh()' del Main de la 
     *                      opci del men (ex: LlenguesMain). 
     *                      Aquesta funci 'refresh()', es la uqe s'encarrega d'accedir a BD, per obtenir el llistat amb tots els items.(en aquest cas amb totes les llengues).
     *                      Si no ho fem d'aquesta manera, s'hauria de crear cada vegauna un nou objecte 'LlenguesMain'(en aquest cas) que fes el refresh().
     *  @param editor:      Instancia de ieditor que ...
     *  @param edit:        Missatge d'edit que es vol mostrar en la opci d'edici.
     *  @param delete:      Missatge de delete que es vol mostrar en la opci de delete.
     *
     */
    public PopupMenuTable(JTable table, final FunctionalModule module, IEditor editor, String edit, String delete) 
    {
        // Atributs de la classe.
        this.table=table;
        this.editor=editor;        
        this.module=module;
        this.edit=edit;
        this.delete=delete;
        
        ActionListener menuListener = new ActionListener( ) {
            public void actionPerformed(ActionEvent event) {
                menuListenerActionPerformed(event);
            }
        };
        
               
        // Opci de edici de la llengua (icona provisional)
        if (edit!=null && !edit.equals(""))
        {       
            add(itemEdit = new JMenuItem(edit, new ImageIcon(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/edit.gif")))));
            itemEdit.addActionListener(menuListener);
        }

        // Opci d'eliminaci de la llengua (icona provisional)
        if (delete!=null && !delete.equals(""))
        {
            add(itemDelete = new JMenuItem(delete, new ImageIcon(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/delete.gif")))));
            itemDelete.addActionListener(menuListener);
        }
        
    }
         
    private void menuListenerActionPerformed(ActionEvent event)
    {
        try
        {
            // Fem efectiva la edici (en funci de la opci del menu) en cas de que s'hagi clicat alguna de les opcions de la taula.
            this.editor.editar(event, this.table,this.module); 
        }
        catch(Exception e)
        {
            // Falta fer el tractament en cas d'error'
            e.printStackTrace();
            System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ErrorTitle")+e.getMessage());
        }
    }  
    
    public void disableMenuItems()
    {
        if (edit!=null && !edit.equals(""))        
            itemEdit.setEnabled(false);
        if (delete!=null && !delete.equals(""))
            itemDelete.setEnabled(false);
    }

    public void enableMenuItems()
    {
        if (edit!=null && !edit.equals(""))        
            itemEdit.setEnabled(true);
        if (delete!=null && !delete.equals(""))
            itemDelete.setEnabled(true);
    }
}

