/**
 *
 * @author Mena
 */

package com.termcat.layout.commons.rtf;


import com.termcat.layout.commons.rtf.editor.RTFEditorKit;
import com.termcat.util.literales.Literales;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;
import java.io.*;
import java.net.URL;
import java.util.*;
import javax.swing.text.AttributeSet;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.Document;
import javax.swing.text.EditorKit;
import javax.swing.text.Element;
import javax.swing.text.JTextComponent;
import javax.swing.text.MutableAttributeSet;
import javax.swing.text.SimpleAttributeSet;
import javax.swing.text.StyleConstants;
import javax.swing.text.StyleContext;
import javax.swing.text.StyledDocument;
//import javax.swing.text.*;
import javax.swing.undo.*;
import javax.swing.event.*;
import javax.swing.*;

/**
 * Sample application using the simple text editor component that
 * supports only one font.
 *
 * @author  Timothy Prinzing
 * @version 1.30 07/26/04 
 */
public class EditorRTF extends JPanel {

    private static ResourceBundle resources;
    private final static String EXIT_AFTER_PAINT = new String(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("-exit"));
    private static boolean exitAfterFirstPaint;

    private JToggleButton boldButton;
    private JToggleButton italicButton;
    private JToggleButton underlineButton;    
    private JToggleButton subButton;    

    private final String BOLD_KEY=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("bold");
    private final String ITALIC_KEY=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("italic");
    private final String UNDERLINE_KEY=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("underline");    
    private final String SUBSCRIPT_KEY=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("sub");
    
    

    static {
        try 
        {
            resources = ResourceBundle.getBundle("com.termcat.layout.commons.rtf.resources.EditorRTF",Locale.getDefault());
        }
        catch (MissingResourceException mre) 
        {
            System.err.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditorRTF.properties_not_found"));
            System.exit(1);
        }
    }


    // ------------------------------------------------------------------------------------------
    // ------------------------------------------------------------------------------------------
    //                           DEFINCIO de VARIABLES I CONSTATNTS   
    // ------------------------------------------------------------------------------------------    
    // ------------------------------------------------------------------------------------------
    //private static JEditorPane editor;
    private JTextPane editor;
    private Hashtable commands;
    private JToolBar toolbar;

    // Constants - Suffix
    public static final String imageSuffix = java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Image");
    public static final String imagePressedSuffix = java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ImagePressed");
    public static final String actionSuffix = java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Action");
    public static final String tipSuffix = java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tooltip");
    
    // Constants - Actions    
    public static final String exitAction = java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("exit");

    // ------------------------------------------------------------------------------------------
    // ------------------------------------------------------------------------------------------
    //                                      CONSTRUCTOR
    // ------------------------------------------------------------------------------------------    
    // ------------------------------------------------------------------------------------------
    
    private RTFEditorKit ek;
    public RTFEditorKit getEditorKit(){
        return ek;
    }
    public EditorRTF() 
    {
	super(true);

	setBorder(BorderFactory.createEtchedBorder());
	setLayout(new BorderLayout());
        setSize(450,350);
        
	// create the embedded JTextComponent
	editor = createEditor();
        
	// install the command table
	commands = new Hashtable();
	Action[] actions = getActions();
	for (int i = 0; i < actions.length; i++) 
        {
	    Action a = actions[i];
            //System.out.println("Action:"+a.getValue(Action.NAME));
	    commands.put(a.getValue(Action.NAME), a);
	}
	
	JScrollPane scroller = new JScrollPane();
	JViewport port = scroller.getViewport();
	port.add(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Center"),editor);
                              
	JPanel panel = new JPanel();
	panel.setLayout(new BorderLayout());	
	panel.add(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("North"),createToolbar());
	panel.add(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Center"), scroller);       
	add(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Center"), panel);
        
        setVisible(true);
    }

    /**
     * Fetch the list of actions supported by this
     * editor.  It is implemented to return the list
     * of actions supported by the embedded JTextComponent
     * augmented with the actions defined locally.
     */
    public Action[] getActions() {
        return editor.getActions();
    }

    /**
     * Create an editor to represent the given document.  
     */
    public JTextPane createEditor() 
    {

        JTextPane c = new JTextPane();

        c.setContentType("text/rtf");
        //EditorKit ek=c.getEditorKitForContentType(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("text/rtf"));
        ek = new RTFEditorKit();
        
        
        
        
        
        c.setEditorKitForContentType("text/rtf",ek);
        //c.setEditorKitForContentType("text/rtf",new tests.rtfAdvancedKit.RTFEditorKit());
        
	c.setDragEnabled(true);
	c.setFont(new Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("monospaced"), Font.PLAIN, 12));
        c.addKeyListener(new java.awt.event.KeyAdapter() {
               public void keyPressed(java.awt.event.KeyEvent evt) {
                setStatusButtons(evt);
            }
        });            
        c.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                setStatusButtons(null);
            }
        });
        
	return c;
    }
 protected JTextPane createTextPane() {
           StyleContext sc = new StyleContext();
           final DefaultStyledDocument doc = new DefaultStyledDocument();
           final JTextPane p = new JTextPane(doc){
           public void paintComponent(Graphics g) {
                   Graphics2D g2d = (Graphics2D)g;
                   g2d.scale(1,1);
                   super.paintComponent(g2d);
                   g2d.dispose();
                  
           }

           
        };
        return p;
    }    
    /** 
     * Fetch the editor contained in this panel
     */
    public JTextComponent getEditor() {
	return editor;
    }

    /**
     * To shutdown when run as an application.  This is a
     * fairly lame implementation.   A more self-respecting
     * implementation would at least check to see if a save
     * was needed.
     */
    
    // Nomes pel cas de tenir frame.
    protected static final class AppCloser extends WindowAdapter {
        public void windowClosing(WindowEvent e) {
	    System.exit(0);
	}
    }

     protected Action getAction(String cmd) {
	return (Action) commands.get(cmd);
    }

    private String getResourceString(String nm) {
	String str;
	try {
	    str = resources.getString(nm);
	} catch (MissingResourceException mre) {
	    str = null;
	}
	return str;
    }

    protected URL getResource(String key) {
	String name = getResourceString(key);
	if (name != null) {
	    URL url = this.getClass().getResource(name);
	    return url;
	}
	return null;
    }

    private Container getToolbar() {
	return toolbar;
    }

    /**
     * Create the toolbar.  By default this reads the 
     * resource file for the definition of the toolbar.
     */
    protected Component createToolbar() {
	toolbar = new JToolBar();
	String[] toolKeys = tokenize(getResourceString(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("toolbar")));
	for (int i = 0; i < toolKeys.length; i++)
        {
	    if (toolKeys[i].equals("-")) 
		toolbar.add(Box.createHorizontalStrut(50));
	    else 
 		toolbar.add(createTool(toolKeys[i]));
	}
        
        // Creem els botons de superScript i subscript i els afegim al toolbar
        JToggleButton subscriptButton = new JToggleButton(new SubscriptAction());
        subscriptButton.setText(Literales.getTextForLiteral("Editor_Subindice"));
        
               
	JToggleButton superscriptButton = new JToggleButton(new SuperscriptAction());
        superscriptButton.setText(Literales.getTextForLiteral("Editor_Supraindice"));
        //subscriptButton.setIcon(new ImageIcon("subscript.gif"));
        //superscriptButton.setIcon(new ImageIcon("superscript.gif"));        
        
        toolbar.add(subscriptButton);
        toolbar.add(superscriptButton);
        
	return toolbar;
    }

    /**
     * Hook through which every toolbar item is created.
     */
    private Component createTool(String key) {
	return createToolbarButton(key);
    }

    /**
     * Create a button to go inside of the toolbar.  By default this
     * will load an image resource.  The image filename is relative to
     * the classpath (including the '.' directory if its a part of the
     * classpath), and may either be in a JAR file or a separate file.
     * 
     * @param key The key in the resource file to serve as the basis
     *  of lookups.
     */
    private JToggleButton createToolbarButton(String key) 
    {
        // Obtenim la URL de la imatge en el fitxer de properties.
	URL url = getResource(key + imageSuffix);
        URL urlPressed = getResource(key + imagePressedSuffix);
        
        // Creem el bot amb la imatge del fitxer de properties.
        JToggleButton b = new JToggleButton() {
            public float getAlignmentY() { return 0.5f; }
	};

        // Ens guardem el boto a l'objecte
        if(key.equals(BOLD_KEY))
            boldButton=b;      
        else if(key.equals(ITALIC_KEY))
            italicButton=b;
        else if(key.equals(UNDERLINE_KEY))
            underlineButton=b;         
        
        // Li associem les imatges
        if (url!=null)
        {
            ImageIcon ii= new ImageIcon(url);
            if (ii!=null)
                b.setIcon(ii);   
        }
        // Definim propietats de l'objecte bot
        b.setRequestFocusEnabled(false);
        b.setMargin(new Insets(1,1,1,1));

	// Obtenim del fitxer de properties el nom de l'action
        String astr = getResourceString(key + actionSuffix);
	if (astr == null) 
	    astr = key;
        
	Action a = getAction(astr);
	if (a != null) 
        {
	    b.setActionCommand(astr);
	    b.addActionListener(a);
	} 
        else 
            b.setEnabled(false);

         // Obtenim el tooltip que s'associar al bot
    	String tip = getResourceString(key + tipSuffix);
	if (tip != null) 
	    b.setToolTipText(tip);

        // Retornem el bot acabat de crear.
        return b;
    }

    /**
     * Take the given string and chop it up into a series
     * of strings on whitespace boundaries.  This is useful
     * for trying to get an array of strings out of the
     * resource file.
     */
    protected String[] tokenize(String input) {
	Vector v = new Vector();
	StringTokenizer t = new StringTokenizer(input);
	String cmd[];

	while (t.hasMoreTokens())
	    v.addElement(t.nextToken());
	cmd = new String[v.size()];
	for (int i = 0; i < cmd.length; i++)
	    cmd[i] = (String) v.elementAt(i);

	return cmd;
    }
    
    // Obtiene el texto 'rtf' sin estilo!
    public  String getRTFPlainText() 
    {
        String content="";
        
        StyledDocument doc = editor.getStyledDocument();
        
        System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("textLabel")+editor.getText());
        try {
            content=doc.getText(0,doc.getLength());
        } catch (BadLocationException ex) {
            ex.printStackTrace();
        }       
        
        return content;
    }
    public  String getRTFText() 
    {
        String res="";
        ByteArrayOutputStream os = new ByteArrayOutputStream();
        RTFEditorKit kit = (RTFEditorKit)editor.getEditorKitForContentType(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("text/rtf"));
        try 
        {
            kit.write(os, editor.getDocument(), 0, editor.getDocument().getLength());
            res=os.toString();
            res = replaceSubSuperEndsForGetter(res);
        }
        catch (Exception e) {
            e.printStackTrace();
          System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Write_failed"));
        }
        
        return res;
     }
    
     
    public  void setRTFText(String text) 
    {       
         
        text = replaceNosupersupForSetter(text);
        RTFEditorKit kit = (RTFEditorKit)editor.getEditorKitForContentType(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("text/rtf"));
        if(text!=null){ 
            StringReader reader = new StringReader(text);
            try {
                kit.read(reader,editor.getDocument(),0);
            } catch (Exception ex) {
                System.out.println("Error en la lectura");
                ex.printStackTrace();
            }
        }
        
        //seteo del tamanyo de las fuentes que bienen del termcat que se visualizan muy pequenyas
        MutableAttributeSet set = kit .getInputAttributes();
        DefaultStyledDocument documento = (DefaultStyledDocument) editor.getDocument();
        SimpleAttributeSet attributeSet = new SimpleAttributeSet();
        StyleConstants.setFontSize( attributeSet, 12 );
        documento.setCharacterAttributes( 0, documento.getLength(), attributeSet, false);
             
        // Printem missatges per pantalla.
        //System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Set_text_Done"));          
    }  
 
     private  String replaceSubSuperEndsForGetter(String cad){
        if(cad!=null){
            cad = cad.replaceAll("\\\\sub0","\\\\nosupersub");
            cad = cad.replaceAll("\\\\super0","\\\\nosupersub");
        }   
        return cad;
    }
     private  String replaceNosupersupForSetter(String cad){
        if(cad!=null){
            int pos = cad.indexOf("\\nosupersub");
            while (pos!=-1){
                String aux = cad.substring(0,pos);
                if(aux.indexOf("\\super")!=-1){
                   aux=aux+"\\super0";
                }
                else{
                    aux=aux+"\\sub0";
                }
                cad = aux+cad.substring(pos+11);
                pos = cad.indexOf("\\nosupersub");
            }
       }
        return cad;
    }
    
  /*   static void buildDemo(){
	new Thread() {
	    public void run() {
		createDummy();
	    }
	}.start();
        
    }
    public static EditorRTF notepad = new EditorRTF();
    public static void createDummy(){
    try {        
        JFrame frame = new JFrame();
        frame.setTitle(resources.getString("Title"));
	frame.setBackground(Color.lightGray);
	frame.getContentPane().setLayout(new BorderLayout());
        
	frame.getContentPane().add("Center", notepad);
	frame.addWindowListener(new AppCloser());

        // Creaci dels botons de 'Guardar' i 'Carregar' per a fer proves.        
        // Bot de SAVE
        JButton saveButton = new JButton();
        saveButton.setText("Save");
        saveButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                String textRtf= notepad.getRTFText();// --> No posem la funci peruqe al no ser estatica dona problemes
                // Printem per pantalla missatges
                System.out.println("Get text Done");   
                System.out.println(" CONTENT: "+textRtf);     
            }
        });
        // Bot de LOAD        
        JButton loadButton = new JButton();
        loadButton.setText("Load");
        loadButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                // setRTFText(str) --> No posem la funci peruqe al no ser estatica dona problemes
                // Afegim el texte a l'objecte
                 //editor.setText("<html><body><i>Carlos </i><b>MENA</b></body></html>");               
                //editor.setText("{\\rtf1{\\colortbl ;\\red255\\green0\\blue0;}Esto\\par s ua \\b prueba\\b0  de \\i cursiva\\i0\\par y \\cf1 todo\\cf0 \\par}");                
                setRTFText("{\\rtf1\\ansi\\ansicpg1252\\deff0{\\fonttbl{\\f0\\fnil\\fcharset0 Univers;}}  \\viewkind4\\uc1\\pard\\tx0\\lang3082\\f0\\fs18 For\\'e7a que s'oposa a l'avan\\'e7 d'un autom\\'f2bil deguda a l'aire. Dep\\'e8n principalment de la velocitat del vehicle. Ve donada per la f\\'f3rmula: \\i R\\sub a\\nosupersub\\i0  = 1/2 \\'b7 <ro grega min\\'fascula> \\'b7 \\i C\\i0  \\'b7 \\i A\\i0  \\'b7 \\i v\\super 2\\nosupersub\\i0 , on <ro grega min\\'fascula> \\'e9s la densitat de l'aire, \\i C\\i0  \\'e9s el coeficient aerodin\\'e0mic, \\i A\\i0  \\'e9s l'\\'e0rea de la secci\\'f3 transversal del vehicle, i \\i v\\i0  \\'e9s la velocitat respecte a l'aire. El par\\'e0metre \\i C\\i0  varia entre 0,3 per als turismes i 0,8 per als camions i fins i tot pot arribar a 1,0. L'\\'e0rea de la secci\\'f3 transversal \\i A\\i0  \\'e9s de prop de 2 m\\super 2\\nosupersub  en els turismes, mentre que en els camions varia entre 5 i 8 m\\super 2\\nosupersub .\\fs24   }  ");
                //setRTFText("{\\rtf1\\ansi\\ansicpg1252\\deff0{\\fonttbl{\\f0\\fnil\\fcharset0 Univers;}}  \\viewkind4\\uc1\\pard\\tx0\\lang3082\\f0\\fs18 For\\'e7a que s'oposa a l'avan\\'e7 d'un autom\\'f2bil deguda a l'aire. Dep\\'e8n principalment de la velocitat del vehicle. Ve donada per la f\\'f3rmula: \\i R\\sub a\\sub0\\i0  = 1/2 \\'b7 <ro grega min\\'fascula> \\'b7 \\i C\\i0  \\'b7 \\i A\\i0  \\'b7 \\i v\\super 2\\nosupersub\\i0 , on <ro grega min\\'fascula> \\'e9s la densitat de l'aire, \\i C\\i0  \\'e9s el coeficient aerodin\\'e0mic, \\i A\\i0  \\'e9s l'\\'e0rea de la secci\\'f3 transversal del vehicle, i \\i v\\i0  \\'e9s la velocitat respecte a l'aire. El par\\'e0metre \\i C\\i0  varia entre 0,3 per als turismes i 0,8 per als camions i fins i tot pot arribar a 1,0. L'\\'e0rea de la secci\\'f3 transversal \\i A\\i0  \\'e9s de prop de 2 m\\super 2\\nosupersub  en els turismes, mentre que en els camions varia entre 5 i 8 m\\super 2\\nosupersub .\\fs24   }  ");
                // Printem missatges per pantalla.
                System.out.println("content type:"+editor.getContentType());              
                System.out.println("Set text Done");                  
            }
        });      
        
        // Afegim els botons al frame.
        JPanel buttonsPanel = new JPanel();
        buttonsPanel.add(saveButton);
        buttonsPanel.add(loadButton);           
        frame.add("South",buttonsPanel);              
	
        frame.pack();
	frame.setSize(450,350);
        frame.setVisible(true);
        } catch (Throwable t) {
            System.out.println("uncaught exception: " + t);
            t.printStackTrace();
        }
        
    }*/
    
// -------------------------------------------------------------------------------------------------------    
// -------------------------------------------------------------------------------------------------------
//                                            METODE PRINCIPAL    
// -------------------------------------------------------------------------------------------------------
// -------------------------------------------------------------------------------------------------------    
    
        public static void main(String[] args) {
           // buildDemo();
            //String dumy = "{\\rtf1\\ansi {\\fonttbl\\f0\\fnil Monospaced;\\f1\\fnil monospaced;} {\\colortbl\\red0\\green0\\blue0;\\red51\\green51\\blue51;} \\f1\\fs24\\i0\\b0\\cf1 d\\sub e\\sub0\\par }";
            //System.out.println(replaceSubSuperEnds(dumy));
            
    }
        
    private void setStatusButtons(java.awt.event.KeyEvent evt) 
    {

        int position=editor.getCaretPosition();
        if (position>1)
            position--;
        if (evt!=null)
        {
            int code=evt.getKeyCode();
        }

        
        AttributeSet a=this.editor.getStyledDocument().getCharacterElement(position).getAttributes();

        boolean isBold=StyleConstants.isBold(a);
        boolean isItalic=StyleConstants.isItalic(a);
        boolean isUnderline=StyleConstants.isUnderline(a);
        
        boldButton.setSelected(isBold);
        italicButton.setSelected(isItalic);
        underlineButton.setSelected(isUnderline);
            
    }
}