/*
 * JTreeMenuTable.java
 *
 * Created on 27 de agosto de 2007, 18:47
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.commons.tree;

/**
 *
 * @author Mena
 */
/*
 * PopupMenuTable.java
 *
 * Created on 17 de julio de 2007, 9:21
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */


import com.termcat.layout.commons.*;
import com.termcat.layout.commons.interfaces.IEditor;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;

import com.termcat.layout.FunctionalModule;

/**
 *
 * @author Mena
 */
public class JTreeMenuTable extends JPopupMenu 
{      
     JTree tree;
     IEditor editor;
     FunctionalModule module;
     
    /** 
     *  Contructor.
     *
     *  @param tree:        Arbre que genera els events.
     *  @param module:      Module en el que s'ha creat la instncia del PopupMenuTable.
     *                      Necessitem el module perque sino en el editar (del menuListenerActionPerformed) no tenim manera d'executar la funci 'refresh()' del Main de la 
     *                      opci del men (ex: LlenguesMain).  --> AQU NO CAL, NO HEM DE FER REFRESH DE RES!!!
     *                      Aquesta funci 'refresh()', es la uqe s'encarrega d'accedir a BD, per obtenir el llistat amb tots els items.(en aquest cas amb totes les llengues).
     *                      Si no ho fem d'aquesta manera, s'hauria de crear cada vegauna un nou objecte 'LlenguesMain'(en aquest cas) que fes el refresh().
     *  @param editor:      Instancia de ieditor que executara el metode Editar (Alta / Edicio / Esborrat)
     *  @param alta:        Missatge d'alta que es vol mostrar en la opci d'alta.
     *  @param edit:        Missatge d'edit que es vol mostrar en la opci d'edici.
     *  @param delete:      Missatge de delete que es vol mostrar en la opci d'esborrat.
     *
     */
    public JTreeMenuTable(JTree tree, IEditor editor, String alta,String edit, String delete) 
    {
        // Atributs de la classe.
        this.tree=tree;
        this.editor=editor;        
        this.module=module;
        
        ActionListener menuListener = new ActionListener( ) {
            public void actionPerformed(ActionEvent event) {
                menuListenerActionPerformed(event);
            }
        };

        JMenuItem item;
        // Opci de edici de la llengua (icona provisional)
        if (alta!=null && !alta.equals(""))
        {
            add(item = new JMenuItem(alta, new ImageIcon(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/alta.gif")))));
            item.addActionListener(menuListener);
        }
        
        // Opci de edici de la llengua (icona provisional)
        if (edit!=null && !edit.equals(""))
        {
            add(item = new JMenuItem(edit, new ImageIcon(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/edit.gif")))));
            item.addActionListener(menuListener);
        }
        // Opci d'eliminaci de la llengua (icona provisional)
        if (delete!=null && !delete.equals(""))
        {
            add(item = new JMenuItem(delete, new ImageIcon(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/delete.gif")))));
            item.addActionListener(menuListener);
        }
    }
         
    private void menuListenerActionPerformed(ActionEvent event)
    {
        try
        {
            // Fem efectiva la edici (en funci de la opci del menu) en cas de que s'hagi clicat alguna de les opcions de la taula.
            this.editor.editar(event, this.tree,null); 
        }
        catch(Exception e)
        {
            // Falta fer el tractament en cas d'error'
            e.printStackTrace();
            System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ErrorTitle")+e.getMessage());
        }
    }  

}


