/*
 * DiccionariMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.diccionari;

import com.termcat.business.areas.AreaManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.util.literales.Literales;
import javax.swing.JPanel;
/**
 *
 * @author  Vazquezl
 */
public class DiccionariEdit extends FunctionalModule {
    
     private String idDiccionari;
     private String dades[];
    /** segundo constructor */
    public DiccionariEdit(MainFrame menuFrame, String idDiccionari) {
        super(menuFrame);
        this.idDiccionari=idDiccionari;
        initComponents();
        // Obtenim les dades del diccionari.
        dades =new String[3];
        try
        {        
            dades=DictionaryManager.getManager().getDadesDiccionari(idDiccionari);
            // Carreguem les dades del diccionari.
            nomValue.setText(dades[0]);
            descValue.setText(dades[1]);
            observacionsValue.setText(dades[2]);        
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelTitol = new javax.swing.JPanel();
        panelIntern = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        observacionsValue = new javax.swing.JTextArea();
        observacionsLabel = new javax.swing.JLabel();
        descripcioLabel = new javax.swing.JLabel();
        nomLabel = new javax.swing.JLabel();
        nomValue = new FixedLengthTextField(50);
        botonAlta = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        descValue = new FixedLengthTextField(50);

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelTitol.setBorder(javax.swing.BorderFactory.createTitledBorder("Diccionaris: Propietats d'un diccionari"));
        panelTitol.setMaximumSize(new java.awt.Dimension(922, 692));
        panelTitol.setMinimumSize(new java.awt.Dimension(922, 692));
        observacionsValue.setColumns(20);
        observacionsValue.setRows(5);
        jScrollPane1.setViewportView(observacionsValue);

        observacionsLabel.setText("Observacions:");

        descripcioLabel.setText("Descripci\u00f3:");

        nomLabel.setText("Nom:");

        nomValue.setColumns(25);

        botonAlta.setText("Desar");
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonEditActionPerformed(evt);
            }
        });

        botonCancela.setText("Cancel\u00b7lar");
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        descValue.setPreferredSize(new java.awt.Dimension(200, 19));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .add(107, 107, 107)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(observacionsLabel)
                    .add(descripcioLabel)
                    .add(nomLabel))
                .add(41, 41, 41)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 211, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, nomValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 211, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, descValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 211, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                        .add(botonAlta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 53, Short.MAX_VALUE)
                        .add(botonCancela)))
                .add(96, 96, 96))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(27, 27, 27)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nomLabel)
                    .add(nomValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(21, 21, 21)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(descripcioLabel)
                    .add(descValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(20, 20, 20)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(observacionsLabel)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 207, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(63, 63, 63)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonAlta)
                    .add(botonCancela))
                .addContainerGap(105, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout panelTitolLayout = new org.jdesktop.layout.GroupLayout(panelTitol);
        panelTitol.setLayout(panelTitolLayout);
        panelTitolLayout.setHorizontalGroup(
            panelTitolLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelTitolLayout.createSequentialGroup()
                .add(168, 168, 168)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(212, Short.MAX_VALUE))
        );
        panelTitolLayout.setVerticalGroup(
            panelTitolLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelTitolLayout.createSequentialGroup()
                .add(76, 76, 76)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(58, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(42, 42, 42)
                .add(panelTitol, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(62, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(panelTitol, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
        // Tornem a la informacio que estava al principi
        nomValue.setText(dades[0]);
        descValue.setText(dades[1]);
        observacionsValue.setText(dades[2]);                
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonEditActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonEditActionPerformed
       try
       {
           if (validateTextComponent("Nom",nomValue,true,50)){
              DictionaryManager.getManager().updateDiccionari(this.idDiccionari,nomValue.getText(),descValue.getText(),observacionsValue.getText());
          
              // Actualitzem el nom del diccionari en el menuFrame
              this.menuFrame.setNomCurrentDictionary(nomValue.getText());

              menuFrame.showMessageInfo(Literales.getTextForMessage("Diccionari_EditOk"));
           } 
       }
       catch(Exception e){
            tratarError(new DictionaryException(e.getMessage()));
       }
       
    }//GEN-LAST:event_botonEditActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JButton botonCancela;
    private javax.swing.JTextField descValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel nomLabel;
    private javax.swing.JTextField nomValue;
    private javax.swing.JLabel observacionsLabel;
    private javax.swing.JTextArea observacionsValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JPanel panelTitol;
    // End of variables declaration//GEN-END:variables
    
}
