/*
 * DiccionariLlengues.java
 *
 * Created on 9 de agosto de 2007, 19:02
 */

package com.termcat.layout.diccionari;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.exceptions.DictionaryLanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.util.literales.Literales;
import java.awt.Color;
import java.util.Vector;
import com.termcat.bd.beans.LlenguesDiccionari;

/**
 *
 * @author  Mena
 */
public class DiccionariLlengues extends FunctionalModule  {
    
    private AssociateLists al;
    
    /** Creates new form DiccionariLlengues */
    public DiccionariLlengues(MainFrame menuFrame) 
    {
        super(menuFrame);
        initComponents();
        
        this.internPanel.setBackground(new Color(238,238,238));
        diccionariName.setText(this.menuFrame.getNomCurrentDictionary());
        setPanel(this);
        
        // Ens assegurem de tancar les possibles transaccions.
        DBConnect.putConnectionTransactional();
        
        initAssociateList();
        
        // Deshabilitem els botons.
        //disableAllButtons();        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        internPanel = new javax.swing.JPanel();
        vScrollPane = new javax.swing.JScrollPane();
        jButton1 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        diccionarioLabel = new javax.swing.JLabel();
        tituloTabla = new javax.swing.JLabel();
        diccionariName = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        internPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("DiccionarisLlengues")));
        internPanel.setMaximumSize(new java.awt.Dimension(922, 692));
        internPanel.setMinimumSize(new java.awt.Dimension(922, 692));
        vScrollPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        vScrollPane.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        jButton1.setText(Literales.getTextForLiteral("Desar"));
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                acceptarButtonActionPerformed(evt);
            }
        });

        jButton2.setText(Literales.getTextForLiteral("BotonCancelar"));
        jButton2.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelarButtonActionPerformed(evt);
            }
        });

        diccionarioLabel.setFont(new java.awt.Font("Tahoma", 1, 24));
        diccionarioLabel.setText(Literales.getTextForLiteral("DiccionariLabel"));
        diccionarioLabel.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("DiccionariLabel"));

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("AssociarLlengues"));

        diccionariName.setFont(new java.awt.Font("Tahoma", 0, 24));
        diccionariName.setText("jLabel1");

        org.jdesktop.layout.GroupLayout internPanelLayout = new org.jdesktop.layout.GroupLayout(internPanel);
        internPanel.setLayout(internPanelLayout);
        internPanelLayout.setHorizontalGroup(
            internPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(internPanelLayout.createSequentialGroup()
                .add(36, 36, 36)
                .add(internPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tituloTabla)
                    .add(internPanelLayout.createSequentialGroup()
                        .add(diccionarioLabel)
                        .add(64, 64, 64)
                        .add(diccionariName, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 666, Short.MAX_VALUE)))
                .addContainerGap())
            .add(internPanelLayout.createSequentialGroup()
                .add(157, 157, 157)
                .add(vScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 582, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(165, Short.MAX_VALUE))
            .add(org.jdesktop.layout.GroupLayout.TRAILING, internPanelLayout.createSequentialGroup()
                .addContainerGap(444, Short.MAX_VALUE)
                .add(jButton1)
                .add(66, 66, 66)
                .add(jButton2)
                .add(252, 252, 252))
        );
        internPanelLayout.setVerticalGroup(
            internPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(internPanelLayout.createSequentialGroup()
                .add(62, 62, 62)
                .add(internPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diccionarioLabel)
                    .add(diccionariName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(59, 59, 59)
                .add(tituloTabla)
                .add(70, 70, 70)
                .add(vScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 275, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(70, 70, 70)
                .add(internPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jButton2)
                    .add(jButton1))
                .add(54, 54, 54))
        );
        internPanel.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("DiccionarisLlengues"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(40, 40, 40)
                .add(internPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(64, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(28, 28, 28)
                .add(internPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(72, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void cancelarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelarButtonActionPerformed
        initAssociateList();
       // disableAllButtons();
    }//GEN-LAST:event_cancelarButtonActionPerformed

    private void acceptarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_acceptarButtonActionPerformed
        Vector selectedList=al.getSelectedList();
        Vector unselectedList=al.getUnselectedList();
        
        try 
        {
            DictionaryManager.getManager().deleteLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary(),unselectedList);
            DictionaryManager.getManager().setLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary(),selectedList);
            
            //Mostrem missatge de confirmacio.
            this.menuFrame.showMessageInfo(Literales.getTextForMessage("LlenguesDiccionari_UpdateOk"));

           //Marquem que s'ha modificat l'estat de les llengues
           this.menuFrame.setLlenguesModified(true);            
        } 
        catch (Exception e) 
        {
            e.printStackTrace();
            tratarError(new DictionaryLanguageException(e.getMessage()));
            
            // Recarreguem la llista inicial.
            initAssociateList();
        }
    }//GEN-LAST:event_acceptarButtonActionPerformed

    private void initAssociateList() 
    {
        try
        {
            Vector associates=DictionaryManager.getManager().getLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary());
            Vector allLlengues=LanguageManager.getManager().getAllCodeIdLlengues();
            
            Vector noAssociates=getNoAssociates(allLlengues,associates);
            
            al=new AssociateLists(noAssociates,associates,true,LLENGUES_NO_ASSOCIATE_TITLE,LLENGUES_ASSOCIATE_TITLE);
            vScrollPane.setViewportView(al);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DictionaryException(e.getMessage()));
        }   
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel diccionariName;
    private javax.swing.JLabel diccionarioLabel;
    private javax.swing.JPanel internPanel;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JLabel tituloTabla;
    private javax.swing.JScrollPane vScrollPane;
    // End of variables declaration//GEN-END:variables
}
