/*
 * FontsAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.diccionari.arees;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.business.areas.AreaManager;
import com.termcat.business.exceptions.AreaException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.util.literales.Literales;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 *
 * @author  mena
 */
public class AreesEdit extends FunctionalModule 
{
    
    private String idArea; 
    private EditorArees editor;
  
    /*
     *       Contructor de la classe. Noms permetr canviar al nom de l'rea temtica. Per canviar el pare
     *      es fara mitjanant el Drag & Drop (DnD).
     */
    public AreesEdit(MainFrame menuFrame, EditorArees editor,String idArea, String nom, String nomPare) 
    {
        super(menuFrame);
        this.idArea=idArea;
        this.editor=editor;
        initComponents();

        this.nomValue.setText(nom);
        if (nomPare!=null && !nomPare.equals("ROOT"))
            this.areaSuperiorValue.setText(nomPare);
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        nomLabel = new javax.swing.JLabel();
        nomValue = new FixedLengthTextField(255);
        botonAlta = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        areaSuperiorLabel = new javax.swing.JLabel();
        areaSuperiorValue = new javax.swing.JLabel();

        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder("Edici\u00f3 d'una \u00e0rea tem\u00e0tica"));
        nomLabel.setText("Nom:");

        nomValue.setColumns(25);

        botonAlta.setText("Desar");
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        botonCancela.setText("Cancel\u00b7lar");
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        areaSuperiorLabel.setText("Area superior");

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(127, 127, 127)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(areaSuperiorLabel)
                    .add(nomLabel))
                .add(41, 41, 41)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(panelInternLayout.createSequentialGroup()
                                .add(botonAlta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 53, Short.MAX_VALUE)
                                .add(botonCancela))
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, nomValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 211, Short.MAX_VALUE))
                        .add(122, 122, 122))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(areaSuperiorValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 203, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(20, 20, 20)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(areaSuperiorLabel)
                    .add(areaSuperiorValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 23, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nomLabel)
                    .add(nomValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(13, 13, 13)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonAlta)
                    .add(botonCancela))
                .addContainerGap(92, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(52, 52, 52)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(35, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(34, 34, 34)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
       try{
           String nom= nomValue.getText();
           if (validateTextComponent("Nom",nomValue,true,255))
           {  
               // Fem la modificaci en la BD.
               ArbreCamp area=AreaManager.getManager().updateArea(this.idArea,"",nom);
               
               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("AreesTematiques_UpdateOk"));
                             
               // Actualitzem l'arbre
              ((DefaultTreeModel)this.editor.tree.getModel()).valueForPathChanged(this.editor.tree.getPathForRow(this.editor.rowSelected),area);               
               
                //Marquem que s'ha modificat l'estat de les Ats
                this.menuFrame.setATModified(true);
              
               // Tanquem la finestra d'alta d'una nova font.
               this.menuFrame.closePanelPopup();               
           } 
       }
       catch(Exception e){
           e.printStackTrace();
           tratarError(new AreaException(e.getMessage())); 
       }     
    }//GEN-LAST:event_botonAltaActionPerformed
        
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel areaSuperiorLabel;
    private javax.swing.JLabel areaSuperiorValue;
    private javax.swing.JButton botonAlta;
    private javax.swing.JButton botonCancela;
    private javax.swing.JLabel nomLabel;
    private javax.swing.JTextField nomValue;
    private javax.swing.JPanel panelIntern;
    // End of variables declaration//GEN-END:variables
}
