/*
 * FontsMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.diccionari.arees;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.bd.beans.Jerarquies;
import com.termcat.business.areas.AreaManager;
import com.termcat.business.exceptions.AreaException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.dndtree.DNDTree;
import com.termcat.layout.commons.tree.JTreeMenuTable;
import com.termcat.layout.commons.tree.MouseJTreeListener;
import com.termcat.util.UIDGenerator;
import com.termcat.util.literales.Literales;
import java.awt.dnd.DnDConstants;
import java.util.List;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.exceptions.CategoryException;
import javax.swing.tree.DefaultMutableTreeNode;

/**
 *
 * @author  mena
 */
public class AreesMain extends FunctionalModule
{
    private String idDiccionari;
       
    //Constants
    private final String ALTA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AltaAT");
    private final String EDITAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarAT");
    private final String ESBORRAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EsborrarAT");
    
    /** segundo constructor */
    public AreesMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        try
        {                 
            initComponents();                              
                                           
            if (this.menuFrame.tree==null)
                this.menuFrame.tree=initJTree();
            
            // Afegim el listener i els elements de DnD
            this.menuFrame.tree.addMouseListener(new MouseJTreeListener(new JTreeMenuTable(this.menuFrame.tree,new EditorArees(this.menuFrame),ALTA,EDITAR,ESBORRAR)));            
            
            diccionariValue.setText(this.menuFrame.getNomCurrentDictionary());
            // Creem l'arbre de camp amb els valors de la BD.
            scrollPaneTabla.setViewportView(this.menuFrame.tree);
            setPanel(this);
        }
        catch(Exception e)
        {
            tratarError(new AreaException(e.getMessage())); 
            e.printStackTrace();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        diccionariValue = new javax.swing.JLabel();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();
        diccionariLabel = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("DiccionarisArbreCamp")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        diccionariValue.setFont(new java.awt.Font("Tahoma", 0, 24));
        diccionariValue.setText("jLabel1");

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("ArbreCampLabel"));

        scrollPaneTabla.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        diccionariLabel.setFont(new java.awt.Font("Tahoma", 1, 24));
        diccionariLabel.setText(Literales.getTextForLiteral("DiccionariLabel"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(38, 38, 38)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tituloTabla)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(diccionariLabel)
                        .add(60, 60, 60)
                        .add(diccionariValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 668, Short.MAX_VALUE))
                    .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 761, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(66, 66, 66)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diccionariLabel)
                    .add(diccionariValue))
                .add(57, 57, 57)
                .add(tituloTabla)
                .add(23, 23, 23)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 393, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(48, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(38, 38, 38)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(66, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents
      
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel diccionariLabel;
    private javax.swing.JLabel diccionariValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables

}