/*
 * EditorFont.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.diccionari.arees;


import com.termcat.bd.beans.ArbreCamp;
import com.termcat.bd.utils.DBConnect;
import com.termcat.business.areas.AreaManager;
import com.termcat.util.literales.Literales;
import java.sql.Connection;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;

import com.termcat.business.exceptions.AreaException;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.layout.MainFrame;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una font de la taula .
 *
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 * 
 *  @author mena
 */
public class EditorArees extends FunctionalModule implements com.termcat.layout.commons.interfaces.IEditor
{      
    //Constants
    private final String ALTA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AltaAT");
    private final String EDITAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarAT");
    private final String ESBORRAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EsborrarAT");
    
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la font(PK).
    
    //  De moment les posem aix per a poder accedir desde AreesAlta i AreesEdit, quan els hi passem a aquestes
    // classes (AreesAlta i AreesEdit) l'objecte 'this' (EditorArees).
    public JTree tree; // Per a poder accedir-hi desde el Alta i Edicio.
    public DefaultMutableTreeNode selectedTreeNode; 
    public int rowSelected;
    
    /** Creates a new instance of EditorLlengua */
    public EditorArees(MainFrame menuFrame) {
        super(menuFrame); 
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        String nomPare=null;
        FunctionalModule moduleAlta=null;

        tree=(JTree) component;

        // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
        String itemClicked=event.getActionCommand( );     
            
        // Obtenim el objecte que ha estat seleccionat i les dades del mateix.
        int selRows[]=tree.getSelectionRows();
        rowSelected=selRows[0];         
            
        selectedTreeNode = ( DefaultMutableTreeNode ) tree.getPathForRow(rowSelected).getLastPathComponent() ;
            
        int fills=selectedTreeNode.getChildCount();         
        ArbreCamp value = (ArbreCamp)selectedTreeNode.getUserObject();
        String idAreaSelected=value.getIdArea();
        String idPare=value.getIdPare();
        String nomArea=value.getNomArea();

        // Obtenim el nom del pare en cas que no sigui ell mateix.
        System.out.println("**********************************************************");
        if(!idAreaSelected.equals(idPare))
        {
            System.out.println("Te pare");
            ArbreCamp ac=new ArbreCamp();
            ArbreCamp acSelected=(ArbreCamp)ac.findByPrimaryKey(idPare);
            nomPare=acSelected.getNomArea();
        }
        else
            System.out.println("NO te pare");
            
        // Printem per pantalla els resultats
        //System.out.println("Id rea: "+idAreaSelected);
        //System.out.println("Nom rea: "+nomArea);
        //System.out.println("Identificador del pare: "+idPare);
        //System.out.println("Nom del pare: "+nomPare);       
        //System.out.println("Popup menu item [" + itemClicked + "] was pressed.");           
            
        // Comprovem la opci clicada
        if(itemClicked!=null && !itemClicked.equals(""))
        {
             // Edici de la font clicada.
             if(itemClicked.equals(ALTA))
             {
                //  Otra opcion, seria en vez de passar el this, pasarle los parametros necesarios. En
                // ste caso: tree, tn i rowSelected.                     
                 
                moduleAlta = new AreesAlta(menuFrame,this,idAreaSelected,nomArea); 
                PanelPopup popupPanel=new PanelPopup(menuFrame,moduleAlta,Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Diccionari")));
                
                // Actualitzem el popup 'actual'.
                menuFrame.setPanelPopup(popupPanel);

                // Mostrem el popup.
                popupPanel.showPopupWindow();    
                //System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Opcio_Alta"));
                    
             }
             else if(itemClicked.equals(EDITAR))
             {
                // Creem el nou mdul d'edici de la font seleccionada, i mostrem la finestra amb el contingut.
                //if (!idAreaSelected.equals(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("root")))
                //{
                    FunctionalModule moduleEdit = new AreesEdit(menuFrame,this,idAreaSelected,nomArea,nomPare);
                    PanelPopup popupPanel=new PanelPopup(menuFrame,moduleEdit,Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Diccionari")));

                    // Actualitzem el popup 'actual'.
                    menuFrame.setPanelPopup(popupPanel);

                    // Mostrem el popup.
                    popupPanel.showPopupWindow();      
                    //System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Opcio_Editar"));
               // }
               // else
               //     menuFrame.showMessageInfo(Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AT_EditRoot")));
             }
             // Eliminaci de la font clicada.
             else if(itemClicked.equals(ESBORRAR))
             {    
                if (!idAreaSelected.equals(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("root")))
                { 
                    // Esborrar de la BD la fila seleccionada.
                    int response = JOptionPane.showConfirmDialog(menuFrame,Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Confirmar_EliminacioAT")), Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Eliminacio_AT")), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response == JOptionPane.YES_OPTION) 
                    {
                        try
                        {
                            // Creem la transacci
                            Connection con=DBConnect.getConnectionTransactional();

                            // Esborrem de la base de dades l'area els fills associats, en cas que en tingui.
                            //if (fills>0)
                                AreaManager.getManager().deleteFillsAssociacions(value); 
                                //AreaManager.getManager().deleteFills(idAreaSelected); 

                            // Esborrem el pare.
                            //AreaManager.getManager().delete(idAreaSelected); 

                            // Esborrem el node de l'arbre.
                            ((DefaultTreeModel) tree.getModel()).removeNodeFromParent(selectedTreeNode);

                            // Fem el commit i tanquem la transacci
                            DBConnect.getConnectionTransactional().commit();
                            DBConnect.putConnection(con);
                            
                            // Indiquem canvis en els manteniments
                            menuFrame.setATModified(true);
                        }
                        catch(Exception e)
                        {
                            // Fem un roll-back i tanquem la transacci
                            DBConnect.getConnectionTransactional().rollback();
                            DBConnect.putConnectionTransactional();

                            tratarError(new AreaException(e.getMessage()));
                        }
                    }                
                   // System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Opcio_Esborrar"));
                }
                else
                    menuFrame.showMessageInfo(Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AT_DeleteRoot")));
                    
             }
             else
                 tratarError(new AreaException(Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Ieditor_OpcioNoOk"))));
        }
        else
            tratarError(new AreaException(Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Ieditor_NoOpcio"))));
    }  
}