/*
 * DiccionariMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.eines;

import com.termcat.business.areas.AreaManager;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.exceptions.FontException;
import com.termcat.business.exceptions.ToolException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.terminologic.contexts.ContextManager;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.business.terminologic.notes.NoteManager;
import com.termcat.business.tools.ToolManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.loader.ExportLoaderThread;
import com.termcat.util.literales.Literales;
import electric.xml.Document;
import electric.xml.Element;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.StringTokenizer;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
/**
 *
 * @author  Vazquezl
 */
public class ExportarDiccionari extends FunctionalModule
{

    private JDialog dialog;
    //private JOptionPane pane;   
     
    /** segundo constructor */
    public ExportarDiccionari(MainFrame menuFrame) {
        super(menuFrame);
        initComponents();
        this.diccionariName.setText(menuFrame.getNomCurrentDictionary());
        dialog=initLoader();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelExtra = new javax.swing.JPanel();
        panelIntern = new javax.swing.JPanel();
        fileLabel = new javax.swing.JLabel();
        fileValue = new javax.swing.JTextField();
        exportButton = new javax.swing.JButton();
        examinarButton = new javax.swing.JButton();
        diccionariLabel = new javax.swing.JLabel();
        diccionariName = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelExtra.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EinesExportar")));
        panelExtra.setMaximumSize(new java.awt.Dimension(922, 692));
        panelExtra.setMinimumSize(new java.awt.Dimension(922, 692));
        fileLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 14));
        fileLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ArxiuExportMsg"));

        fileValue.setPreferredSize(new java.awt.Dimension(200, 19));

        exportButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Exportar"));
        exportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exportButtonActionPerformed(evt);
            }
        });

        examinarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Examinar"));
        examinarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                examinarButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(79, 79, 79)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(exportButton)
                            .add(fileValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 490, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(107, 107, 107)
                        .add(examinarButton))
                    .add(fileLabel))
                .addContainerGap(131, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(113, 113, 113)
                .add(fileLabel)
                .add(46, 46, 46)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(fileValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(examinarButton))
                .add(53, 53, 53)
                .add(exportButton)
                .addContainerGap(71, Short.MAX_VALUE))
        );

        diccionariLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 1, 24));
        diccionariLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DiccionariLabel"));

        diccionariName.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 24));
        diccionariName.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("jLabel2"));

        org.jdesktop.layout.GroupLayout panelExtraLayout = new org.jdesktop.layout.GroupLayout(panelExtra);
        panelExtra.setLayout(panelExtraLayout);
        panelExtraLayout.setHorizontalGroup(
            panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelExtraLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelIntern, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(panelExtraLayout.createSequentialGroup()
                        .add(87, 87, 87)
                        .add(diccionariLabel)
                        .add(117, 117, 117)
                        .add(diccionariName)))
                .addContainerGap())
        );
        panelExtraLayout.setVerticalGroup(
            panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelExtraLayout.createSequentialGroup()
                .add(68, 68, 68)
                .add(panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diccionariLabel)
                    .add(diccionariName))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 52, Short.MAX_VALUE)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(143, 143, 143))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(40, 40, 40)
                .add(panelExtra, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(64, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(panelExtra, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void exportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exportButtonActionPerformed
        String s=fileValue.getText();
        if (!s.trim().equals("") && s!=null)
            exportAction(s);
        else
            tratarError(new ToolException(Literales.getTextForMessage("Export_NoFile")));
               
    }//GEN-LAST:event_exportButtonActionPerformed

    private void examinarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_examinarButtonActionPerformed
        File file2export=getFiles();
        if (file2export!=null)
        {
            String filePath=file2export.getAbsolutePath();
            System.out.println("File selected: "+filePath);
            fileValue.setText(filePath);
        }
    }//GEN-LAST:event_examinarButtonActionPerformed

    //  Mtode encarregat de fer la exportaci de les dades que hi ha a la BD al fitxer indicat.
    private void exportAction(String path) 
    {
        BufferedWriter outfile;
        File file2export=null;
        

        File newFile=new File(path);       

        try
        {
            // Comprovem si existeix el path que s'indica. En cas que no existeixi, el creem.
            if(newFile.exists())
                file2export=newFile;
            else
                file2export=createPath(path);

            // Comprovaci de permisos en el 
             if(!file2export.canWrite())
                 tratarError(new ToolException("No es pot guardar en el fitxer indicat: no te permisos d'escriptura."));                
             else
             {
                    // Creem el fitxer XML a partir de la BD.
                    dialog.setVisible(true);                        
                    ExportLoaderThread thread=new ExportLoaderThread(menuFrame,file2export,diccionariName,dialog,this);
                    thread.start();                                                                
             }
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new ToolException(e.getMessage()));
        }
    }



    private File createPath(String path) throws ToolException 
    {   
        File file2export=null;
        String exportPath=path.replace("\\","/");
        String relativePath="";
        StringTokenizer st=new StringTokenizer(exportPath,"/");
        int count=st.countTokens();      
        
        for(int i=0;i<count-1;++i)
        {
                relativePath+=st.nextToken()+"/";      
                file2export=new File(relativePath);
                boolean isCreated=false;
                if (!file2export.exists())
                {
                    isCreated=file2export.mkdir();
                    if(isCreated)
                        System.out.println("folder Created: "+relativePath);
                    else
                        throw new ToolException("Error al crear el directori: "+relativePath);
                }                
         }
        // Cas del fitxer
        String fitxer=st.nextToken();
        System.out.println("file: "+fitxer);
        file2export=new File(exportPath);
        
        try {
            boolean ok=file2export.createNewFile();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
         
         return file2export;
    }
     
    public void setEnableExportButton(boolean b)
    {
        this.exportButton.setEnabled(b);
    }
    
    public void setEnableExaminarButton(boolean b)
    {
        this.examinarButton.setEnabled(b);
    }

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel diccionariLabel;
    private javax.swing.JLabel diccionariName;
    private javax.swing.JButton examinarButton;
    private javax.swing.JButton exportButton;
    private javax.swing.JLabel fileLabel;
    private javax.swing.JTextField fileValue;
    private javax.swing.JPanel panelExtra;
    private javax.swing.JPanel panelIntern;
    // End of variables declaration//GEN-END:variables
}
