/*
 * DiccionariMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.eines;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.areas.AreaManager;
import com.termcat.business.exceptions.AreaException;
import com.termcat.business.exceptions.CategoryException;
import com.termcat.business.exceptions.ContextException;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.exceptions.DefinitionException;
import com.termcat.business.exceptions.DenominationException;
import com.termcat.business.exceptions.FontException;
import com.termcat.business.exceptions.HyerarchyException;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.exceptions.MarkException;
import com.termcat.business.exceptions.NoteException;
import com.termcat.business.exceptions.ToolException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.terminologic.contexts.ContextManager;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.business.terminologic.notes.NoteManager;
import com.termcat.business.tools.ToolManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.loader.ImportLoaderThread;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.util.literales.Literales;
import electric.xml.Document;
import electric.xml.Element;
import electric.xml.Elements;
import electric.xml.NodeList;
import electric.xml.ParseException;
import java.awt.Color;
import java.awt.geom.Area;
import java.io.File;
import java.sql.SQLException;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JInternalFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;

/**
 *
 * @author  Vazquezl
 */
public class ImportarDiccionari extends FunctionalModule 
{

    private JDialog dialog;
    //private JOptionPane pane;

    /** segundo constructor */
    public ImportarDiccionari(MainFrame menuFrame) {
        super(menuFrame);
        initComponents();
        this.diccionariName.setText(menuFrame.getNomCurrentDictionary());
        importButton.setEnabled(false);
        dialog=initLoader();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelExtra = new javax.swing.JPanel();
        panelIntern = new javax.swing.JPanel();
        fileLabel = new javax.swing.JLabel();
        fileValue = new javax.swing.JTextField();
        importButton = new javax.swing.JButton();
        examinarButton = new javax.swing.JButton();
        diccionariLabel = new javax.swing.JLabel();
        diccionariName = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelExtra.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EinesImportar")));
        panelExtra.setMaximumSize(new java.awt.Dimension(922, 692));
        panelExtra.setMinimumSize(new java.awt.Dimension(922, 692));
        fileLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 14));
        fileLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ArxiuImportMsg"));

        fileValue.setPreferredSize(new java.awt.Dimension(200, 19));

        importButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Importar"));
        importButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                importButtonActionPerformed(evt);
            }
        });

        examinarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Examinar"));
        examinarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                examinarButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(79, 79, 79)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(fileLabel)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(importButton)
                            .add(fileValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 490, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .add(107, 107, 107)
                        .add(examinarButton)))
                .addContainerGap(131, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(113, 113, 113)
                .add(fileLabel)
                .add(46, 46, 46)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(fileValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(examinarButton))
                .add(53, 53, 53)
                .add(importButton)
                .addContainerGap(71, Short.MAX_VALUE))
        );

        diccionariLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 1, 24));
        diccionariLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DiccionariLabel"));

        diccionariName.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 24));
        diccionariName.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("jLabel2"));

        org.jdesktop.layout.GroupLayout panelExtraLayout = new org.jdesktop.layout.GroupLayout(panelExtra);
        panelExtra.setLayout(panelExtraLayout);
        panelExtraLayout.setHorizontalGroup(
            panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelExtraLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelIntern, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(panelExtraLayout.createSequentialGroup()
                        .add(82, 82, 82)
                        .add(diccionariLabel)
                        .add(113, 113, 113)
                        .add(diccionariName)))
                .addContainerGap())
        );
        panelExtraLayout.setVerticalGroup(
            panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelExtraLayout.createSequentialGroup()
                .add(68, 68, 68)
                .add(panelExtraLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diccionariLabel)
                    .add(diccionariName))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 52, Short.MAX_VALUE)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(143, 143, 143))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(40, 40, 40)
                .add(panelExtra, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(64, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(panelExtra, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void importButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_importButtonActionPerformed
        String path=fileValue.getText();
        if (!path.trim().equals("") && path!=null)
            importAction(path);
        else
        {
            importButton.setEnabled(false);
            tratarError(new ToolException(Literales.getTextForMessage("Import_NoFile")));        
        }
        
    }//GEN-LAST:event_importButtonActionPerformed

    private void examinarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_examinarButtonActionPerformed
        file2import=getFiles();
        if (file2import!=null)
        {                        
            System.out.println("File selected: "+file2import.getAbsolutePath());
            fileValue.setText(file2import.getAbsolutePath());
            importButton.setEnabled(true);

        }    
    }//GEN-LAST:event_examinarButtonActionPerformed
    
    //  Mtode encarregat de fer la importaci de les dades del fitxer indicat.
    private void importAction(String path) 
    {
        // Comprovacio de que el fitxer seleccionat existeix      
        File file=new File(path);  
        if (!file.exists())     
            tratarError(new ToolException(Literales.getTextForMessage("Import_NoExistsFile")));                   
        else
        {    
            // Comprovacio de que hi ha actiu un diccionari actualment.
            if (this.menuFrame.getIdCurrentDictionary()!=null && !this.menuFrame.getIdCurrentDictionary().equals(""))
            {
                int response = JOptionPane.showConfirmDialog(menuFrame, Literales.getTextForMessage("Confirmar_Importacio"), Literales.getTextForMessage("Importacio_Exportacio"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                if (response == JOptionPane.YES_OPTION) 
                {                  
                    try 
                    {
                        dialog.setVisible(true);                        
                        ImportLoaderThread thread=new ImportLoaderThread(menuFrame,file,diccionariName,dialog,this);
                        thread.start();                                                
                    } 
                    catch (Exception ex) 
                    {
                        ex.printStackTrace();
                        tratarError(new ToolException(ex.getMessage()));
                    }
                }
            }
            else
            {
                try 
                {
                    dialog.setVisible(true);                        
                    ImportLoaderThread thread=new ImportLoaderThread(menuFrame,file,diccionariName,dialog,this);
                    thread.start();                                                                    
                }
                catch (Exception ex) 
                {
                        ex.printStackTrace();
                        tratarError(new ToolException(ex.getMessage()));
                }
            }
        }

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JLabel diccionariLabel;
    private javax.swing.JLabel diccionariName;
    private javax.swing.JButton examinarButton;
    private javax.swing.JLabel fileLabel;
    private javax.swing.JTextField fileValue;
    private javax.swing.JButton importButton;
    private javax.swing.JPanel panelExtra;
    private javax.swing.JPanel panelIntern;
    // End of variables declaration//GEN-END:variables

    private File file2import=null;    
    
    public void setEnableImportButton(boolean b)
    {
        this.importButton.setEnabled(b);
    }
    
    public void setEnableExaminarButton(boolean b)
    {
        this.examinarButton.setEnabled(b);
    }
}