/*
 * LlistatReportDiccionariReport.java
 *
 * Created on 5 de octubre de 2007, 16:33
 */

package com.termcat.layout.informes.reports;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.reports.llistat.*;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.tree.DoubleClickTree;
import java.awt.event.MouseEvent;
import java.util.Vector;
import javax.swing.JTree;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;

/**
 *
 * @author  Mena
 */
public class SelectTematicAreaPanel extends FunctionalModule 
{   
    /** Creates new form LlistatReportDiccionariReport */
    public SelectTematicAreaPanel(MainFrame menuFrame) {
        super(menuFrame);

        initComponents();
        
        // Inicialitzem els valors dels atributs que se li envien al report
        nomSelected="";
        idAreaSelected="";
        idPareSelected="";
                
        // Inicialitzem l'arbre amb els valors de la BD i els seus listeners
        if (this.menuFrame.tree==null)
                this.menuFrame.tree=initJTree();
        
        JTree freezeTree = new JTree();
        freezeTree.setModel(this.menuFrame.tree.getModel());
        removeAll2ClickListeners(freezeTree);
        freezeTree.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                setSelectedArea(evt);
            }
            public void mousePressed(java.awt.event.MouseEvent evt) {
                setSelectedArea(evt);
            }           
        });
        
        treeScrollPane.setViewportView(freezeTree);                    

         setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jPanel1 = new javax.swing.JPanel();
        reportButton = new javax.swing.JButton();
        treeScrollPane = new javax.swing.JScrollPane();

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("SeleccioAT")));
        reportButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Veure_informe"));
        reportButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reportButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                        .add(reportButton)
                        .add(129, 129, 129))
                    .add(jPanel1Layout.createSequentialGroup()
                        .add(treeScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 355, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .add(treeScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(reportButton)
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void reportButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reportButtonActionPerformed
         // Obtenim els resultats de l'arbre.
        // Passarle el idArea, idPare.    
       // if (!idAreaSelected.equals("root"))
            new com.termcat.business.reports.llistat.LlistatReportManager(menuFrame.getIdCurrentDictionary()).viewTematicAreaReport(idAreaSelected,nomSelected,idPareSelected); 
          //System.out.println("Nom: "+nomSelected+" IdArea:"+idAreaSelected+" IdPare:"+idPareSelected);
       // else
       //     this.menuFrame.showMessageInfo("L'area seleccionada no es vlida.");
    }//GEN-LAST:event_reportButtonActionPerformed

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel jPanel1;
    private javax.swing.JButton reportButton;
    private javax.swing.JScrollPane treeScrollPane;
    // End of variables declaration//GEN-END:variables

    private String nomSelected;
    private String idAreaSelected;
    private String idPareSelected;
    
    private void setSelectedArea(MouseEvent e) 
    {                    
            
            DefaultMutableTreeNode node;
            
            JTree treeClicked=(JTree)e.getSource();
            TreePath path = treeClicked.getPathForLocation(e.getX(), e.getY());

            if (path != null)
            {
                treeClicked.setSelectionPath(path);
                node = (DefaultMutableTreeNode)path.getLastPathComponent();                     
                ArbreCamp value = (ArbreCamp)node.getUserObject();                   
                nomSelected=getAbsoluteAreaName(value.getIdPare(),value.getNomArea(),value.getIdArea());
                idAreaSelected=value.getIdArea();
                idPareSelected=value.getIdPare();                           
            }
    }
}
