/*
 * FontsMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.categories;

import com.termcat.bd.beans.Categories;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.exceptions.CategoryException;

/**
 *
 * @author  mena
 */
public class CategoriesMain extends FunctionalModule{
    
    private JTable tablaCategories; 
    private DefaultTableModel model;   
    
    //Constants
    private final String EDIT_CATEGORIA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarCategoria");
    private final String DELETE_CATEGORIA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarCategoria");
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la categoria(PK).
    
    private final int PRIORITAT_UP=1;
    private final int PRIORITAT_DOWN=-1;
    
    /** segundo constructor */
    public CategoriesMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        initComponents();                              
        refresh(-1);
        this.setSize(this.menuFrame.getSize());
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();
        ordreUp = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource("/com/termcat/resources/img/botonFlechaUp.gif"),this.getClass().getResource("/com/termcat/resources/img/botonFlechaUpDisable.gif"));
        ordreDown = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource("/com/termcat/resources/img/botonFlechaDown.gif"),this.getClass().getResource("/com/termcat/resources/img/botonFlechaDownDisable.gif"));
        jLabel1 = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("MantenimentsCategories")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        botonAlta.setActionCommand(Literales.getTextForLiteral("AltaCategoria"));
        botonAlta.setLabel(Literales.getTextForLiteral("AltaCategoria"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("LlistatCategoriesExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        ordreUp.setText("  ");
        ordreUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAddPrioridad(evt);
            }
        });

        ordreDown.setText("  ");
        ordreDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDownPrioridad(evt);
            }
        });

        jLabel1.setText(Literales.getTextForLiteral("OrdreLabel"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(43, 43, 43)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(botonAlta)
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 676, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(tituloTabla)))
                .add(85, 85, 85)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(jLabel1)
                        .addContainerGap())
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(panelInternLayout.createSequentialGroup()
                            .add(ordreDown)
                            .addContainerGap())
                        .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                            .add(ordreUp, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                            .add(61, 61, 61)))))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(199, 199, 199)
                        .add(ordreUp)
                        .add(70, 70, 70)
                        .add(jLabel1)
                        .add(67, 67, 67)
                        .add(ordreDown)
                        .add(113, 113, 113))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(45, 45, 45)
                        .add(tituloTabla)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 402, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(19, 19, 19)))
                .add(botonAlta)
                .add(106, 106, 106))
        );
        panelIntern.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("MantenimentsCategories"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(40, 40, 40)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(64, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(73, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAddPrioridad(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAddPrioridad
        try
        {
           int rowSelected=tablaCategories.getSelectedRow();
           String idSelectedItem=(String)tablaCategories.getModel().getValueAt(rowSelected,COL_ID);
           String idItem=(String)tablaCategories.getModel().getValueAt(rowSelected-1,COL_ID);

           CategoryManager.getManager().updatePrioritat(idItem,PRIORITAT_UP);
           CategoryManager.getManager().updatePrioritat(idSelectedItem,PRIORITAT_DOWN);          
           
           refresh(rowSelected-1);
           
           setEnableButtons(this.tablaCategories,rowSelected-1,this.ordreUp,this.ordreDown);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new CategoryException(e.getMessage()));
        }
    }//GEN-LAST:event_botonAddPrioridad

    private void botonDownPrioridad(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDownPrioridad
         try 
         {  
             int rowSelected=tablaCategories.getSelectedRow();
             String idSelectedItem=(String)tablaCategories.getModel().getValueAt(rowSelected,COL_ID);
             String idItem=(String)tablaCategories.getModel().getValueAt(rowSelected+1,COL_ID);
             CategoryManager.getManager().updatePrioritat(idSelectedItem,PRIORITAT_UP);
             CategoryManager.getManager().updatePrioritat(idItem,PRIORITAT_DOWN);
             
             //table.changeSelection(rowSelected+1, 0, false, false);
             refresh(rowSelected+1);
             
           setEnableButtons(this.tablaCategories,rowSelected+1,this.ordreUp,this.ordreDown);
             
        } catch (Exception e) {
            e.printStackTrace();
            tratarError(new CategoryException(e.getMessage()));
        }

    }//GEN-LAST:event_botonDownPrioridad

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaCategoriesActionPerformed();
      refresh(-1);
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton ordreDown;
    private javax.swing.JButton ordreUp;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        final String[] names = {"ID","Codi", "Nom"};
        final Object[][] data =null;
                
        model=new DefaultTableModel(data,names);
        tablaCategories= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
       
        // Amagar les columnes d'ID i prioritat de la 'vista'.
        tablaCategories.getColumnModel().removeColumn(tablaCategories.getColumnModel().getColumn(0));
        tablaCategories.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                setEnableButtons(tablaCategories,-1,ordreUp,ordreDown);
            }
        });
      
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(tablaCategories);
        
        // Deshabilitem els botons d'ordre
        ordreUp.setEnabled(false);
        ordreDown.setEnabled(false);
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova font.  
     *
     */
    private void altaCategoriesActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new CategoriesAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Manteniments"));
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh(int row)
    {
        try
        {
            // Inicializem els components: taula i model.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            Vector allCategories=CategoryManager.getManager().getAllCategories();
            PopupMenuTable categoriesPopupTable=new PopupMenuTable(tablaCategories,this,new EditorCategoria(menuFrame),EDIT_CATEGORIA,DELETE_CATEGORIA);
            
            if (allCategories.size()==0)
            {
                    model.addRow(new Object[] {null,null, null});            
                    categoriesPopupTable.disableMenuItems();
            }
            else
            {
                Iterator allCategoriesIt=allCategories.iterator();                   
                while(allCategoriesIt.hasNext())
                {
                    Categories categoria=(Categories)allCategoriesIt.next();                             
                    model.addRow(new Object[] {categoria.getIdCategoria(),categoria.getCodiCategoria(), categoria.getDescripcio()});
                    System.out.println("ID Categoria:"+categoria.getIdCategoria()+" Categoria:"+categoria.getCodiCategoria()+" Descripcio:"+categoria.getDescripcio()+" Prioritat:"+categoria.getPrioritat());
                }  
                System.out.println("--------------------------------------------------------------------------------------------------------------------------------------------------");
                // Associem el listener de l'event del ratol a la taula creada.
            }
            tablaCategories.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(categoriesPopupTable));
            
            if(row>=0)
                tablaCategories.setRowSelectionInterval(row,row);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new CategoryException(e.getMessage())); 
        }
    }    
}
