/*
 * EditorFont.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.manteniments.categories;


import com.termcat.util.literales.Literales;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;

import com.termcat.business.exceptions.CategoryException;
import com.termcat.business.maintenance.category.CategoryManager;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.layout.MainFrame;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una font de la taula .
 *
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 * 
 *  @author mena
 */
public class EditorCategoria extends FunctionalModule implements com.termcat.layout.commons.interfaces.IEditor
{      
    //Constants
    private final String EDITAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarCategoria");
    private final String ESBORRAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarCategoria");
    
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la font(PK).
    
    /** Creates a new instance of EditorLlengua */
    public EditorCategoria(MainFrame menuFrame) {
        super(menuFrame); 
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        try
        {
            JTable table=(JTable)component;
            // Obtenim la pantalla principal de l'aplicaci (menuFrame)
            CategoriesMain moduleMain=(CategoriesMain)functionalModule;
            //MainFrame menuFrame=module.getMenuFrame();

            // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
            String itemClicked=event.getActionCommand( );      
            int rowSelected=table.getSelectedRow();
            String data=(String)table.getModel().getValueAt(rowSelected,COL_ID);

            // Printem per pantalla la opci seleccionada.
            
            //String msg="Row: "+rowSelected+java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ValueLabel");   
            //msg+=data;  
            //System.out.println(msg);

            // Comprovem la opci clicada
            if(itemClicked!=null && !itemClicked.equals(""))
            {
                 // Edici de la font clicada.
                 if(itemClicked.equals(EDITAR))
                 {
                    // Creem el nou mdul d'edici de la font seleccionada, i mostrem la finestra amb el contingut.
                    String result[]=new String[2];
                    //result=CategoryManager.getManager().getDataCategoriaSelected(data);
                    result[0]=(String)table.getModel().getValueAt(rowSelected,1);
                    result[1]=(String)table.getModel().getValueAt(rowSelected,2);

                    FunctionalModule moduleEdit = new CategoriesEdit(menuFrame,moduleMain, data, result[0],result[1]);
                    PanelPopup popupPanel=new PanelPopup(menuFrame,moduleEdit,Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Manteniments")));

                     // Actualitzem el popup 'actual'.
                     menuFrame.setPanelPopup(popupPanel);

                     // Mostrem el popup.
                     popupPanel.showPopupWindow();         
                 }
                 // Eliminaci de la font clicada.
                 else if(itemClicked.equals(ESBORRAR))
                 {           
                    // Esborrar de la BD la fila seleccionada.
                    int response = JOptionPane.showConfirmDialog(menuFrame, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("MsgEsborrarFont"), java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminacioFont"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response == JOptionPane.YES_OPTION) 
                    {
                         CategoryManager.getManager().deleteCategoria(data);                      
                         // Refresh de la llista amb les fonts.
                         CategoryManager.getManager().updatePrioritats();                      
                         
                         // Indiquem canvis en els manteniments
                         menuFrame.setCategoriesModified(true);                         
                         
                         moduleMain.refresh(-1);    
                    }                
                 }
                 else
                 {
                     tratarError(new CategoryException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioNoValida")));
                 }
            }
            else
            {
                tratarError(new CategoryException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoOpcioSelect")));
            }    
        }
        catch(Exception e)
        {
             tratarError(new CategoryException(e.getMessage()));            
        }
    }  
}