/*
 * EditorFont.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.manteniments.fonts;


//import com.termcat.layout.commons.rtf.HTML2Text;
import com.termcat.util.literales.Literales;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;

import com.termcat.business.exceptions.FontException;
import com.termcat.business.maintenance.font.FontManager;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.layout.MainFrame;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una font de la taula .
 *
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 * 
 *  @author mena
 */
public class EditorFont extends FunctionalModule implements com.termcat.layout.commons.interfaces.IEditor
{      
    //Constants
    private final String EDITAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarFont");
    private final String ESBORRAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarFont");
    
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la font(PK).
    
    /** Creates a new instance of EditorLlengua */
    public EditorFont(MainFrame menuFrame) {
        super(menuFrame); 
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        try
        {
            JTable table=(JTable)component;
            // Obtenim la pantalla principal de l'aplicaci (menuFrame)
            FontsMain moduleMain=(FontsMain)functionalModule;
            //MainFrame menuFrame=module.getMenuFrame();

            // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
            String itemClicked=event.getActionCommand( );      
            int rowSelected=table.getSelectedRow();
            String data=(String)table.getModel().getValueAt(rowSelected,COL_ID);

            // Printem per pantalla la opci seleccionada.
            System.out.println("Popup menu item [" + itemClicked + "] was pressed.");
            String msg="Row: "+rowSelected+" Value: ";   
            msg+=data;  
            System.out.println(msg);

            // Comprovem la opci clicada
            if(itemClicked!=null && !itemClicked.equals(""))
            {
                 // Edici de la font clicada.
                 if(itemClicked.equals(EDITAR))
                 {
                    // Creem el nou mdul d'edici de la font seleccionada, i mostrem la finestra amb el contingut.                   
                    String codi=(String)table.getModel().getValueAt(rowSelected,1);
                    String descHTML=FontManager.getManager().getRTFDescription((String) table.getModel().getValueAt(rowSelected,0));
                    
                    FunctionalModule moduleEdit = new FontsEdit(menuFrame,moduleMain, data, codi,descHTML);
                    PanelPopup popupPanel=new PanelPopup(menuFrame,moduleEdit,Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Manteniments")));

                     // Actualitzem el popup 'actual'.
                     menuFrame.setPanelPopup(popupPanel);

                     // Mostrem el popup.
                     popupPanel.showPopupWindow();         
                 }
                 // Eliminaci de la font clicada.
                 else if(itemClicked.equals(ESBORRAR))
                 {           
                    // Esborrar de la BD la fila seleccionada.
                    int response = JOptionPane.showConfirmDialog(menuFrame, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("MsgEsborrarFont"), java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminacioFont"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response == JOptionPane.YES_OPTION) 
                    {
                         FontManager.getManager().deleteFont(data);                      

                         menuFrame.allFontsUpdated=FontManager.getManager().getAllCodeIdFonts();
                         
                         // Indiquem canvis en els manteniments
                         menuFrame.setFontsModified(true);

                         // Refresh de la llista amb les fonts.
                         moduleMain.refresh();                             
                    }                
                 }
                 else
                 {
                     tratarError(new FontException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioNoValida")));
                 }
            }
            else
            {
                tratarError(new FontException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoOpcioSelect")));
            }    
        }
        catch(Exception e)
        {
             tratarError(new FontException(e.getMessage()));
        }
    }  
}