/*
 * FontsAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.fonts;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.FontException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
import com.termcat.util.literales.Literales;
import com.termcat.business.maintenance.font.FontManager;
import javax.swing.ScrollPaneConstants;

/**
 *
 * @author  mena
 */
public class FontsAlta extends FunctionalModule {
    
     private EditorRTF editorRTF;
     
    /** segundo constructor */
    public FontsAlta(MainFrame menuFrame) {
        super(menuFrame);
        initComponents();
        this.editorRTF = new EditorRTF();
        this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setViewportView(editorRTF);
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        codiLabel = new javax.swing.JLabel();
        codiValue = new FixedLengthTextField(100);
        botonAlta = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(650, 375));
        setMinimumSize(new java.awt.Dimension(650, 375));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("AltaFont")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 350));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 350));
        descripcioLabel.setText(Literales.getTextForLiteral("LabelDescripcio"));

        codiLabel.setText(Literales.getTextForLiteral("CodiLabel"));

        codiValue.setColumns(25);

        botonAlta.setText(Literales.getTextForLiteral("BotonAlta"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                        .add(37, 37, 37)
                        .add(codiLabel)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(panelInternLayout.createSequentialGroup()
                                .add(344, 344, 344)
                                .add(botonAlta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(botonCancela)
                                .add(38, 38, 38))
                            .add(panelInternLayout.createSequentialGroup()
                                .add(17, 17, 17)
                                .add(codiValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 529, Short.MAX_VALUE))))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(descripcioLabel)
                        .add(17, 17, 17)
                        .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 529, Short.MAX_VALUE)))
                .add(21, 21, 21))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(codiLabel)
                    .add(codiValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 231, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(botonCancela)
                            .add(botonAlta)))
                    .add(descripcioLabel))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(18, 18, 18)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(27, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 349, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(15, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
       try
       {
           codiValue.getText();
           if (validateTextComponent(Literales.getTextForMessage("Fonts_Codi"),codiValue,true,100)){
               
               // Tanquem la transaccio per si no s'ha tancat
               DBConnect.putConnectionTransactional();
               
               // Fem la inserci a BD.
               FontManager.getManager().altaFont(codiValue.getText(),editorRTF.getRTFText());
               
               // Indiquem que s'han modificat les fonts
               menuFrame.allFontsUpdated=FontManager.getManager().getAllCodeIdFonts();               
               
               menuFrame.setFontsModified(true);

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Fonts_AltaOk"));
               
               // Tanquem la finestra d'alta d'una nova font.
               this.menuFrame.closePanelPopup();               
           } 
       }
       catch(Exception e){
           e.printStackTrace();
          tratarError(new FontException(e.getMessage())); 
       }     
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JButton botonCancela;
    private javax.swing.JLabel codiLabel;
    private javax.swing.JTextField codiValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
