/*
 * FontsEdit.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.fonts;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.FontException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
import com.termcat.util.literales.Literales;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 */
public class FontsEdit extends FunctionalModule 
{         
    private String idFont;
    
    //  Guardem una referncia del "FontsMain" (llistat amb les llengues) per a despres poder cridar al seu
    // mtode 'refresh()' (que obte els valors de la BD) i aix no haver de tornar a crear un nou objecte 
    // FontsMain.
    private FontsMain fontsMain;    
    private EditorRTF editorRTF; 
    
    /**
     *  Constructor.
     * 
     *  @param menuFrame:   Referncia al pare de l'aplicaci.
     *  @functionalModule:  Referncia del mdul on s'ha clicat la opci d'edici de la llengua(idLlengua) de la llista de llengues.
     *  @idFont:            Identificador de la font clicada per a modificar.
     *  @codi:              Valor del codi de la font amb idfont=@idFont
     *  @descripcio:        Valor de la descripci de la font amb idFont=@idFont
     */
    public FontsEdit(MainFrame menuFrame, FunctionalModule functionalModule, String idFont, String codi, String descripcio) {
        super(menuFrame);
        initComponents();
        
        this.editorRTF = new EditorRTF();
        this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setViewportView(editorRTF);
        
        // Actualitzem els atributs de la classe.
        this.idFont=idFont;
        this.fontsMain=(FontsMain)functionalModule;      
        
        // Carreguem el formulari amb els valors de la BD.
        nomValue.setText(codi);
        editorRTF.setRTFText(descripcio);
        
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        nomLabel = new javax.swing.JLabel();
        nomValue = new FixedLengthTextField(100);
        botonDesar = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(650, 375));
        setMinimumSize(new java.awt.Dimension(650, 375));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("EdicioFont")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 350));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 350));
        descripcioLabel.setText(Literales.getTextForLiteral("LabelDescripcio"));

        nomLabel.setText(Literales.getTextForLiteral("CodiLabel"));

        nomValue.setColumns(25);

        botonDesar.setText(Literales.getTextForLiteral("Desar"));
        botonDesar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDesarActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(botonDesar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botonCancela)
                        .add(58, 58, 58))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                            .add(descripcioLabel)
                            .add(nomLabel))
                        .add(21, 21, 21)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE)
                            .add(nomValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 515, Short.MAX_VALUE))))
                .addContainerGap())
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(nomLabel)
                    .add(nomValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(24, 24, 24)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 229, Short.MAX_VALUE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(botonDesar)
                            .add(botonCancela)))
                    .add(descripcioLabel))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(20, 20, 20)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(25, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonDesarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDesarActionPerformed
       try{           
           nomValue.getText();
           if (validateTextComponent(Literales.getTextForMessage("Fonts_Codi"),nomValue,true,100)){
                 // Tanquem la transaccio per si no s'ha tancat
                 DBConnect.putConnectionTransactional();
                 
                 FontManager.getManager().updateFont(this.idFont,nomValue.getText(),editorRTF.getRTFText());

                 menuFrame.allFontsUpdated=FontManager.getManager().getAllCodeIdFonts();                 
                 
                 // Missatge de confirmaci 
                 menuFrame.showMessageInfo(Literales.getTextForMessage("Fonts_UpdateOk"));

                 // Indiquem que s'han modificat les fonts
                 menuFrame.setFontsModified(true);

                 // Tanquem la finiestra d'edici de la llengua.
                 this.menuFrame.closePanelPopup();
                 
                 // Fem un 'refresh' de la llista perque aparegui la font amb la corresponent modificaci.
                 this.fontsMain.refresh();                                
           } 
       }
       catch(Exception e){
           e.printStackTrace();
          tratarError(new FontException(e.getMessage())); 
       }
       
    }//GEN-LAST:event_botonDesarActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonDesar;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JLabel nomLabel;
    private javax.swing.JTextField nomValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
        
}
