/*
 * FontsMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.fonts;

import com.termcat.business.reports.llistat.sortable.TermcatComparator;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.util.literales.Literales;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.Collections;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.exceptions.FontException;
import com.termcat.bd.beans.Fonts;
/**
 *
 * @author  mena
 */
public class FontsMain extends FunctionalModule {
    
    private JTable tablaFonts; 
    private DefaultTableModel model;   
    
    //Constants
    private final String EDIT_FONT=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarFont");
    private final String DELETE_FONT=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarFont");
    
    
    /** segundo constructor */
    public FontsMain(MainFrame menuFrame)
    {     
        super(menuFrame);

        initComponents();                              
        refresh();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("MantenimentsFonts")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        botonAlta.setText(Literales.getTextForLiteral("AltaFont"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("LlistatFontsExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(48, 48, 48)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(botonAlta)
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(tituloTabla)
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 794, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(62, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(48, 48, 48)
                .add(tituloTabla)
                .add(22, 22, 22)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 415, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(34, 34, 34)
                .add(botonAlta)
                .addContainerGap(74, Short.MAX_VALUE))
        );
        panelIntern.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("MantenimentsFonts"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(40, 40, 40)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(64, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(26, 26, 26)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(74, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaFontsActionPerformed();
      refresh();
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        final String[] names = {"ID","Codi", "Nom"};
        final Object[][] data =null;
                
        model=new DefaultTableModel(data,names);
        tablaFonts= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };
        // Amagar la columna de la 'vista'.
        tablaFonts.getColumnModel().removeColumn(tablaFonts.getColumnModel().getColumn(0));
               
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(tablaFonts);
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova font.  
     *
     */
    private void altaFontsActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new FontsAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Manteniments"));
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh()
    {        
        try
        {                    
            // Inicializem els components: taula i model.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            Fonts fonts=new Fonts();
            Vector allFonts=fonts.findAllSorted();
            
            PopupMenuTable fontPopupTable=new PopupMenuTable(tablaFonts,this,new EditorFont(menuFrame),EDIT_FONT,DELETE_FONT);
            if (allFonts.size()==0)
            {
                model.addRow(new Object[] {null,null, null});
                fontPopupTable.disableMenuItems();
            }    
            else
            {    
                Iterator allFontsIt=allFonts.iterator();                    
                while(allFontsIt.hasNext())
                {
                    Fonts font=(Fonts)allFontsIt.next();                             
                    String descripcio=convertRTF2Text(font.getDescripcio());
                    model.addRow(new Object[] {font.getIdFont(),font.getCodiFont(),descripcio });
                }  
            }
            // Associem el listener de l'event del ratol a la taula creada.
            tablaFonts.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(fontPopupTable));
            /*tablaFonts.addMouseListener(new MouseAdapter() {
                                       public void mouseClicked(MouseEvent e) {
                                           //System.out.println("count: "+e.getClickCount());
                                         if (e.getClickCount() == 2)
                                         {
                                               System.out.println("---> Double-click <----");
                                         }                                      
                                        }
 
            });*/
            
        }
        catch(Exception e)
        {
             e.printStackTrace(); 
             tratarError(new FontException(e.getMessage())); 
        }
    }
}
