/*
 * FontsEdit.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.jerarquies;

import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.HyerarchyException;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.layout.commons.FixedLengthTextField;
    
import com.termcat.util.literales.Literales;
/**
 *
 * @author  Vazquezl
 */
public class JerarquiesEdit extends FunctionalModule 
{         
    private String idJerarquia;
    
    //  Guardem una referncia del "JerarquiesMain" (llistat amb les llengues) per a despres poder cridar al seu
    // mtode 'refresh()' (que obte els valors de la BD) i aix no haver de tornar a crear un nou objecte 
    // JerarquiesMain.
    private JerarquiesMain jerarquiesMain; 
    
    /**
     *  Constructor.
     * 
     *  @param menuFrame:   Referncia al pare de l'aplicaci.
     *  @functionalModule:  Referncia del mdul on s'ha clicat la opci d'edici de la llengua(idLlengua) de la llista de llengues.
     *  @idFont:            Identificador de la font clicada per a modificar.
     *  @codi:              Valor del codi de la font amb idfont=@idFont
     *  @descripcio:        Valor de la descripci de la font amb idFont=@idFont
     */
    public JerarquiesEdit(MainFrame menuFrame, FunctionalModule functionalModule, String idJerarquia, String codi, String descripcio) {
        super(menuFrame);
        initComponents();
        
        // Actualitzem els atributs de la classe.
        this.idJerarquia=idJerarquia;
        this.jerarquiesMain=(JerarquiesMain)functionalModule;      
        
        // Carreguem el formulari amb els valors de la BD.
        nomValue.setText(codi);
        descValue.setText(descripcio);
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        nomLabel = new javax.swing.JLabel();
        nomValue = new FixedLengthTextField(50);
        botonDesar = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        descValue = new javax.swing.JTextArea();

        setMaximumSize(new java.awt.Dimension(650, 375));
        setMinimumSize(new java.awt.Dimension(650, 375));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("EdicioJerarquia")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 350));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 350));
        descripcioLabel.setText(Literales.getTextForLiteral("LabelDescripcio"));

        nomLabel.setText(Literales.getTextForLiteral("JerarquiaLabel"));

        nomValue.setColumns(25);

        botonDesar.setText(Literales.getTextForLiteral("Desar"));
        botonDesar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDesarActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        descValue.setColumns(20);
        descValue.setRows(5);
        jScrollPane1.setViewportView(descValue);

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(81, 81, 81)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(nomLabel)
                    .add(descripcioLabel))
                .add(51, 51, 51)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(botonDesar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 240, Short.MAX_VALUE)
                        .add(botonCancela))
                    .add(nomValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 398, Short.MAX_VALUE)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 398, Short.MAX_VALUE))
                .add(26, 26, 26))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(27, 27, 27)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nomLabel)
                    .add(nomValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 34, Short.MAX_VALUE)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 139, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(40, 40, 40)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(botonCancela)
                            .add(botonDesar)))
                    .add(descripcioLabel))
                .add(37, 37, 37))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(35, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 349, Short.MAX_VALUE)
                .add(15, 15, 15))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonDesarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDesarActionPerformed
       try{
           nomValue.getText();
           if (validateTextComponent(Literales.getTextForMessage("Jerarquies_Codi"),nomValue,true,50)){

                // Tanquem la transaccio per si no s'ha tancat
                 DBConnect.putConnectionTransactional();
               
                 HyerarchyManager.getManager().updateJerarquia(this.idJerarquia,nomValue.getText(),descValue.getText());
                 
                 // Missatge de confirmaci 
                 menuFrame.showMessageInfo(Literales.getTextForMessage("Jerarquies_UpdateOk"));
                 
                 // Tanquem la finiestra d'edici de la llengua.
                 this.menuFrame.closePanelPopup();
                 
                // Indiquem que s'han modificat les jerarquies
                menuFrame.setJerarquiesModified(true);
                 
                 // Fem un 'refresh' de la llista perque aparegui la font amb la corresponent modificaci.
                 this.jerarquiesMain.refresh(-1);                                
           } 
       }
       catch(Exception e){
           e.printStackTrace();                   
           tratarError(new HyerarchyException(e.getMessage())); 
       }
       
    }//GEN-LAST:event_botonDesarActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonDesar;
    private javax.swing.JTextArea descValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel nomLabel;
    private javax.swing.JTextField nomValue;
    private javax.swing.JPanel panelIntern;
    // End of variables declaration//GEN-END:variables
        
}
