/*
 * FontsMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.jerarquies;

import com.termcat.bd.beans.Jerarquies;
import com.termcat.business.exceptions.HyerarchyException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.exceptions.CategoryException;

/**
 *
 * @author  mena
 */
public class JerarquiesMain extends FunctionalModule{
    
    private JTable tablaJerarquies; 
    private DefaultTableModel model;   
    
    //Constants
    private final String EDIT_JERARQUIA=Literales.getTextForLiteral("EditarJerarquia");
    private final String DELETE_JERARQUIA=Literales.getTextForLiteral("EliminarJerarquia");
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la categoria(PK).
    
    private final int PRIORITAT_UP=1;
    private final int PRIORITAT_DOWN=-1;
    
    /** segundo constructor */
    public JerarquiesMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        initComponents();                              
        refresh(-1);
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();
        ordreUp = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource("/com/termcat/resources/img/botonFlechaUp.gif"),this.getClass().getResource("/com/termcat/resources/img/botonFlechaUpDisable.gif"));
        ordreDown = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource("/com/termcat/resources/img/botonFlechaDown.gif"),this.getClass().getResource("/com/termcat/resources/img/botonFlechaDownDisable.gif"));
        jLabel1 = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("MantenimentsJerarquies")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        botonAlta.setText(Literales.getTextForLiteral("AltaJerarquia"));
        botonAlta.setActionCommand(Literales.getTextForLiteral("AltaJerarquia"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("LlistatJerarquiesExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        ordreUp.setText("  ");
        ordreUp.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAddPrioridad(evt);
            }
        });

        ordreDown.setText("  ");
        ordreDown.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDownPrioridad(evt);
            }
        });

        jLabel1.setText(Literales.getTextForLiteral("OrdreLabel"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(41, 41, 41)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(botonAlta)
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 674, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(tituloTabla)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 83, Short.MAX_VALUE)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(ordreUp)
                    .add(jLabel1)
                    .add(ordreDown))
                .addContainerGap(67, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(55, 55, 55)
                        .add(tituloTabla)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 21, Short.MAX_VALUE)
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 399, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                        .add(189, 189, 189)
                        .add(ordreUp)
                        .add(97, 97, 97)
                        .add(jLabel1)
                        .add(76, 76, 76)
                        .add(ordreDown)))
                .add(37, 37, 37)
                .add(botonAlta)
                .add(81, 81, 81))
        );
        panelIntern.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("MantenimentsJerarquies"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(41, 41, 41)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, Short.MAX_VALUE)
                .add(63, 63, 63))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(25, 25, 25)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(75, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAddPrioridad(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAddPrioridad
        try
        {
           int rowSelected=tablaJerarquies.getSelectedRow();
           String idSelectedItem=(String)tablaJerarquies.getModel().getValueAt(rowSelected,COL_ID);
           String idItem=(String)tablaJerarquies.getModel().getValueAt(rowSelected-1,COL_ID);

           HyerarchyManager.getManager().updatePrioritat(idItem,PRIORITAT_UP);
           HyerarchyManager.getManager().updatePrioritat(idSelectedItem,PRIORITAT_DOWN);
           refresh(rowSelected-1);
           setEnableButtons(this.tablaJerarquies,rowSelected-1,this.ordreUp,this.ordreDown);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }

    }//GEN-LAST:event_botonAddPrioridad

    private void botonDownPrioridad(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDownPrioridad
         try 
         {  
             int rowSelected=tablaJerarquies.getSelectedRow();
             String idSelectedItem=(String)tablaJerarquies.getModel().getValueAt(rowSelected,COL_ID);
             String idItem=(String)tablaJerarquies.getModel().getValueAt(rowSelected+1,COL_ID);
             HyerarchyManager.getManager().updatePrioritat(idSelectedItem,PRIORITAT_UP);
             HyerarchyManager.getManager().updatePrioritat(idItem,PRIORITAT_DOWN);
             
             refresh(rowSelected+1);
            setEnableButtons(this.tablaJerarquies,rowSelected+1,this.ordreUp,this.ordreDown);
        } catch (Exception e) {
            e.printStackTrace();
            tratarError(new HyerarchyException(e.getMessage())); 
        }

    }//GEN-LAST:event_botonDownPrioridad

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaJerarquiesActionPerformed();
      refresh(-1);
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JButton ordreDown;
    private javax.swing.JButton ordreUp;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        final String[] names = {"ID","Codi", "Nom"};
        final Object[][] data =null;
                
        model=new DefaultTableModel(data,names);
        tablaJerarquies= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
       
        // Amagar les columnes d'ID i prioritat de la 'vista'.
        tablaJerarquies.getColumnModel().removeColumn(tablaJerarquies.getColumnModel().getColumn(0));
        tablaJerarquies.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                setEnableButtons(tablaJerarquies,-1,ordreUp,ordreDown);
            }
        });

        // Deshabilitem els botons d'ordre
        ordreUp.setEnabled(false);
        ordreDown.setEnabled(false);
               
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(tablaJerarquies);
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova font.  
     *
     */
    private void altaJerarquiesActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new JerarquiesAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Manteniments"));
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh(int row)
    {
        try
        {
            // Inicializem els components: taula i model.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            Vector allJerarquies=HyerarchyManager.getManager().getAllJerarquies();            
            PopupMenuTable jerarquiesPopupTable=new PopupMenuTable(tablaJerarquies,this,new EditorJerarquia(menuFrame),EDIT_JERARQUIA,DELETE_JERARQUIA);
            if ((allJerarquies.size()==0) || ((allJerarquies.size()==1)) &&((Jerarquies)allJerarquies.firstElement()).getIdJerarquia().equals(""))
            {
                model.addRow(new Object[] {null,null, null});
                jerarquiesPopupTable.disableMenuItems();
            }
            else
            {
                Iterator allJerarquiesIt=allJerarquies.iterator();                   
                while(allJerarquiesIt.hasNext())
                {
                    Jerarquies jerarquia=(Jerarquies)allJerarquiesIt.next();     
                    if (jerarquia.getIdJerarquia()!=null && !jerarquia.getIdJerarquia().equals(""))
                        model.addRow(new Object[] {jerarquia.getIdJerarquia(),jerarquia.getCodiJerarquia(), jerarquia.getDescripcio()});
                    System.out.println("ID Jerarquia:"+jerarquia.getIdJerarquia()+" Jerarquia:"+jerarquia.getCodiJerarquia()+" Descripcio:"+jerarquia.getDescripcio()+" Prioritat:"+jerarquia.getPrioritat());
                }  
            }
             System.out.println("--------------------------------------------------------------------------------------------------------------------------------------------------");
            // Associem el listener de l'event del ratol a la taula creada.
            tablaJerarquies.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(jerarquiesPopupTable));
            
            if(row>=0)
                tablaJerarquies.setRowSelectionInterval(row,row);
        }
        catch(Exception e)
        {
            e.printStackTrace();
           tratarError(new HyerarchyException(e.getMessage())); 
        }
    }
}
