/*
 * EditorLlengua.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.manteniments.llengues;

import com.termcat.util.literales.Literales;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;
import com.termcat.layout.commons.popup.PanelPopup;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;

import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una llengua de la taula .
 * 
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame --> problema??? es un JPANEL.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 *
 *  @author mena
 */
public class EditorLlengua extends FunctionalModule implements com.termcat.layout.commons.interfaces.IEditor
{
    //Constants
    private final String EDITAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarLlengua");
    private final String ESBORRAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarLlengua");
    
    private final int COL_ID=0; // Numero de la columna que cont el identificador de la llengua(PK).
    
    /** Creates a new instance of EditorLlengua */
    public EditorLlengua(MainFrame menuFrame) { 
        super(menuFrame);
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.    
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        try
        {

        JTable table=(JTable)component;    
        // Obtenim la pantalla principal de l'aplicaci (llistat amb totes les llengues).
        LlenguesMain moduleMain=(LlenguesMain)functionalModule;

        // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
        String itemClicked=event.getActionCommand( );      
        int rowSelected=table.getSelectedRow();
        String data=(String)table.getModel().getValueAt(rowSelected,COL_ID);
         
        // Printem per pantalla la opci seleccionada.
        System.out.println("Popup menu item [" + itemClicked + "] was pressed.");
        String msg="Row: "+rowSelected+" Value: ";   
        msg+=data;  
        System.out.println(msg);
 
        // Comprovem la opci clicada
        if(itemClicked!=null && !itemClicked.equals(""))
        {
             //     Edici de la llengua clicada.
             if(itemClicked.equals(EDITAR))
             {
               
                // Creem el nou mdul d'edici de la llengua seleccionada, i mostrem la finestra amb el contingut.               
                String result[]=new String[2];
                result[0]=(String)table.getModel().getValueAt(rowSelected,1);
                result[1]=(String)table.getModel().getValueAt(rowSelected,2);         
                FunctionalModule moduleEdit = new LlenguesEdit(menuFrame,moduleMain, data, result[0],result[1]);
                PanelPopup popupPanel=new PanelPopup(menuFrame,moduleEdit,Literales.getTextForMessage(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Manteniments")));
                 
                 // Actualitzem el popup 'actual'.
                 menuFrame.setPanelPopup(popupPanel);
                 
                 // Mostrem el popup.
                 popupPanel.showPopupWindow();
                 
             }             
             //     Eliminaci de la llengua clicada.
             else if(itemClicked.equals(ESBORRAR))
             {           
                // Esborrar de la BD la fila seleccionada.
                int response = JOptionPane.showConfirmDialog(menuFrame, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("MsgEsborrarLlengua"), java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminacioLlengua"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                if (response == JOptionPane.YES_OPTION) 
                {
                     LanguageManager.getManager().deleteLlengua(data);                      
                     // Refresh de la llista amb les llengues.
                     moduleMain.refresh();    
                }                
             }
             else
             {
                 tratarError(new LanguageException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioNoValida")));
             }
        }
        else
        {
                 tratarError(new LanguageException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoOpcioSelect")));
        }  
        }
        catch(Exception e)
        {
                 tratarError(new LanguageException(e.getMessage()));            
        }
    }  
}
