/*
 * LlenguesEdit.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.llengues;

import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.util.literales.Literales;
/**
 *
 * @author  Vazquezl
 */
public class LlenguesEdit extends FunctionalModule 
{         
    private String idLlengua;
    
    //  Guardem una referncia del "LlenguesMain" (llistat amb les llengues) per a despres poder cridar al seu
    // mtode 'refresh()' (que obte els valors de la BD) i aix no haver de tornar a crear un nou objecte 
    // LlenguesMain.
    private LlenguesMain llenguesMain; 
    
    /**
     *  Constructor.
     * 
     *  @param menuFrame:   Referncia al pare de l'aplicaci.
     *  @functionalModule:  Referncia del mdul on s'ha clicat la opci d'edici de la llengua(idLlengua) de la llista de llengues.
     *  @idLlengua:         Identificador de la Llengua clicada per a modificar.
     *  @llengua:           Valor del codi de la llengua amb idLlengua=@idLlengua
     *  @descripcio:        Valor de la descripci(camp 'nom' de la BD) de la llengua amb idLlengua=@idLlengua
     */
    public LlenguesEdit(MainFrame menuFrame, FunctionalModule functionalModule, String idLlengua, String llengua, String descripcio) {
        super(menuFrame);
        initComponents();
        
        // Actualitzem els atributs de la classe.
        this.idLlengua=idLlengua;
        this.llenguesMain=(LlenguesMain)functionalModule;      
        
        // Carreguem el formulari amb els valors de la BD.
        nomValue.setText(llengua);
        descValue.setText(descripcio);
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        nomLabel = new javax.swing.JLabel();
        nomValue = new FixedLengthTextField(10);
        botonDesar = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        descValue = new javax.swing.JTextArea();

        setMaximumSize(new java.awt.Dimension(650, 375));
        setMinimumSize(new java.awt.Dimension(650, 375));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("EdicioLlengua")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 350));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 350));
        descripcioLabel.setText(Literales.getTextForLiteral("LabelDescripcio"));

        nomLabel.setText(Literales.getTextForLiteral("LlenguaLabel"));

        nomValue.setColumns(25);

        botonDesar.setText(Literales.getTextForLiteral("Desar"));
        botonDesar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDesarActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        descValue.setColumns(20);
        descValue.setRows(5);
        jScrollPane1.setViewportView(descValue);

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(66, 66, 66)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(nomLabel))
                .add(72, 72, 72)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(botonDesar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 134, Short.MAX_VALUE)
                        .add(botonCancela))
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, nomValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 292, Short.MAX_VALUE))
                .add(126, 126, 126))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(38, 38, 38)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nomValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(nomLabel))
                .add(61, 61, 61)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(51, 51, 51)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(botonDesar)
                            .add(botonCancela))))
                .add(35, 35, 35))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(19, 19, 19)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(26, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 349, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(15, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonDesarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDesarActionPerformed
       try{
           nomValue.getText();
           if (validateTextComponent(Literales.getTextForMessage("Llengua_Codi"),nomValue,true,10)){
                 // Tanquem la transaccio per si no s'ha tancat
                 DBConnect.putConnectionTransactional();
              
                 LanguageManager.getManager().updateLlengua(this.idLlengua,nomValue.getText(),descValue.getText());
                 
                 // Missatge de confirmaci 
                 menuFrame.showMessageInfo(Literales.getTextForMessage("Lenguas_UpdateOk"));
                 
                 // Tanquem la finiestra d'edici de la llengua.
                 this.menuFrame.closePanelPopup();
                 
                 // Fem un 'refresh' de la llista perque aparegui la llengua amb la corresponent modificaci.
                 this.llenguesMain.refresh();                                
           } 
       }
       catch(Exception e){
            e.printStackTrace();
            tratarError(new LanguageException(e.getMessage())); 
       }
       
    }//GEN-LAST:event_botonDesarActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonDesar;
    private javax.swing.JTextArea descValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel nomLabel;
    private javax.swing.JTextField nomValue;
    private javax.swing.JPanel panelIntern;
    // End of variables declaration//GEN-END:variables
        
}
