/*
 * LlenguesMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.llengues;

import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import java.util.Iterator;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import java.awt.Dimension;

import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.maintenance.language.LanguageManager;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.manteniments.llengues.LlenguesAlta;
import com.termcat.layout.commons.popup.PanelPopup;

import com.termcat.bd.beans.Llengues;
import com.termcat.business.exceptions.LanguageException;

/**
 *
 * @author  Vazquezl
 */
public class LlenguesMain extends FunctionalModule {
    
    private JTable tablaLenguas; 
    private DefaultTableModel model;   
    
    // Constants
    private final String EDIT_LLENGUA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarLlengua");
    private final String DELETE_LLENGUA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarLlengua");
    
    /** segundo constructor */
    public LlenguesMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        initComponents();                              
        refresh();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("MantenimentsLlengues")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        botonAlta.setText(Literales.getTextForLiteral("AltaLlengua"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("LlistatLlengues"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(40, 40, 40)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 789, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tituloTabla)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(694, 694, 694)
                        .add(botonAlta)))
                .addContainerGap(75, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(52, 52, 52)
                .add(tituloTabla)
                .add(20, 20, 20)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 412, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(49, 49, 49)
                .add(botonAlta)
                .addContainerGap(60, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(41, 41, 41)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(63, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(73, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaLlenguesActionPerformed();
      refresh();
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        final String[] names = {"ID","Codi", "Nom"};
        final Object[][] data =null;
                
        this.model=new DefaultTableModel(data,names);
        this.tablaLenguas= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
       
        // Amagar la columna de la 'vista'.
        this.tablaLenguas.getColumnModel().removeColumn(this.tablaLenguas.getColumnModel().getColumn(0));
               
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(this.tablaLenguas);
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova llengua.  
     *
     */
    private void altaLlenguesActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new LlenguesAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Manteniments"));
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh()
    {
        try
        {
            // Inicializem els components: taula i model --> Es creen cada vegada... Massa objectes!!! Mirar de buidar les que existeixen.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            Vector allLlengues=LanguageManager.getManager().getAllLlengues();
            PopupMenuTable llenguesPopupTable=new PopupMenuTable(this.tablaLenguas,this,new EditorLlengua(menuFrame),EDIT_LLENGUA,DELETE_LLENGUA);
            if (allLlengues.size()==0)
            {
                model.addRow(new Object[] {null,null, null});
                llenguesPopupTable.disableMenuItems();                
            }
            else
            {        
                Iterator allLlenguesIt=allLlengues.iterator();                   
                while(allLlenguesIt.hasNext())
                {
                    Llengues llengua=(Llengues)allLlenguesIt.next();                             
                    this.model.addRow(new Object[] {llengua.getIdLlengua(),llengua.getCodiLlengua(), llengua.getNom()});
                    System.out.println("ID: "+llengua.getIdLlengua()+" Codi: "+llengua.getCodiLlengua()+" Nom: "+llengua.getNom());
                }  
            }

            // Associem el listener de l'event del ratol a la taula creada.
            this.tablaLenguas.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(llenguesPopupTable));

        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new LanguageException(e.getMessage())); 
        }
    }
}
