/*
 * MarquesEdit.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.marques;

import com.termcat.bd.utils.DBConnect;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.MarkException;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.util.literales.Literales;
/**
 *
 * @author  Vazquezl
 */
public class MarquesEdit extends FunctionalModule 
{         
    private String idMarca;
    
    //  Guardem una referncia del "MarquesMain" (llistat amb les llengues) per a despres poder cridar al seu
    // mtode 'refresh()' (que obte els valors de la BD) i aix no haver de tornar a crear un nou objecte 
    // MarquesMain.
    private MarquesMain marquesMain; 
    
    /**
     *  Constructor.
     * 
     *  @param menuFrame:   Referncia al pare de l'aplicaci.
     *  @functionalModule:  Referncia del mdul on s'ha clicat la opci d'edici de la llengua(idLlengua) de la llista de llengues.
     *  @idMarca:            Identificador de la marca clicada per a modificar.
     *  @codi:              Valor del codi de la marca amb idmarca=@idMarca
     *  @descripcio:        Valor de la descripci de la marca amb idMarca=@idMarca
     */
    public MarquesEdit(MainFrame menuFrame, FunctionalModule functionalModule, String idMarca, String codi, String descripcio) {
        super(menuFrame);
        initComponents();
        
        // Actualitzem els atributs de la classe.
        this.idMarca=idMarca;
        this.marquesMain=(MarquesMain)functionalModule;      
        
        // Carreguem el formulari amb els valors de la BD.
        nomValue.setText(codi);
        descValue.setText(descripcio);
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        nomLabel = new javax.swing.JLabel();
        nomValue = new FixedLengthTextField(3);
        botonDesar = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        descValue = new javax.swing.JTextArea();

        setMaximumSize(new java.awt.Dimension(650, 375));
        setMinimumSize(new java.awt.Dimension(650, 375));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("EdicioMarca")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 350));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 350));
        descripcioLabel.setText(Literales.getTextForLiteral("LabelDescripcio"));

        nomLabel.setText(Literales.getTextForLiteral("MarqiuesLabel"));

        nomValue.setColumns(25);

        botonDesar.setText(Literales.getTextForLiteral("Desar"));
        botonDesar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonDesarActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.setActionCommand(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        descValue.setColumns(20);
        descValue.setRows(5);
        jScrollPane1.setViewportView(descValue);

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(53, 53, 53)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(nomLabel)
                    .add(descripcioLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 68, Short.MAX_VALUE)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jScrollPane1, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(botonDesar, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 179, Short.MAX_VALUE)
                        .add(botonCancela))
                    .add(nomValue, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 337, Short.MAX_VALUE))
                .add(46, 46, 46))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(45, 45, 45)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(nomValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(nomLabel))
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(43, 43, 43)
                        .add(descripcioLabel))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(33, 33, 33)
                        .add(jScrollPane1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 148, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .add(25, 25, 25)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonDesar)
                    .add(botonCancela))
                .add(23, 23, 23))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(49, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 349, Short.MAX_VALUE)
                .add(15, 15, 15))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonDesarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonDesarActionPerformed
       try{
           nomValue.getText();
           if (validateTextComponent(Literales.getTextForMessage("Marques_Codi"),nomValue,true,3)){
                 // Tanquem la transaccio per si no s'ha tancat
                 DBConnect.putConnectionTransactional();
               
                 MarkManager.getManager().updateMarca(this.idMarca,nomValue.getText(),descValue.getText());
                 
                 // Missatge de confirmaci 
                 menuFrame.showMessageInfo(Literales.getTextForMessage("Marques_UpdateOk"));
                 
                 // Tanquem la finiestra d'edici de la llengua.
                 this.menuFrame.closePanelPopup();
                 
                 // Fem un 'refresh' de la llista perque aparegui la marca amb la corresponent modificaci.
                 this.marquesMain.refresh();                                
           } 
       }
       catch(Exception e){
           e.printStackTrace();
            tratarError(new MarkException(e.getMessage())); 
       }
       
    }//GEN-LAST:event_botonDesarActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonDesar;
    private javax.swing.JTextArea descValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JLabel nomLabel;
    private javax.swing.JTextField nomValue;
    private javax.swing.JPanel panelIntern;
    // End of variables declaration//GEN-END:variables
        
}
