/*
 * MarquesMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.manteniments.marques;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.exceptions.MarkException;
import com.termcat.bd.beans.MarquesP;
import com.termcat.layout.commons.popup.PopupMenuTable;
/**
 *
 * @author  mena
 */
public class MarquesMain extends FunctionalModule {
    
    private JTable tablaMarques; 
    private DefaultTableModel model;   
    
    //Constants
    private final String EDIT_MARCA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EditarMarca");
    private final String DELETE_MARCA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarMarca");
    
    /** segundo constructor */
    public MarquesMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        //try
        //{                 
            initComponents();                              
            refresh();
            setPanel(this);
       /* }
        catch(Exception e)
        {
            tratarError(e);
            e.printStackTrace();
        }*/
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("MantenimentsMarques")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        botonAlta.setText(Literales.getTextForLiteral("AltaMarca"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("LlistatMarquesExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(41, 41, 41)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(botonAlta)
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 787, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(tituloTabla)))
                .addContainerGap(76, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(56, 56, 56)
                .add(tituloTabla)
                .add(28, 28, 28)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 413, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(31, 31, 31)
                .add(botonAlta)
                .addContainerGap(65, Short.MAX_VALUE))
        );
        panelIntern.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("MantenimentsMarques"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(41, 41, 41)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(63, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(73, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaMarquesActionPerformed();
      refresh();
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        final String[] names = {"ID","Codi", "Nom"};
        final Object[][] data =null;
                
        model=new DefaultTableModel(data,names);
        tablaMarques= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
       
        // Amagar la columna de la 'vista'.
        tablaMarques.getColumnModel().removeColumn(tablaMarques.getColumnModel().getColumn(0));
               
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(tablaMarques);
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova marca.  
     *
     */
    private void altaMarquesActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new MarquesAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Manteniments"));
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh()
    {
        try
        {
            // Inicializem els components: taula i model.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            Vector allMarques=MarkManager.getManager().getAllMarques();
 
           PopupMenuTable marquesPopupTable=new PopupMenuTable(tablaMarques,this,new EditorMarques(menuFrame),EDIT_MARCA,DELETE_MARCA);           
            if (allMarques.size()==0 || ((allMarques.size()==1)) &&((MarquesP)allMarques.firstElement()).getIdMarca().equals(""))
           {
                model.addRow(new Object[] {null,null, null});
                marquesPopupTable.disableMenuItems();
           }
           else
           {
                Iterator allMarquesIt=allMarques.iterator();                      
                while(allMarquesIt.hasNext())
                {
                    MarquesP marca=(MarquesP)allMarquesIt.next();                             
                    if (marca.getIdMarca()!=null && !marca.getIdMarca().equals(""))
                        model.addRow(new Object[] {marca.getIdMarca(),marca.getCodiMarca_p(), marca.getDescripcio()});
                }  
            }
            // Associem el listener de l'event del ratol a la taula creada.
            tablaMarques.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(marquesPopupTable));
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new MarkException(e.getMessage())); 
        }
    }
}
