/*
 * NotesAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.arees;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.business.areas.AreaManager;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.AreaException;
import com.termcat.business.terminologic.notes.NoteManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.popup.MousePopupListener;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.commons.tree.DoubleClickTree;
import com.termcat.layout.commons.tree.JTreeMenuTable;
import com.termcat.layout.commons.tree.MouseJTreeListener;
import com.termcat.layout.terminologic.arees.EditorAreesAlta;
import com.termcat.util.literales.Literales;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.util.List;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.bd.beans.Fitxes;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.TreePath;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la denominacio
 */
public class AreesTematiquesAlta extends FunctionalModule
{
    private String idFitxa;
    private JTable tableAt;
    public PopupMenuTable arbrePopupTable;
    private final String ESBORRAR_ASSOCIACIO=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarAssociacio");  
    private final String AREES_TEMATIQUES_SELECCIONADES=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Arees_Tematiques_Select");  
    /** Constructor. */
    public AreesTematiquesAlta(MainFrame menuFrame) 
    {
        super(menuFrame);
        initComponents();
            
        // Inicialitzem la taula amb els valors de la BD
        tableAt=initTable(AREES_TEMATIQUES_SELECCIONADES,this.menuFrame.getIdFitxa());    
        arbrePopupTable=new PopupMenuTable(tableAt,this,new EditorAreesAlta(this.menuFrame,this),null,ESBORRAR_ASSOCIACIO);
            
        // Deshabilitem els menuItems de la taula en cas que estigui buida. (1 nica fila sense continguts)
        String id=(String)tableAt.getModel().getValueAt(0,0);
        if (id==null || id.equals(""))
            arbrePopupTable.disableMenuItems();
                
        tableAt.addMouseListener(new MousePopupListener(arbrePopupTable));        
        tableAt.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
            }
            public void keyReleased(java.awt.event.KeyEvent evt) {
                deleteAssociacio(evt);
            }
        });
        tableScrollPane.setViewportView(tableAt);                                  

        // Inicialitzem l'arbre amb els valors de la BD i els seus listeners
        JTree freezeTree = new JTree();
        freezeTree.setModel(this.menuFrame.tree.getModel());
        removeAll2ClickListeners(freezeTree);
        freezeTree.addMouseListener(new  DoubleClickTree(menuFrame,this,arbrePopupTable));
        
        treeScrollPane.setViewportView(freezeTree);           
       //removeAll2ClickListeners(this.menuFrame.tree);
       //this.menuFrame.tree.addMouseListener();
       //treeScrollPane.setViewportView(this.menuFrame.tree);                    
             
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        titolLabel = new javax.swing.JLabel();
        treeScrollPane = new javax.swing.JScrollPane();
        tableScrollPane = new javax.swing.JScrollPane();
        textDescriptiu = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(944, 373));
        setMinimumSize(new java.awt.Dimension(944, 373));
        panelIntern.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        panelIntern.setMaximumSize(new java.awt.Dimension(944, 373));
        panelIntern.setMinimumSize(new java.awt.Dimension(944, 373));
        titolLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 14));
        titolLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("SeleccioAT"));

        textDescriptiu.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 2, 12));
        textDescriptiu.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AfegirAT2Click"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(treeScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 388, Short.MAX_VALUE)
                        .add(38, 38, 38)
                        .add(tableScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 481, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(24, 24, 24))
                    .add(titolLabel)
                    .add(textDescriptiu, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 551, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(titolLabel)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(treeScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 274, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(tableScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 274, Short.MAX_VALUE))
                .add(20, 20, 20)
                .add(textDescriptiu)
                .add(29, 29, 29))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 943, Short.MAX_VALUE)
                .add(65, 65, 65))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 372, Short.MAX_VALUE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane tableScrollPane;
    private javax.swing.JLabel textDescriptiu;
    private javax.swing.JLabel titolLabel;
    private javax.swing.JScrollPane treeScrollPane;
    // End of variables declaration//GEN-END:variables

    public javax.swing.JTable getTableAt()
    {
        return this.tableAt;
    }
    
    /*
     *  Creem aquesta funci perque desde DoubleClick no ens permet accedir directament a 'getAbsoluteAreaName'
     * ni a 'tratarError'
     *
    public String getAbsoluteName(String idPare, String nomArea,String idArea)
    {
        return this.getAbsoluteAreaName(idPare,nomArea,idArea);
    }
    */
    public void tratarErrorException(Exception e) 
    {
       this.tratarError(e);
    }
    
    private void deleteAssociacio(java.awt.event.KeyEvent evt) 
    {
        int keyCode=evt.getKeyCode();
        String keyText=evt.getKeyText(keyCode);
        System.out.println("*******************************************************");
        System.out.println("KeyCode:"+keyCode+" KeyText: "+keyText);              

        int rowSelected=tableAt.getSelectedRow();
        String idAreaSelected=(String)tableAt.getModel().getValueAt(rowSelected,0);
        System.out.println("Id Area Selected: "+idAreaSelected);
        
        if (idAreaSelected!=null && !idAreaSelected.equals(""))
        {
            try
            {
                // Cas que l'usuari hagi clicat la tecla de 'Supr'
                if (keyCode==127)
                {
                    // Esborrar de la BD la fila seleccionada.
                    int response = JOptionPane.showConfirmDialog(menuFrame, "Estas segur d'esborrar l'associaci a l'rea temtica seleccionada?", "Eliminaci d'una rea temtica", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response == JOptionPane.YES_OPTION) 
                    {
                        // Esborrem de la base de dades l'area els fills associats i indicar el flag de dirty a true.
                        AreaManager.getManager().deleteAssociacio(idAreaSelected,this.menuFrame.getIdFitxa()); 
                        this.menuFrame.setCurrentFitxaDirty(true);                        

                        // Esborrem de la taula l'associaci
                        DefaultTableModel model =(DefaultTableModel)tableAt.getModel();
                        model.removeRow(rowSelected);
                        if (model.getRowCount()==0)
                        {
                            model.addRow(new Object[] {null,null});      
                            arbrePopupTable.disableMenuItems();
                        }
                       // Deseleccionem l'element de l'arbre
                       this.menuFrame.tree.setSelectionPath(null);
                   }
                }
            }
            catch (Exception e)
            {
                e.printStackTrace();
                tratarError(new AreaException(e.getMessage()));
            }
        }
    }

}