/*
 * EditorFont.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.terminologic.arees;


import com.termcat.bd.beans.ArbreCamp;
import com.termcat.business.areas.AreaManager;
import com.termcat.layout.commons.popup.PopupMenuTable;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;

import com.termcat.business.exceptions.AreaException;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.layout.MainFrame;
import javax.swing.JTree;
import javax.swing.table.DefaultTableModel;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una font de la taula .
 *
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 * 
 *  @author mena
 */
public class EditorAreesAlta extends FunctionalModule implements com.termcat.layout.commons.interfaces.IEditor
{      
    //Constants
    private final String ESBORRAR=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminarAssociacio");  
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la font(PK).
    private AreesTematiquesAlta areaTematica;
    
    /** Creates a new instance of EditorLlengua */
    public EditorAreesAlta(MainFrame menuFrame, FunctionalModule module) 
    {
        super(menuFrame); 
        this.areaTematica=(AreesTematiquesAlta)module;
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        String nomPare=null;
        FunctionalModule moduleAlta=null;
        try
        {
            JTable table=(JTable)component;

            // Obtenim la pantalla principal de l'aplicaci (menuFrame)
            AreesTematiquesAlta moduleMain=(AreesTematiquesAlta)functionalModule;

            // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
            String itemClicked=event.getActionCommand( );      
            int rowSelected=table.getSelectedRow();
            String idAreaSelected=(String)table.getModel().getValueAt(rowSelected,0);
                        
            // Comprovem la opci clicada
            if(itemClicked!=null && !itemClicked.equals(""))
            {
                 // Eliminaci de la font clicada.
                 if(itemClicked.equals(ESBORRAR))
                 {           
                    // Esborrar de la BD la fila seleccionada.
                    int response = JOptionPane.showConfirmDialog(menuFrame, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("MsgEsborrarAT"), java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminacioAT"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response == JOptionPane.YES_OPTION) 
                    {
                        // Esborrem de la base de dades l'area els fills associats i indicar el flag de dirty a true.
                        AreaManager.getManager().deleteAssociacio(idAreaSelected,this.menuFrame.getIdFitxa()); 
                        this.menuFrame.setCurrentFitxaDirty(true);                        
                        
                        // Esborrem de la taula l'associaci
                        DefaultTableModel model =(DefaultTableModel)table.getModel();
                        model.removeRow(rowSelected);
                        if (model.getRowCount()==0)
                        {
                            model.addRow(new Object[] {null,null});  
                            areaTematica.arbrePopupTable.disableMenuItems();
                        }
                        // Deseleccionem l'element de l'arbre
                        this.menuFrame.tree.setSelectionPath(null);
                    }                
                     //System.out.println(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioEsborrarAssociacio"));
                 }
                 else
                 {
                     tratarError(new AreaException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioNoValida")));
                 }
            }
            else
            {
                tratarError(new AreaException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoOpcioSelect")));
            }    
        }
        catch(Exception e)
        {
             tratarError(new AreaException(e.getMessage()));                                  
        }
    }  
}