/*
 * ValorsMain.java
 *
 * Created on 21 de septiembre de 2007, 10:46
 */

package com.termcat.layout.terminologic.cerca;

import com.termcat.business.exceptions.CategoryException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.layout.commons.search.SelectedList;
import com.termcat.util.literales.Literales;
import java.util.Vector;

/**
 *
 * @author  Mena
 */
public class CategoriaMain extends FunctionalModule 
{
    private static CategoriaMain categoriaMain=null;
    private Vector allCategories;
    
    public static synchronized CategoriaMain getInstance(MainFrame menuFrame) throws CategoryException
    {
        if(categoriaMain!=null && (menuFrame.isCategoriesModified()==false) )
            return categoriaMain;
        else
        {
            menuFrame.setCategoriesModified(false);
            categoriaMain=new CategoriaMain(menuFrame);
            return categoriaMain ;      
        }
    }
    
    public void destroy()
    {
         //this.categoriaMain=null;        
        scrollPane.remove(list);
        list=new AssociateLists(allCategories,null,CATEGORIES_NO_ASSOCIATE_TITLE,CATEGORIES_ASSOCIATE_TITLE);                
        scrollPane.setViewportView(list);                
    }
    /** Creates new form ValorsMain */
    private CategoriaMain(MainFrame menuFrame) throws CategoryException 
    {
        super(menuFrame);
        initComponents();        
        try 
        {
            allCategories = CategoryManager.getManager().getAllCodeIdCategories();
            if (menuFrame.getCercaObject()==null)
               list=new AssociateLists(allCategories,null,CATEGORIES_NO_ASSOCIATE_TITLE,CATEGORIES_ASSOCIATE_TITLE);
            else
            {
                Vector selectedCategories=menuFrame.getCercaObject().getCategories().getSelectedList();
                Vector noAssociates=getNoAssociates(allCategories,selectedCategories);
                
                list=new AssociateLists(noAssociates,selectedCategories,CATEGORIES_NO_ASSOCIATE_TITLE,CATEGORIES_ASSOCIATE_TITLE);                

                // Indiquem el criteri de cerca
                noContainsRadioButton.setSelected(!menuFrame.getCercaObject().getCategories().getContains());                
            }
            scrollPane.setViewportView(list);

        } 
        catch (Exception ex) 
        {
            ex.printStackTrace();
            throw new CategoryException(ex.getMessage());
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        criteriCategoria = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        containsRadioButton = new javax.swing.JRadioButton();
        noContainsRadioButton = new javax.swing.JRadioButton();

        setMaximumSize(new java.awt.Dimension(805, 460));
        setMinimumSize(new java.awt.Dimension(805, 460));
        scrollPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(55, 55, 55)
                .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 586, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(45, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(23, Short.MAX_VALUE)
                .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 285, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Contingut_de_la_cerca")));
        criteriCategoria.add(containsRadioButton);
        containsRadioButton.setSelected(true);
        containsRadioButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ContingutCategoriesSelected"));
        containsRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        containsRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        criteriCategoria.add(noContainsRadioButton);
        noContainsRadioButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoContingutCategoriesSelected"));
        noContainsRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        noContainsRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(142, 142, 142)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(containsRadioButton)
                    .add(noContainsRadioButton))
                .addContainerGap(119, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(containsRadioButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(noContainsRadioButton)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(63, 63, 63)
                        .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(135, 135, 135)
                        .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(56, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(36, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    SelectedList getCategoriaCerca() 
    {
        SelectedList cercalist=new SelectedList();
                
        cercalist.setContains(getSelectedRadioButton(criteriCategoria).equals(containsRadioButton));
        cercalist.setSelectedList(list.getSelectedList());
        
        return cercalist;      
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton containsRadioButton;
    private javax.swing.ButtonGroup criteriCategoria;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JRadioButton noContainsRadioButton;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables

    private final String CATEGORIES_NO_ASSOCIATE_TITLE=Literales.getTextForLiteral("NoAssociatedCat");
    private final String CATEGORIES_ASSOCIATE_TITLE=Literales.getTextForLiteral("AssociatedCat");
    
    private AssociateLists list;
}
