/*
 * LlenguesMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.cerca;

import com.termcat.business.exceptions.SearchException;
import com.termcat.business.terminologic.search.SearchManager;
import com.termcat.layout.commons.BoolString;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.commons.search.Fitxa;
import com.termcat.layout.commons.search.Search;
import com.termcat.layout.commons.search.SelectedList;
import com.termcat.layout.commons.search.Values;
import com.termcat.layout.terminologic.cerca.FitxaMain;
import com.termcat.layout.terminologic.fitxes.FitxesMain;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import java.util.Iterator;

import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import java.awt.Dimension;

import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.maintenance.language.LanguageManager;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.manteniments.llengues.LlenguesAlta;
import com.termcat.layout.commons.popup.PanelPopup;

import com.termcat.bd.beans.Llengues;
import com.termcat.business.exceptions.LanguageException;

/**
 *
 * @author  Vazquezl
 */
public class CercaMain extends FunctionalModule 
{
    private static CercaMain cerca=null;   

    private ValorsMain valorsMain;
    private LlenguaMain llenguesMain;
    private AreaTematicaMain areesMain;
    private JerarquiaMain jerarquiesMain;
    private CategoriaMain categoriesMain;
    private FontMain fontsMain;
    private FitxaMain fitxaMain;
    
    private boolean definitionConflict;
    private boolean noteConflict;
    
    public static synchronized CercaMain getInstance(MainFrame menuFrame)
    {      
        if(cerca!=null)
            return cerca;
        else
            return new CercaMain(menuFrame);
    }
    
    public void destroy()
    {
        valorsMain.destroy();
        areesMain.destroy();
        llenguesMain.destroy();
        jerarquiesMain.destroy();
        categoriesMain.destroy();
        fontsMain.destroy();
        fitxaMain.destroy();
        
        this.cerca=null;
    }
    
    /** segundo constructor */
    private CercaMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        initComponents();
        try
        {        
            diccionariName.setText(menuFrame.getNomCurrentDictionary());
            initTabs();       

            menuFrame.setCurrentPage(0);

            menuFrame.setNoteConflict(false);
            menuFrame.setDefinitionConflict(false);

            setPanel(this);
        }
        catch(SearchException e)
        {
            // En cas de que es produeixi un error es mostra l'error i es mostra el llistat sense filtrar.
            this.menuFrame.showMessageError(Literales.getTextForMessage("LoadingCercaError"));
            loadFitxesMain();                        
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        tituloTabla = new javax.swing.JLabel();
        diccionariLabel = new javax.swing.JLabel();
        diccionariName = new javax.swing.JLabel();
        tabbedPane = new javax.swing.JTabbedPane();
        cercaButton = new javax.swing.JButton();
        esborraCercaButton = new javax.swing.JButton();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("TreballTerminologic_Cerca")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        tituloTabla.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 18));
        tituloTabla.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Indiqui_els_criteris_de_cerca"));

        diccionariLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 1, 24));
        diccionariLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DiccionariLabel"));

        diccionariName.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 24));
        diccionariName.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("jLabel1"));

        tabbedPane.setMaximumSize(new java.awt.Dimension(805, 460));
        tabbedPane.setMinimumSize(new java.awt.Dimension(805, 460));
        tabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tabbedPaneStateChanged(evt);
            }
        });

        cercaButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cercar"));
        cercaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cercaButtonActionPerformed(evt);
            }
        });

        esborraCercaButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Esborrar_cerca_actual"));
        esborraCercaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                esborraCercaButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(40, 40, 40)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(tituloTabla)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(diccionariLabel)
                        .add(97, 97, 97)
                        .add(diccionariName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 396, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                        .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 806, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(panelInternLayout.createSequentialGroup()
                            .add(cercaButton)
                            .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                            .add(esborraCercaButton))))
                .addContainerGap(58, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diccionariLabel)
                    .add(diccionariName))
                .add(36, 36, 36)
                .add(tituloTabla)
                .add(17, 17, 17)
                .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 462, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 18, Short.MAX_VALUE)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(esborraCercaButton)
                    .add(cercaButton))
                .add(20, 20, 20))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(41, 41, 41)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(63, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(27, 27, 27)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 668, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(73, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void tabbedPaneStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_tabbedPaneStateChanged
        resolveConflicts(tabbedPane.getSelectedIndex());
    }//GEN-LAST:event_tabbedPaneStateChanged

    private void esborraCercaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_esborraCercaButtonActionPerformed
        removeSearch();
        loadFitxesMain();
    }//GEN-LAST:event_esborraCercaButtonActionPerformed

    private void cercaButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cercaButtonActionPerformed
        //setSearchObject(this.menuFrame.getIdCurrentDictionary(),(menuFrame.getCurrentPage())*menuFrame.getRowsInPage(),this.menuFrame.getRowsInPage());
        setSearchObject();
        loadFitxesMain();
    }//GEN-LAST:event_cercaButtonActionPerformed

    private void initTabs() throws SearchException 
    {
        try
        {
            valorsMain= new ValorsMain(menuFrame);        
            llenguesMain=LlenguaMain.getInstance(menuFrame);
            areesMain=AreaTematicaMain.getInstance(menuFrame);
            jerarquiesMain=JerarquiaMain.getInstance(menuFrame);
            categoriesMain=CategoriaMain.getInstance(menuFrame);
            fontsMain=FontMain.getInstance(menuFrame);
            fitxaMain=new FitxaMain(menuFrame);

            // Afegim les pestanyes al panell.
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Valors"),valorsMain);
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Llengua"),llenguesMain);
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Area"),areesMain);
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Jer"),jerarquiesMain);
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Categ"),categoriesMain);
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Font"),fontsMain);
            tabbedPane.addTab(Literales.getTextForLiteral("Cerca_Fitxa"),fitxaMain);        
        }
        catch(Exception e)
        {
            e.printStackTrace();
            throw new SearchException(e.getMessage());
        }
    }
    
    private void setSearchObject() 
    {
        // En cas que hi hagi una cerca anterior l'eliminem per a evitar problemes.
        Values denominacio=valorsMain.getDenominacionsCerca();
        Values definicio=valorsMain.getDefinicionsCerca();
        Values nota=valorsMain.getNotesCerca();
        
        SelectedList llengues=llenguesMain.getLlenguaCerca();
        SelectedList arees=areesMain.getAreesCerca();
        SelectedList jerarquies=jerarquiesMain.getJerarquiaCerca();
        SelectedList categories=categoriesMain.getCategoriaCerca();        
        SelectedList fonts=fontsMain.getFontsCerca();
        
        Fitxa fitxa=fitxaMain.getFitxaCerca();       
       
        // Creem l'objecte Search
        Search cerca=new Search();
        
        cerca.setDenominacions(denominacio);
        cerca.setDefinicions(definicio);
        cerca.setNotes(nota);
        cerca.setLlengues(llengues);
        cerca.setAreesTematiques(arees);
        cerca.setJerarquies(jerarquies);
        cerca.setCategories(categories);
        cerca.setFonts(fonts);
        cerca.setFitxa(fitxa);       
        
        // Construim la query i la guardem a l'objecte del menuFrame
        menuFrame.setCercaObject(cerca);
    }

    private void removeSearch() 
    {
        if (menuFrame.getCercaObject()==null)
            menuFrame.showMessageInfo("No hi ha cap filtre aplicat");            
        else
        {
            // Posem a nul els objectes de les pestanyes i la cerca.
            destroy();
        
           // Esborrem l'objecte de memria        
            this.menuFrame.setCercaObject(null);
            this.menuFrame.setCurrentPage(0);
            
            // Esborrem la pantalla i la tornem a carregar de nou
            tabbedPane.removeAll();
            //initTabs();
        }
    }

    private void resolveConflicts(int tab)
    {
        switch(tab)
        {
           // Pestanya de VALORS.
            case 0: // Actualitzem els valors del booleans que creen conflictes i li passem l'objecte fitxaMain
                    this.menuFrame.setDefinitionConflict(fitxaMain.getFitxaCerca().getDefinicions()>0);
                    this.menuFrame.setNoteConflict(fitxaMain.getFitxaCerca().getNotes()>0);
                    valorsMain.setFitxaMain(fitxaMain);
                    break;
            // Pestanya de FITXA
            case 6:  // Actualitzem els valors del booleans que creen conflictes i li passem l'objecte valorsMain
                    this.menuFrame.setDefinitionConflict(!valorsMain.getDefinicionsCerca().getValue().trim().equals(""));
                    this.menuFrame.setNoteConflict(!valorsMain.getNotesCerca().getValue().trim().equals(""));
                    fitxaMain.setValorsMain(valorsMain);
                    break;
            // En la resta de pestanyes no fem res.
            default:break;             
        }
    }
    
    private void loadFitxesMain()
    {
           FunctionalModule module = new FitxesMain(this.menuFrame);
           menuFrame.setFuncionalModule (module);    
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cercaButton;
    private javax.swing.JLabel diccionariLabel;
    private javax.swing.JLabel diccionariName;
    private javax.swing.JButton esborraCercaButton;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JTabbedPane tabbedPane;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
}
