/*
 * ValorsMain.java
 *
 * Created on 21 de septiembre de 2007, 10:46
 */

package com.termcat.layout.terminologic.cerca;

import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.util.literales.Literales;
import javax.swing.ButtonModel;
import javax.swing.event.ChangeListener;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.layout.commons.search.Fitxa;
import com.termcat.layout.commons.search.SelectedList;
import com.termcat.layout.commons.search.Values;
import java.util.Enumeration;
import java.util.Vector;
import javax.swing.ButtonGroup;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;

/**
 *
 * @author  Mena
 */
public class FitxaMain extends FunctionalModule 
{
    private static FitxaMain fitxaMain=null;
    
    // Referencia a l'objecte de ValorsMain, per tal de poder resoldre conflictes.
    private ValorsMain valorsMain;
    private int DEFINITION_ITEMS;
    private int NOTES_ITEMS;
    
   /* public static synchronized FitxaMain getInstance(MainFrame menuFrame)
    {
        if(fitxaMain!=null)
            return fitxaMain;
        else
        {
            fitxaMain=new FitxaMain(menuFrame);
            return fitxaMain;      
        }
    }   */ 
    
    public void destroy()
    {
        this.fitxaMain=null;
    }
    
    /** Creates new form ValorsMain */
    public FitxaMain(MainFrame menuFrame) 
    {
        super(menuFrame);
        
        // Esborrem els listeners anteriors.
/*        if (ambDefinicions!=null)
        {
            removeAllListeners(ambDefinicions);
            removeAllListeners(senseDefinicions);       
            removeAllListeners(ambNotes);
            removeAllListeners(senseNotes);
        }
  */      
        initComponents();

        DEFINITION_ITEMS=definicionsGroup.getButtonCount();
        NOTES_ITEMS=notesGroup.getButtonCount();
        
        if (menuFrame.getCercaObject()!=null)
        {
            // En cas de fer-se la crrega d'un filtre es defineixen els conflictes a false.
            this.menuFrame.setDefinitionConflict(false);
            this.menuFrame.setNoteConflict(false);
            
            // Calculem el radioButton que esta a la cerca
            ButtonModel defButtonModel=getSelectedDefinicionsModel(menuFrame.getCercaObject().getFitxa().getDefinicions());            
            ButtonModel notesButtonModel=getSelectedNotesModel(menuFrame.getCercaObject().getFitxa().getNotes());
            ButtonModel obsButtonModel=getSelectedObservacionsModel(menuFrame.getCercaObject().getFitxa().getObservacions());

            // Seleccionem el radio Button
            if (defButtonModel!=null)
                definicionsGroup.setSelected(defButtonModel,true);                        
            if (notesButtonModel!=null)            
                notesGroup.setSelected(notesButtonModel,true);
            if(obsButtonModel!=null) 
                observacionsGroup.setSelected(obsButtonModel,true);            
            
            // Inicialitzaci del valorsMain. COM??
        }    
        else
            valorsMain=null;               
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        definicionsGroup = new javax.swing.ButtonGroup();
        notesGroup = new javax.swing.ButtonGroup();
        observacionsGroup = new javax.swing.ButtonGroup();
        obsPanel = new javax.swing.JPanel();
        totesObs = new javax.swing.JRadioButton();
        ambObs = new javax.swing.JRadioButton();
        senseObs = new javax.swing.JRadioButton();
        notesPanel = new javax.swing.JPanel();
        totesNotes = new javax.swing.JRadioButton();
        ambNotes = new javax.swing.JRadioButton();
        senseNotes = new javax.swing.JRadioButton();
        definicionsPanel = new javax.swing.JPanel();
        totesDefinicions = new javax.swing.JRadioButton();
        ambDefinicions = new javax.swing.JRadioButton();
        senseDefinicions = new javax.swing.JRadioButton();

        setMaximumSize(new java.awt.Dimension(805, 460));
        setMinimumSize(new java.awt.Dimension(805, 460));
        obsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Observacions"));
        observacionsGroup.add(totesObs);
        totesObs.setSelected(true);
        totesObs.setText(Literales.getTextForLiteral("Totes_les_fitxes_obs"));
        totesObs.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        totesObs.setMargin(new java.awt.Insets(0, 0, 0, 0));

        observacionsGroup.add(ambObs);
        ambObs.setText("Totes les fitxes amb observacions");
        ambObs.setActionCommand(Literales.getTextForLiteral("Totes_les_fitxes_amb_observacions"));
        ambObs.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        ambObs.setMargin(new java.awt.Insets(0, 0, 0, 0));

        observacionsGroup.add(senseObs);
        senseObs.setText(Literales.getTextForLiteral("Totes_les_fitxes_sense_observacions"));
        senseObs.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        senseObs.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout obsPanelLayout = new org.jdesktop.layout.GroupLayout(obsPanel);
        obsPanel.setLayout(obsPanelLayout);
        obsPanelLayout.setHorizontalGroup(
            obsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(obsPanelLayout.createSequentialGroup()
                .add(151, 151, 151)
                .add(obsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(totesObs)
                    .add(ambObs)
                    .add(senseObs))
                .addContainerGap(164, Short.MAX_VALUE))
        );
        obsPanelLayout.setVerticalGroup(
            obsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(obsPanelLayout.createSequentialGroup()
                .add(totesObs, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(17, 17, 17)
                .add(ambObs)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(senseObs)
                .addContainerGap())
        );
        obsPanel.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("Observacions_no_puntos"));

        notesPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Notes"));
        notesGroup.add(totesNotes);
        totesNotes.setSelected(true);
        totesNotes.setText(Literales.getTextForLiteral("Totes_les_fitxes_notes"));
        totesNotes.setActionCommand(Literales.getTextForLiteral("Totes_les_fitxes_notes"));
        totesNotes.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        totesNotes.setMargin(new java.awt.Insets(0, 0, 0, 0));

        notesGroup.add(ambNotes);
        ambNotes.setText(Literales.getTextForLiteral("Totes_les_fitxes_amb_notes"));
        ambNotes.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        ambNotes.setMargin(new java.awt.Insets(0, 0, 0, 0));
        ambNotes.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ambNotesStateChanged(evt);
            }
        });

        notesGroup.add(senseNotes);
        senseNotes.setText(Literales.getTextForLiteral("Totes_les_fitxes_sense_notes"));
        senseNotes.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        senseNotes.setMargin(new java.awt.Insets(0, 0, 0, 0));
        senseNotes.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                senseNotesStateChanged(evt);
            }
        });

        org.jdesktop.layout.GroupLayout notesPanelLayout = new org.jdesktop.layout.GroupLayout(notesPanel);
        notesPanel.setLayout(notesPanelLayout);
        notesPanelLayout.setHorizontalGroup(
            notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(notesPanelLayout.createSequentialGroup()
                .add(151, 151, 151)
                .add(notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(totesNotes)
                    .add(ambNotes)
                    .add(senseNotes))
                .addContainerGap(200, Short.MAX_VALUE))
        );
        notesPanelLayout.setVerticalGroup(
            notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(notesPanelLayout.createSequentialGroup()
                .add(totesNotes, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(17, 17, 17)
                .add(ambNotes)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(senseNotes)
                .addContainerGap())
        );
        notesPanel.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("Notes_no_puntos"));

        definicionsPanel.setBorder(javax.swing.BorderFactory.createTitledBorder("Definicions"));
        definicionsGroup.add(totesDefinicions);
        totesDefinicions.setSelected(true);
        totesDefinicions.setText(Literales.getTextForLiteral("Totes_les_fitxes_defini"));
        totesDefinicions.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        totesDefinicions.setMargin(new java.awt.Insets(0, 0, 0, 0));

        definicionsGroup.add(ambDefinicions);
        ambDefinicions.setText(Literales.getTextForLiteral("Totes_les_fitxes_amb_definicions"));
        ambDefinicions.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        ambDefinicions.setMargin(new java.awt.Insets(0, 0, 0, 0));
        ambDefinicions.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                ambDefinicionsStateChanged(evt);
            }
        });

        definicionsGroup.add(senseDefinicions);
        senseDefinicions.setText(Literales.getTextForLiteral("Totes_les_fitxes_sense_definicions"));
        senseDefinicions.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        senseDefinicions.setMargin(new java.awt.Insets(0, 0, 0, 0));
        senseDefinicions.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                senseDefinicionsStateChanged(evt);
            }
        });

        org.jdesktop.layout.GroupLayout definicionsPanelLayout = new org.jdesktop.layout.GroupLayout(definicionsPanel);
        definicionsPanel.setLayout(definicionsPanelLayout);
        definicionsPanelLayout.setHorizontalGroup(
            definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(definicionsPanelLayout.createSequentialGroup()
                .add(151, 151, 151)
                .add(definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(totesDefinicions)
                    .add(ambDefinicions)
                    .add(senseDefinicions))
                .addContainerGap(176, Short.MAX_VALUE))
        );
        definicionsPanelLayout.setVerticalGroup(
            definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(definicionsPanelLayout.createSequentialGroup()
                .add(totesDefinicions, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(17, 17, 17)
                .add(ambDefinicions)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(senseDefinicions)
                .addContainerGap())
        );
        definicionsPanel.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("Definicions"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(119, 119, 119)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING, false)
                    .add(definicionsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(obsPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .add(notesPanel, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(168, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .add(definicionsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(27, 27, 27)
                .add(notesPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 24, Short.MAX_VALUE)
                .add(obsPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(38, 38, 38))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void senseNotesStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_senseNotesStateChanged
        int indexNotes=getSelectedRadioButtonType(notesGroup);   
        if (indexNotes>=0&& indexNotes <NOTES_ITEMS)
            comprovaConflicteNotes();        
    }//GEN-LAST:event_senseNotesStateChanged

    private void ambNotesStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ambNotesStateChanged
        int indexNotes=getSelectedRadioButtonType(notesGroup);   
        if (indexNotes>=0&& indexNotes <NOTES_ITEMS)
            comprovaConflicteNotes();        
    }//GEN-LAST:event_ambNotesStateChanged

    private void senseDefinicionsStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_senseDefinicionsStateChanged
        int indexDefinicions=getSelectedRadioButtonType(definicionsGroup);   
        if (indexDefinicions>=0&& indexDefinicions <DEFINITION_ITEMS)
            comprovaConflicteDefinicions();        
    }//GEN-LAST:event_senseDefinicionsStateChanged

    private void ambDefinicionsStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_ambDefinicionsStateChanged
        int indexDefinicions=getSelectedRadioButtonType(definicionsGroup);     
        if (indexDefinicions>=0&& indexDefinicions <DEFINITION_ITEMS)
            comprovaConflicteDefinicions();
    }//GEN-LAST:event_ambDefinicionsStateChanged
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton ambDefinicions;
    private javax.swing.JRadioButton ambNotes;
    private javax.swing.JRadioButton ambObs;
    private javax.swing.ButtonGroup definicionsGroup;
    private javax.swing.JPanel definicionsPanel;
    private javax.swing.ButtonGroup notesGroup;
    private javax.swing.JPanel notesPanel;
    private javax.swing.JPanel obsPanel;
    private javax.swing.ButtonGroup observacionsGroup;
    private javax.swing.JRadioButton senseDefinicions;
    private javax.swing.JRadioButton senseNotes;
    private javax.swing.JRadioButton senseObs;
    private javax.swing.JRadioButton totesDefinicions;
    private javax.swing.JRadioButton totesNotes;
    private javax.swing.JRadioButton totesObs;
    // End of variables declaration//GEN-END:variables

    
    
    public Fitxa getFitxaCerca()
    {
        int indexDefinicions=getSelectedRadioButtonType(definicionsGroup);
        int indexNotes=getSelectedRadioButtonType(notesGroup);
        
        Fitxa fitxa=new Fitxa();                            
        fitxa.setDefinicions(indexDefinicions);      
        fitxa.setNotes(indexNotes);
        fitxa.setObservacions(getSelectedRadioButtonType(observacionsGroup));
        
        return fitxa;
    }

    private int getSelectedRadioButtonType(ButtonGroup group) 
    {
        int i=0;
        for (Enumeration e=group.getElements(); e.hasMoreElements(); ) 
        {
            JRadioButton b = (JRadioButton)e.nextElement();
            if (b.isSelected())             
                break;
            
            ++i;
        }
        return i;
    }


    public void setValorsMain(ValorsMain valorsMain)
    {       
        this.valorsMain=valorsMain;
    }
    
    private void comprovaConflicteDefinicions() 
    {
        int indexDefinicions=getSelectedRadioButtonType(definicionsGroup);     
        System.out.println("INDEX: "+indexDefinicions+" obj: "+this.toString());
        if (indexDefinicions>0 && this.menuFrame.getDefinitionConflict())
        {
             int response = JOptionPane.showConfirmDialog(menuFrame, "Hi ha conflicte en el camp de definicions. Desitja mantenir el criteri seleccionat?", "", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
             if (response == JOptionPane.YES_OPTION) 
             {
                // Hauriem d'esborrar el criteri de la pestanya de Valors.
                 valorsMain.setDefinicioField("");
                 this.menuFrame.setNoteConflict(false);
             }
             else if (response == JOptionPane.NO_OPTION)
             {
                 totesDefinicions.setSelected(true);
             }
        }        
    }
    
    private void comprovaConflicteNotes() 
    {
        int indexNotes=getSelectedRadioButtonType(notesGroup);        
        if (indexNotes>0 && this.menuFrame.getNoteConflict())
        {
             int response = JOptionPane.showConfirmDialog(menuFrame, "Hi ha conflicte en el camp de notes. Desitja mantenir el criteri seleccionat?", "", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
             if (response == JOptionPane.YES_OPTION) 
             {
                // Hauriem d'esborrar el criteri de la pestanya de Valors. Necessitariem una referencia a l'objecte Valors
                 valorsMain.setNoteField("");
                 this.menuFrame.setNoteConflict(false);
             }
             else if (response == JOptionPane.NO_OPTION)
             {
                 totesNotes.setSelected(true);
             }
        }
    }

    public JRadioButton getTotesDefinitionsRadioButton() 
    {
        return this.totesDefinicions;
    }

    public JRadioButton getTotesNotesRadioButton() 
    {
        return this.totesNotes;
    }

    private void removeAllListeners(JRadioButton button) 
    {
        ChangeListener[] cls=button.getChangeListeners();

            for (int i=0;i<cls.length;++i)
            {
                if (((ChangeListener)cls[i]) instanceof ChangeListener)
                {
                    ambDefinicions.removeChangeListener(cls[i]);
                    System.out.println("Change Listener deleted. Id: "+cls[i].toString());                       
                }
            }
    }

    private ButtonModel getSelectedDefinicionsModel(int i) 
    {
        switch(i)
        {
            case 0: return totesDefinicions.getModel();
            case 1: return ambDefinicions.getModel();
            case 2: return senseDefinicions.getModel();            
        }   

        return null;
    }
    
    
    private ButtonModel getSelectedNotesModel(int i) 
    {
        switch(i)
        {
            case 0: return totesNotes.getModel();
            case 1: return ambNotes.getModel();
            case 2: return senseNotes.getModel();            
        }           
        
        return null;        
    }
    
    private ButtonModel getSelectedObservacionsModel(int i) 
    {
        switch(i)
        {
            case 0: return totesObs.getModel();
            case 1: return ambObs.getModel();
            case 2: return senseObs.getModel();            
        }                
        
        return null;
    }
    
}
