/*
 * ValorsMain.java
 *
 * Created on 21 de septiembre de 2007, 10:46
 */

package com.termcat.layout.terminologic.cerca;

import com.termcat.business.exceptions.HyerarchyException;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.layout.commons.search.SelectedList;
import com.termcat.util.literales.Literales;
import java.util.Vector;

/**
 *
 * @author  Mena
 */
public class JerarquiaMain extends FunctionalModule 
{
    private static JerarquiaMain jerarquiaMain=null;
    private Vector allJerarquies;
    
    public static synchronized JerarquiaMain getInstance(MainFrame menuFrame) throws HyerarchyException
    {
        if(jerarquiaMain!=null && (menuFrame.isJerarquiesModified()==false) )
            return jerarquiaMain;
        else
        {
            menuFrame.setJerarquiesModified(false);
            jerarquiaMain=new JerarquiaMain(menuFrame);
            return jerarquiaMain;                
        }
    } 
    
    public void destroy()
    {
          scrollPane.remove(list);
          list=new AssociateLists(allJerarquies,null,JERARQUIES_NO_ASSOCIATE_TITLE,JERARQUIES_ASSOCIATE_TITLE);
          scrollPane.setViewportView(list);
    }
    /** Creates new form ValorsMain */
    private JerarquiaMain(MainFrame menuFrame) throws HyerarchyException 
    {
        super(menuFrame);
        initComponents();

        try 
        {
            allJerarquies = HyerarchyManager.getManager().getAllCodeIdJerarquies();
            // Esborrem del vector l'objecte amb id=''. Com est ordenat per prioritat i el primer sempre es id='' 
            // esborrem l'objecte de la pos 0.
            allJerarquies.remove(0);
            
            if (menuFrame.getCercaObject()==null)            
                list=new AssociateLists(allJerarquies,null,JERARQUIES_NO_ASSOCIATE_TITLE,JERARQUIES_ASSOCIATE_TITLE);
            else
            {
                Vector selectedJerarquies=menuFrame.getCercaObject().getJerarquies().getSelectedList();
                Vector noAssociates=getNoAssociates(allJerarquies,selectedJerarquies);
                list=new AssociateLists(noAssociates,selectedJerarquies,JERARQUIES_NO_ASSOCIATE_TITLE,JERARQUIES_ASSOCIATE_TITLE);                

                // Indiquem el criteri de cerca
                noContainsRadioButton.setSelected(!menuFrame.getCercaObject().getJerarquies().getContains());                
            }
            scrollPane.setViewportView(list);

        } 
        catch (Exception ex) 
        {
            ex.printStackTrace();
            throw new HyerarchyException(ex.getMessage());
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        criteriJerarquia = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        scrollPane = new javax.swing.JScrollPane();
        jPanel3 = new javax.swing.JPanel();
        containsRadioButton = new javax.swing.JRadioButton();
        noContainsRadioButton = new javax.swing.JRadioButton();

        setMaximumSize(new java.awt.Dimension(805, 460));
        setMinimumSize(new java.awt.Dimension(805, 460));
        scrollPane.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout jPanel1Layout = new org.jdesktop.layout.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel1Layout.createSequentialGroup()
                .add(55, 55, 55)
                .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 586, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(45, Short.MAX_VALUE))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, jPanel1Layout.createSequentialGroup()
                .addContainerGap(23, Short.MAX_VALUE)
                .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 285, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Contingut_de_la_cerca")));
        criteriJerarquia.add(containsRadioButton);
        containsRadioButton.setSelected(true);
        containsRadioButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ContingutJerarquiesSelected"));
        containsRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        containsRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        criteriJerarquia.add(noContainsRadioButton);
        noContainsRadioButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoContingutJerarquiaSelected"));
        noContainsRadioButton.setBorder(javax.swing.BorderFactory.createEmptyBorder(0, 0, 0, 0));
        noContainsRadioButton.setMargin(new java.awt.Insets(0, 0, 0, 0));

        org.jdesktop.layout.GroupLayout jPanel3Layout = new org.jdesktop.layout.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .add(142, 142, 142)
                .add(jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(noContainsRadioButton)
                    .add(containsRadioButton))
                .addContainerGap(119, Short.MAX_VALUE))
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .add(containsRadioButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 15, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(noContainsRadioButton)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(63, 63, 63)
                        .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(layout.createSequentialGroup()
                        .add(135, 135, 135)
                        .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(56, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(jPanel1, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(jPanel3, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(36, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    SelectedList getJerarquiaCerca() 
    {
         SelectedList cercalist=new SelectedList();
                
         cercalist.setContains(getSelectedRadioButton(criteriJerarquia).equals(containsRadioButton));
         cercalist.setSelectedList(list.getSelectedList());
        
        return cercalist;       
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JRadioButton containsRadioButton;
    private javax.swing.ButtonGroup criteriJerarquia;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JRadioButton noContainsRadioButton;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables

    private final String JERARQUIES_NO_ASSOCIATE_TITLE=Literales.getTextForLiteral("NoAssociatedJer");
    private final String JERARQUIES_ASSOCIATE_TITLE=Literales.getTextForLiteral("AssociatedJer");
    
    private AssociateLists list;
}
