/*
 * DefinicionsAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.definicions;

import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DefinitionException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
//import com.termcat.layout.commons.rtf.HTML2Text;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.layout.commons.lists.AssociateLists;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la denominacio
 */
public class DefinicionsAlta extends com.termcat.layout.terminologic.fitxes.Fitxa
{
     private AssociateLists fontsList;
     
     private EditorRTF editorRTF; 
     //private HTML2Text html2Text;       
     
    /** Constructor. */
    public DefinicionsAlta(MainFrame menuFrame) 
    {
        super(menuFrame);
        initComponents();
        
        //html2Text=new HTML2Text();         
        this.editorRTF = new EditorRTF();
        this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setViewportView(editorRTF); 
        
        initCombos();
        initFonts();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        llenguaLabel = new javax.swing.JLabel();
        botonAlta = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        llenguaValue = new javax.swing.JComboBox();
        fontsScrollPane = new javax.swing.JScrollPane();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(670, 600));
        setMinimumSize(new java.awt.Dimension(670, 600));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AltaDefinicio")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 525));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 525));
        descripcioLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DefinicioLabel"));

        llenguaLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("LlenguaLabel"));

        botonAlta.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Alta"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        botonCancela.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        fontsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Fonts")));
        fontsScrollPane.setMaximumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setMinimumSize(new java.awt.Dimension(520, 300));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(23, 23, 23)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(descripcioLabel))
                    .add(llenguaLabel))
                .add(19, 19, 19)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(botonAlta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botonCancela)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED))
                    .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 818, Short.MAX_VALUE)
                    .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 629, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(10, 10, 10))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(llenguaLabel)
                    .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(21, 21, 21)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 255, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 300, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonCancela)
                    .add(botonAlta))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(44, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
       try{
           int llenguaSelectedIndex=llenguaValue.getSelectedIndex();
           String idLlengua=null,idJerarquia=null,idCategoria=null,idMarca=null,idFitxa=null;
           Vector fonts =new Vector();
           
           // Obtenim els resultats del formulari.
           ItemListCustom item=new ItemListCustom();
           item=(ItemListCustom)llenguaValue.getSelectedItem();
           String codiLlengua=item.getValue(); 
           idLlengua=item.getId();

           // Obtenim la definicio en format 'plain'
           //String descText=html2Text.convert(editorRTF.getRTFText());           
           String descText=editorRTF.getRTFPlainText();
           // Printem per pantalla
           System.out.println("CODI_LLENGUA:"+codiLlengua+" ID_LLENGUA"+idLlengua);          
           
           if (descText!=null && !descText.trim().equals(""))       
           {
               // Fem la inserci a BD.
               String idDefinicio=DefinitionManager.getManager().altaDefinicio(this.menuFrame.getIdCurrentDictionary(),this.menuFrame.getIdFitxa(),idLlengua,descText,editorRTF.getRTFText());
               FontManager.getManager().insertFontDefinicions(idDefinicio,fontsList.getSelectedList());

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Definiciones_AltaOk"));

               // actualitzem el flag de dirty en cas que no ho estigui ja
               if(!this.menuFrame.isCurrentFitxaDirty())
                   this.menuFrame.setCurrentFitxaDirty(true);           

               // Tanquem la finestra d'alta d'una nova llengua.
                this.menuFrame.closePanelPopup();
           }
           else
               menuFrame.showMessageInfo(Literales.getTextForMessage("Definicions_Empty"));

       }
       catch(Exception e){
            e.printStackTrace();
            tratarError(new DefinitionException(e.getMessage())); 
       }     
    }//GEN-LAST:event_botonAltaActionPerformed

    private void initCombos() 
    {
        try
        {
            String codiLlengua=null;

            Vector idLlenguesDiccionari=DictionaryManager.getManager().getLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary());
            // Creem un nou vector amb tots els codis de les llengues.
            Vector llenguesDiccionari=new Vector();
            for (int i=0;i<idLlenguesDiccionari.size();++i)
            {
                ItemListCustom item=(ItemListCustom)idLlenguesDiccionari.get(i);
                llenguesDiccionari.add(item);
            }
            llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(llenguesDiccionari));
            
           // En cas que no estiguin tots els elements necessaris per a donar l'alta, es deshabilita el bot.
            if (!this.menuFrame.isReady2Add())
                botonAlta.setEnabled(false);

        }
        catch(Exception e)
        {
            e.printStackTrace();
        }     
    }
    
    
    private void initFonts() 
    {
         try
        {
            Vector allFonts=menuFrame.allFontsUpdated;
            
            fontsList=new AssociateLists(allFonts,null,FONTS_NO_ASSOCIATE_TITLE,FONTS_ASSOCIATE_TITLE);
            fontsScrollPane.setViewportView(fontsList);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JButton botonCancela;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane fontsScrollPane;
    private javax.swing.JLabel llenguaLabel;
    private javax.swing.JComboBox llenguaValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
