/*
 * LlenguesAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.definicions;

import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DefinitionException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
//import com.termcat.layout.commons.rtf.HTML2Text;
import com.termcat.util.literales.Literales;
import java.awt.Component;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.lists.AssociateLists;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la definicio
 */
public class DefinicionsEdit extends com.termcat.layout.terminologic.fitxes.Fitxa
{
    private String idDefinicio;
    private DefinicionsMain definicionsMain;
    private AssociateLists fontsList;
    
    // Editor RTF
    private EditorRTF editorRTF; 
    //private HTML2Text html2Text;        
    
    // Vectors
    private Vector llenguesDiccionariVector;
    
    /** Constructor. */
    public DefinicionsEdit(MainFrame menuFrame, FunctionalModule functionalModule,String idDefinicio, ItemListCustom llengua,String definicio) 
    {
        super(menuFrame);
        int llenguaPos;
        // Variables
        ItemListCustom llenguaSelected=null, jerarquiaSelected=null, categoriaSelected=null,marcaSelected=null;
        try
        {
            this.editorRTF = new EditorRTF();
            // Inicialitzaci dels components i variables de la classe.
            initComponentsNoDesign();
            
            /**Llamada al metodo de codigo generado automaticamente por netbenas
             * reemplazado por el metodo initComponentsNoDesign que permite insertar directamente un objeto 
             *de tipo rtfEditor
            initComponents();
            this.scrollPane.setViewportView(editorRTF);               
            */
            this.idDefinicio=idDefinicio;
            this.definicionsMain=(DefinicionsMain)functionalModule;
            llenguesDiccionariVector=initVectorLlengues(this.menuFrame.getIdCurrentDictionary());
            initCombos();    
            initFonts();

            editorRTF.setRTFText(definicio);
            
            // Carreguem els combos amb els valors de la BD.
            llenguaPos=calculatePositionInVector(llenguesDiccionariVector,llengua.getId());
            llenguaValue.setSelectedIndex(llenguaPos);
            
            // Fem actiu el panel.
            setPanel(this);
        }
        catch (Exception e)
        {
            e.printStackTrace();
            tratarError(new DefinitionException(e.getMessage())); 
        }
    }
    
    /**
     *Deprecado se utiliza  initComponentsNoDesign 
     **/
    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        botonModifica = new javax.swing.JButton();
        llenguaLabel = new javax.swing.JLabel();
        botonCancela = new javax.swing.JButton();
        llenguaValue = new javax.swing.JComboBox();
        fontsScrollPane = new javax.swing.JScrollPane();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(670, 600));
        setMinimumSize(new java.awt.Dimension(670, 600));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EdicioDefinicio")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 525));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 525));
        descripcioLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DefinicioLabel"));

        botonModifica.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Desar"));
        botonModifica.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonModificaActionPerformed(evt);
            }
        });

        llenguaLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("LlenguaLabel"));

        botonCancela.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        fontsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Fonts")));
        fontsScrollPane.setMaximumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setMinimumSize(new java.awt.Dimension(520, 300));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(botonModifica, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botonCancela))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(llenguaLabel)
                            .add(descripcioLabel))
                        .add(43, 43, 43)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 580, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 795, Short.MAX_VALUE))))
                .addContainerGap())
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(llenguaLabel)
                    .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 254, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 299, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(55, 55, 55))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(botonCancela)
                            .add(botonModifica))
                        .addContainerGap())))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(22, 22, 22)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(46, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonModificaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonModificaActionPerformed
       try
       {
           int llenguaSelectedIndex=llenguaValue.getSelectedIndex();
           String idLlengua=null,idJerarquia=null,idCategoria=null,idMarca=null,idFitxa=null;
           Vector fonts =new Vector();
           
           // Obtenim els resultats del formulari.
           ItemListCustom item=new ItemListCustom();
           item=(ItemListCustom)llenguaValue.getSelectedItem();
           String codiLlengua=item.getValue(); 
           idLlengua=item.getId();

           //String descText=html2Text.convert(editorRTF.getRTFText());
           String descText=editorRTF.getRTFPlainText();
           // Printem per pantalla
           System.out.println("CODI_LLENGUA:"+codiLlengua+" ID_LLENGUA"+idLlengua);
           
           if (descText!=null && !descText.trim().equals(""))
           {
               // Fem la inserci a BD.
               DefinitionManager.getManager().updateDefinicio(this.idDefinicio,idLlengua,descText,editorRTF.getRTFText());
               FontManager.getManager().deleteFontDefinicions(idDefinicio);
               FontManager.getManager().insertFontDefinicions(idDefinicio,fontsList.getSelectedList());

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Definiciones_UpdateOk"));

               // actualitzem el flag de dirty en cas que no ho estigui ja
               if(!this.menuFrame.isCurrentFitxaDirty())
                   this.menuFrame.setCurrentFitxaDirty(true);           

               // Tanquem la finestra d'alta d'una nova denominaci i fem el refresh de la taula amb els continguts.
                this.menuFrame.closePanelPopup();           
                this.definicionsMain.refresh(); 
           }
           else
               menuFrame.showMessageInfo(Literales.getTextForMessage("Definicions_Empty"));


       }
       catch(Exception e)
       {
           e.printStackTrace();
            tratarError(new DefinitionException(e.getMessage())); 
       }     
    }//GEN-LAST:event_botonModificaActionPerformed

    /*
     *
     */
    private void initCombos() 
    {
        try
        {
            String codiLlengua=null;          
            Vector idLlenguesDiccionari=DictionaryManager.getManager().getLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary());
            // Creem un nou vector amb tots els codis de les llengues.
            Vector llenguesDiccionari=new Vector();
            for (int i=0;i<idLlenguesDiccionari.size();++i)
            {
                ItemListCustom item=(ItemListCustom)idLlenguesDiccionari.get(i);
                llenguesDiccionari.add(item);
            }
            llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(llenguesDiccionari));
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }     
    }
    
    private void initFonts() 
    {
        try
        {
            Vector allFonts=menuFrame.allFontsUpdated;
            Vector associates=FontManager.getManager().getFontsDefinicions(idDefinicio);
            Vector noAssociates=getNoAssociates(allFonts,associates);
            
            fontsList=new AssociateLists(noAssociates,associates,FONTS_NO_ASSOCIATE_TITLE,FONTS_ASSOCIATE_TITLE);
            fontsScrollPane.setViewportView(fontsList);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonModifica;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane fontsScrollPane;
    private javax.swing.JLabel llenguaLabel;
    private javax.swing.JComboBox llenguaValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
 
    
   /**
    *Metodo copipateado del metodo generado automaticamente initComponents
    *donde se sustituye scrollPane directamente por editorRtf. 
    *Si se modificara el disenyo habria que volver copipastar aqui para plasmarlo 
    **/ 
   private void initComponentsNoDesign() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        botonModifica = new javax.swing.JButton();
        llenguaLabel = new javax.swing.JLabel();
        botonCancela = new javax.swing.JButton();
        llenguaValue = new javax.swing.JComboBox();
        fontsScrollPane = new javax.swing.JScrollPane();


        setMaximumSize(new java.awt.Dimension(670, 600));
        setMinimumSize(new java.awt.Dimension(670, 600));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EdicioDefinicio")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 525));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 525));
        descripcioLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("DefinicioLabel"));

        botonModifica.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Desar"));
        botonModifica.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonModificaActionPerformed(evt);
            }
        });

        llenguaLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("LlenguaLabel"));

        botonCancela.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        fontsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Fonts")));
        fontsScrollPane.setMaximumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setMinimumSize(new java.awt.Dimension(520, 300));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(botonModifica, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(botonCancela))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(llenguaLabel)
                            .add(descripcioLabel))
                        .add(43, 43, 43)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 580, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(editorRTF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 795, Short.MAX_VALUE))))
                .addContainerGap())
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(llenguaLabel)
                    .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(editorRTF, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 254, Short.MAX_VALUE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 299, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(55, 55, 55))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(botonCancela)
                            .add(botonModifica))
                        .addContainerGap())))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(22, 22, 22)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(46, Short.MAX_VALUE))
        );
    }// </editor-fold>          
    
}
