/*
 * LlenguesMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.definicions;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DefinitionException;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.terminologic.fitxes.Fitxa;
import com.termcat.util.literales.Literales;
import java.util.List;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.bd.beans.Definicions;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.mark.MarkManager;
import java.sql.Connection;
/**
 *
 * @author  Vazquezl
 */
public class DefinicionsMain extends FunctionalModule {
    
    private JTable tablaDefiniciones; 
    private DefaultTableModel model;   
    
    // Constants
    public  final static String EDIT_DEFINICIO=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Editar_definicio");
    public  final static String DELETE_DEFINICIO=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Eliminar_definicio");
    
    private static DefinicionsMain _definicionsMain=null;
    
    
   private static synchronized DefinicionsMain getInstance(MainFrame menuFrame){
        
        if(_definicionsMain!=null){
            return _definicionsMain;
        }
        else
        {
            _definicionsMain=new DefinicionsMain(menuFrame);
            return _definicionsMain;
        }
    }
    
    /** segundo constructor */
    public DefinicionsMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        initComponents();                              
        refresh();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(944, 373));
        setMinimumSize(new java.awt.Dimension(944, 373));
        panelIntern.setMaximumSize(new java.awt.Dimension(944, 373));
        panelIntern.setMinimumSize(new java.awt.Dimension(944, 373));
        botonAlta.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Nova_Definicio"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 14));
        tituloTabla.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("LlistatDefinicionsExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 923, Short.MAX_VALUE)
                            .add(tituloTabla))
                        .addContainerGap())
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(botonAlta)
                        .add(22, 22, 22))))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(tituloTabla)
                .add(15, 15, 15)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 263, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(botonAlta)
                .addContainerGap(37, Short.MAX_VALUE))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 943, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(63, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 372, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(71, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaDefinicionsActionPerformed();
      refresh();
    }//GEN-LAST:event_botonAltaActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        final String[] names = {"ID",Literales.getTextForLiteral("Cabecera_Lengua"),Literales.getTextForLiteral("Cabecera_Definicio")};
        final Object[][] data =null;
                
        this.model=new DefaultTableModel(data,names);
        this.tablaDefiniciones= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
        
        // Amagar la columna de la 'vista'.
        this.tablaDefiniciones.getColumnModel().removeColumn(this.tablaDefiniciones.getColumnModel().getColumn(0));
               
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(this.tablaDefiniciones);
        
        java.sql.Connection ct=DBConnect.getConnectionTransactional();
        java.sql.Connection c=DBConnect.getConnection();
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova llengua.  
     *
     */
    private void altaDefinicionsActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new DefinicionsAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Treball_terminologic"), 1000,740,0,0);
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh()
    {
        String idDefinicio=null,codiLlengua=null, nomDefinicio=null,idLlengua=null;
        ItemListCustom itemLlengua=null;
        try
        {
            // Inicializem els components: taula i model --> Es creen cada vegada... Massa objectes!!! Mirar de buidar les que existeixen.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            List allDefinicions=DefinitionManager.getManager().getAllDefinitionsOfFitxa(this.menuFrame.getIdFitxa());
            PopupMenuTable definicionsPopupTable=new PopupMenuTable(this.tablaDefiniciones,this,new EditorDefinicio(menuFrame),EDIT_DEFINICIO,DELETE_DEFINICIO);    
            if (allDefinicions.size()==0)
            {
                model.addRow(new Object[] {null,null, null});  
                definicionsPopupTable.disableMenuItems();
            }
            else
            {
                Iterator allDefinicionsIt=allDefinicions.iterator();                   
                while(allDefinicionsIt.hasNext())
                {
                    Definicions definicio=(Definicions)allDefinicionsIt.next();

                    // Obtenim els valors dels codis de cadascuna de les columnes que volem visualitzar a la taula.
                    idDefinicio=definicio.getIdDefinicio();
                    nomDefinicio=definicio.getDefinicionNormal();

                    // Obtenim els ids dels objectes
                    idLlengua=definicio.getIdLlengua();

                    // Obtenim els codis en funcio del Id de cadascun dels objectes
                    codiLlengua=LanguageManager.getManager().getCodiLlengua(idLlengua);

                    // Creem els itemsListCustom per a poder carregar despres desde el Edit els valors del combo correctament.
                    itemLlengua=new ItemListCustom(idLlengua, codiLlengua);

                    // Afegim els valors a la taula
                    this.model.addRow(new Object[] {idDefinicio,itemLlengua,nomDefinicio});
                }  
            }
            // Associem el listener de l'event del ratol a la taula creada.
            this.tablaDefiniciones.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(definicionsPopupTable));
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DefinitionException(e.getMessage())); 
        }
    }
}
