/*
 * LlenguesAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.denominacions;

import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DenominationException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.lists.AssociateLists;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la denominacio
 */
public class DenominacionsAlta extends com.termcat.layout.terminologic.fitxes.Fitxa
{
    private AssociateLists fontsList;

    private EditorRTF editorRTF; 
    
    /** Constructor. */
    public DenominacionsAlta(MainFrame menuFrame) 
    {
        super(menuFrame);

        initComponents();
        this.editorRTF = new EditorRTF();
        this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setViewportView(editorRTF); 
         
        initCombos();
        initFonts();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        llenguaLabel = new javax.swing.JLabel();
        botonAlta = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        llenguaValue = new javax.swing.JComboBox();
        jerarquiaLabel = new javax.swing.JLabel();
        jerarquiaValue = new javax.swing.JComboBox();
        categoriaLabel = new javax.swing.JLabel();
        categoriaValue = new javax.swing.JComboBox();
        marcaLabel = new javax.swing.JLabel();
        marcaValue = new javax.swing.JComboBox();
        fontsScrollPane = new javax.swing.JScrollPane();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(670, 700));
        setMinimumSize(new java.awt.Dimension(670, 700));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("AltaDenominacio")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 660));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 660));
        descripcioLabel.setText(Literales.getTextForLiteral("DenominacioLabel"));

        llenguaLabel.setText(Literales.getTextForLiteral("LlenguaLabel"));

        botonAlta.setText(Literales.getTextForLiteral("BotonAlta"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jerarquiaLabel.setText(Literales.getTextForLiteral("MarqiuesLabel"));

        jerarquiaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        categoriaLabel.setText(Literales.getTextForLiteral("CategoriaLabel"));

        categoriaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        marcaLabel.setText(Literales.getTextForLiteral("JerarquiaLabel"));

        marcaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        fontsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("Fonts")));
        fontsScrollPane.setMaximumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setMinimumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("Fonts"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(categoriaLabel)
                            .add(jerarquiaLabel)
                            .add(descripcioLabel)
                            .add(llenguaLabel)
                            .add(marcaLabel))
                        .add(69, 69, 69)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(marcaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(jerarquiaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(categoriaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 366, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(381, 381, 381)
                        .add(botonAlta, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(21, 21, 21)
                        .add(botonCancela))
                    .add(panelInternLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 565, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(33, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(llenguaLabel)
                            .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(58, 58, 58)
                        .add(descripcioLabel)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jerarquiaLabel)
                    .add(panelInternLayout.createSequentialGroup()
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(marcaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(categoriaLabel)
                    .add(categoriaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(marcaLabel)
                    .add(jerarquiaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 16, Short.MAX_VALUE)
                .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 338, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(15, 15, 15)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonAlta)
                    .add(botonCancela))
                .addContainerGap())
        );
        panelIntern.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("AltaDenominacio"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(54, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 656, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(45, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
        altaDenominacio();
    }//GEN-LAST:event_botonAltaActionPerformed

    private void initCombos() 
    {
        try
        {
            String codiLlengua=null;

            Vector jerarquiaVector=new Vector();
            Vector marcaVector=new Vector();

            Vector idLlenguesDiccionari=DictionaryManager.getManager().getLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary());
            // Creem un nou vector amb tots els codis de les llengues.
            Vector llenguesDiccionari=new Vector();
            
            for (int i=0;i<idLlenguesDiccionari.size();++i)
            {
                ItemListCustom item=(ItemListCustom)idLlenguesDiccionari.get(i);
                llenguesDiccionari.add(item);
            }
            llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(llenguesDiccionari));

            // Categories Combo
            categoriaValue.setModel(new javax.swing.DefaultComboBoxModel(CategoryManager.getManager().getAllCodeIdCategories()));
            
            
            // Jerarquies combo.
            jerarquiaVector=HyerarchyManager.getManager().getAllCodeIdJerarquies();
            jerarquiaValue.setModel(new javax.swing.DefaultComboBoxModel(jerarquiaVector));
            
            // Marques de ponderaci combo.
            marcaVector=MarkManager.getManager().getAllCodeIdMarques();
            marcaValue.setModel(new javax.swing.DefaultComboBoxModel(marcaVector));

            // En cas que no estiguin tots els elements necessaris per a donar l'alta, es deshabilita el bot.
            if (!this.menuFrame.isReady2Add())
                botonAlta.setEnabled(false);                
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }     
    }

    private void initFonts() 
    {
         try
        {
            Vector allFonts=menuFrame.allFontsUpdated;           
            fontsList=new AssociateLists(allFonts,null,FONTS_NO_ASSOCIATE_TITLE,FONTS_ASSOCIATE_TITLE);
            fontsScrollPane.setViewportView(fontsList);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }

    private void altaDenominacio() 
    {
       try
       {
           int llenguaSelectedIndex=llenguaValue.getSelectedIndex();
           String idLlengua=null,idJerarquia=null,idCategoria=null,idMarca=null,idFitxa=null;
           Vector fonts =new Vector();
           
           // Obtenim els resultats del formulari.
           ItemListCustom item=new ItemListCustom();
           item=(ItemListCustom)llenguaValue.getSelectedItem();
           String codiLlengua=item.getValue(); 
           idLlengua=item.getId();
           
           item=(ItemListCustom)jerarquiaValue.getSelectedItem();
           String codiJerarquia=item.getValue();
           idJerarquia=item.getId();      
           
           item=(ItemListCustom)categoriaValue.getSelectedItem();          
           String categoriaValue=item.getValue();
           idCategoria=item.getId();
           
           item=(ItemListCustom)marcaValue.getSelectedItem();
           String marcaValue=item.getValue();
           idMarca=item.getId();

           // Obtenim la denominacio en format 'plain'           
           String descText=editorRTF.getRTFPlainText();

           // Printem per pantalla
           System.out.println("CODI_LLENGUA:"+codiLlengua+" ID_LLENGUA"+idLlengua);
           
           if (descText!=null && !descText.trim().equals(""))
           {
               // Fem la inserci a BD.
               String idDenominacio=DenominationManager.getManager().altaDenominacio(this.menuFrame.getIdCurrentDictionary(),this.menuFrame.getIdFitxa(),idLlengua,descText,editorRTF.getRTFText(),idJerarquia,idCategoria,idMarca);
               FontManager.getManager().insertFontDenominacions(idDenominacio,fontsList.getSelectedList());

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Denominaciones_AltaOk"));

               // actualitzem el flag de dirty en cas que no ho estigui ja
               if(!this.menuFrame.isCurrentFitxaDirty())
                   this.menuFrame.setCurrentFitxaDirty(true);           

               // Tanquem la finestra d'alta d'una nova llengua.
                this.menuFrame.closePanelPopup();
           }
           else
               menuFrame.showMessageInfo(Literales.getTextForMessage("Denominacions_Empty"));

       }
       catch(Exception e)
       {
           e.printStackTrace();
           tratarError(new DenominationException(e.getMessage())); 
       }    
    }
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JButton botonCancela;
    private javax.swing.JLabel categoriaLabel;
    private javax.swing.JComboBox categoriaValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane fontsScrollPane;
    private javax.swing.JLabel jerarquiaLabel;
    private javax.swing.JComboBox jerarquiaValue;
    private javax.swing.JLabel llenguaLabel;
    private javax.swing.JComboBox llenguaValue;
    private javax.swing.JLabel marcaLabel;
    private javax.swing.JComboBox marcaValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
