/*
 * LlenguesAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.denominacions;

import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DenominationException;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.maintenance.mark.MarkManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
import com.termcat.util.literales.Literales;
import java.awt.Component;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.lists.AssociateLists;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la denominacio
 */
public class DenominacionsEdit extends com.termcat.layout.terminologic.fitxes.Fitxa
{
    private String idDenominacio;
    private DenominacionsMain denominacionsMain;
    private AssociateLists fontsList;
    
    // Vectors
    private Vector llenguesDiccionariVector;
    private Vector jerarquiaVector;
    private Vector marcaVector;
    private Vector categoriaVector;
    
    private EditorRTF editorRTF; 

    /** Constructor. */
   
    //public DenominacionsEdit(MainFrame menuFrame, FunctionalModule functionalModule,String idDenominacio, String llengua,String denominacio,String jerarquia,String categoria, String marca) 
    public DenominacionsEdit(MainFrame menuFrame, FunctionalModule functionalModule, String idDenominacio, ItemListCustom llengua,String denominacio,ItemListCustom jerarquia,ItemListCustom categoria, ItemListCustom marca) 
    {
        super(menuFrame);

        // Variables
        int llenguaPos, jerarquiaPos, categoriaPos=0,marcaPos;
        try
        {
            initComponents();
            
            this.editorRTF = new EditorRTF();
            this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
            this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
            this.scrollPane.setViewportView(editorRTF);            
            
            this.idDenominacio=idDenominacio;
            this.denominacionsMain=(DenominacionsMain)functionalModule;
            llenguesDiccionariVector=initVectorLlengues(this.menuFrame.getIdCurrentDictionary());
            initVectors();
            initCombos();    
            initFonts();
                      
            // Calculem les posicions dels ids
            try
            {
                llenguaPos=calculatePositionInVector(llenguesDiccionariVector,llengua.getId());                      
                llenguaValue.setSelectedIndex(llenguaPos);                
            }
            catch(Exception e){}
            
            try
            {
                if (categoria!=null || categoria.getId()==null || categoria.getId().equals(""))
                    categoriaPos=calculatePositionInVector(categoriaVector,categoria.getId());   
                // Carreguem el combos amb el valor                
                categoriaValue.setSelectedIndex(categoriaPos);
            }
            catch(Exception e){}
            
            try
            {
                if (jerarquia.getId()==null || jerarquia.getId().equals(""))
                    jerarquiaPos=calculatePositionInVector(jerarquiaVector,"");
                else
                    jerarquiaPos=calculatePositionInVector(jerarquiaVector,jerarquia.getId());
                // Carreguem el combos amb el valor                
                jerarquiaValue.setSelectedIndex(jerarquiaPos);
            }
            catch(Exception e){}
            try
            {
                if (marca.getId()==null || marca.getId().equals(""))
                    marcaPos=calculatePositionInVector(marcaVector,"");
                else            
                    marcaPos=calculatePositionInVector(marcaVector,marca.getId());              
                // Carreguem el combos amb el valor
                marcaValue.setSelectedIndex(marcaPos);            
            }
            catch(Exception e){}
                                    
            editorRTF.setRTFText(denominacio);
            setPanel(this);
        }
        catch (Exception e)
        {
            e.printStackTrace();
           tratarError(new DenominationException(e.getMessage())); 
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        llenguaLabel = new javax.swing.JLabel();
        botonModifica = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        llenguaValue = new javax.swing.JComboBox();
        jerarquiaLabel = new javax.swing.JLabel();
        jerarquiaValue = new javax.swing.JComboBox();
        categoriaLabel = new javax.swing.JLabel();
        categoriaValue = new javax.swing.JComboBox();
        marcaLabel = new javax.swing.JLabel();
        marcaValue = new javax.swing.JComboBox();
        fontsScrollPane = new javax.swing.JScrollPane();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(670, 700));
        setMinimumSize(new java.awt.Dimension(670, 700));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("EdicioDenominacio")));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 660));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 660));
        descripcioLabel.setText(Literales.getTextForLiteral("DenominacioLabel"));

        llenguaLabel.setText(Literales.getTextForLiteral("LlenguaLabel"));

        botonModifica.setText(Literales.getTextForLiteral("Aplicar"));
        botonModifica.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonModificaActionPerformed(evt);
            }
        });

        botonCancela.setText(Literales.getTextForLiteral("BotonCancelar"));
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        jerarquiaLabel.setText(Literales.getTextForLiteral("MarqiuesLabel"));

        jerarquiaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        categoriaLabel.setText(Literales.getTextForLiteral("CategoriaLabel"));

        categoriaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        marcaLabel.setText(Literales.getTextForLiteral("JerarquiaLabel"));

        marcaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        fontsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("Fonts")));
        fontsScrollPane.setMaximumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setMinimumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setPreferredSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("Fonts"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(descripcioLabel)
                            .add(jerarquiaLabel)
                            .add(categoriaLabel)
                            .add(marcaLabel)
                            .add(llenguaLabel))
                        .add(43, 43, 43)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                .add(marcaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(categoriaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                                    .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 407, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                    .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)))
                            .add(jerarquiaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(44, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                        .add(botonModifica, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .add(42, 42, 42)
                        .add(botonCancela)
                        .add(48, 48, 48))
                    .add(panelInternLayout.createSequentialGroup()
                        .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 588, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(llenguaLabel))
                .add(10, 10, 10)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 100, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(jerarquiaLabel)
                    .add(marcaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(categoriaLabel)
                    .add(categoriaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(marcaLabel)
                    .add(jerarquiaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(8, 8, 8)
                .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 335, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonModifica)
                    .add(botonCancela))
                .add(45, 45, 45))
        );
        panelIntern.getAccessibleContext().setAccessibleName(Literales.getTextForLiteral("EdicioDenominacio"));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(44, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 657, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(47, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonModificaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonModificaActionPerformed
       try
       {
           int llenguaSelectedIndex=llenguaValue.getSelectedIndex();
           String idLlengua=null,idJerarquia=null,idCategoria=null,idMarca=null,idFitxa=null;
           Vector fonts =new Vector();
           
           // Obtenim els resultats del formulari.
           ItemListCustom item=new ItemListCustom();
           item=(ItemListCustom)llenguaValue.getSelectedItem();
           String codiLlengua=item.getValue(); 
           idLlengua=item.getId();
           
           item=(ItemListCustom)jerarquiaValue.getSelectedItem();
           String codiJerarquia=item.getValue();
           idJerarquia=item.getId();
           
           item=(ItemListCustom)categoriaValue.getSelectedItem();          
           String categoriaValue=item.getValue();
           idCategoria=item.getId();
           
           item=(ItemListCustom)marcaValue.getSelectedItem();
           String marcaValue=item.getValue();
           idMarca=item.getId();

           String descText=editorRTF.getRTFPlainText();
           // Printem per pantalla
           System.out.println("CODI_LLENGUA:"+codiLlengua+" ID_LLENGUA"+idLlengua);
           
           if (descText!=null && !descText.trim().equals(""))
           {
               // Fem la inserci a BD.
               DenominationManager.getManager().updateDenominacio(this.idDenominacio,idLlengua,descText,editorRTF.getRTFText(),idJerarquia,idCategoria,idMarca);
               FontManager.getManager().deleteFontDenominacions(idDenominacio);
               FontManager.getManager().insertFontDenominacions(idDenominacio,fontsList.getSelectedList());

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Denominaciones_UpdateOk"));

               // actualitzem el flag de dirty en cas que no ho estigui ja
               if(!this.menuFrame.isCurrentFitxaDirty())
                   this.menuFrame.setCurrentFitxaDirty(true);           

                // Tanquem la finestra d'alta d'una nova denominaci.
                this.menuFrame.closePanelPopup();

                this.denominacionsMain.refresh(); 
           }
           else
               menuFrame.showMessageInfo(Literales.getTextForMessage("Denominacions_Empty"));
       }
       catch(Exception e){
           e.printStackTrace();
           tratarError(new DenominationException(e.getMessage())); 
       }     
    }//GEN-LAST:event_botonModificaActionPerformed

   
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonModifica;
    private javax.swing.JLabel categoriaLabel;
    private javax.swing.JComboBox categoriaValue;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane fontsScrollPane;
    private javax.swing.JLabel jerarquiaLabel;
    private javax.swing.JComboBox jerarquiaValue;
    private javax.swing.JLabel llenguaLabel;
    private javax.swing.JComboBox llenguaValue;
    private javax.swing.JLabel marcaLabel;
    private javax.swing.JComboBox marcaValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables

    
    // -------------------------------------------------------------------------------------
    //          MTODES ENCARREGATS DE LES INICIALITZACIONS DE COMPONENTS.
    // -------------------------------------------------------------------------------------    
    /*
     *       Inicialitzem els vectors de jerarquies, categories i marques amb els continguts de la BD.
     */     
    private void initVectors()
    {
        try 
        {      
           jerarquiaVector=new Vector();
           categoriaVector=new Vector();
           marcaVector=new Vector();
       
            // Categories Combo
            categoriaVector=CategoryManager.getManager().getAllCodeIdCategories();    
                       
            // Jerarquies combo.
            jerarquiaVector=HyerarchyManager.getManager().getAllCodeIdJerarquies();
            //jerarquiaVector.add(item);            
            
            // Marques de ponderaci combo.
            marcaVector=MarkManager.getManager().getAllCodeIdMarques();
            //marcaVector.add(item);                      
       }
       catch (Exception e) 
       {
            e.printStackTrace();
            tratarError(new DenominationException(e.getMessage()));
       }
    }
    
    /*
     *       Mtode encarregat de la inicialitzaci dels combos.
     */
     private void initCombos() 
    {
        try
        {
            String codiLlengua=null;          

            llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(llenguesDiccionariVector));
            jerarquiaValue.setModel(new javax.swing.DefaultComboBoxModel(jerarquiaVector));
            categoriaValue.setModel(new javax.swing.DefaultComboBoxModel(categoriaVector));
            marcaValue.setModel(new javax.swing.DefaultComboBoxModel(marcaVector));            
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DenominationException(e.getMessage()));
        }     
    }
     
    /*
     *       Mtode encarregat de la inicialitzaci de les fonts. 
     *
     */    
    private void initFonts() 
    {

        try
        {
            Vector allFonts=menuFrame.allFontsUpdated;
                           
            Vector associates=FontManager.getManager().getFontsDenominacions(idDenominacio);

            // Calculem les fonts no associades en funcio de totes les fonts que hi ha i de les que te associades.
            Vector noAssociates=getNoAssociates(allFonts,associates);
            
            // Creem les llistes amb les fonts no associades i associades i ho fem visible.
            fontsList=new AssociateLists(noAssociates,associates,FONTS_NO_ASSOCIATE_TITLE,FONTS_ASSOCIATE_TITLE);
            fontsScrollPane.setViewportView(fontsList);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DenominationException(e.getMessage()));
        }

    }
}
