/*
 * DenominacionsMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.denominacions;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DenominationException;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.terminologic.fitxes.Fitxa;
import com.termcat.layout.terminologic.fitxes.FitxesAlta;
import com.termcat.layout.terminologic.fitxes.FitxesEdit;
import com.termcat.layout.terminologic.fitxes.FitxesMain;
import com.termcat.util.literales.Literales;
import java.util.List;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.JButton;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.bd.beans.Denominacions;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.business.maintenance.hyerarchy.HyerarchyManager;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.mark.MarkManager;
import java.sql.Connection;


public class DenominacionsMain extends FunctionalModule 
{
    
    private JTable tablaDenominaciones; 
    private DefaultTableModel model;   
    
    private JButton aplicar,acceptar,left,right;
    // Constants
    public final static String EDIT_DENOMINACIO=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Editar_denominacio");
    public final static String DELETE_DENOMINACIO=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Eliminar_denominacio");
    
    private boolean isEdit=false;
    private int row;
    
    private FitxesMain fitxesMain;
    /** segundo constructor */
    
    //  Necessitem el tipus perque sino desde aqui no tenim manera de saber en quina opcio
    // Alta / Edit ens trobem.
    public DenominacionsMain(MainFrame menuFrame, FunctionalModule module, boolean isEdit, int row, FitxesMain fitxesMain)
    {     
        super(menuFrame);
        
               
        initComponents();                              
        this.isEdit=isEdit;   
        this.row=row;          
        this.fitxesMain=fitxesMain;
            
        if (isEdit)
        {
            this.aplicar=((FitxesEdit) module).getAplicarButton();
            this.acceptar=((FitxesEdit) module).getAcceptarButton();
            this.left=((FitxesEdit) module).getLeftButton();
            this.right=((FitxesEdit) module).getRightButton();
        }
        else
        {
           this.aplicar=((FitxesAlta) module).getAplicarButton();
           this.acceptar=((FitxesAlta) module).getAcceptarButton();                
        }
                      
        refresh();
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();
        textInfo = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(944, 373));
        setMinimumSize(new java.awt.Dimension(944, 373));
        panelIntern.setMaximumSize(new java.awt.Dimension(944, 373));
        panelIntern.setMinimumSize(new java.awt.Dimension(944, 373));
        botonAlta.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Nova_Denominacio"));
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 14));
        tituloTabla.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("LlistatDenominacioExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        textInfo.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 2, 12));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 923, Short.MAX_VALUE)
                            .add(tituloTabla))
                        .addContainerGap())
                    .add(panelInternLayout.createSequentialGroup()
                        .add(textInfo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 468, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 324, Short.MAX_VALUE)
                        .add(botonAlta)
                        .add(20, 20, 20))))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(tituloTabla)
                .add(15, 15, 15)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 263, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(textInfo, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 20, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(botonAlta))
                .add(32, 32, 32))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 943, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 372, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(71, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      altaDenominacionsActionPerformed();
      refresh();
    }//GEN-LAST:event_botonAltaActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel textInfo;
    private javax.swing.JLabel tituloTabla;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    private void initCustomComponents()
    {  
        
        final String[] names = {"ID",Literales.getTextForLiteral("Cabecera_Lengua"),Literales.getTextForLiteral("Cabecera_Marcas"),Literales.getTextForLiteral("Cabecera_Denominacion"),Literales.getTextForLiteral("Cabecera_Categoria"),Literales.getTextForLiteral("Cabecera_Jerarquia")};
        final Object[][] data =null;
                
        this.model=new DefaultTableModel(data,names);
        this.tablaDenominaciones= new JTable(model)
        {
            public boolean isCellEditable(int row, int column)
            {
                    return false;
            }
        };    
        
        // Amagar la columna de la 'vista'.
        this.tablaDenominaciones.getColumnModel().removeColumn(this.tablaDenominaciones.getColumnModel().getColumn(0));
               
        // insertar la table al frame mitjanant un scroll panel.
        scrollPaneTabla.setViewportView(this.tablaDenominaciones);
        
        java.sql.Connection ct=DBConnect.getConnectionTransactional();
    }
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova llengua.  
     */
    private void altaDenominacionsActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new DenominacionsAlta(this.menuFrame);
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Treball_terminologic"),670,720,0,0);
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setPanelPopup(popupPanel);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();
    }
    
    /*
     *  Mtode encarregat de refrescar la llista amb les llengues disponibles a la BD.
     */
    public void refresh()
    {
        String idDenominacio=null,codiLlengua=null, nomDenominacio=null,codiJerarquia=null,codiCategoria=null,codiMarca=null;
        String idLlengua=null,idJerarquia=null,idCategoria=null,idMarca=null;
        ItemListCustom itemLlengua=null,itemJerarquia=null,itemCategoria=null,itemMarca=null;
        
        boolean leftArrow=false;
        boolean rightArrow=false;
        
        try
        {
            // Inicializem els components: taula i model --> Es creen cada vegada... Massa objectes!!! Mirar de buidar les que existeixen.
            initCustomComponents();
            
            // Accedim a la BD per a recuperar els valors.
            List allDenominacions=DenominationManager.getManager().getAllDenominationsOfFitxa(this.menuFrame.getIdFitxa());
            
            // Actualitzem el boolea que cont si est definida la denominaci.
            boolean isDenoDefined=(allDenominacions.size()!=0) && (allDenominacions.size()>0);
            PopupMenuTable denominacionsPopupTable=new PopupMenuTable(this.tablaDenominaciones,this,new EditorDenominacio(menuFrame),EDIT_DENOMINACIO,DELETE_DENOMINACIO);                
            
            if (!isDenoDefined)
            {    
                textInfo.setText(Literales.getTextForMessage("Denominacions_Necessari1"));
                this.acceptar.setEnabled(false);
                this.aplicar.setEnabled(false);
                if (isEdit)
                {
                    this.left.setEnabled(false);
                    this.right.setEnabled(false);
                }                
                
                this.model.addRow(new Object[] {null,null,null,null,null,null});                
                denominacionsPopupTable.disableMenuItems();
            }
            else
            {
                textInfo.setText("");
                this.acceptar.setEnabled(true);
                this.aplicar.setEnabled(true);
                if (isEdit)
                {
                    if (row==0 && this.menuFrame.getCurrentPage()==0)
                        leftArrow=true;
                    if (row==this.fitxesMain.MAX_TABLE_FITXES_ROW-1 && this.fitxesMain.isLastPage)
                        rightArrow=true;                                
                    
                    if (leftArrow && rightArrow)
                    {
                        this.left.setEnabled(false);    
                        this.right.setEnabled(false);
                    }
                    else if (!leftArrow && rightArrow)
                    {
                        this.left.setEnabled(true);    
                        this.right.setEnabled(false);                        
                    }
                    else if (leftArrow && !rightArrow)                        
                    {
                        this.left.setEnabled(false);    
                        this.right.setEnabled(true);
                    }
                    else
                    {
                        this.left.setEnabled(true);
                        this.right.setEnabled(true);
                    }
                }
       
                Iterator allDenominacionsIt=allDenominacions.iterator();                       
                while(allDenominacionsIt.hasNext())
                {
                    Denominacions denominacio=(Denominacions)allDenominacionsIt.next();

                    // Obtenim els valors dels codis de cadascuna de les columnes que volem visualitzar a la taula.
                    idDenominacio=denominacio.getIdDenominacio();
                    nomDenominacio=denominacio.getTermeNormal();

                    // Obtenim els ids dels objectes
                    idLlengua=denominacio.getIdLlengua();
                    idJerarquia=denominacio.getIdJerarquia();
                    idCategoria=denominacio.getIdCategoria();                       
                    idMarca=denominacio.getIdMarca();                        

                    // Obtenim els codis en funcio del Id de cadascun dels objectes
                    codiLlengua=LanguageManager.getManager().getCodiLlengua(idLlengua);
                    if (idCategoria!=null)
                        codiCategoria=CategoryManager.getManager().getCodiCategoria(idCategoria);                        
                    else
                        codiCategoria=null;
                    
                    // Fem la comprovaci de que no tant el idJerarquia com idMarca no sigui null
                    if (idJerarquia!=null)
                        codiJerarquia=HyerarchyManager.getManager().getCodiJerarquia(idJerarquia);
                    else
                        codiJerarquia=null;
                    
                    if (idMarca!=null)
                        codiMarca=MarkManager.getManager().getCodiMarca(idMarca);
                    else
                        codiMarca=null;

                    // Creem els itemsListCustom per a poder carregar despres desde el Edit els valors del combo correctament.
                    itemLlengua=new ItemListCustom(idLlengua, codiLlengua);
                    itemJerarquia=new ItemListCustom(idJerarquia, codiJerarquia);
                    itemCategoria=new ItemListCustom(idCategoria, codiCategoria);
                    itemMarca=new ItemListCustom(idMarca, codiMarca);

                    // Afegim els valors a la taula
                    this.model.addRow(new Object[] {idDenominacio,itemLlengua,itemMarca,nomDenominacio,itemCategoria,itemJerarquia});                
                }  
            }
            // Associem el listener de l'event del ratol a la taula creada.
            this.tablaDenominaciones.addMouseListener(new com.termcat.layout.commons.popup.MousePopupListener(denominacionsPopupTable));
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DenominationException(e.getMessage()));
           //throw new DenominationException(e.getMessage());
        }
    }    
}
