/*
 * EditorLlengua.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.terminologic.denominacions;

import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.util.literales.Literales;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;
import com.termcat.layout.commons.popup.PanelPopup;

import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;

import com.termcat.business.exceptions.DenominationException;
import com.termcat.business.terminologic.denominations.DenominationManager;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una llengua de la taula .
 * 
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame --> problema??? es un JPANEL.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 *
 *  @author mena
 */
public class EditorDenominacio extends FunctionalModule implements com.termcat.layout.commons.interfaces.IEditor
{
    
    private final int COL_ID=0; // Numero de la columna que cont el identificador de la llengua(PK).
    
    /** Creates a new instance of EditorLlengua */
    public EditorDenominacio(MainFrame menuFrame) { 
        super(menuFrame);
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.    
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        try
        {
            JTable table=(JTable)component;
            String denominacio=null;

            // Obtenim la pantalla principal de l'aplicaci (llistat amb totes les llengues).
            DenominacionsMain moduleMain=(DenominacionsMain)functionalModule;

            // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
            String itemClicked=event.getActionCommand( );      
            int rowSelected=table.getSelectedRow();
            String id=(String)table.getModel().getValueAt(rowSelected,COL_ID);

            // Printem per pantalla la opci seleccionada.
            System.out.println("Popup menu item [" + itemClicked + "] was pressed.");
            String msg="Row: "+rowSelected+" Value: ";   
            msg+=id;  
            System.out.println(msg);
            System.out.println(itemClicked);
            // Comprovem la opci clicada
            if(itemClicked!=null && !itemClicked.equals(""))
            {
                 //     Edici de la llengua clicada.
                 if(itemClicked.equals(DenominacionsMain.EDIT_DENOMINACIO))
                 {
                    denominacio=DenominationManager.getManager().getRTFDenomination((String)table.getModel().getValueAt(rowSelected,0));                                        
                    
                    // Creem el nou mdul d'edici de la llengua seleccionada, i mostrem la finestra amb el contingut.               
                    ItemListCustom llengua=(ItemListCustom)table.getModel().getValueAt(rowSelected,1);                                     
                    ItemListCustom categoria=(ItemListCustom)table.getModel().getValueAt(rowSelected,4);
                    ItemListCustom jerarquia=(ItemListCustom)table.getModel().getValueAt(rowSelected,5);
                    ItemListCustom marca=(ItemListCustom)table.getModel().getValueAt(rowSelected,2);
                    
                    FunctionalModule moduleEdit = new DenominacionsEdit(menuFrame,moduleMain,id,llengua,denominacio,jerarquia,categoria,marca);
                    PanelPopup popupPanel=new PanelPopup(menuFrame,moduleEdit,Literales.getTextForMessage("Treball_terminologic"),670,720,0,0);

                     // Actualitzem el popup 'actual'.
                     menuFrame.setPanelPopup(popupPanel);

                     // Mostrem el popup.
                     popupPanel.showPopupWindow();

                 }             
                 //     Eliminaci de la llengua clicada.
                 else if(itemClicked.equals(DenominacionsMain.DELETE_DENOMINACIO))
                 {           
                    // Esborrar de la BD la fila seleccionada.
                    int response = JOptionPane.showConfirmDialog(menuFrame, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("MsgEsborrarDenominacio"), java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminacioLlengua"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response == JOptionPane.YES_OPTION) 
                    {
                         DenominationManager.getManager().deleteDenominacio(id);                      
                         // Refresh de la llista amb les llengues.
                         moduleMain.refresh();   
                         this.menuFrame.setCurrentFitxaDirty(true);
                    }                
                 }
                 else
                 {
                     tratarError(new DenominationException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioNoValida")));
                 }
            }
            else
            {
                     tratarError(new DenominationException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoOpcioSelected")));
            }          
        }
        catch(Exception e)
        {
            e.printStackTrace(); 
            tratarError(new DenominationException(e.getMessage()));
        }
    }
}
