/*
 * EditorFont.java
 *
 * Created on 30 de julio de 2007, 18:34
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.terminologic.fitxes;


import com.termcat.bd.utils.DBConnect;
import com.termcat.util.literales.Literales;
import java.sql.Connection;
import javax.swing.JComponent;
import javax.swing.JTable;
import javax.swing.JOptionPane;
import com.termcat.layout.MainFrame;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.terminologic.data.DataManager;

/**
 * Es la classe que instancia la interficie IEditor. 
 * S'encarrega de mostrar el formulari d'edici, un cop seleccionat la opci d'edici d'una fitxa de la taula .
 *
 *  Fem que extengui de la classe FuncionalModule per aixi poder tenir accs al menuFrame.
 *  Tamb permetem que es pugui fer el tractament d'excepcions ("tratarError(Exception e)").
 * 
 *  @author mena
 */
public class EditorFitxes extends Fitxa implements com.termcat.layout.commons.interfaces.IEditor
{      
    private final int COL_ID=0;     // Numero de la columna que cont el identificador de la fitxa(PK).
    
    /** Creates a new instance of EditorLlengua */
    public EditorFitxes(MainFrame menuFrame) {
        super(menuFrame); 
    }
    
    // Implementaci del mtode d'edici de la interficie IEditor.
    public void editar(java.awt.event.ActionEvent event, JComponent component, FunctionalModule functionalModule) throws Exception 
    {   
        try
        {
            JTable table=(JTable)component;
            // Obtenim la pantalla principal de l'aplicaci (menuFrame)
            FitxesMain moduleMain=(FitxesMain)functionalModule;
            final MainFrame menuFrame=moduleMain.getMenuFrame();
            
            // Obtenim el item que ha sigut clicat i l'identificador de l'objecte(data).
            String itemClicked=event.getActionCommand( );      
            int rowSelected=table.getSelectedRow();
            String idFitxa=(String)table.getModel().getValueAt(rowSelected,COL_ID);
            String denominacioPrincipal=(String)table.getModel().getValueAt(rowSelected,1);
            int numRows=table.getModel().getRowCount();
            // Printem per pantalla la opci seleccionada.         
            String msg="Row: "+rowSelected+" Value: ";   
            msg+=idFitxa;  
            System.out.println(msg);
            System.out.println(itemClicked);
            // Comprovem la opci clicada
            if(itemClicked!=null && !itemClicked.equals(""))
            {
                 // Edici de la fitxa clicada.=> "Rigth-click+edit"
                 if(itemClicked.equals(FitxesMain.EDIT_FITXA))
                 {
                     // Creem el nou mdul d'edici de la fitxa seleccionada, i mostrem la finestra amb el contingut.
                     FitxesEdit fitxesEdit= FitxesEdit.getInstance(menuFrame);
                     fitxesEdit.init(moduleMain, idFitxa,denominacioPrincipal,rowSelected, numRows);
                     PanelPopup popupPanel=new PanelPopup(menuFrame,fitxesEdit,Literales.getTextForMessage("Treball_terminologic"),1000,740,10,10);
                     popupPanel.addWindowListener(new java.awt.event.WindowAdapter() {
                            public void windowClosed(java.awt.event.WindowEvent evt) {
                                actionWindowClose(evt,false);
                                menuFrame.setLastTab(0);
                            }
                            public void windowClosing(java.awt.event.WindowEvent evt) {
                                actionWindowClose(evt,false);
                                menuFrame.setLastTab(0);
                            }
                        });
                         // Actualitzem el popup 'actual'.
                     menuFrame.setEditPanelPopup(popupPanel,false);

                     // Mostrem el popup.
                     popupPanel.showPopupWindow();         
                 }
                 // Eliminaci de la fitxa clicada.
                 else if(itemClicked.equals(FitxesMain.DELETE_FITXA))
                 {           
                    // Esborrar de la BD la fila seleccionada.
                    int response=JOptionPane.showConfirmDialog(menuFrame, java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("MsgEsborrarFitxa"), java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EliminacioFitxa"), JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                    if (response==JOptionPane.YES_OPTION) 
                    {
                         DataManager.getManager().deleteFitxa(idFitxa);                                              
                         this.menuFrame.setCurrentFitxaDirty(true);
 
                         // Fem el commit a BD                        
                         doCommit();
                         
                        // Refresh de la llista amb les fitxes.
                         moduleMain.refresh();                          
                    }                
                 }
                 else
                 {
                     tratarError(new DataException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("OpcioNoValida")));
                 }
            }
            else
            {
                tratarError(new DataException(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NoOpcioSelected")));
            }    
        }
        catch(Exception e)
        {
            // No se si aqu s'hauria de fer el rollback perque podria ser que falls el delete.
            tratarError(new DataException(e.getMessage()));
        }
    }  
    
      /*private void actionWindowClose(java.awt.event.WindowEvent evt) 
      {
          try
          {
            DBConnect.getConnectionTransactional().rollback();
            DBConnect.putConnectionTransactional();
            this.menuFrame.closeEditPanelPopup();
            this.menuFrame.setCurrentFitxaDirty(false);

          }
          catch (Exception e)
          {
              e.printStackTrace();
          }
      }*/
   
}