/*
 * Fitxa.java
 *
 * Created on 7 de agosto de 2007, 9:54
 */

package com.termcat.layout.terminologic.fitxes;

import com.termcat.bd.beans.ArbreCamp;
import com.termcat.business.areas.AreaManager;
import com.termcat.business.exceptions.DictionaryException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.terminologic.arees.AreesTematiquesAlta;
import com.termcat.layout.terminologic.contextes.ContextesMain;
import com.termcat.layout.terminologic.definicions.DefinicionsMain;
import com.termcat.layout.terminologic.denominacions.DenominacionsMain;
import com.termcat.layout.terminologic.notes.NotesMain;
import com.termcat.layout.terminologic.observacions.ObservacionsAlta;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import javax.swing.JButton;
import javax.swing.JTabbedPane;
import java.sql.SQLException;
import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DataException;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author  Mena
 */
public class Fitxa extends FunctionalModule 
{
    // Atributs de la classe.
    private String idDiccionari;
    private String nomDiccionari;
        
    /** Creates new form Fitxa */
    public Fitxa(MainFrame menuFrame) 
    {
        super(menuFrame);
        // Inicialitzem el valor de modificaci a 'false'.
        try
        {
            this.idDiccionari=menuFrame.getIdCurrentDictionary();
            setNomDiccionari(this.idDiccionari);
            this.setSize(this.menuFrame.getSize());
        }
        catch(Exception e)
        {
               e.printStackTrace();
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 400, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 300, Short.MAX_VALUE)
        );
    }// </editor-fold>//GEN-END:initComponents
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    // End of variables declaration//GEN-END:variables
 
    private void setNomDiccionari(String idDiccionari) throws Exception
    {
        try
        {
            this.idDiccionari=DictionaryManager.getManager().getNomDiccionari(idDiccionari);            
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DictionaryException(e.getMessage())); 
        }
    }
    
   /*
    *        Mtode que retorna la posicio d'un item dins d'un vector. S'utilitza en els 'edits' per a poder
    *       carregar el valor del combo que te emmagatzemat a BD.
    *
    *       @param v:   Vector on es vol realitxzar la cerca.
    *       @param id:  Identificador de l'item del que es vol obtenir la posici.
    *       
    *       @return position: Posici en la que es troba l'item. Si no existeix retorna -1.
    */
    protected int calculatePositionInVector(Vector v, String id)
    {
        int position=-1;
        ItemListCustom item=new ItemListCustom();
        for(int i=0;i<v.size();++i)
        {
            item=(ItemListCustom)v.get(i);
            if(id.equals(item.getId()))
            {
                position=i;
                break;
            }
        }
        return position;
    }
    
    /*
     *       Mtode que inicialitza les llengues del diccionari que se li passa com a parmetre.
     *      @param idDiccionari:    Identificador del diccionari del que es volen obtenir les llengues associades.
     *      @return llenguesDiccionariVector:   Vector amb totes les llengues del diccionari indicat.
     */
    protected Vector initVectorLlengues(String idDiccionari)
    {
        Vector idLlenguesDiccionari=null,llenguesDiccionariVector=null;
        
        try 
        {
            idLlenguesDiccionari=DictionaryManager.getManager().getLlenguesOfDictionary(idDiccionari);
            // Creem un nou vector amb tots els codis de les llengues.
            llenguesDiccionariVector=new Vector();
            for (int i=0;i<idLlenguesDiccionari.size();++i)
            {
                ItemListCustom item=(ItemListCustom)idLlenguesDiccionari.get(i);
                llenguesDiccionariVector.add(item);
            }            
       }
       catch (Exception ex) 
       {
            ex.printStackTrace();
       }
        return llenguesDiccionariVector;
    }
    
    /*
     *   Mtode encarregat de fer un commit de la transaccio. Noms far el commit si s'han fet modificacions
     *  (flag dirty=true), en cas contrari, es far un rollback.
     */
    protected void doCommit() throws DataException
    {  
        try 
        {       
             System.out.println("isDirty? "+this.menuFrame.isCurrentFitxaDirty());
             if(this.menuFrame.isCurrentFitxaDirty())
                DBConnect.getConnectionTransactional().commit();
             else
                DBConnect.getConnectionTransactional().rollback();
        }
        catch (SQLException e) 
        {
            e.printStackTrace();
            throw new DataException(e.getMessage());
        }
        finally{
            DBConnect.putConnectionTransactional();
            this.menuFrame.setCurrentFitxaDirty(false);
        }
    }
   
    /*
     *       Mtode encarregat d'inicialitzar les pestanyes.
     *      Li passem el modul i un bole per a que en la pestanya de Denominacions es puguin activar i desactivar
     *      els botons. El bole ser per a saber si es un Edit o Alta.
     *  
     */
    protected void initTabs(javax.swing.JTabbedPane tabbedPane, FunctionalModule module, boolean isEdit, int selectedTab, int row, FitxesMain fitxesMain) 
    {      

        // Els afegim a la taula amb pestanyes.
        tabbedPane.addTab(Literales.getTextForLiteral("Treball_Denominacions"),new DenominacionsMain(menuFrame,module,isEdit,row, fitxesMain));
        tabbedPane.addTab(Literales.getTextForLiteral("Treball_Definicions"),new DefinicionsMain(menuFrame));
        tabbedPane.addTab(Literales.getTextForLiteral("Treball_Notes"),new NotesMain(menuFrame));
        tabbedPane.addTab(Literales.getTextForLiteral("Treball_Observacions"),new ObservacionsAlta(menuFrame));
        tabbedPane.addTab(Literales.getTextForLiteral("Treball_Arees"),new AreesTematiquesAlta(menuFrame));
        tabbedPane.addTab(Literales.getTextForLiteral("Treball_Context"),new ContextesMain(menuFrame));        
        tabbedPane.setSelectedIndex(selectedTab);       
    }     
}