/*
 *  FitxesAlta.java
 *
 *  Created on 7 de agosto de 2007, 11:35
 */

package com.termcat.layout.terminologic.fitxes;

import java.sql.SQLException;
import com.termcat.layout.MainFrame;
import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DataException;
import com.termcat.layout.terminologic.notes.NotesMain;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.layout.terminologic.definicions.DefinicionsMain;
import com.termcat.layout.terminologic.denominacions.DenominacionsMain;
import com.termcat.layout.terminologic.observacions.ObservacionsAlta;
import javax.swing.JButton;
import javax.swing.JTree;

public class FitxesAlta extends Fitxa 
{
    private FitxesMain fitxesMain;
    
    /** 
     *      Constructor de la classe. S'encarrega de crear una nova fitxa pel diccionari 'current'.
     *     Se li passa una referencia del FitxesMain ja que sino en cap cas desde aqui es podria actulitzar la taula
     *     amb els valors de la nova fitxa acabada d'insertar (al prmer el bot d'Acceptar). Com exten de la classe
     *     'Fitxa' que a la vegada ho fa de la 'FunctionalModule' necessita el menuFrame en el constructor.
     */
    public FitxesAlta(MainFrame menuFrame, FitxesMain fitxesMain) 
    {
        super(menuFrame);

        // Inicialitzem l'arbre i la taula
        if (this.menuFrame.tree==null)
                this.menuFrame.tree=initJTree();     

        try
        {
            // Creem una nova transaccio.
            java.sql.Connection ct=DBConnect.getConnectionTransactional();                      

            // Creem la fitxa i guardem el id de la fitxa a la variable del menuFrame.
            String idFitxa=DataManager.getManager().altaFitxa(this.menuFrame.getIdCurrentDictionary());

            this.menuFrame.setIdFitxa(idFitxa);
            this.fitxesMain=fitxesMain;
            
            initComponents();
            initTabs(tabbedPane,this,false,0,-1,null);

            // Inicialitzem el flag de modificacio a 'false'
            this.menuFrame.setCurrentFitxaDirty(false);
            
            //this.menuFrame.setDenoDefined(false);
            
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        denominacionsPanel = new javax.swing.JPanel();
        definicionsPanel = new javax.swing.JPanel();
        notesPanel = new javax.swing.JPanel();
        observacionsPanel = new javax.swing.JPanel();
        areaTematicaPanel = new javax.swing.JPanel();
        contextPanel = new javax.swing.JPanel();
        imatgePanel = new javax.swing.JPanel();
        mainPanel = new javax.swing.JPanel();
        tabbedPane = new javax.swing.JTabbedPane();
        aplicarButton = new javax.swing.JButton();
        acceptarButton = new javax.swing.JButton();
        cancelarButton = new javax.swing.JButton();

        org.jdesktop.layout.GroupLayout denominacionsPanelLayout = new org.jdesktop.layout.GroupLayout(denominacionsPanel);
        denominacionsPanel.setLayout(denominacionsPanelLayout);
        denominacionsPanelLayout.setHorizontalGroup(
            denominacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        denominacionsPanelLayout.setVerticalGroup(
            denominacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout definicionsPanelLayout = new org.jdesktop.layout.GroupLayout(definicionsPanel);
        definicionsPanel.setLayout(definicionsPanelLayout);
        definicionsPanelLayout.setHorizontalGroup(
            definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        definicionsPanelLayout.setVerticalGroup(
            definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout notesPanelLayout = new org.jdesktop.layout.GroupLayout(notesPanel);
        notesPanel.setLayout(notesPanelLayout);
        notesPanelLayout.setHorizontalGroup(
            notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        notesPanelLayout.setVerticalGroup(
            notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout observacionsPanelLayout = new org.jdesktop.layout.GroupLayout(observacionsPanel);
        observacionsPanel.setLayout(observacionsPanelLayout);
        observacionsPanelLayout.setHorizontalGroup(
            observacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        observacionsPanelLayout.setVerticalGroup(
            observacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout areaTematicaPanelLayout = new org.jdesktop.layout.GroupLayout(areaTematicaPanel);
        areaTematicaPanel.setLayout(areaTematicaPanelLayout);
        areaTematicaPanelLayout.setHorizontalGroup(
            areaTematicaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        areaTematicaPanelLayout.setVerticalGroup(
            areaTematicaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout contextPanelLayout = new org.jdesktop.layout.GroupLayout(contextPanel);
        contextPanel.setLayout(contextPanelLayout);
        contextPanelLayout.setHorizontalGroup(
            contextPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        contextPanelLayout.setVerticalGroup(
            contextPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout imatgePanelLayout = new org.jdesktop.layout.GroupLayout(imatgePanel);
        imatgePanel.setLayout(imatgePanelLayout);
        imatgePanelLayout.setHorizontalGroup(
            imatgePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        imatgePanelLayout.setVerticalGroup(
            imatgePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );

        setMaximumSize(new java.awt.Dimension(1000, 525));
        setMinimumSize(new java.awt.Dimension(1000, 525));
        mainPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("AltaFitxa")));
        mainPanel.setMaximumSize(new java.awt.Dimension(994, 525));
        mainPanel.setMinimumSize(new java.awt.Dimension(994, 525));
        mainPanel.setPreferredSize(new java.awt.Dimension(994, 525));
        tabbedPane.setMaximumSize(new java.awt.Dimension(944, 373));
        tabbedPane.setMinimumSize(new java.awt.Dimension(944, 373));

        aplicarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Aplicar"));
        aplicarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aplicarButtonActionPerformed(evt);
            }
        });

        acceptarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Acceptar"));
        acceptarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                acceptarButtonActionPerformed(evt);
            }
        });

        cancelarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cancelar"));
        cancelarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelarButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout mainPanelLayout = new org.jdesktop.layout.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainPanelLayout.createSequentialGroup()
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(mainPanelLayout.createSequentialGroup()
                        .addContainerGap(681, Short.MAX_VALUE)
                        .add(aplicarButton)
                        .add(19, 19, 19)
                        .add(acceptarButton)
                        .add(24, 24, 24)
                        .add(cancelarButton))
                    .add(org.jdesktop.layout.GroupLayout.LEADING, mainPanelLayout.createSequentialGroup()
                        .addContainerGap()
                        .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 935, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, mainPanelLayout.createSequentialGroup()
                .add(40, 40, 40)
                .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 373, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(21, 21, 21)
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(aplicarButton)
                    .add(acceptarButton)
                    .add(cancelarButton))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(mainPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 971, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(19, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                .addContainerGap(14, Short.MAX_VALUE)
                .add(mainPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 500, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents

    /**
     *      Mtode que s'executar al clicar el bot de cancelar els canvis. En aquest cas el que farem ser
     *     fer el rollback de la transaccio, tancar la transaccio i el popup.
     */
    private void cancelarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelarButtonActionPerformed
        try
        {
            DBConnect.getConnectionTransactional().rollback();

        }
        catch (SQLException e) 
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
        finally{
            DBConnect.putConnectionTransactional();
            // Fem un refresh de la taula perque en cas de no fer-ho es creen tuples 'fantasmes' a la taula.
           // fitxesMain.refresh();
            this.menuFrame.closeAltaPanelPopup();            
        }
    }//GEN-LAST:event_cancelarButtonActionPerformed

    /*
     *      Mtode que s'executar al clicar el bot d'acceptar els canvis. En aquest cas cridar a la funci doCommit(),
     *     que far el commit i tancar la transacci. Tamb fem el refresh de la taula on es troben les fitxes i tanquem
     *     el popup.
     */
    private void acceptarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_acceptarButtonActionPerformed
        try 
        {
            doCommit();
            this.menuFrame.setIdFitxa(null);
            this.menuFrame.closeAltaPanelPopup();
        }
        catch (Exception e) 
        {    
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }//GEN-LAST:event_acceptarButtonActionPerformed

    /*
     *      Mtode que s'executar al clicar el bot d'aplicar els canvis. En aquest cas cridar a la funci doCommit(),
     *     que far el commit i tancar la transacci. En aquest cas ens quedarem a la mateixa pantalla.
     *     el popup.
     */
    private void aplicarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aplicarButtonActionPerformed
        try 
        {
            doCommit();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }//GEN-LAST:event_aplicarButtonActionPerformed
   
    public JButton getAcceptarButton()
    {
        return this.acceptarButton;
    }
    
    public JButton getAplicarButton()
    {
        return this.aplicarButton;
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton acceptarButton;
    private javax.swing.JButton aplicarButton;
    private javax.swing.JPanel areaTematicaPanel;
    private javax.swing.JButton cancelarButton;
    private javax.swing.JPanel contextPanel;
    private javax.swing.JPanel definicionsPanel;
    private javax.swing.JPanel denominacionsPanel;
    private javax.swing.JPanel imatgePanel;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JPanel notesPanel;
    private javax.swing.JPanel observacionsPanel;
    private javax.swing.JTabbedPane tabbedPane;
    // End of variables declaration//GEN-END:variables
}