/*
 * FitxesAlta.java
 *
 * Created on 7 de agosto de 2007, 11:35
 */

package com.termcat.layout.terminologic.fitxes;

import com.termcat.bd.utils.DBConnect;
import com.termcat.business.exceptions.DenominationException;
import com.termcat.business.terminologic.definitions.DefinitionManager;
import com.termcat.layout.MainFrame;
import com.termcat.layout.terminologic.definicions.DefinicionsMain;
import com.termcat.layout.terminologic.denominacions.DenominacionsMain;
import com.termcat.layout.terminologic.notes.NotesMain;
import com.termcat.business.exceptions.DataException;
import com.termcat.layout.terminologic.observacions.ObservacionsAlta;
import com.termcat.util.literales.Literales;
import java.sql.SQLException;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.commons.popup.PanelPopup;
import java.util.List;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JOptionPane;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JPanel;
import javax.swing.table.DefaultTableModel;
import java.util.Vector;
import java.util.Iterator;
import com.termcat.bd.beans.Definicions;
import com.termcat.business.maintenance.language.LanguageManager;

/**
 *
 * @author  Mena
 */
public class FitxesEdit extends Fitxa 
{
    // Loader
    private JDialog dialog;
    //private JOptionPane pane;      
    
    private FitxesMain fitxesMain;
    private JTable tablaDefiniciones; 
    private DefaultTableModel model;  
    
    private JTable tablaAt; 
    private static FitxesEdit _fitxesEdit=null;   
    public boolean refreshTable=false;
    
   /*
    *    Constructor de la classe. Es gestiona amb un 'Singleton'. Se li passa per parmetre el menuFrame perque
    *   com exten de Fitxa, que a la vegada ho fa de Functional Module que necessita el menu en el constructor.
    */
    public static synchronized FitxesEdit getInstance(MainFrame menuFrame)
    {
        if(_fitxesEdit!=null)
            return _fitxesEdit;       
        else
        {
            _fitxesEdit=new FitxesEdit(menuFrame);
            return _fitxesEdit;
        }
    }
     
    private FitxesEdit(MainFrame menuFrame)
    {
        super(menuFrame);
        
        // Inicialitzaci de l'arbre d'rees temtiques.
        if (this.menuFrame.tree==null)
                this.menuFrame.tree=initJTree();                
    }
   
    
    /**
     *       Mtode que inicialitza la classe. En primer lloc esborra el contingut per a despres carregar les
     *      dades que se li passen per parmetre.
     */
    public void init(FitxesMain fitxesMain, String idFitxa, String denominacioPrincipal, int row, int maxRows) throws DenominationException
    {
        // Creem la nova transaccio
        //DBConnect.putConnectionTransactional();
        java.sql.Connection ct=DBConnect.getConnectionTransactional();
        
        //  Buidem el contingut anterior dels components i inicialitzem en el MainFrame el id de la Fitxa que acabem
        // de seleccionar.
        this.removeAll();
        this.menuFrame.setIdFitxa(idFitxa);
        
        // Ens guardem el una referencia al FitxesMain per a poder fer el refresh de la taula quan es facin modificacions.
        this.fitxesMain=fitxesMain;
        
        // Inicialitzaci dels components.
        initComponents();  

        // inicialitzaci de l'arbre en cas que sigui null.
        if (this.menuFrame.tree==null)
                this.menuFrame.tree=initJTree();

        // Inicialitzaci de les pestanyes i del nom de la fitxa.
        initTabs(tabbedPane,this,true,this.menuFrame.getLastTab(),this.fitxesMain.tablaFichas.getSelectedRow(),this.fitxesMain); 
        
        fitxaNom.setText(denominacioPrincipal);
        
        // Inicialitzaci de la taula de definicions
        initDefinicionsFitxa(this.menuFrame.getIdFitxa());
        
        // Inicialitzaci de la taula d'arees temtiques.
        this.tablaAt=new JTable();
        this.tablaAt=initTable("",this.menuFrame.getIdFitxa());
        areesScrollPane.setViewportView(tablaAt);
        
        // Primera fila de la taula paginada: Deshabilitem el bot de <-- nomes en el cas que estiguem en la primera pgina.
        if (row==0 && this.menuFrame.getCurrentPage()==0)
           leftButton.setEnabled(false);
        
        // ltima fila de la taula paginada: Deshabilitem el bot de --> nomes en el cas que estiguem en la ltima pgina.            
        
        if (row==maxRows-1 && this.fitxesMain.isLastPage)
                rightButton.setEnabled(false);        // Inicialitzem el flag de modificacio a 'false'
        this.menuFrame.setCurrentFitxaDirty(false);      
        
        // Deseleccionamos cualquier seleccion previa
        this.menuFrame.tree.setSelectionRow(-1);
    }
    
    /*
     *   Mtode per obtenir l'objecte FitxesEdit.
     */
    public FitxesEdit getFitxesEdit()
    {
        return this._fitxesEdit;
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        denominacionsPanel = new javax.swing.JPanel();
        definicionsPanel = new javax.swing.JPanel();
        notesPanel = new javax.swing.JPanel();
        observacionsPanel = new javax.swing.JPanel();
        areaTematicaPanel = new javax.swing.JPanel();
        contextPanel = new javax.swing.JPanel();
        imatgePanel = new javax.swing.JPanel();
        mainPanel = new javax.swing.JPanel();
        tabbedPane = new javax.swing.JTabbedPane();
        definicionsScrollPane = new javax.swing.JScrollPane();
        fitxaLabel = new javax.swing.JLabel();
        changeLabel = new javax.swing.JLabel();
        leftButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaLeft.gif")),this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaLeftDisable.gif")));
        rightButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaRight.gif")),this.getClass().getResource(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("/com/termcat/resources/img/botonFlechaRightDisable.gif")));
        areesScrollPane = new javax.swing.JScrollPane();
        seeFitxaButton = new javax.swing.JButton();
        fitxaNom = new javax.swing.JLabel();
        cancelarButton = new javax.swing.JButton();
        acceptarButton = new javax.swing.JButton();
        aplicarButton = new javax.swing.JButton();

        org.jdesktop.layout.GroupLayout denominacionsPanelLayout = new org.jdesktop.layout.GroupLayout(denominacionsPanel);
        denominacionsPanel.setLayout(denominacionsPanelLayout);
        denominacionsPanelLayout.setHorizontalGroup(
            denominacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        denominacionsPanelLayout.setVerticalGroup(
            denominacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout definicionsPanelLayout = new org.jdesktop.layout.GroupLayout(definicionsPanel);
        definicionsPanel.setLayout(definicionsPanelLayout);
        definicionsPanelLayout.setHorizontalGroup(
            definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        definicionsPanelLayout.setVerticalGroup(
            definicionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout notesPanelLayout = new org.jdesktop.layout.GroupLayout(notesPanel);
        notesPanel.setLayout(notesPanelLayout);
        notesPanelLayout.setHorizontalGroup(
            notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        notesPanelLayout.setVerticalGroup(
            notesPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout observacionsPanelLayout = new org.jdesktop.layout.GroupLayout(observacionsPanel);
        observacionsPanel.setLayout(observacionsPanelLayout);
        observacionsPanelLayout.setHorizontalGroup(
            observacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        observacionsPanelLayout.setVerticalGroup(
            observacionsPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout areaTematicaPanelLayout = new org.jdesktop.layout.GroupLayout(areaTematicaPanel);
        areaTematicaPanel.setLayout(areaTematicaPanelLayout);
        areaTematicaPanelLayout.setHorizontalGroup(
            areaTematicaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        areaTematicaPanelLayout.setVerticalGroup(
            areaTematicaPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout contextPanelLayout = new org.jdesktop.layout.GroupLayout(contextPanel);
        contextPanel.setLayout(contextPanelLayout);
        contextPanelLayout.setHorizontalGroup(
            contextPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        contextPanelLayout.setVerticalGroup(
            contextPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        org.jdesktop.layout.GroupLayout imatgePanelLayout = new org.jdesktop.layout.GroupLayout(imatgePanel);
        imatgePanel.setLayout(imatgePanelLayout);
        imatgePanelLayout.setHorizontalGroup(
            imatgePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );
        imatgePanelLayout.setVerticalGroup(
            imatgePanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(0, 100, Short.MAX_VALUE)
        );

        setMaximumSize(new java.awt.Dimension(1000, 750));
        setMinimumSize(new java.awt.Dimension(1000, 750));
        mainPanel.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("EdicioFitxa")));
        mainPanel.setMaximumSize(new java.awt.Dimension(994, 855));
        mainPanel.setMinimumSize(new java.awt.Dimension(994, 855));
        tabbedPane.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                actionStateChanged(evt);
            }
        });

        definicionsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("LlistaDefinicionsExistents")));

        fitxaLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 1, 18));
        fitxaLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("NomFitxa"));

        changeLabel.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 14));
        changeLabel.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("CanviarFitxa"));

        leftButton.setText("   ");
        leftButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                leftButtonActionPerformed(evt);
            }
        });

        rightButton.setText("   ");
        rightButton.setBorderPainted(false);
        rightButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                rigthButtonActionPerformed(evt);
            }
        });

        areesScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("ATFitxa")));

        seeFitxaButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Veure_fitxa"));
        seeFitxaButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                seeFitxaActionPerformed(evt);
            }
        });

        fitxaNom.setFont(new java.awt.Font(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Tahoma"), 0, 18));
        fitxaNom.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("jLabel1"));

        org.jdesktop.layout.GroupLayout mainPanelLayout = new org.jdesktop.layout.GroupLayout(mainPanel);
        mainPanel.setLayout(mainPanelLayout);
        mainPanelLayout.setHorizontalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainPanelLayout.createSequentialGroup()
                .addContainerGap()
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, mainPanelLayout.createSequentialGroup()
                        .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(mainPanelLayout.createSequentialGroup()
                                .add(fitxaLabel)
                                .add(26, 26, 26)
                                .add(fitxaNom, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 191, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                            .add(mainPanelLayout.createSequentialGroup()
                                .add(leftButton)
                                .add(54, 54, 54)
                                .add(changeLabel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 84, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(61, 61, 61)
                                .add(rightButton)))
                        .add(98, 98, 98)
                        .add(seeFitxaButton)
                        .add(79, 79, 79)
                        .add(areesScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 290, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, tabbedPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 917, Short.MAX_VALUE)
                    .add(definicionsScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 917, Short.MAX_VALUE))
                .add(37, 37, 37))
        );
        mainPanelLayout.setVerticalGroup(
            mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(mainPanelLayout.createSequentialGroup()
                .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(mainPanelLayout.createSequentialGroup()
                        .add(20, 20, 20)
                        .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(fitxaLabel)
                            .add(fitxaNom, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 27, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                            .add(seeFitxaButton))
                        .add(12, 12, 12)
                        .add(mainPanelLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                            .add(changeLabel)
                            .add(rightButton)
                            .add(leftButton)))
                    .add(areesScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 106, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(tabbedPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 387, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 17, Short.MAX_VALUE)
                .add(definicionsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 95, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
        );

        cancelarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Cancelar"));
        cancelarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelarButtonActionPerformed(evt);
            }
        });

        acceptarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Acceptar"));
        acceptarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                acceptarButtonActionPerformed(evt);
            }
        });

        aplicarButton.setText(java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Aplicar"));
        aplicarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aplicarButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(aplicarButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(acceptarButton)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(cancelarButton)
                        .add(53, 53, 53))
                    .add(mainPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 980, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(mainPanel, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 641, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .add(9, 9, 9)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(aplicarButton)
                    .add(acceptarButton)
                    .add(cancelarButton))
                .addContainerGap(66, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    /*
     *       Mtode que s'executar quan es produeixi un canvi de la pestanya 'activa'. El que far ser 'amagar' la taula 
     *      on apareixen les definicions que te associades la fitxa, per a la pestanya de definicions.
     */
    private void actionStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_actionStateChanged
        int selectedTab=tabbedPane.getSelectedIndex();
        this.menuFrame.setLastTab(selectedTab);
        
        switch(selectedTab)
        {           
           // Pestanya de definici: Amaguem la taula amb les definicions.
            case 1: definicionsScrollPane.setVisible(false);
                    break;
                    
            default:
                    definicionsScrollPane.setVisible(true);
                    break;                
        }      
    }//GEN-LAST:event_actionStateChanged

    private void seeFitxaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_seeFitxaActionPerformed
        new com.termcat.business.reports.veurefitxa.VeureFitxaReportManager().viewFitxaReport(menuFrame.getIdFitxa(),fitxaNom.getText());
    }//GEN-LAST:event_seeFitxaActionPerformed

    // -------------------------------------------------------------------------------
    //          BOTONS DE CANVI DE FITXA ( <-- / --> )
    // -------------------------------------------------------------------------------    
    /*
     *      Mtode que s'executar al clicar el bot de canvi de fitxa anterior. Crida a la funci 'changeFitxa'
     *     passant-li com a parmetre la fila on es troba la fitxa anterior que es vol mostrar.
     */
    private void leftButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_leftButtonActionPerformed
        int row=this.fitxesMain.tablaFichas.getSelectedRow();
        // La condici (getCurrentPage >0) es redundant ja que en aquest cas row=0 & currentPage=0 el boto est disable.
        if (row==0 && menuFrame.getCurrentPage()>0)
        {
            row=menuFrame.getRowsInPage()-1;
            menuFrame.setCurrentPage(menuFrame.getCurrentPage()-1);
            refreshTable=true;
        }
        else
            row--;

        changeFitxa(row);
    }//GEN-LAST:event_leftButtonActionPerformed

    /*
     *      Mtode que s'executar al clicar el bot de canvi de fitxa segent. Crida a la funci 'changeFitxa'
     *     passant-li com a parmetre la fila on es troba la fitxa segent que es vol mostrar.
     */
    private void rigthButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_rigthButtonActionPerformed
        int row=this.fitxesMain.tablaFichas.getSelectedRow();
        // La condici (!fitxesMain.isLastPage) es redundant ja que en aquest cas row=0 & currentPage=fitxesMain.isLastPage el boto est disable.
        if (row==fitxesMain.MAX_TABLE_FITXES_ROW-1 && !fitxesMain.isLastPage)
        {
            row=0;
            menuFrame.setCurrentPage(menuFrame.getCurrentPage()+1);
            refreshTable=true;
        }
        else
            row++;

        changeFitxa(row);
    }//GEN-LAST:event_rigthButtonActionPerformed

    // -------------------------------------------------------------------------------
    //          BOTONS DE GUARDAR MODIFICACIONS (Acceptar / Aplicar / Cancellar)
    // -------------------------------------------------------------------------------    
    
   /*
    *        Mtode que s'executa al clicar al bot de cancellar. Farem un rollback i tancarem la transaccio i el popup.
    *       Actualizarem el flag de dirty a 'false' i farem un refresh de la taula amb les fitxes perque sino es generen
    *       algunes files fantasma. (???)
    */
    private void cancelarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelarButtonActionPerformed
        try
        {
            DBConnect.getConnectionTransactional().rollback();
            DBConnect.putConnectionTransactional();
            this.menuFrame.closeEditPanelPopup();
            this.menuFrame.setCurrentFitxaDirty(false);
            this.menuFrame.setLastTab(0);
        }
        catch (SQLException e) 
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }//GEN-LAST:event_cancelarButtonActionPerformed

  /*
   *       Mtode que s'executa al clicar al bot d'Acceptar. En aquest cas cridar a la funci doCommit(),
   *     que far el commit i tancar la transacci. Fem el refresh de la taula on es troben les fitxes i tanquem
   *     el popup. Tamb s'actualitzen les definicions de la fitxa per si ha hagut algun canvi.
   */
    private void acceptarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_acceptarButtonActionPerformed
        try 
        {
            doCommit();
            initDefinicionsFitxa(this.menuFrame.getIdFitxa());
            this.menuFrame.closeEditPanelPopup();
            this.menuFrame.setIdFitxa(null);
            this.menuFrame.setLastTab(0);
            fitxesMain.refresh();
         }
        catch (DataException e) 
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }//GEN-LAST:event_acceptarButtonActionPerformed

  /*
   *       Mtode que s'executa al clicar al bot d'Aplicar. En aquest cas cridar a la funci doCommit(),
   *     que far el commit i tancar la transacci. Tamb fem el refresh de la taula on es troben les fitxes, en aquest
   *     cas el refresh far un set de la row actual, ja que com no es tanca el popup i es pot continuar seleccionant
   *     fitxes amb els botons de canvi, hem d'indicar la fila. (En el refresh es crea la taula de nou i per tant es perd
   *     la referencia a la fila actual. Tamb s'actualitzen les definicions de la fitxa per si ha hagut algun canvi.
   */
    private void aplicarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aplicarButtonActionPerformed
        try
        {
            doCommit();
            int row=fitxesMain.tablaFichas.getSelectedRow();            
            initDefinicionsFitxa(this.menuFrame.getIdFitxa());
            fitxesMain.refresh();
            fitxesMain.tablaFichas.setRowSelectionInterval(row,row);
        }
        catch (DataException e) 
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }//GEN-LAST:event_aplicarButtonActionPerformed

    // -------------------------------------------------------------------------------
    //          Mtodes PRIVATS
    // -------------------------------------------------------------------------------    
    /*
     *       Mtode encarregat d'actualitzar la fitxa que s'esta visualitzant. En cas que hi hagi hagut alguna modificaci en
     *      la fitxa que s'estava editant es mostra un missatge indicatiu. 
     *      @param row: posici de la fitxa dins de la taula.
     */
    private void changeFitxa(int row) 
    {
         // Inicialitzem els boleans a fals.
         boolean changeFitxa=false;  
         
         try
         {
             // Comprovem que no s'hagi modificat el flag de dirty
             if(this.menuFrame.isCurrentFitxaDirty())
             {
                // Mostrem un missatge d'alerta que hi ha valors pendents de modificacio. En cas que es cliqui canvi, 
                //es guardaran els canvis i es canviar la fitxa indicada, en cas contrari, "no es fara res".
                int response = JOptionPane.showConfirmDialog(menuFrame, "Hi ha modificacions pendents de guardar. Vols guardarles i canviar de fitxa?", "Canvi de fitxa", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE);
                if (response == JOptionPane.YES_OPTION) 
                {
                    changeFitxa=true;
                    refreshTable=true;
                }
             }
             else
                    changeFitxa=true;

             if(changeFitxa)
             {

                 if (refreshTable)
                 {           
                   // Creem el loader i el fem visible
                    dialog=initLoader();
                    dialog.setVisible(true);                                    
            
                    FitxesEditThread thread=new FitxesEditThread(menuFrame,dialog,this.fitxesMain,row,this);
                    thread.start();       
                 }                     
                 else
                 {
                    // Obtenim el id de la fitxa anterior a la seleccionada i actualitzem la nova fitxa seleccionada
                    String idFitxa=(String)this.fitxesMain.tablaFichas.getModel().getValueAt(row,0);
                    this.fitxesMain.tablaFichas.setRowSelectionInterval(row,row);

                    // Guardem a BD les dades modificades.
                    doCommit();
                                 
                    // Fer un right-click+Edit
                    // Creem el nou mdul d'edici de la fitxa seleccionada, i mostrem la finestra amb el contingut.
                    String denoPrincipal=(String)this.fitxesMain.tablaFichas.getModel().getValueAt(row,1);               
                    init(fitxesMain,idFitxa,denoPrincipal,row,this.fitxesMain.tablaFichas.getModel().getRowCount());

                    // Desassociem la seleccio en l'arbre!
                    this.menuFrame.tree.setSelectionRow(-1);
                 }
             }
         }
         catch(Exception e)
         {
              e.printStackTrace();
              tratarError(new DataException(e.getMessage()));
         }
    }

    /*
     *       Mtode encarregat d'obtenir les definicions que te una determinada fitxa.
     *      @param idFitxa: Id de la fitxa de la que es volen obtenir les definicions.
     */
    private void initDefinicionsFitxa(String idFitxa) 
    {
        final String[] names = {Literales.getTextForLiteral("Cabecera_Lengua"), Literales.getTextForLiteral("Cabecera_Definicio")};
        final Object[][] data =null;
        
        try               
        {
            this.model=new DefaultTableModel(data,names);
            this.tablaDefiniciones= new JTable(model)
            {
                public boolean isCellEditable(int row, int column)
                {
                    return false;
                }
            };      

            List allDefinicions=DefinitionManager.getManager().getAllDefinitionsOfFitxa(idFitxa);
            if (allDefinicions.size()==0)
                model.addRow(new Object[] {null,null});
            else
            {
                for(int i=0;i<allDefinicions.size();++i)
                {    
                         Definicions definicio=(Definicions)allDefinicions.get(i);
                        // Obtenim els valors dels codis de cadascuna de les columnes que volem visualitzar a la taula.
                        String idLlengua=definicio.getIdLlengua();

                        // Obtenim els codis en funcio del Id de cadascun dels objectes
                        String codiLlengua=LanguageManager.getManager().getCodiLlengua(idLlengua);

                        // Afegir les definicions a la taula
                        this.model.addRow(new Object[] {codiLlengua,definicio.getDefinicionNormal()});
                 }
            }
            // insertar la table al frame mitjanant un scroll panel.
            definicionsScrollPane.setViewportView(this.tablaDefiniciones);
        }
        catch(Exception e)
        {
            e.printStackTrace();
            tratarError(new DataException(e.getMessage()));
        }
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton acceptarButton;
    private javax.swing.JButton aplicarButton;
    private javax.swing.JPanel areaTematicaPanel;
    private javax.swing.JScrollPane areesScrollPane;
    private javax.swing.JButton cancelarButton;
    private javax.swing.JLabel changeLabel;
    private javax.swing.JPanel contextPanel;
    private javax.swing.JPanel definicionsPanel;
    private javax.swing.JScrollPane definicionsScrollPane;
    private javax.swing.JPanel denominacionsPanel;
    private javax.swing.JLabel fitxaLabel;
    private javax.swing.JLabel fitxaNom;
    private javax.swing.JPanel imatgePanel;
    private javax.swing.JButton leftButton;
    private javax.swing.JPanel mainPanel;
    private javax.swing.JPanel notesPanel;
    private javax.swing.JPanel observacionsPanel;
    private javax.swing.JButton rightButton;
    private javax.swing.JButton seeFitxaButton;
    private javax.swing.JTabbedPane tabbedPane;
    // End of variables declaration//GEN-END:variables

    // Mtodes publics       
    public JButton getAcceptarButton()
    {
        return this.acceptarButton;
    }
    
    public JButton getAplicarButton()
    {
        return this.aplicarButton;
    }
    
     public JButton getRightButton()
    {
        return this.rightButton;
    }
    
    public JButton getLeftButton()
    {
        return this.leftButton;
    }
}
