/*
 * AreesMainThread.java
 *
 * Created on 29 de enero de 2008, 14:55
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.termcat.layout.terminologic.fitxes;

import com.termcat.bd.beans.AreesFitxes;
import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.Fitxes;
import com.termcat.bd.beans.Notes;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.terminologic.search.SearchManager;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.ItemCustom;
import com.termcat.layout.commons.fitxes.FitxesManager;
import com.termcat.layout.commons.popup.MousePopupListener;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.commons.search.Search;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import javax.swing.ImageIcon;
import javax.swing.JDialog;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.table.DefaultTableModel;

/**
 *
 * @author Mena
 */
public class FitxesEditThread extends Thread
{    
    private MainFrame menuFrame;    
    private JDialog loader;
    private FitxesMain fMain;    
    private FitxesEdit fEdit;
    private int row;
    
    /** Creates a new instance of AreesMainThread */
    public FitxesEditThread(MainFrame menuFrame,JDialog dialog,FitxesMain fMain,int row,FitxesEdit fEdit) 
    {
        super();
        this.menuFrame=menuFrame;              
        this.loader=dialog;
        this.fMain=fMain;
        this.row=row;
        this.fEdit=fEdit;
    }
    
    public void run() 
    {    
        try 
        {  
            new FitxesManager().refreshContents(this.menuFrame,this.fMain);              
            endAction();
        }
        catch (Exception ex) 
        {
            ex.printStackTrace();            
            this.menuFrame.showMessageError(ex.getMessage());
        }    
        finally
        {
            loader.setVisible(false);                    
            this.interrupt();            
        }
    }        


    private void endAction() throws Exception 
    {
        // Inicialitzerm el valor del refresc de la taula.
        fEdit.refreshTable=false;
                 
        // Obtenim el id de la fitxa anterior a la seleccionada i actualitzem la nova fitxa seleccionada
        String idFitxa=(String)this.fMain.tablaFichas.getModel().getValueAt(row,0);
        this.fMain.tablaFichas.setRowSelectionInterval(row,row);

        // Guardem a BD les dades modificades.
        fEdit.doCommit();
                                 
        // Fer un right-click+Edit
        // Creem el nou mdul d'edici de la fitxa seleccionada, i mostrem la finestra amb el contingut.
        String denoPrincipal=(String)this.fMain.tablaFichas.getModel().getValueAt(row,1);               
        fEdit.init(fMain,idFitxa,denoPrincipal,row,this.fMain.tablaFichas.getModel().getRowCount());

        // Desassociem la seleccio en l'arbre!
        this.menuFrame.tree.setSelectionRow(-1);        
    }        
}
