/*
 * FitxesMain.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.fitxes;

import com.termcat.bd.beans.AreesFitxes;
import com.termcat.bd.beans.Definicions;
import com.termcat.bd.beans.Denominacions;
import com.termcat.bd.beans.Notes;
import com.termcat.bd.exceptions.FinderException;
import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.exceptions.SearchException;
import com.termcat.business.maintenance.category.CategoryManager;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.business.reports.llistat.BeanFichaData;
import com.termcat.business.terminologic.denominations.DenominationManager;
import com.termcat.business.terminologic.search.SearchManager;
import com.termcat.layout.commons.ItemCustom;
import com.termcat.layout.commons.popup.MousePopupListener;
import com.termcat.layout.commons.popup.PopupMenuTable;
import com.termcat.layout.commons.search.Search;
import com.termcat.layout.terminologic.cerca.CercaMain;
import com.termcat.util.literales.Literales;
import java.net.URL;
import java.util.ArrayList;
import java.util.List;
import java.util.Vector;
import java.util.Iterator;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JTable;
import javax.swing.table.DefaultTableModel;
import javax.swing.JScrollPane;
import java.awt.Dimension;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.layout.commons.popup.PanelPopup;
import com.termcat.bd.beans.Fitxes;


/**
 *
 * @author  Vazquezl
 */
public class FitxesMain extends FunctionalModule
{
    // Loader
    private JDialog dialog;
    //private JOptionPane pane;   
    
    public JTable tablaFichas;  // ?? Es per a poder accedir-hi desde la classe FitxesEdit
    private DefaultTableModel model;   
       
    // Constants
    public static final String EDIT_FITXA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Editar_fitxa");
    public static final String DELETE_FITXA=java.util.ResourceBundle.getBundle("com/termcat/util/literales/Literales").getString("Eliminar_fitxa");

    public int MAX_TABLE_FITXES_ROW; // publica perque s'accedeix desde FitxesEdit
    public boolean isLastPage=false;

    private PopupMenuTable tablaPopupMenu;
    private URL filterInactiveUrl;
    private URL filterActiveUrl;
    /** segundo constructor */
    
    public URL getFilterInactiveUrl()
    {
        return this.filterInactiveUrl;        
    }

    public URL getFilterActiveUrl()
    {
        return this.filterActiveUrl;        
    }
    
    public JButton getFilterButton()
    {
        return this.filterButton;
    }
    
    public JLabel getPageLabel()
    {
        return this.pageLabel;
    }
    
    public JLabel getFilterName()
    {
        return this.filtreName;
    }
    public void setLastPage(boolean page)
    {
        this.isLastPage=page;
    }
    public boolean isLastPage()
    {
        return this.isLastPage;
    }
    
    public JButton getFwButton()
    {
        return this.fwButton;
    }
    
    public JButton getReButton()
    {
        return this.reButton;
    }
    
    public JLabel getTotalFitxes()
    {
        return this.totalFitxes;
    }
    
    public DefaultTableModel getModel()
    {
        return this.model;
    }
    public JTable getTablaFichas()
    {
        return this.tablaFichas;
    }

    public void setModel(DefaultTableModel model)
    {
        this.model=model;
    }
    public void setTablaFichas(JTable table)
    {
        this.tablaFichas=table;
    }
    
    public JScrollPane getScrollPaneTabla()
    {
        return this.scrollPaneTabla;
    }
    
    public PopupMenuTable getPopUpMenuTable()
    {
        return this.tablaPopupMenu;
    }
    
    public void setPopUpMenuTable(PopupMenuTable tabla)
    {
        this.tablaPopupMenu=tabla;
    }
    
    public FitxesMain(MainFrame menuFrame)
    {     
        super(menuFrame);
        
        try
       {                 
            initComponents();  
            this.filterInactiveUrl=this.getClass().getResource("/com/termcat/resources/img/botoFilterInactive.gif");
            this.filterActiveUrl=this.getClass().getResource("/com/termcat/resources/img/botoFilterActive.gif");           

            refresh();
            
            initIsReady2Add();
            diccionarioName.setText(this.menuFrame.getNomCurrentDictionary());
            this.setSize(this.menuFrame.getSize());
            setPanel(this);
        }
        catch(Exception e)
        {
            e.printStackTrace();            
            tratarError(new DataException(e.getMessage())); 
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        botonAlta = new javax.swing.JButton();
        tituloTabla = new javax.swing.JLabel();
        scrollPaneTabla = new javax.swing.JScrollPane();
        diccionarioLabel = new javax.swing.JLabel();
        diccionarioName = new javax.swing.JLabel();
        reButton = new javax.swing.JButton();
        fwButton = new javax.swing.JButton();
        pageLabel = new javax.swing.JLabel();
        filtreName = new javax.swing.JLabel();
        filterButton = new com.termcat.layout.commons.buttons.ArrowButton(this.getClass().getResource("/com/termcat/resources/img/botoFilterInactive.gif"),this.getClass().getResource("/com/termcat/resources/img/botoFilterInactive.gif"));
        totalFitxes = new javax.swing.JLabel();

        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder(Literales.getTextForLiteral("TreballTerminologic_Fitxes")));
        panelIntern.setMaximumSize(new java.awt.Dimension(922, 692));
        panelIntern.setMinimumSize(new java.awt.Dimension(922, 692));
        botonAlta.setText("Alta d'una nova fitxa");
        botonAlta.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonAltaActionPerformed(evt);
            }
        });

        tituloTabla.setFont(new java.awt.Font("Tahoma", 0, 18));
        tituloTabla.setText(Literales.getTextForLiteral("LlistatFitxesExistents"));

        scrollPaneTabla.setViewportBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));

        diccionarioLabel.setFont(new java.awt.Font("Tahoma", 1, 24));
        diccionarioLabel.setText(Literales.getTextForLiteral("DiccionariLabel"));

        diccionarioName.setFont(new java.awt.Font("Tahoma", 0, 24));
        diccionarioName.setText(" ");

        reButton.setText("<<");
        reButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                reButtonActionPerformed(evt);
            }
        });

        fwButton.setText(">>");
        fwButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fwButtonActionPerformed(evt);
            }
        });

        pageLabel.setText("jLabel1");

        filtreName.setFont(new java.awt.Font("Tahoma", 0, 14));
        filtreName.setText(Literales.getTextForLiteral("Filtrar"));

        filterButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                filterButtonActionPerformed(evt);
            }
        });

        totalFitxes.setText(Literales.getTextForLiteral("CalculantNombreFitxes"));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 872, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .add(panelInternLayout.createSequentialGroup()
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(tituloTabla)
                            .add(panelInternLayout.createSequentialGroup()
                                .add(totalFitxes, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 301, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                                        .add(filtreName)
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                        .add(filterButton)
                                        .add(80, 80, 80))
                                    .add(panelInternLayout.createSequentialGroup()
                                        .add(326, 326, 326)
                                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING, false)
                                            .add(org.jdesktop.layout.GroupLayout.LEADING, botonAlta, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                            .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                                                .add(reButton)
                                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                                .add(pageLabel)
                                                .add(16, 16, 16)
                                                .add(fwButton)))
                                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 19, Short.MAX_VALUE))))
                            .add(panelInternLayout.createSequentialGroup()
                                .add(diccionarioLabel)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 10, Short.MAX_VALUE)
                                .add(diccionarioName, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 660, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .add(70, 70, 70)))
                        .add(26, 26, 26))))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(diccionarioLabel)
                    .add(diccionarioName))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(panelInternLayout.createSequentialGroup()
                        .add(tituloTabla)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(totalFitxes))
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                        .add(filtreName)
                        .add(filterButton, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 18, Short.MAX_VALUE)))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(scrollPaneTabla, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 484, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(reButton)
                    .add(fwButton)
                    .add(pageLabel))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(botonAlta)
                .add(20, 20, 20))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(33, 33, 33)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 920, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(71, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 686, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(71, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void filterButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_filterButtonActionPerformed
        FunctionalModule module = CercaMain.getInstance(this.menuFrame);
        this.menuFrame.setFuncionalModule (module);
    }//GEN-LAST:event_filterButtonActionPerformed

    private void fwButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fwButtonActionPerformed
        menuFrame.setCurrentPage(menuFrame.getCurrentPage()+1);
        refresh();
    }//GEN-LAST:event_fwButtonActionPerformed

    private void reButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_reButtonActionPerformed
        menuFrame.setCurrentPage(menuFrame.getCurrentPage()-1);
        refresh();
    }//GEN-LAST:event_reButtonActionPerformed
   
   /*
    *       Mtode que s'executa al clicar el bot d'alta. Crea el component i es refresca la llista amb el
    *      contingut de les fitxes.
    */
    private void botonAltaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonAltaActionPerformed
      // Esborrem el id de la Fitxa per si s'acaba de fer alguna modificaci.
      this.menuFrame.setIdFitxa(null);
      // Posem la pgina actual a 0, perque quan torni es mostri la primera pgina del llistat.
      this.menuFrame.setCurrentPage(0);
      altaFitxesActionPerformed();
      refresh();
    }//GEN-LAST:event_botonAltaActionPerformed
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonAlta;
    private javax.swing.JLabel diccionarioLabel;
    private javax.swing.JLabel diccionarioName;
    private javax.swing.JButton filterButton;
    private javax.swing.JLabel filtreName;
    private javax.swing.JButton fwButton;
    private javax.swing.JLabel pageLabel;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JButton reButton;
    private javax.swing.JScrollPane scrollPaneTabla;
    private javax.swing.JLabel tituloTabla;
    private javax.swing.JLabel totalFitxes;
    // End of variables declaration//GEN-END:variables
       
    /*
     *  Inicialitzaci de la taula i el model.
     */      
    
    /*
     *  Funci que s'encarrega de crear un nou mdul per a l'alta d'una nova llengua.  
     */
    private void altaFitxesActionPerformed() 
    {
        // Creem el nou mdul d'alta de la llengua.
        FunctionalModule module = new FitxesAlta(this.menuFrame, this);
         
        PanelPopup popupPanel=new PanelPopup(this.menuFrame,module,Literales.getTextForMessage("Treball_terminologic"),1000,575,10,10);
        popupPanel.addWindowListener(new java.awt.event.WindowAdapter() {
           public void windowClosed(java.awt.event.WindowEvent evt) {
               actionWindowClose(evt,true);
           }
           public void windowClosing(java.awt.event.WindowEvent evt) {
               actionWindowClose(evt,true);
           }
        });
        
        //Actualitzem el popupPanel 'actual'.
        this.menuFrame.setAltaPanelPopup(popupPanel,false);
        
        // Mostrem el popup
        popupPanel.showPopupWindow();  
    }
       
    public MainFrame getMenuFrame() {
        return this.menuFrame;
    }    
    
    private void initIsReady2Add() throws Exception 
    {
        boolean b=false;
        
        //Obtenir el llistat de llengues
        boolean hasLanguages=(DictionaryManager.getManager().getLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary()).size()>0);
        boolean hasCategories=(CategoryManager.getManager().getAllCategories().size()>0);
        b=hasLanguages & hasCategories;

        // Actualitzem la variable en la 'sessi'.
        this.menuFrame.setReady2Add(b);        
    }    
        
    public void tratarError(Exception e)
    {
        super.tratarError(e);
    }

    public void refresh() 
    {           
           // Creem el loader i el fem visible
            dialog=initLoader();
            dialog.setVisible(true);                                    
            
            FitxesMainThread thread=new FitxesMainThread(menuFrame,dialog,this);
            thread.start();                                                                
    }
}