/*
 * LlenguesAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.notes;

import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.NoteException;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.business.terminologic.notes.NoteManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.exceptions.LanguageException;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
import com.termcat.util.literales.Literales;
import java.awt.Component;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.layout.commons.lists.AssociateLists;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la definicio
 */
public class NotesEdit extends com.termcat.layout.terminologic.fitxes.Fitxa
{
    private String idNota;
    private NotesMain notesMain;
    
    private AssociateLists fontsList;

    // Editor RTF
    private EditorRTF editorRTF; 
    
    // Vectors
    private Vector llenguesDiccionariVector;
    
    /** Constructor. */
    public NotesEdit(MainFrame menuFrame, FunctionalModule functionalModule,String idNota, ItemListCustom llengua,String nota) 
    {
        super(menuFrame);
        // Variables
        ItemListCustom llenguaSelected=null, jerarquiaSelected=null, categoriaSelected=null,marcaSelected=null;
  
        initComponents();
            
        this.editorRTF = new EditorRTF();
        this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
        this.scrollPane.setViewportView(editorRTF);                        
  
        this.idNota=idNota;
        this.notesMain=(NotesMain)functionalModule;
        llenguesDiccionariVector=initVectorLlengues(this.menuFrame.getIdCurrentDictionary());
        initCombos();    
        initFonts();

        int llenguaPos=calculatePositionInVector(llenguesDiccionariVector,llengua.getId());                      
  
        // Carreguem els combos amb els valors
        llenguaValue.setSelectedIndex(llenguaPos);
        editorRTF.setRTFText(nota);        
            
        setPanel(this);
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        descripcioLabel = new javax.swing.JLabel();
        llenguaLabel = new javax.swing.JLabel();
        botonModifica = new javax.swing.JButton();
        botonCancela = new javax.swing.JButton();
        llenguaValue = new javax.swing.JComboBox();
        fontsScrollPane = new javax.swing.JScrollPane();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(670, 600));
        setMinimumSize(new java.awt.Dimension(670, 600));
        panelIntern.setBorder(javax.swing.BorderFactory.createTitledBorder("Edici\u00f3 d'una nota"));
        panelIntern.setMaximumSize(new java.awt.Dimension(625, 525));
        panelIntern.setMinimumSize(new java.awt.Dimension(625, 525));
        panelIntern.setPreferredSize(new java.awt.Dimension(625, 525));
        descripcioLabel.setText("Nota:");

        llenguaLabel.setText("Llengua:");

        botonModifica.setText("Desar");
        botonModifica.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonModificaActionPerformed(evt);
            }
        });

        botonCancela.setText("Cancel\u00b7lar");
        botonCancela.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                botonCancelaActionPerformed(evt);
            }
        });

        llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Item 1", "Item 2", "Item 3", "Item 4" }));

        fontsScrollPane.setBorder(javax.swing.BorderFactory.createTitledBorder("Fonts"));
        fontsScrollPane.setMaximumSize(new java.awt.Dimension(520, 300));
        fontsScrollPane.setMinimumSize(new java.awt.Dimension(520, 300));

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, fontsScrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 572, Short.MAX_VALUE)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, descripcioLabel)
                    .add(org.jdesktop.layout.GroupLayout.LEADING, panelInternLayout.createSequentialGroup()
                        .add(llenguaLabel)
                        .add(28, 28, 28)
                        .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                                .add(botonModifica, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 77, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                                .add(botonCancela))
                            .add(panelInternLayout.createSequentialGroup()
                                .add(15, 15, 15)
                                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                                    .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 488, Short.MAX_VALUE)
                                    .add(panelInternLayout.createSequentialGroup()
                                        .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 72, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                                        .add(396, 396, 396)))))))
                .add(26, 26, 26))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(llenguaLabel)
                    .add(llenguaValue, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(descripcioLabel)
                    .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 278, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(fontsScrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 280, Short.MAX_VALUE)
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(botonCancela)
                    .add(botonModifica))
                .addContainerGap())
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(18, 18, 18)
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 624, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(36, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 673, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(36, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void botonCancelaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonCancelaActionPerformed
      this.menuFrame.closePanelPopup();
    }//GEN-LAST:event_botonCancelaActionPerformed

    private void botonModificaActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_botonModificaActionPerformed
       try
       {
           int llenguaSelectedIndex=llenguaValue.getSelectedIndex();
           String idLlengua=null,idJerarquia=null,idCategoria=null,idMarca=null,idFitxa=null;
           Vector fonts =new Vector();
           
           // Obtenim els resultats del formulari.
           ItemListCustom item=new ItemListCustom();
           item=(ItemListCustom)llenguaValue.getSelectedItem();
           String codiLlengua=item.getValue(); 
           idLlengua=item.getId();

           //String descText=html2Text.convert(editorRTF.getRTFText());           
           String descText=editorRTF.getRTFPlainText();
           
           // Printem per pantalla
           System.out.println("CODI_LLENGUA:"+codiLlengua+" ID_LLENGUA"+idLlengua);
           if (descText!=null && !descText.trim().equals(""))
           {
               // Fem la inserci a BD.
               NoteManager.getManager().updateNota(this.idNota,idLlengua,descText,editorRTF.getRTFText());
               FontManager.getManager().deleteFontNotes(idNota);
               FontManager.getManager().insertFontNotes(idNota,fontsList.getSelectedList());

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Notes_UpdateOk"));

               // actualitzem el flag de dirty en cas que no ho estigui ja
               if(!this.menuFrame.isCurrentFitxaDirty())
                   this.menuFrame.setCurrentFitxaDirty(true);           

               // Tanquem la finestra d'alta d'una nova denominaci.
                this.menuFrame.closePanelPopup();

                this.notesMain.refresh(); 
           }
           else
               menuFrame.showMessageInfo(Literales.getTextForMessage("Notes_Empty"));
           

       }
       catch(Exception e){
           e.printStackTrace();
           tratarError(new NoteException(e.getMessage())); 
       }     
    }//GEN-LAST:event_botonModificaActionPerformed

    private void initCombos() 
    {
        try
        {
            String codiLlengua=null;          
            Vector idLlenguesDiccionari=DictionaryManager.getManager().getLlenguesOfDictionary(this.menuFrame.getIdCurrentDictionary());
            // Creem un nou vector amb tots els codis de les llengues.
            Vector llenguesDiccionari=new Vector();
            for (int i=0;i<idLlenguesDiccionari.size();++i)
            {
                ItemListCustom item=(ItemListCustom)idLlenguesDiccionari.get(i);
                llenguesDiccionari.add(item);
            }
            llenguaValue.setModel(new javax.swing.DefaultComboBoxModel(llenguesDiccionari));
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }     
    }
    
    private void initFonts() 
    {
        try
        {
            Vector allFonts=menuFrame.allFontsUpdated;
            Vector associates=FontManager.getManager().getFontsNotes(idNota);
            Vector noAssociates=getNoAssociates(allFonts,associates);
            
            fontsList=new AssociateLists(noAssociates,associates,FONTS_NO_ASSOCIATE_TITLE,FONTS_ASSOCIATE_TITLE);
            fontsScrollPane.setViewportView(fontsList);
        }
        catch(Exception e)
        {
            e.printStackTrace();
        }
        
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton botonCancela;
    private javax.swing.JButton botonModifica;
    private javax.swing.JLabel descripcioLabel;
    private javax.swing.JScrollPane fontsScrollPane;
    private javax.swing.JLabel llenguaLabel;
    private javax.swing.JComboBox llenguaValue;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables
    
}
