/*
 * NotesAlta.java
 *
 * Created on 11 de julio de 2007, 14:59
 */

package com.termcat.layout.terminologic.observacions;

import com.termcat.business.dictionary.DictionaryManager;
import com.termcat.business.exceptions.DataException;
import com.termcat.business.exceptions.ObservationException;
import com.termcat.business.terminologic.data.DataManager;
import com.termcat.business.terminologic.notes.NoteManager;
import com.termcat.layout.FunctionalModule;
import com.termcat.layout.MainFrame;
import com.termcat.business.maintenance.language.LanguageManager;
import com.termcat.layout.commons.FixedLengthTextField;
import com.termcat.layout.commons.rtf.EditorRTF;
import com.termcat.util.literales.Literales;
import java.util.Vector;
import com.termcat.layout.commons.lists.ItemListCustom;
import com.termcat.business.maintenance.font.FontManager;
import com.termcat.layout.commons.lists.AssociateLists;
import com.termcat.bd.beans.Fitxes;
import javax.swing.ScrollPaneConstants;
/**
 *
 * @author  Vazquezl
 * Exten de Fita perque si no no hi ha manera de saber quina es la fitxa a la que pertany la denominacio
 */
public class ObservacionsAlta extends com.termcat.layout.terminologic.fitxes.Fitxa
{
    private AssociateLists fontsList;
    private EditorRTF editorRTF;
     
    /** Constructor. */
    public ObservacionsAlta(MainFrame menuFrame) 
    {
        super(menuFrame);
        try
        {
            initComponents();
            
            this.editorRTF = new EditorRTF();
            this.scrollPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_AS_NEEDED);
            this.scrollPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_AS_NEEDED);
            this.scrollPane.setViewportView(editorRTF);
        
            Fitxes fitxa=new Fitxes();
            Fitxes fitxaSelected=(Fitxes)fitxa.findByPrimaryKey(this.menuFrame.getIdFitxa());
            editorRTF.setRTFText(fitxaSelected.getObservacions());  

            setPanel(this);
        }
        catch (Exception e)
        {
            e.printStackTrace();
            tratarError(new ObservationException(e.getMessage()));
        }
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        panelIntern = new javax.swing.JPanel();
        llenguaLabel = new javax.swing.JLabel();
        desarButton = new javax.swing.JButton();
        scrollPane = new javax.swing.JScrollPane();

        setMaximumSize(new java.awt.Dimension(944, 373));
        setMinimumSize(new java.awt.Dimension(944, 373));
        panelIntern.setBorder(javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1));
        panelIntern.setMaximumSize(new java.awt.Dimension(944, 373));
        panelIntern.setMinimumSize(new java.awt.Dimension(944, 373));
        llenguaLabel.setFont(new java.awt.Font("Tahoma", 0, 14));
        llenguaLabel.setText(Literales.getTextForLiteral("ObservacionsFitxa"));

        desarButton.setText(Literales.getTextForLiteral("Desar"));
        desarButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                desarButtonActionPerformed(evt);
            }
        });

        org.jdesktop.layout.GroupLayout panelInternLayout = new org.jdesktop.layout.GroupLayout(panelIntern);
        panelIntern.setLayout(panelInternLayout);
        panelInternLayout.setHorizontalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(panelInternLayout.createSequentialGroup()
                .addContainerGap()
                .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(llenguaLabel)
                    .add(panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.TRAILING)
                        .add(desarButton)
                        .add(scrollPane, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 892, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap(39, Short.MAX_VALUE))
        );
        panelInternLayout.setVerticalGroup(
            panelInternLayout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(org.jdesktop.layout.GroupLayout.TRAILING, panelInternLayout.createSequentialGroup()
                .add(36, 36, 36)
                .add(llenguaLabel)
                .add(32, 32, 32)
                .add(scrollPane, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 206, Short.MAX_VALUE)
                .add(14, 14, 14)
                .add(desarButton)
                .add(46, 46, 46))
        );

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 943, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(panelIntern, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(103, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void desarButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_desarButtonActionPerformed
        try 
        {
            String descText="";
            String plailText = "";
            try 
            {
                plailText = editorRTF.getRTFPlainText();
                if(plailText!=null && plailText.trim().equals("")){
                    descText="";
                }else{
                    descText = editorRTF.getRTFText();
                }
                System.out.println("DESC_TEXT: "+descText);
            } 
            catch (Exception ex) 
            {
                ex.printStackTrace();
            }           
           
            if(descText!=null)
            {
                // Insertem a la base de dades el camp observaci.
                DataManager.getManager().altaObservacions(this.menuFrame.getIdFitxa(),descText);        

                // Indiquem el flag de dirty a true
                this.menuFrame.setCurrentFitxaDirty(true);

               // Mostrem missatge de confirmaci.
               menuFrame.showMessageInfo(Literales.getTextForMessage("Observaciones_Ok"));
            }
            else
                menuFrame.showMessageInfo(Literales.getTextForMessage("Observaciones_Empty"));
        }
        catch (DataException ex) 
        {
            ex.printStackTrace();
        }        
    }//GEN-LAST:event_desarButtonActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton desarButton;
    private javax.swing.JLabel llenguaLabel;
    private javax.swing.JPanel panelIntern;
    private javax.swing.JScrollPane scrollPane;
    // End of variables declaration//GEN-END:variables

    
}
